C                                   MASTER
C  ****************************************************************************
C  * MASTER3.0: MODIFIED VERSION OF MASTER2.0/BOAST/ASTER FOR MULTI-COMPONENT,*
C  *            MISCIBLE SIMULATION WITH EMPHASIS ON CARBON DIOXIDE FLOODING  *
C  *                                                                          *
C  * SPONSORED BY: U.S. DEPARTMENT OF ENERGY                                  *
C  * ------------                                                             *
C  * MODIFIED BY:ZHENGWEN ZENG, REID B. GRIGG AND SHIH-HSIEN CHANG            *
C  *             NEW MEXICO PETROLEUM RECOVERY RESEARCH CENTER                *
C  *             NEW MEXICO INSTITUTE OF MINING AND TECHNOLOGY                *
C  * LAST RELEASE: JULY 2005                                                  *
C  * ------------                                                             * 
C  ****************************************************************************
C
      PROGRAM MASTER
      PARAMETER (NXMAXX=16  ,NYMAXX=16   ,NZMAXX=7 
     &          ,MAXX=NXMAXX*NYMAXX*NZMAXX)
      PARAMETER (MXROWW=400 ,MAXAA=MXROWW*MAXX/2)
      PARAMETER (NWELLL=40  ,NWLL=16)
      DIMENSION P(MAXX),PBOT(MAXX),VP(MAXX),SO(MAXX),SW(MAXX),SG(MAXX)
     &         ,VG(MAXX),XS(MAXX),BO(MAXX),BW(MAXX),BG(MAXX)
     &         ,RSOR(MAXX),RSWR(MAXX),RSWS1(MAXX)
     &         ,AWG(MAXX),C21(MAXX),C23(MAXX),C31(MAXX),C33(MAXX)
     &         ,OL(MAXX),WL(MAXX),GL(MAXX),GWSWT(MAXX)
     &         ,GOWT(MAXX),GWWT(MAXX),GGWT(MAXX)
      DIMENSION PN(MAXX),PBOTN(MAXX),VPN(MAXX)
     &         ,SON(MAXX),SWN(MAXX),SGN(MAXX),VGGN(MAXX)
     &         ,XSN(MAXX),BON(MAXX),BWN(MAXX),BGN(MAXX),RSORN(MAXX)
     &         ,RSWRN(MAXX),RSWS1N(MAXX),AWGN(MAXX),C21N(MAXX)
     &         ,C23N(MAXX),C31N(MAXX),C33N(MAXX),OLN(MAXX),WLN(MAXX)
     &         ,GLN(MAXX),GWSWTN(MAXX)
     &         ,GOWTN(MAXX),GWWTN(MAXX),GGWTN(MAXX),EN(MAXX)
      DIMENSION OX(MAXX),OY(MAXX),OZ(MAXX),WX(MAXX),WY(MAXX),WZ(MAXX)
     &         ,GX(MAXX),GY(MAXX),GZ(MAXX),DX(MAXX),DY(MAXX),DZ(MAXX)
     &         ,WSX(MAXX),WSY(MAXX),WSZ(MAXX),DP(MAXX)
     &         ,EL(MAXX),XK(MAXX),YK(MAXX),ZK(MAXX)
     &         ,PVEC(MAXX),QVEC(MAXX),ISOLID(MAXX)
     &         ,NTAB(MAXX),QO(MAXX),QW(MAXX),QG(MAXX)
     &         ,OK(MAXX),WK(MAXX),GK(MAXX),UO(MAXX),UW(MAXX),UG(MAXX)
     &         ,RHOO(MAXX),RHOW(MAXX),RHOG(MAXX),PCW(MAXX),PCG(MAXX)
      DIMENSION VS(4*MAXX),GSWT(4*MAXX),BS(4*MAXX),RSO(4*MAXX)
     &         ,AWS(4*MAXX),CSP(4*MAXX),SL(4*MAXX),CSS(4*MAXX)
     &         ,VSN(4*MAXX),GSWTN(4*MAXX)
     &         ,BSN(4*MAXX),RSON(4*MAXX),AWSN(4*MAXX)
     &         ,CSPN(4*MAXX),SLN(4*MAXX),CSSN(4*MAXX)
     &         ,US(4*MAXX),RHOS(4*MAXX),QS(4*MAXX)
     &         ,SX(4*MAXX),SY(4*MAXX),SZ(4*MAXX)
      COMMON/BANDS/AW(MAXX),AE(MAXX),AS(MAXX)
     &         ,AN(MAXX),AT(MAXX),AB(MAXX),E(MAXX),B(MAXX)
      COMMON/WORK/A1(MAXX),A2(MAXX),A3(MAXX)
      DIMENSION TX(NXMAXX+1,NYMAXX,NZMAXX)
     &         ,TY(NXMAXX,NYMAXX+1,NZMAXX)
     &         ,TZ(NXMAXX,NYMAXX,NZMAXX+1)
     &         ,NTABIJ(NXMAXX,NYMAXX,NZMAXX)
      DIMENSION PID(NWELLL,NWLL),PWF(NWELLL,NWLL),PWFC(NWELLL,NWLL)
     &  ,KIPN(NWELLL),KIP(NWELLL),GMO(NWELLL,NWLL),GMW(NWELLL,NWLL)
     &         ,GMG(NWELLL,NWLL),LAYER(NWELLL),QVO(NWELLL)
     &         ,QVW(NWELLL),QVG(NWELLL),QVT(NWELLL),CUMO(NWELLL,NWLL)
     &         ,CUMW(NWELLL,NWLL),CUMG(NWELLL,NWLL)

      DIMENSION CUMS1(NWELLL,NWLL),CUMS2(NWELLL,NWLL)
     &         ,CUMS3(NWELLL,NWLL),CUMS4(NWELLL,NWLL)
     &         ,GM1(NWELLL,NWLL),GM2(NWELLL,NWLL)
     &         ,GM3(NWELLL,NWLL),GM4(NWELLL,NWLL),QVS(NWELLL)
     &         ,IQN1(NWELLL),IQN2(NWELLL),IQN3(NWELLL)

      CHARACTER*5 WELLID(NWELLL)
C
C     WORK ARRAYS FOR LINEAR SOLVER
C
      DIMENSION CGAL3(MAXX),CGAL2(MAXX),CGAL1(MAXX),CGAD(MAXX)
     &         ,CGAU1(MAXX),CGAU2(MAXX),CGAU3(MAXX)
      DIMENSION QI(15,MAXX),AQI(15,MAXX)
      DIMENSION AMAT(MAXAA),ROW(-MXROWW:MXROWW)
      DIMENSION LINK(MAXX,6),NLBW(MAXX),NRBW(MAXX),IXA(MAXX)
     &         ,INAT(MAXX)
      DIMENSION UM(NXMAXX),AZL(NXMAXX),BZL(NXMAXX),CZL(NXMAXX)
     &         ,DZL(NXMAXX),UZL(NXMAXX)
     &         ,BET(NXMAXX),GMMA(NXMAXX),W(NXMAXX)
C
      LOGICAL BVBP(MAXX),BVBPN(MAXX)
C
      CHARACTER C80*80
C      
      DIMENSION ILOOK(MAXX),ILOOKO(MAXX),ILOOKN(MAXX)
      DIMENSION RES(MAXX),RESN(MAXX)
      DIMENSION CRUX(0:NXMAXX,NYMAXX,NZMAXX),
     &          CRUY(NXMAXX,0:NYMAXX,NZMAXX),
     &          CRUZ(NXMAXX,NYMAXX,0:NZMAXX)    
C
      DIMENSION IDIR(NWELLL),RW(NWELLL,NWLL),IWM(NWELLL)
      DIMENSION FWX(MAXX),FWY(MAXX),FWZ(MAXX),SWPRE(MAXX)
      DIMENSION FGX(MAXX),FGY(MAXX),FGZ(MAXX),SGPRE(MAXX),VC(MAXX)
      DIMENSION UVW(MAXX),UVG(MAXX),QWS(MAXX),QGS(MAXX)
      DIMENSION CSPRE(MAXX),CS(MAXX),RHOWN(MAXX),FI(MAXX)
      DIMENSION BNFPRE(MAXX),BNF(MAXX),BLN(MAXX),BLNPRE(MAXX)
      DIMENSION GF(MAXX),GFPRE(MAXX),PKO(MAXX)
      DIMENSION CSI(NWELLL),BNFI(NWELLL),QGP(MAXX)
      DIMENSION CSN(MAXX),BNFN(MAXX),GFN(MAXX),BB(MAXX),QS1(4*MAXX)
      DIMENSION FGXN(MAXX),FGYN(MAXX),FGZN(MAXX),SGPREN(MAXX)
     &	      ,SWPREN(MAXX)
      DIMENSION DV(MAXX)
      DIMENSION VMUG(MAXX)
      DIMENSION ISWITH(NWELLL) 
      DIMENSION TORJL(NWELLL),TGRJL(NWELLL),TWRJL(NWELLL)
      DIMENSION GORJL(NWELLL),WORJL(NWELLL)
      DIMENSION TOCJL(NWELLL),TGCJL(NWELLL),TWCJL(NWELLL)
C
	PRINT *,""
	PRINT *,"MASTER"
	PRINT *,""
	PRINT *,"Miscible Applied Simulation Tech for Energy Recovery"
	PRINT *,"with emphasis on carbon dioxide flooding"
	PRINT *,""
	PRINT *,"Sponsor: US Department of Energy"
	PRINT *,""
	PRINT *,"by"
	PRINT *,""
	PRINT *,"Zhengwen Zeng, Reid B. Grigg and Shih-Hsien Chang"
	PRINT *,"New Mexico Petroleum Recovery Research Center"
	PRINT *,"New Mexico Institute of Mining and Technology"
	PRINT *,""
	PRINT *,"Last modified: July 2005"
	PRINT *,""
	PRINT *,"Simulation in progress, please wait......"
	PRINT *,""


      OPEN(UNIT=5,FILE='MASTER.d',STATUS='OLD')
10    OPEN(UNIT=66,FILE='MASTER.OUT',STATUS='NEW', ERR=9001)
      GOTO 11
9001  OPEN(UNIT=66,FILE='MASTER.OUT')
      CLOSE(66,STATUS='DELETE')
      OPEN(UNIT=2,FILE='fort2')
      CLOSE(2,STATUS='DELETE')
      OPEN(UNIT=6,FILE='screen.out')
      CLOSE(6,STATUS='DELETE')
      OPEN(UNIT=7,FILE='MASTER.SUM')
      CLOSE(7,STATUS='DELETE')
      OPEN(UNIT=8,FILE='MASTER.MBE')
      CLOSE(8,STATUS='DELETE')
      GOTO 10
11    OPEN(UNIT=7,FILE='MASTER.SUM',STATUS='NEW')
      OPEN(UNIT=8,FILE='MASTER.MBE',STATUS='NEW')
      OPEN(UNIT=6,FILE='screen.out',STATUS='NEW')
      OPEN(UNIT=2,FILE='fort2',STATUS='NEW')
      MAX1=MAXX
      MAXA=MAXAA
      MAXROW=MXROWW
      NWELL=NWELLL
      NWL=NWLL
      READ(5,'(A80)') C80
      WRITE(66,1020) C80
      READ (5,*) II,JJ,KK
      IJKM = II*JJ*KK
      WRITE(*,*)' test..........1'
      IF(IJKM.GT.MAX1) THEN 
		PRINT *,""
		PRINT *,"Simulation is over, please check the results."
		PRINT *,"Error: DIMENSIONS EXCEED MAXIMUM DECLARED IN MASTER."
		PRINT *,""
		WRITE(*,*)'Error: DIMENSIONS EXCEED MAXIMUM DECLARED IN MASTER.'
		STOP 'DIMENSIONS ENTERED EXCEED MAXIMUM DECLARED IN MASTER'
	ENDIF
C
      CALL AMSUB(P,PBOT,VP,SO,SW,SG,VG,VS,XS,BO,BW,BG,BS
     & ,RSOR,RSWR,RSO,RSWS1,OK,WK,GK,UO,UW,UG,US,RHOO,RHOW,RHOG,RHOS
     & ,PCW,PCG,GOWT,GWWT,GGWT,GSWT,GWSWT,PN,PBOTN,VPN,SON,SWN
     & ,SGN,VGGN,VSN,XSN,GOWTN,GWWTN,GGWTN,GSWTN,QO,QW,QG,QS
     & ,OL,WL,GL,SL,AW,AE,AS,AN,AT,AB,E,B,OX,OY,OZ,WX,WY,WZ,GX
     & ,GY,GZ,SX,SY,SZ,WSX,WSY,WSZ,DP,AWG,AWS,C21,C23,C31,C33
     & ,CSP,CSS,DX,DY,DZ,EL,XK,YK,ZK,TX,TY,TZ,A1,A2,A3,PVEC
     &,QVEC,AMAT,ROW,ISOLID,BVBP,BVBPN,LINK,NLBW,NRBW,IXA,INAT,QI,AQI
     & ,II,JJ,KK,IJKM,MAX1,MAXA,MAXROW,NWELL,NWL,CGAL3,CGAL2
     & ,CGAL1,CGAD,CGAU1,CGAU2,CGAU3,NTABS,BON,BWN,BGN,RSORN,RSWRN
     & ,RSWS1N,AWGN,C21N,C23N,C31N,C33N,OLN,WLN,GLN,GWSWTN,BSN,RSON
     & ,AWSN,CSPN,SLN,CSSN,EN,PID,PWF,PWFC,KIP,KIPN,GMO,GMW,GMG
     & ,WELLID,LAYER,QVO,QVW,QVG,QVT,CUMO,CUMW,CUMG , CUMS1 ,CUMS2 
     & ,CUMS3,CUMS4,GM1,GM2,GM3,GM4,QVS,IQN1,IQN2,IQN3,CRUX,CRUY,CRUZ
     & ,UM,AZL,BZL,CZL,DZL,UZL,BET,GMMA,W,NTAB,NTABIJ
     & ,IDIR,RW,IWM,FWX,FWY,FWZ,CS,CSPRE,SWPRE,SGPRE,FGX,FGY,FGZ
     & ,UVW,UVG,PKO,RHOWN,QWS,QGS,FI,BNFPRE,BNF,BLN,BLNPRE,GF
     & ,GFPRE,VC,CSI,BNFI,CSN,BNFN,GFN,BB,QS1,QGP,DV,VMUG,TORJL,TGRJL
     &,TWRJL,GORJL,WORJL,TOCJL,TGCJL,TWCJL,iswith,FGXN,FGYN,FGZN
     &,SWPREN,SGPREN,ILOOK,ILOOKO,RES,RESN,ILOOKN)

	close(2,status='delete')	 
	close(5,status='keep')		 
	close(6,status='delete')		 
	close(7,status='keep')		 
	close(8,status='delete')	 

	PRINT *,""
	PRINT *,"Simulation is over, please check the results."
	PRINT *,""

      STOP

 1020 FORMAT(T24,82('*'),/,T24,('*'),T105,('*'),/,
     & T24,('*'),A80,T105,('*'),/,T24,('*'),T105,
     & ('*'),/,T24,82('*'),//)
      END PROGRAM MASTER

      SUBROUTINE AMSUB(P,PBOT,VP,SO,SW,SG,VG,VS,XS,BO,BW,BG,BS
     & ,RSOR,RSWR,RSO,RSWS1,OK,WK,GK,UO,UW,UG,US,RHOO,RHOW,RHOG,RHOS
     & ,PCW,PCG,GOWT,GWWT,GGWT,GSWT,GWSWT,PN,PBOTN,VPN,SON,SWN
     & ,SGN,VGGN,VSN,XSN,GOWTN,GWWTN,GGWTN,GSWTN,QO,QW,QG,QS
     & ,OL,WL,GL,SL,AW,AE,AS,AN,AT,AB,E,B,OX,OY,OZ,WX,WY,WZ,GX
     & ,GY,GZ,SX,SY,SZ,WSX,WSY,WSZ,DP,AWG,AWS,C21,C23,C31,C33
     & ,CSP,CSS,DX,DY,DZ,EL,XK,YK,ZK,TX,TY,TZ,A1,A2,A3,PVEC
     &,QVEC,AMAT,ROW,ISOLID,BVBP,BVBPN,LINK,NLBW,NRBW,IXA,INAT,QI,AQI
     & ,II,JJ,KK,IJKM,MAX1,MAXA,MAXROW,NW,NWL,AL3,AL2
     & ,AL1,AD,AU1,AU2,AU3,NTABS,BON,BWN,BGN,RSORN,RSWRN
     & ,RSWS1N,AWGN,C21N,C23N,C31N,C33N,OLN,WLN,GLN,GWSWTN,BSN,RSON
     & ,AWSN,CSPN,SLN,CSSN,EN,PID,PWF,PWFC,KIP,KIPN,GMO,GMW,GMG
     & ,WELLID,LAYER ,QVO ,QVW ,QVG ,QVT,CUMO,CUMW,CUMG ,CUMS1,CUMS2
     & ,CUMS3,CUMS4,GM1,GM2,GM3,GM4,QVS,IQN1,IQN2,IQN3,CRUX,CRUY,CRUZ
     & ,UM,AZL,BZL,CZL,DZL,UZL,BET,GMMA,W,NTAB,NTABIJ
     & ,IDIR,RW,IWM,FWX,FWY,FWZ,CS,CSPRE,SWPRE,SGPRE,FGX,FGY,FGZ
     & ,UVW,UVG,PKO,RHOWN,QWS,QGS,FI,BNFPRE,BNF,BLN,BLNPRE,GF
     &,GFPRE,VC,CSI,BNFI,CSN,BNFN,GFN,BLNN,QS1,QGP,DV,VMUG,TORJL,TGRJL
     &,TWRJL,GORJL,WORJL,TOCJL,TGCJL,TWCJL,iswith,FGXN,FGYN,FGZN
     &,SWPREN,SGPREN,ILOOK,ILOOKO,RES,RESN,ILOOKN)
C
      DIMENSION P(IJKM),PBOT(IJKM),VP(IJKM),SO(IJKM),SW(IJKM),SG(IJKM)
     &         ,VG(IJKM),XS(IJKM),BO(IJKM),BW(IJKM),BG(IJKM)
     &         ,RSOR(IJKM),RSWR(IJKM),RSWS1(IJKM)
     &         ,AWG(IJKM),C21(IJKM),C23(IJKM),C31(IJKM),C33(IJKM)
     &         ,OL(IJKM),WL(IJKM),GL(IJKM),GWSWT(IJKM)
     &         ,GOWT(IJKM),GWWT(IJKM),GGWT(IJKM)
      DIMENSION PN(IJKM),PBOTN(IJKM),VPN(IJKM)
     &         ,SON(IJKM),SWN(IJKM),SGN(IJKM),VGGN(IJKM)
     &         ,XSN(IJKM),BON(IJKM),BWN(IJKM),BGN(IJKM),RSORN(IJKM)
     &         ,RSWRN(IJKM),RSWS1N(IJKM),AWGN(IJKM),C21N(IJKM)
     &         ,C23N(IJKM),C31N(IJKM),C33N(IJKM),OLN(IJKM),WLN(IJKM)
     &         ,GLN(IJKM),GWSWTN(IJKM)
     &         ,GOWTN(IJKM),GWWTN(IJKM),GGWTN(IJKM),EN(IJKM)
      DIMENSION OX(IJKM),OY(IJKM),OZ(IJKM),WX(IJKM),WY(IJKM),WZ(IJKM)
     &         ,GX(IJKM),GY(IJKM),GZ(IJKM),DX(IJKM),DY(IJKM),DZ(IJKM)
     &         ,WSX(IJKM),WSY(IJKM),WSZ(IJKM),DP(IJKM)
     &         ,EL(IJKM),XK(IJKM),YK(IJKM),ZK(IJKM)
     &         ,PVEC(IJKM),QVEC(IJKM),ISOLID(IJKM)
     &         ,NTAB(IJKM),QO(IJKM),QW(IJKM),QG(IJKM)
     &         ,OK(IJKM),WK(IJKM),GK(IJKM),UO(IJKM),UW(IJKM),UG(IJKM)
     &         ,RHOO(IJKM),RHOW(IJKM),RHOG(IJKM),PCW(IJKM),PCG(IJKM)
      DIMENSION VS(4*IJKM),GSWT(4*IJKM),BS(4*IJKM),RSO(4*IJKM)
     &         ,AWS(4*IJKM),CSP(4*IJKM),SL(4*IJKM),CSS(4*IJKM)
     &         ,VSN(4*IJKM),GSWTN(4*IJKM)
     &         ,BSN(4*IJKM),RSON(4*IJKM),AWSN(4*IJKM)
     &         ,CSPN(4*IJKM),SLN(4*IJKM),CSSN(4*IJKM)
     &         ,US(4*IJKM),RHOS(4*IJKM),QS(4*IJKM)
     &         ,SX(4*IJKM),SY(4*IJKM),SZ(4*IJKM)
      DIMENSION AW(IJKM),AE(IJKM),AS(IJKM)
     &         ,AN(IJKM),AT(IJKM),AB(IJKM),E(IJKM),B(IJKM)
      DIMENSION A1(IJKM),A2(IJKM),A3(IJKM)
      DIMENSION TX(II+1,JJ,KK),NTABIJ(II,JJ,KK)
     &         ,TY(II,JJ+1,KK),TZ(II,JJ,KK+1)
C
      DIMENSION PID(NW,NWL),PWF(NW,NWL),PWFC(NW,NWL),KIP(NW)
     &		 ,KIPN(NW),GMO(NW,NWL),GMW(NW,NWL),GMG(NW,NWL)
     &         ,LAYER(NW),QVO(NW),QVW(NW),QVG(NW),QVT(NW)
     &         ,CUMO(NW,NWL),CUMW(NW,NWL),CUMG(NW,NWL)

      DIMENSION CUMS1(NW,NWL),CUMS2(NW,NWL),CUMS3(NW,NWL)
     &         ,CUMS4(NW,NWL),GM1(NW,NWL),GM2(NW,NWL),GM3(NW,NWL)
     &         ,GM4(NW,NWL),QVS(NW),IQN1(NW),IQN2(NW),IQN3(NW)
      CHARACTER*5 WELLID(NW)
C
      DIMENSION AL3(IJKM),AL2(IJKM),AL1(IJKM),AD(IJKM)
     &         ,AU1(IJKM),AU2(IJKM),AU3(IJKM)
      DIMENSION QI(15,IJKM),AQI(15,IJKM)
      DIMENSION AMAT(MAXA),ROW(-MAXROW:MAXROW)
      DIMENSION LINK(IJKM,6),NLBW(IJKM),NRBW(IJKM),IXA(IJKM)
     &         ,INAT(IJKM)
      DIMENSION UM(II),AZL(II),BZL(II),CZL(II),DZL(II),UZL(II)
     &         ,BET(II),GMMA(II),W(II)
C
      LOGICAL BVBP(IJKM),BVBPN(IJKM)
C
      CHARACTER C80*80
      REAL MCFGN,MBEO,MBEW,MBEG,MCFG,MCFGD,MCFGT,OMEGA 
     &    ,MCFGTI,MCF1TI,MCF2TI,MCF3TI,MCF4TI,MCFS1T,MCFS2T,MCFS3T
     &    ,MCFS4T,MCFS1N,MCFS2N,MCFS3N,MCFS4N,MBES1,MBES2,MBES3,MBES4
      DIMENSION SIPK(4),DSIPK(4),TSLUG(4),TSLUGN(4),TSLUGD(4)
C
      DIMENSION IDIR(NW),RW(NW,NWL),IWM(NW)
      DIMENSION FWX(IJKM),FWY(IJKM),FWZ(IJKM),SWPRE(IJKM)
      DIMENSION FGX(IJKM),FGY(IJKM),FGZ(IJKM),SGPRE(IJKM),VC(IJKM)
      DIMENSION UVW(IJKM),UVG(IJKM),QWS(IJKM),QGS(IJKM)
      DIMENSION CSPRE(IJKM),CS(IJKM),RHOWN(IJKM),FI(IJKM)
      DIMENSION BNFPRE(IJKM),BNF(IJKM),BLN(IJKM),BLNPRE(IJKM),
     &          GF(IJKM),GFPRE(IJKM),PKO(IJKM), QGP(IJKM),
     &		  CSN(IJKM),BNFN(IJKM),GFN(IJKM),BLNN(IJKM),QS1(4*IJKM),
     &		  DV(IJKM),CSI(NW),BNFI(NW)
      DIMENSION FGXN(IJKM),FGYN(IJKM),FGZN(IJKM),SGPREN(IJKM)
     &		,SWPREN(IJKM)
      
      DIMENSION ILOOK(IJKM),ILOOKO(IJKM),ILOOKN(IJKM)
      DIMENSION RES(IJKM),RESN(IJKM)
      DIMENSION CRUX(0:II,JJ,KK),CRUY(II,0:JJ,KK),
     &          CRUZ(II,JJ,0:KK)    
      DIMENSION VMUG(IJKM)
      DIMENSION TORJL(NW),TGRJL(NW),TWRJL(NW),GORJL(NW),WORJL(NW)
      DIMENSION TOCJL(NW),TGCJL(NW),TWCJL(NW)
      DIMENSION ISWITH(NW) 
      COMMON/RHOSTO/RHOSCO,RHOSCG,RHOSCW,RHOSC(4)
      COMMON/ZERO/SMAS0,BUBB0

      PARAMETER (BBLSCF=1.0/5.615)
      DATA IOCODE/66/
C
      N = 0
      ITTOT = 0
      DELT = 1.0
      FT = 0.0
      FTMAX = 0.0
      JFLOW = 1
      JSTAT = 1
      BES = 0.0
      BEB = 0.0
      TOBI = 0.
      TOBO = 0.
      TOSMI = 0.
      TOSMO = 0.
      COP = 0.0
      CWP = 0.0
      CGP = 0.0
      CWI = 0.0
      CGI = 0.0
      DO 30 IW = 1,NW
        DO 30 K = 1,NWL
          CUMO(IW,K) = 0.0
          CUMW(IW,K) = 0.0
          CUMG(IW,K) = 0.0
          CUMS1(IW,K) = 0.0
          CUMS2(IW,K) = 0.0
          CUMS3(IW,K) = 0.0
          CUMS4(IW,K) = 0.0
   30 CONTINUE
C
      CWSP = 0.0
      CWSI = 0.0
      PRECIP = 0.0
C
      CALL GRID1(IOCODE,II,JJ,KK,OK,WK,DX,DY,DZ,EL)
C
      CALL PARM1(IOCODE,II,JJ,KK,OK,FI,XK,YK,ZK)
C
      CALL TABLE2(IOCODE,NSLUGS,SOMIN,REDK,BETA,SORM
     &           ,NOMOB,MOBCTL,SCI,PBO,MSATW,MSATG,MPOT
     &           ,MPWT,MPGT,PMAXT
     &           ,II,JJ,KK,IJKM,NTABS,NTAB,ILOOKO,NTABIJ)

      MOBCTL = 0
      DO 40 IB = 1,IJKM
        DP(IB) = 0.0
        GOWT(IB) = 0.0
        GWWT(IB) = 0.0
        GGWT(IB) = 0.0
        GWSWT(IB) = 0.0
        XS(IB) = 0.0
        WSX(IB) = 0.0
        WSY(IB) = 0.0
        WSZ(IB) = 0.0
        ISOLID(IB) = -1
   40 CONTINUE
C
      IJKM4 = 4*IJKM
      DO 50 IBS = 1,IJKM4
        GSWT(IBS) = 0.0
        SX(IBS) = 0.0
        SY(IBS) = 0.0
        SZ(IBS) = 0.0
   50 CONTINUE
C
      CALL UINIT2(EL,PBO,SOMIN,ISOLID,NSLUGS,II,JJ,KK,IJKM,MSATW
     &           ,MSATG,MPOT,MPWT,MPGT,P,PBOT,SO,SW,SG,VG,VS
     &           ,NTABS,NTAB)
C
      CALL CODES(IOCODE,FACT1,FACT2,TMAX,WORMAX,GORMAX,PAMIN,PAMAX
     &          ,OMEGA,TOL,DSMAX,DPMAX,RTOL,RSWGHT,KSW1,KSW2,KSW3
     &          ,NN,KSOL,MITER,NCYCLE,ITMAX,NERR)
C
      NMAX = NN + 1
      IF(KSOL .EQ. 1 .AND. JJ .EQ. 1) THEN
        WRITE(6,1050)
 1050 FORMAT(//,10X,'JJ = 1, SOLUTION METHOD CHANGED TO D4')
        KSOL = 3
      ENDIF
C
      IF(KSOL .EQ. 1) CALL SLORD(II,KK,IJKM,MAXA
     &                     ,LINK,NLBW,NRBW,IXA,MAXBND)
      IF(KSOL .EQ. 3) CALL D4ORD(II,JJ,KK,MAXA,MAXROW,IJKM
     &					 ,LINK,NLBW,NRBW,IXA,INAT)
C
      KRED = 0
      CALL TRAN2(II,JJ,KK,IOCODE,KRED,XK,YK,ZK,DX,DY,DZ,A1,A2,A3
     &          ,TX,TY,TZ)
C
      DO 60 IB = 1,IJKM
        DV(IB) = DX(IB)*DY(IB)*DZ(IB)
        VP(IB) = FI(IB)*DV(IB)
 60    CONTINUE
C
       CALL INPUTF(IOCODE,II,JJ,KK,IFOAM,JCHFM,CS,BNF)
C
      IF(IFOAM.EQ.1) THEN
      DO 1780 IJK = 1,IJKM
        RES(IJK) = 1.0
        ILOOK(IJK) = 0
        BNFPRE(IJK) = 0.0
        BLN(IJK) = 0.0
        BLNPRE(IJK) = 0.0
        GF(IJK) = 0.0
        GFPRE(IJK) = 0.0
        RHOW(IJK) = 0.0
        QS(IJK) = 0.0
        QG(IJK) = 0.0
        QW(IJK) = 0.0
        FGX(IJK) = 0.0
        FGY(IJK) = 0.0
        FGZ(IJK) = 0.0
        SWPRE(IJK) = 0.0
        SGPRE(IJK) = 0.0
1780    continue
        ENDIF
C
      IPKO = 1  
      IF(IFOAM.EQ.1) THEN
      DO 1111 IJK = 1,IJKM
        IF(IPKO.EQ.1) THEN
           ppp = YK(IJK)*ZK(IJK)+XK(IJK)*ZK(IJK)+XK(IJK)*YK(IJK)
           PKO(IJK) = 3.0*XK(IJK)*YK(IJK)*ZK(IJK)/ppp
        ELSE 
        IF(IPKO.EQ.2) THEN
          aa = XK(IJK)*XK(IJK)
          bb = YK(IJK)*YK(IJK)
          cc = ZK(IJK)*ZK(IJK)
          PKO(IJK) = SQRT(aa+bb+cc)
        ELSE 
          PKO(IJK) = XK(IJK)
          IF(YK(IJK).GT.PKO(IJK)) PKO(IJK)=YK(IJK)
          IF(ZK(IJK).GT.PKO(IJK)) PKO(IJK)=ZK(IJK)
        ENDIF
        ENDIF
1111    CONTINUE
        ENDIF
C
      READ(5,'(A80)') C80
      CALL PFUN(P,PBOT,SO,SW,SG,VG,VS,DP,NSLUGS,IJKM,MPOT,MPWT 
     &         ,MPGT,VP,BO,BW,BG,BS,RSOR,RSWR,RSO,RSWS1,E,AWG
     &         ,AWS,C21,C23,C31,C33,CSP,CSS,BVBP)
C
      STBO  = 0.0
      STBW  = 0.0
      MCFG  = 0.0
      MCFGD = 0.0
      DO 70 ISOL = 1,4
        TSLUG(ISOL) = 0.0
        TSLUGD(ISOL) = 0.0
   70 CONTINUE
C
      IB = 0
      IBS = 0
      DO 120 K = 1,KK
        OIPK = 0.0
        WIPK = 0.0
        GIPK = 0.0
        DGIPK= 0.0
        DO 80 ISOL = 1,4
          SIPK(ISOL) = 0.0
          DSIPK(ISOL) = 0.0
   80   CONTINUE
        DO 100 J = 1,JJ
        DO 100 I = 1,II
          IB = IB + 1
          VPP = VP(IB)
          FF1 = VPP*SO(IB)/BO(IB)
          FF2 = VPP*SW(IB)/BW(IB)
          FF3 = VPP*SG(IB)
          OIPK  = OIPK  + FF1
          WIPK  = WIPK  + FF2
          DO 90 ISOL = 1,NSLUGS
            IBS = IBS + 1
            VSI = VS(IBS)
            SIPK(ISOL) = SIPK(ISOL)  + VSI*FF3/BS(IBS)
            DSIPK(ISOL) = DSIPK(ISOL) + VSI*RSO(IBS)*FF1
            IF(ISOL .EQ. 1) DSIPK(1) = DSIPK(1) + VSI*RSWS1(IB)*FF2
            SL(IBS) = VSI*FF3/BS(IBS)+ VSI*RSO(IBS)*FF1
            IF(ISOL .EQ. 1) SL(IBS) = SL(IBS) + VSI*RSWS1(IB)*FF2
   90     CONTINUE
          VGG = VG(IB)
          GIPK  = GIPK  + VGG*FF3/BG(IB)
          DGIPK = DGIPK + VGG*(RSOR(IB)*FF1+RSWR(IB)*FF2)
          OL(IB) = FF1
          WL(IB) = FF2
          GL(IB) = VGG*(FF3/BG(IB)+RSOR(IB)*FF1+RSWR(IB)*FF2)
  100   CONTINUE
        OIPK  = BBLSCF*OIPK
        WIPK  = BBLSCF*WIPK
        GIPK  = .001*GIPK
        DGIPK = .001*DGIPK
        STBO = STBO + OIPK
        STBW = STBW + WIPK
        MCFG = MCFG + GIPK
        MCFGD = MCFGD + DGIPK
        WRITE(IOCODE,1100) K,.001*OIPK,.001*WIPK,.001*GIPK,.001*DGIPK
 1100 FORMAT(///,1X,'LAYER',I3,' INITIAL FLUID VOLUMES:',
     & /,10X,'OIL IN PLACE (MSTB)',         T50,F15.3,
     & /,10X,'WATER IN PLACE (MSTB)',       T50,F15.3,
     & /,10X,'FREE GAS IN PLACE (MMCF)',    T50,F15.3, 
     & /,10X,'SOLUTION GAS IN PLACE (MMCF)',T50,F15.3)
        DO 110 ISOL = 1,NSLUGS
          SIPK(ISOL) = .001*SIPK(ISOL)
          DSIPK(ISOL) = .001*DSIPK(ISOL)
          TSLUG(ISOL) = TSLUG(ISOL) + SIPK(ISOL)
          TSLUGD(ISOL) = TSLUGD(ISOL) + DSIPK(ISOL)
          WRITE(IOCODE,1110) ISOL,.001*SIPK(ISOL),.001*DSIPK(ISOL)
 1110 FORMAT(/,
     & 10X,'INITIAL SOLVENT',I3,2X,'FREE VOLUME IN PLACE (MMCF) = ',
     & F12.3, 7X,'AMOUNT DISSOLVED (MMCF) = ',F12.3)
  110   CONTINUE
  120 CONTINUE
      WRITE(IOCODE,1115) .001*STBO,.001*STBW,.001*MCFG,.001*MCFGD
 1115 FORMAT(//,1X,'TOTAL INITIAL FLUID VOLUMES IN RESERVOIR:',
     & /,10X,'OIL IN PLACE (MSTB)',         T50,F15.3,
     & /,10X,'WATER IN PLACE (MSTB)',       T50,F15.3,
     & /,10X,'FREE GAS IN PLACE (MMCF)',    T50,F15.3, 
     & /,10X,'SOLUTION GAS IN PLACE (MMCF)',T50,F15.3)
C
      MCFGT = MCFG + MCFGD
      STBOI = STBO
      STBWI = STBW
      MCFGTI = MCFGT
      IF(NSLUGS .GT. 0) THEN
        DO 130 ISOL = 1,NSLUGS
          WRITE(IOCODE,1110) ISOL,.001*TSLUG(ISOL),.001*TSLUGD(ISOL)
  130   CONTINUE
        MCFS1T = TSLUG(1) + TSLUGD(1)
        MCFS2T = TSLUG(2) + TSLUGD(2)
        MCFS3T = TSLUG(3) + TSLUGD(3)
        MCFS4T = TSLUG(4) + TSLUGD(4)
        MCF1TI = MCFS1T
        MCF2TI = MCFS2T
        MCF3TI = MCFS3T
        MCF4TI = MCFS4T
      ENDIF
      IF(IFOAM.EQ.1)THEN
C
      NVQN=0
        CALL MBESF(N,II,JJ,KK,IJKM,DELT,DV, 
     &                   BES,BEB,TOBI,TOBO,TOSMI,TOSMO, 
     &                   QW,QG,CS,BNF,CSI,BNFI,
     &                   SW,FI,ROW,SG,BLN,GF,
     &                   IQN1,IQN2,IQN3,LAYER,KIP,NVQN,NW,idir)
      ENDIF
C
      STBWSI = 0.0
C
      OPR = 0.0
      WPR = 0.0
      GPR = 0.0
      GIR = 0.0
      WIR = 0.0
      S1PR = 0.0
      CS1P = 0.0
      S1IR = 0.0
      CS1I = 0.0
      S2PR = 0.0
      CS2P = 0.0
      S2IR = 0.0
      CS2I = 0.0
      S3PR = 0.0
      CS3P = 0.0
      S3IR = 0.0
      CS3I = 0.0
      S4PR = 0.0
      CS4P = 0.0
      S4IR = 0.0
      CS4I = 0.0
      MBEO = 0.0
      MBEW = 0.0
      MBEG = 0.0
      MBES1 = 0.0
      MBES2 = 0.0
      MBES3 = 0.0
      MBES4 = 0.0
      CMBEO = 0.0
      CMBEW = 0.0
      CMBEG = 0.0
      CMBE1 = 0.0
      CMBE2 = 0.0
      CMBE3 = 0.0
      CMBE4 = 0.0
      PAVG = 0.0
      PAVG0 = 0.0
      IPMAP = 0
      ISOMAP = 0
      ISWMAP = 0
      ISGMAP = 0
      IPBMAP = 0
      IRSMAP = 0
      IS1MAP = 0
      IS2MAP = 0
      IS3MAP = 0
      IS4MAP = 0
      CALL PRTPS2(P,SO,SW,SG,VS,PBOT,RSOR,XS,PN,SON,SWN,SGN,VSN
     &           ,OPR,COP,WPR,CWP,WIR,CWI,GPR,CGP,GIR,CGI,S1PR,CS1P
     &           ,S1IR,CS1I,S2PR,CS2P,S2IR,CS2I,S3PR,CS3P,S3IR,CS3I
     &           ,S4PR,CS4P,S4IR,CS4I,MBEO,MBEW,MBEG,MBES1,MBES2
     &           ,MBES3,MBES4,CMBEO,CMBEW,CMBEG,CMBE1,CMBE2,CMBE3
     &           ,CMBE4,FT,DELT,PAVG,PAVG0,SOMIN,PRECIP,II,JJ,KK
     &           ,IJKM,N,NSLUGS,IPMAP,ISOMAP,ISWMAP,ISGMAP,IPBMAP
     &           ,IRSMAP,IS1MAP,IS2MAP,IS3MAP,IS4MAP,MOBCTL,IOCODE
     &           ,CS,BNF,IFOAM,BES,BEB)
C
C >>>>>>>>> B E G I N N I N G  O F  T I M E - S T E P  L O O P  <<<<<<<<<
C
      DPMC = 2.0*DPMAX
      DSMC = 2.0*DSMAX
      DO 900 N = 1,NMAX
        DO 150 IB = 1,IJKM
          PN(IB) = P(IB)
          PBOTN(IB) = PBOT(IB)
          VPN(IB) = VP(IB)
          SON(IB) = SO(IB)
          SWN(IB) = SW(IB)
          SGN(IB) = SG(IB)
          GOWTN(IB) = GOWT(IB)
          GWWTN(IB) = GWWT(IB)
          GGWTN(IB) = GGWT(IB)
C
          GWSWTN(IB) = GWSWT(IB)
          BON(IB) = BO(IB)
          BWN(IB) = BW(IB)
          BGN(IB) = BG(IB)
          RSORN(IB) = RSOR(IB)
          RSWRN(IB) = RSWR(IB)
          RSWS1N(IB) = RSWS1(IB)
          BVBPN(IB) = BVBP(IB)
          EN(IB) = E(IB)
          AWGN(IB) = AWG(IB)
          C21N(IB) = C21(IB)
          C23N(IB) = C23(IB)
          C31N(IB) = C31(IB)
          C33N(IB) = C33(IB)
          OLN(IB) = OL(IB)
          WLN(IB) = WL(IB)
          GLN(IB) = GL(IB)
          VGGN(IB) = VG(IB)
C
         IF(IFOAM .EQ. 1) THEN
          FGXN(IB) = FGX(IB)
          FGYN(IB) = FGY(IB)
          FGZN(IB) = FGZ(IB)
          SGPREN(IB) = SGPRE(IB)
          SWPREN(IB) = SWPRE(IB)
          ILOOKN(IB) = ILOOK(IB)

          CSN(IB) = CS(IB)
          RESN(IB) = RES(IB)
          BNFN(IB) = BNF(IB)
          GFN(IB) = GF(IB)
          BLNN(IB) = BLN(IB)
          QWS(IB) = QW(IB) 
          QGS(IB) = QG(IB) 
         ENDIF
C 
          QO(IB) = 0.0
          QW(IB) = 0.0
          QG(IB) = 0.0
  150   CONTINUE
C
      IJKMS = NSLUGS*IJKM
        DO 160 IBS = 1,IJKMS
          VSN(IBS) = VS(IBS)
          GSWTN(IBS) = GSWT(IBS)
C
         BSN(IBS) = BS(IBS)
         RSON(IBS) = RSO(IBS)
         AWSN(IBS) = AWS(IBS)
         CSPN(IBS) = CSP(IBS)
         SLN(IBS) = SL(IBS)
         CSSN(IBS) = CSS(IBS)
         VSN(IBS) = VS(IBS)
         GSWTN(IBS) = GSWT(IBS)
         QS1(IBS) = QS(IBS)
         QS(IBS) = 0.
  160   CONTINUE
        IF(MOBCTL .GT. 0) THEN
          DO 170 IB = 1,IJKM
            XSN(IB) = XS(IB)
  170     CONTINUE
        ENDIF
       JFL = JFLOW
       JST = JSTAT
        TOBIN = TOBI
        TOBON = TOBO
        TOSMIN = TOSMI
        TOSMON = TOSMO
        TSLUGN(1) = TSLUG(1)
        TSLUGN(2) = TSLUG(2)
        TSLUGN(3) = TSLUG(3)
        TSLUGN(4) = TSLUG(4)
C
      IF(IFOAM.EQ.1) THEN
      DO 222 ijk = 1,IJKM
         RHOWN(ijk) = RHOW(ijk) 
222   CONTINUE
      ENDIF
C
       DELT0 = DELT
        ETI = FT
        IF(DSMC .LT. DSMAX .AND. DPMC .LT. DPMAX) DELT = DELT*FACT1
C
C     RECURRENT DATA.
C
      IF(FT .GE. FTMAX) THEN
        READ(5,*,END=995) IWREAD,ICHANG,IWLREP,ISUMRY,IPMAP
     &                           ,ISOMAP,ISWMAP,ISGMAP,IPBMAP,IRSMAP
     &                           ,IS1MAP,IS2MAP,IS3MAP,IS4MAP
        READ(5,*) DELT,DTMIN,DTMAX
        IF(IWREAD .GT. 0) then
        CALL NODES2(IFOAM,IOCODE,QVS,IQN1,IQN2,IQN3,NVQN,KSIS
     &               ,PID,PWF,KIP,WELLID,IDIR
     &               ,LAYER,QVO,QVW,QVG,QVT,NW,NWL
     &       ,II,JJ,KK,DX,DY,DZ,XK,YK,ZK,IWM,RW,CSI,BNFI,iswith)
       ENDIF 
        FTMAX = ETI + ICHANG*DELT
      ENDIF
      IF(ETI+DELT .GT. FTMAX) DELT = FTMAX - ETI
      IF(DELT .GT. DTMAX) DELT = DTMAX
      IF(DELT .LT. DTMIN) DELT = DTMIN
		FT = ETI + DELT
      IF(ETI+DELT*0.5 .GE. TMAX) GO TO 995
C 
       DO 195 IW=1,NVQN
       KIPN(IW)=KIP(IW)
195     CONTINUE       
C 
C    REENTRY POINT FOR REPEATED TIME STEP
C
  200 CONTINUE

      DIV1 = 1.0/DELT
      FACT = DELT0*DIV1
      IF(NERR .GT. 0) THEN
        DO 220 IB = 1,IJKM
          GOWT(IB) = FACT*GOWT(IB)
          GWWT(IB) = FACT*GWWT(IB)
          GGWT(IB) = FACT*GGWT(IB)
  220   CONTINUE
        DO 230 IBS = 1,IJKMS
          GSWT(IBS) = FACT*GSWT(IBS)
  230   CONTINUE
      ELSE
        DO 240 IB = 1,IJKM
          GOWT(IB) = 0.0
          GWWT(IB) = 0.0
          GGWT(IB) = 0.0
  240   CONTINUE
        DO 250 IBS = 1,IJKMS
          GSWT(IBS) = 0.0
  250   CONTINUE
      ENDIF
      IF(MOBCTL .GT. 0) THEN
        DO 260 IB = 1,IJKM
          GWSWT(IB) = FACT*GWSWT(IB)
  260   CONTINUE
      ENDIF
C
      IF(N .EQ. NMAX) GOTO 995
      IT = 1
      IF(KSW2 .GT. 0) WRITE(6,1200) FT
 1200 FORMAT(5X,'ELAPSED TIME = ',F8.2,' DAYS')
      IF(KSW1 .GT. 0) WRITE(8,1200) FT
C
C
      CALL PSFUN(P,PBOT,SO,SW,SG,VG,VS,XS,BO,BW,BG,BS,RSOR,RSWR
     &          ,RSO,RSWS1,BETA,SORM,SCI,REDK,ISOLID,NSLUGS
     &          ,IJKM,MSATW,MSATG,MPGT,NOMOB,MOBCTL,DP,OK,WK,GK
     &          ,UO,UW,UG,US,RHOO,RHOW,RHOG,RHOS,PCW,PCG
     &          ,NTABS,NTAB)
C
       IF(N.EQ.1) THEN
       DO 223 ijk = 1,IJKM
         RHOWN(ijk) = RHOW(ijk) 
223    CONTINUE
       ENDIF

C 
      IF(IFOAM.EQ.1) THEN

C 
      CALL CUV (II,JJ,KK,IJKM,DX,DY,DZ,
     &           FWX,FWY,FWZ,UVW)
C
C     CONVERT WATER WELL RATE FROM STANDER CONDITION (SCF/DAY) TO LBM/DAY
C
	  DO 232 ijk = 1,IJKM 
          QWS(ijk) = RHOSCW *QWS(ijk)
232     CONTINUE 
         
	CALL CUV (II,JJ,KK,IJKM,DX,DY,DZ,
     &         FGX,FGY,FGZ,UVG)

C
       IBS1=0
       DO 99 JLK=1,KK
       DO 99 JLJ=1,JJ
       DO 99 JLI=1,II
       IBS1=IBS1+1
       ISS=NSLUGS*(IBS1-1)+1
       VMUG(IBS1)=US(ISS)
       QGP(IBS1) = BG(IBS1)*QGS(IBS1) + BS(ISS)*QS1(ISS)
99       CONTINUE
C
      CALL FOAM(
     &   DX,DY,DZ,DV,DELT,II,JJ,KK,JFLOW,JSTAT,ETI,
     &   CSI,CS,CSPRE,
     &   RHOW,RHOWN,UVW,FWX,FWY,FWZ,
     &   QWS,SWPRE,SW,FI,
     &   BNFI,BNFPRE,BNF,BLNPRE,BLN,GF,GFPRE,
     &   QGP,SO,SG,SGPRE,UVG,FGX,FGY,FGZ,
     &   VMUG,GK,VC,PKO,
     &   IQN1,IQN2,IQN3,LAYER,KIP,NVQN,NW,
     &   N, BES,BEB,TOBI,TOBO,TOSMI,TOSMO,RES,
     &   idir,jchfm,AQI,QI,AU3,AL3,ILOOK,ILOOKO,
     &     WK,UW,CRUX,CRUY,CRUZ,AU1,AU2,AL1,AL2,AD)
C
       IBS1=0
       DO 97 JLK=1,KK
       DO 97 JLJ=1,JJ
       DO 97 JLI=1,II
       IBS1=IBS1+1
       US(NSLUGS*(IBS1-1)+1)=VMUG(IBS1)
97       CONTINUE
      ENDIF
C
      IF(NVQN .GT. 0) 
     &  CALL QRATE2(P,VG,VS,BO,BW,BG,BS,RSOR,RSWR,RSO,RSWS1,UO,UW,UG,US
     &             ,OK,WK,GK,GM1,GM2,GM3,GM4,QVS,IQN1,IQN2,IQN3
     &             ,NVQN,NSLUGS,NW,II,JJ,IJKM,QO,QW,QG,QS
     &             ,PID,PWF,PWFC,KIP,GMO,GMW,GMG,IDIR,PMAXT
     &             ,LAYER,QVO,QVW,QVG,QVT,NWL,ISWITH)
C
C     CALCULATE SEVEN DIAGONAL MATRIX FOR PRESSURE SOLUTION
C
      CALL COEF(P,VP,VG,VS,XS,BO,BW,BG,BS,RSOR,RSWR,RSO
     &         ,RSWS1,OK,WK,GK,UO,UW,UG,US,RHOO,RHOW,RHOG,RHOS
     &         ,PCW,PCG,QO,QW,QG,QS,AWG,AWS,EL,TX,TY,TZ,DIV1
     &         ,RSWGHT,II,JJ,KK,NSLUGS,IJKM,MOBCTL
     &         ,GOWT,GWWT,GGWT,GSWT,GWSWT,AW,AE,AS,AN,AT,AB,E,B
     &         ,OX,OY,OZ,WX,WY,WZ,GX,GY,GZ,SX,SY,SZ,WSX,WSY,WSZ
     &         ,FWX,FWY,FWZ,FGX,FGY,FGZ) 
C
      IF(IFOAM.EQ.1) THEN
       DO 111 IJK = 1,IJKM
          SWPRE(IJK) = SW(IJK)
          SGPRE(IJK) = SG(IJK)
111    CONTINUE
      ENDIF
C
C     REENTRY POINT FOR CONVERGENCE
C
280   CONTINUE
C
C     MODIFY MATRIX ELEMENTS FOR WELLS UNDER IMPLICIT CONTROL.
C
      IF(NVQN .GT. 0) 
     & CALL PRATEI(VG,VS,BO,BW,RSOR,RSWR,RSO,RSWS1,AWG,AWS,GM1
     &            ,GM2,GM3,GM4,IQN1,IQN2,IQN3,NVQN,NSLUGS,NW
     &            ,II,JJ,IJKM,E,IDIR
     &            ,KIP,GMO,GMW,GMG,LAYER,NWL)
      ITTOT = ITTOT + 1
C
C     CALCULATE NEW PRESSURE DISTRIBUTION
C
      IF(KSOL .EQ. 1) THEN
C
C     WORK ARRAYS: A1, PVEC, QVEC
C
        CALL SLSOR(AW,AE,AS,AN,AT,AB,E,B,OMEGA,TOL
     &            ,LINK,NLBW,NRBW,IXA,II,JJ,KK,IJKM,NCYCLE,MITER
     &            ,IOCODE,KSW1,KSW3,MAXROW,MAXBND
     &            ,PVEC,A1,QVEC,AMAT,ROW,DP)
      ELSEIF(KSOL .EQ. 2) THEN
        CALL LSOR(AW,AE,AS,AN,AT,AB,E,B,OMEGA,TOL
     &           ,II,JJ,KK,NCYCLE,MITER,IOCODE,KSW1,KSW3
     &           ,UM,AZL,BZL,CZL,DZL,UZL,BET,GMMA,W,DP)
      ELSEIF(KSOL .EQ. 3) THEN
        CALL D4GAUS(AW,E,B,LINK,NLBW,NRBW,IXA,INAT,IJKM,MAX1,MAXA
     &             ,MAXROW,AMAT,ROW,DP)
      ELSEIF(KSOL .EQ. 4) THEN
C
C     WORK ARRAYS: A1, A2, A3, PVEC, QVEC
C     WORK ARRAYS: AU1, AU2, AU3, AL1, AL2, AL3, QI, AQI, AD
C
        CALL CMAT(AW,AE,AS,AN,AT,AB,E,B,TOL,II,JJ,KK,IJKM,MITER
     &           ,IOCODE,KSW1,KSW3,QI,AQI,AL3,AL2,AL1,AD,AU1,AU2
     &           ,AU3,PVEC,QVEC,A1,A2,A3,DP)
      ENDIF
C
C     UPDATE IMPLICIT RATES.
C
      IF(NVQN .NE. 0) 
     & CALL PRATEO(DP,GM1,GM2,GM3,GM4,IQN1,IQN2,IQN3,NVQN,NSLUGS
     &           ,NW,II,JJ,IJKM,QO,QW,QG,QS,GOWT,GWWT,GGWT
     &           ,GSWT,IDIR,KIP,GMO,GMW,GMG,LAYER,NWL)
      CALL UPDATE(VP,BO,BW,BG,BS,RSOR,RSWR,RSO,RSWS1,OX,OY,OZ,WX
     &           ,WY,WZ,GX,GY,GZ,SX,SY,SZ,WSX,WSY,WSZ,DP,C21,C23
     &           ,C31,C33,CSP,CSS,BVBP,DELT,NSLUGS,II,JJ,KK,IJKM
     &           ,MOBCTL,P,PBOT,SO,SW,SG,VG,VS,GOWT,GWWT,GGWT,GSWT
     &           ,GWSWT)
      CALL PFUN(P,PBOT,SO,SW,SG,VG,VS,DP,NSLUGS,IJKM,MPOT,MPWT
     &         ,MPGT,VP,BO,BW,BG,BS,RSOR,RSWR,RSO,RSWS1,E,AWG
     &         ,AWS,C21,C23,C31,C33,CSP,CSS,BVBP)
      CALL RESID(VP,SO,SW,SG,BO,BW,BG,BS,RSOR,RSWR,RSO,RSWS1
     &          ,GOWT,GWWT,GGWT,GSWT,OX,OY,OZ,WX,WY,WZ,GX,GY,GZ
     &          ,SX,SY,SZ,AWG,AWS,DELT,DIV1,RTOL,NSLUGS,II,JJ,KK
     &          ,IJKM,KSW1,KSW2,OL,WL,GL,SL,VG,VS,AW,AE,AS,AN,AT
     &          ,AB,B,E,TSLUG,SCFO,SCFW,SCFG,SCFGD,RESVOL,RMAX)
C
      IF(RMAX .GT. RTOL) THEN
        IT = IT + 1
        IF(IT .LE. ITMAX) GOTO 280
      ENDIF
C
C     AUTO. TIME STEP CONTROL CALC. OF PRESSURE AND SAT. MAXIMA.
C
      DPMC = 0.0
      DSMC = 0.0
      IBS = 0
      DO 400 IB = 1,IJKM
        DPO = ABS(P(IB)-PN(IB))
        IF(DPO .GT. DPMC) DPMC = DPO
        DSO = ABS(SO(IB)-SON(IB))
        IF(DSO .GT. DSMC) DSMC = DSO
        DSW = ABS(SW(IB)-SWN(IB))
        IF(DSW .GT. DSMC) DSMC = DSW
        VGN = 1.0
        DO 375 ISOL = 1,NSLUGS
          IBS = IBS + 1
          VGN = VGN - VSN(IBS)
          DSV = ABS(VS(IBS)*SG(IB)-VSN(IBS)*SGN(IB))
          IF(DSV .GT. DSMC) DSMC = DSV
  375   CONTINUE
        DSG = ABS(VG(IB)*SG(IB)-VGN*SGN(IB))
        IF(DSG .GT. DSMC) DSMC = DSG
       DBN = ABS(BNF(IB) - BNFN(IB)) / 1e7
        IF(DBN .GT. DSMC) DSMC = DBN
       DCS = ABS(CS(IB) - CSN(IB)) / 0.1
        IF(DCS .GT. DSMC) DSMC = DCS
  400 CONTINUE
C
C     NOTE THAT TIME-STEP WILL BE REPEATED ONLY IF -
C     (1) Maximum saturation or pressure change is exceeded, "AND"
C     (2) DELT > DTMIN  "AND"  
C     (3) FACT2 < 1.0
C
      IF(DELT .GT. 1.001*DTMIN .AND. FACT2 .LT. 1.0) THEN
        IF(DSMC .GT. DSMAX .OR. DPMC .GT. DPMAX) THEN
          DELT = DELT*FACT2
          IF(DELT .LT. DTMIN) DELT = DTMIN  
          FT = ETI + DELT
          WRITE(6,1440) ETI,DELT
          WRITE(2,1440) ETI,DELT
 1440 FORMAT(//,5X,'AT TIME = ',F9.3,' DELT REDUCED TO ',F7.3)
          IF(KSW1 .GT. 0) WRITE(8,1440) ETI,DELT
C
C     RESET ARRAYS AND REPEAT TIME STEP
C
           IBS=0
          DO 450 IB = 1,IJKM
            P(IB) = PN(IB)
            PBOT(IB) = PBOTN(IB)
            VP(IB) = VPN(IB)
            SO(IB) = SON(IB)
            SW(IB) = SWN(IB)
            SG(IB) = SGN(IB)
            GOWT(IB) = GOWTN(IB)
            GWWT(IB) = GWWTN(IB)
            GGWT(IB) = GGWTN(IB)
            GWSWT(IB) = GWSWTN(IB)
            BO(IB) = BON(IB) 
            BW(IB) = BWN(IB) 
            BG(IB) = BGN(IB) 
            RSOR(IB) = RSORN(IB) 
            RSWR(IB) = RSWRN(IB) 
            RSWS1(IB) = RSWS1N(IB) 
            BVBP(IB) = BVBPN(IB) 
            E(IB) = EN(IB) 
            AWG(IB) = AWGN(IB) 
            C21(IB) = C21N(IB) 
            C23(IB) = C23N(IB) 
            C31(IB) = C31N(IB) 
            C33(IB) = C33N(IB) 
            OL(IB) = OLN(IB) 
            WL(IB) = WLN(IB) 
            GL(IB) = GLN(IB) 
         IF(IFOAM .EQ. 1 .AND. N .GT. 1) THEN
           ILOOK(IB) = ILOOKN(IB)
           SGPRE(IB) = SGPREN(IB)
           SWPRE(IB) = SWPREN(IB)
            FGX(IB) = FGXN(IB)
            FGY(IB) = FGYN(IB)
            FGZ(IB) = FGZN(IB)
            CS(IB) = CSN(IB)
            BNF(IB) = BNFN(IB)
            GF(IB) = GFN(IB)
            RES(IB) = RESN(IB)
            BLN(IB) = BLNN(IB)
           QWS(IB) = QW(IB)
           QGS(IB) = QG(IB)
             ENDIF
            VG(IB) = VGGN(IB)
            QO(IB) = 0.0
            QW(IB) = 0.0
            QG(IB) = 0.0
            IF(MOBCTL .GT. 0) then
               XS(IB) = XSN(IB)
             endif
  450     CONTINUE
          DO 425 IBS = 1,IJKMS
              BS(IBS) = BSN(IBS) 
              RSO(IBS) = RSON(IBS) 
            VS(IBS) = VSN(IB)
            GSWT(IBS) = GSWTN(IBS)
              AWS(IBS) = AWSN(IBS) 
              SL(IBS) = SLN(IBS)
              CSP(IBS) = CSPN(IBS) 
              CSS(IBS) = CSSN(IBS) 
              VS(IBS) = VSN(IBS)
              GSWT(IBS) = GSWTN(IBS)
              QS1(IBS) = QS(IBS)
              QS(IBS) = 0.0
  425     CONTINUE
         JFLOW = JFL 
         JSTAT = JST
          IF(MOBCTL .GT. 0) THEN
            DO 426 IB = 1,IJKM
                XS(IB) = XSN(IB)
  426       CONTINUE
          ENDIF
        TOBI = TOBIN
        TOBO = TOBON
        TOSMI = TOSMIN
        TOSMO = TOSMON
          TSLUG(1) = TSLUGN(1) 
          TSLUG(2) = TSLUGN(2) 
          TSLUG(3) = TSLUGN(3) 
          TSLUG(4) = TSLUGN(4) 
C 
       DO 196 IW=1,NVQN
       KIP(IW)=KIPN(IW)
196     CONTINUE       
C 
          GOTO 200
        ENDIF
      ENDIF
C
C     COMPUTE SURFACTANT CONCENTRATION VIA MATERIAL BALANCE
C
      IF(MOBCTL .GT. 0) THEN
        SCFWS = 0.0
        WPS = 0.0
        WIS = 0.0
        DO 500 IB = 1,IJKM
          QWSS = 0.0
          IF(QW(IB) .LT. 0.0 .AND. KSIS .EQ. 1) THEN
            QWSS = QW(IB)
            WIS = WIS - QWSS
          ELSEIF(QW(IB) .GT. 0.0) THEN
            QWSS = XS(IB)*QW(IB)
            WPS = WPS + QWSS
          ENDIF
          GWSWT(IB) = GWSWT(IB) + QWSS
          XS(IB) = -DELT*GWSWT(IB)/WL(IB)
          SCFWS = SCFWS - DELT*GWSWT(IB)          
  500   CONTINUE
        STBWS = BBLSCF*SCFWS
        CWSP = CWSP + DELT*BBLSCF*WPS
        CWSI = CWSI + DELT*BBLSCF*WIS
        CMBEWS = 0.0
        DENOMC = STBWSI - CWSP + CWSI
        IF(ABS(DENOMC) .GE. 1.E-07) CMBEWS = 100.0*(STBWS/DENOMC-1.0)
      ENDIF
C
C     COMPUTE PRECIPITATE THIS TIME STEP
C
      IF(NSLUGS .GT. 0 .AND. SOMIN .GT. 0.0) THEN
        VSOLT = 0.0
        IB = 0
        DO 575 I = 1,II
          DO 550 J = 1,JJ
            DO 525 K = 1,KK
              IB = IB + 1
              IF(SO(IB) .LE. SOMIN .AND. ISOLID(IB) .EQ. -1) THEN
                VSOLT = VSOLT + VP(IB)*SO(IB)/BO(IB)
                ISOLID(IB) = N
                WRITE(6,1525) I,J,K
              ENDIF
  525       CONTINUE
  550     CONTINUE
  575   CONTINUE
        PRECIP = PRECIP + VSOLT
      ENDIF
      STBON = STBO
      STBWN = STBW
      MCFGN = MCFGT
      STBO  = BBLSCF*SCFO
      STBW  = BBLSCF*SCFW
      MCFGT = .001*(SCFG+SCFGD)
      IF(NSLUGS .GT. 0) THEN
        MCFS1N = MCFS1T
        MCFS2N = MCFS2T
        MCFS3N = MCFS3T
        MCFS4N = MCFS4T
C
C     TSLUG FROM RESID IS TOTAL SOLVENT IN SCF
C
        MCFS1T = .001*TSLUG(1)
        MCFS2T = .001*TSLUG(2)
        MCFS3T = .001*TSLUG(3)
        MCFS4T = .001*TSLUG(4)
      ENDIF
C
C     WELL REPORT (ALL RATE & PRESSURE DATA APPLICABLE THIS STEP)
C 
        IJ = 0
        TOR = 0.0
        TGR = 0.0
        TWR = 0.0
        TOC = 0.0
        TGC = 0.0
        TWC = 0.0
        DO 700 IW = 1,NVQN
          IF(KIP(IW) .GT. 10) GOTO 700
          IF(KIP(IW) .LE. -4 .AND. KIP(IW) .GE. -7) GOTO 700
          IF(KIP(IW) .LE. -14) GOTO 700
        TORJL(IW) = 0.0
        TGRJL(IW) = 0.0
        TWRJL(IW) = 0.0
        TOCJL(IW) = 0.0
        TGCJL(IW) = 0.0
        TWCJL(IW) = 0.0
       GORJL(IW)=0.0
       WORJL(IW)=0.0
         IF(IDIR(IW).EQ.3) THEN 
        IQ1 = IQN1(IW) 
        IQ2 = IQN2(IW)
        IQ3 = IQN3(IW)
        ELSEIF(IDIR(IW).EQ.2) THEN 
           IQ1=IQN3(IW)	 
           IQ2=IQN1(IW)
           IQ3=IQN2(IW)	
        ELSE 
           IQ1=IQN2(IW)
           IQ2=IQN3(IW)
           IQ3=IQN1(IW)
        ENDIF
        LAY = IQ3 + (LAYER(IW)-1)
          DO 650 K = IQ3,LAY
            IJ = IJ + 1
          IF (IDIR(IW).EQ.3) THEN
          IB = IQ1 + II*(IQ2-1+JJ*(K-1))
          ELSEIF(IDIR(IW).EQ.2) THEN
             IB=IQ2+II*(K-1+JJ*(IQ1-1))
          ELSE
             IB=K+II*(IQ1-1+JJ*(IQ2-1))
          ENDIF
            QOO = BBLSCF*QO(IB)
            QWW = BBLSCF*QW(IB)
            QGG = .001*QG(IB)
            CUMO(IW,K) = CUMO(IW,K) + .001*DELT*QOO
            CUMW(IW,K) = CUMW(IW,K) + .001*DELT*QWW
            CUMG(IW,K) = CUMG(IW,K) + .001*DELT*QGG
            IF(IWLREP .EQ. 0) GOTO 650
              IF(IJ .EQ.1) then
              WRITE(IOCODE,1620) FT
              WRITE(IOCODE,1625)
            ENDIF      
            GOR = 0.0
            WOR = 0.0
            IF(QOO .GT. 0.0) THEN
              GOR = 1000.*QGG/QOO
              WOR = QWW/QOO
            ENDIF
             IF (IDIR(IW).EQ.3) THEN
            WRITE(IOCODE,1630) WELLID(IW),IQ1,IQ2,K,PWFC(IW,K)
     &                       ,PWF(IW,K),PID(IW,K),QOO,QGG,QWW,GOR,WOR
     &                       ,CUMO(IW,K),CUMG(IW,K),CUMW(IW,K)
            ELSEIF(IDIR(IW).EQ.2) THEN
            WRITE(IOCODE,1630) WELLID(IW),IQ2,K,IQ1,PWFC(IW,K)
     &                       ,PWF(IW,K),PID(IW,K),QOO,QGG,QWW,GOR,WOR
     &                       ,CUMO(IW,K),CUMG(IW,K),CUMW(IW,K)
           ELSE
            WRITE(IOCODE,1630) WELLID(IW),K,IQ1,IQ2,PWFC(IW,K)
     &                       ,PWF(IW,K),PID(IW,K),QOO,QGG,QWW,GOR,WOR
     &                       ,CUMO(IW,K),CUMG(IW,K),CUMW(IW,K)
            ENDIF
            TOR = TOR + QOO
            TGR = TGR + QGG
            TWR = TWR + QWW
            TOC = TOC + CUMO(IW,K)
            TGC = TGC + CUMG(IW,K)
            TWC = TWC + CUMW(IW,K)
               TORJL(IW)=TORJL(IW)+QOO
               TGRJL(IW)=TGRJL(IW)+QGG
               TWRJL(IW)=TWRJL(IW)+QWW
               TOCJL(IW)=TOCJL(IW)+CUMO(IW,K)
               TGCJL(IW)=TGCJL(IW)+CUMG(IW,K)
               TWCJL(IW)=TWCJL(IW)+CUMW(IW,K)
  650     CONTINUE
            IF(TORJL(IW) .GT. 0.0) THEN
              GORJL(IW) = 1000.*TGRJL(IW)/TORJL(IW)
              WORJL(IW) = TWRJL(IW)/TORJL(IW)
              ENDIF
  700   CONTINUE

        IF(IWLREP .EQ. 1) THEN
       write(IOCODE,1652)
       DO 701 IW=1,NVQN
       WRITE(IOCODE,1651) WELLID(IW),TORJL(IW),TGRJL(IW),
     $                     TWRJL(IW), GORJL(IW),WORJL(IW),
     $                        TOCJL(IW), TGCJL(IW),TWCJL(IW)
701       CONTINUE
       WRITE(IOCODE,1650) TOR,TGR,TWR,TOC,TGC,TWC
       ENDIF
c
C
C     Solvent Injection/Production report
C
        IF(NSLUGS .GT. 0) THEN
          IJ = 0
          TS1R = 0.0
          TS2R = 0.0
          TS3R = 0.0
          TS4R = 0.0
          TS1C = 0.0
          TS2C = 0.0
          TS3C = 0.0
          TS4C = 0.0
          DO 800 IW = 1,NVQN
            IF(KIP(IW) .EQ. 2 .OR. KIP(IW) .EQ. 3) GOTO 800
            IF(KIP(IW) .EQ. -2 .OR. KIP(IW) .EQ. -3) GOTO 800
            IF(KIP(IW) .EQ. -12 .OR. KIP(IW) .EQ. -13) GOTO 800
        IF(IDIR(IW).EQ.3) THEN
        IQ1 = IQN1(IW)
        IQ2 = IQN2(IW)
        IQ3 = IQN3(IW)
        ELSEIF(IDIR(IW).EQ.2) THEN
           IQ1=IQN3(IW)
           IQ3=IQN2(IW)
           IQ2=IQN1(IW)
        ELSE
           IQ2=IQN3(IW)
           IQ1=IQN2(IW)
           IQ3=IQN1(IW)
        ENDIF
        LAY = IQ3 + (LAYER(IW)-1)
          DO 750 K = IQ3,LAY
              IJ  = IJ + 1
          IF (IDIR(IW).EQ.3) THEN
          IB = IQ1 + II*(IQ2-1+JJ*(K-1))
          ELSEIF(IDIR(IW).EQ.2) THEN
             IB=IQ2+II*(K-1+JJ*(IQ1-1)) 
          ELSE
             IB=K+II*(IQ1-1+JJ*(IQ2-1))
          ENDIF
              IBS = NSLUGS*(IB-1)
              QSS1 = .001*QS(IBS+1)
              CUMS1(IW,K) = CUMS1(IW,K) + QSS1*DELT*.001
              IF(NSLUGS .GE. 2) THEN
                QSS2 = .001*QS(IBS+2)
                CUMS2(IW,K) = CUMS2(IW,K) + QSS2*DELT*.001
              ELSE
                QSS2 = 0.0
              ENDIF
              IF(NSLUGS .GE. 3) THEN
                QSS3 = .001*QS(IBS+3)
                CUMS3(IW,K) = CUMS3(IW,K) + QSS3*DELT*.001
              ELSE
                QSS3 = 0.
              ENDIF
              IF(NSLUGS .EQ. 4) THEN
                QSS4 = .001*QS(IBS+4)
                CUMS4(IW,K) = CUMS4(IW,K) + QSS4*DELT*.001
              ELSE
                QSS4 = 0.0
              ENDIF
              IF(IWLREP .EQ. 0) GOTO 750
              IF(IJ .EQ. 1) THEN
                WRITE(IOCODE,1700) FT
                WRITE(IOCODE,1710)
              ENDIF
              IF (IDIR(IW).EQ.3) THEN
              WRITE(IOCODE,1720) WELLID(IW),IQ1,IQ2,K,PWFC(IW,K)
     &                          ,PWF(IW,K),PID(IW,K),QSS1,QSS2,QSS3
     &                          ,QSS4,CUMS1(IW,K),CUMS2(IW,K)
     &                          ,CUMS3(IW,K),CUMS4(IW,K)
               ELSEIF(IDIR(IW).EQ.2) THEN
              WRITE(IOCODE,1720) WELLID(IW),IQ2,K,IQ1,PWFC(IW,K)
     &                          ,PWF(IW,K),PID(IW,K),QSS1,QSS2,QSS3
     &                          ,QSS4,CUMS1(IW,K),CUMS2(IW,K)
     &                          ,CUMS3(IW,K),CUMS4(IW,K) 
              ELSE
              WRITE(IOCODE,1720) WELLID(IW),K,IQ1,IQ2,PWFC(IW,K)
     &                          ,PWF(IW,K),PID(IW,K),QSS1,QSS2,QSS3
     &                          ,QSS4,CUMS1(IW,K),CUMS2(IW,K)
     &                          ,CUMS3(IW,K),CUMS4(IW,K)
              ENDIF
C
              TS1R = TS1R + QSS1
              TS2R = TS2R + QSS2
              TS3R = TS3R + QSS3
              TS4R = TS4R + QSS4
              TS1C = TS1C + CUMS1(IW,K)
              TS2C = TS2C + CUMS2(IW,K)
              TS3C = TS3C + CUMS3(IW,K)
              TS4C = TS4C + CUMS4(IW,K)
  750       CONTINUE
  800     CONTINUE
          IF(IWLREP .EQ. 1) WRITE(IOCODE,1825) TS1R,TS2R,TS3R,TS4R
     &                                        ,TS1C,TS2C,TS3C,TS4C
        ENDIF
       IF(IWLREP .EQ. 1)IWLREP=0
C
C.... Calculate material balance errors & average reservoir pressure
C
      CALL MATBL2(PN,P,VP,QO,QW,QG,QS,STBO,STBW,MCFGT,MCFS1T,MCFS2T
     &           ,MCFS3T,MCFS4T,STBON,STBWN,MCFGN,MCFS1N,MCFS2N
     &           ,MCFS3N,MCFS4N,DELT,RESVOL,NSLUGS,IJKM
     &           ,COP,CWP,CGP,CS1P,CS2P,CS3P,CS4P,CWI,CGI,CS1I,CS2I
     &           ,CS3I,CS4I,OPR,WPR,GPR,S1PR,S2PR,S3PR,S4PR,WIR,GIR
     &           ,S1IR,S2IR,S3IR,S4IR,MBEO,MBEW,MBEG,MBES1,MBES2,MBES3
     &           ,MBES4,PAVG0,PAVG)
C
C**** CALCULATE CUMULATIVE MATERIAL BALANCES FOR PRINTOUT IN PRTPS2
C
      CMBEO = 0.0
      DENOM = STBOI - COP
      IF(ABS(DENOM) .GT. 1.E-07) CMBEO = 100.0*(STBO/DENOM - 1.0)
      CMBEW = 0.0
      DENOM = STBWI - CWP + CWI
      IF(ABS(DENOM) .GT. 1.E-07) CMBEW = 100.0*(STBW/DENOM - 1.0)
      CMBEG = 0.0
      DENOM = MCFGTI - CGP + CGI
      IF(ABS(DENOM) .GT. 1.E-07 .AND. MCFGT .GT. 100.)
     &      CMBEG = (MCFGT/DENOM - 1.0) * 100.0
      IF(NSLUGS .GT. 0) THEN
        CMBE1 = 0.0
        DENOM = MCF1TI - CS1P + CS1I
        IF(ABS(DENOM) .GE. 1.E-07 .AND. MCFS1T .GT. 100.) 
     &         CMBE1 = 100.0*(MCFS1T/DENOM-1.0)
        IF(NSLUGS .EQ. 1) GOTO 850
        CMBE2 = 0.0
        DENOM = MCF2TI - CS2P + CS2I
        IF(ABS(DENOM) .GE. 1.E-07 .AND. MCFS2T .GT. 100.) 
     &         CMBE2 = 100.0*(MCFS2T/DENOM-1.0)
        IF(NSLUGS .EQ. 2) GOTO 850
        CMBE3 = 0.0
        DENOM = MCF3TI - CS3P + CS3I
        IF(ABS(DENOM) .GE. 1.E-07 .AND. MCFS3T .GT. 100.)
     &         CMBE3 = 100.0*(MCFS3T/DENOM-1.0)
        IF(NSLUGS .EQ. 3) GOTO 850
        CMBE4 = 0.0
        DENOM = MCF4TI - CS4P + CS4I
        IF(ABS(DENOM) .GE. 1.E-07 .AND. MCFS4T .GT. 100.)
     &         CMBE4 = 100.0*(MCFS4T/DENOM-1.0)
      ENDIF
  850 CONTINUE
      TGOR = 0.0
      WOR = 0.0
      IF(OPR .GT. 1.E-6) THEN
        TGOR = 1000.*(GPR+S1PR+S2PR+S3PR+S4PR)/OPR
        S1OR =1000.*S1PR/OPR
        WOR = WPR/OPR
      ENDIF
      IF(WOR .GT. WORMAX) THEN
		WRITE(IOCODE,1900)
		PRINT *,""
		PRINT *,"MAXIMUM WOR HAS BEEN EXCEEDED."
		PRINT *,"SIMULATION IS BEING TERMINATED."
		PRINT *, "Please check the results."
		PRINT *,""
		STOP
      ENDIF
      IF(TGOR .GT. GORMAX) THEN
        WRITE(IOCODE,1910)
		PRINT *,""
		PRINT *,"MAXIMUM GOR HAS BEEN EXCEEDED."
		PRINT *,"SIMULATION IS BEING TERMINATED."
		PRINT *, "Please check the results."
		PRINT *,""
        STOP
      ENDIF
      IF(PAVG .LT. PAMIN) THEN
        WRITE(IOCODE,1920)
		PRINT *,""
		PRINT *,"PAVG IS LESS THAN PAMIN."
		PRINT *,"SIMULATION IS BEING TERMINATED."
		PRINT *, "Please check the results."
		PRINT *,""
        STOP
      ENDIF
      IF(PAVG .GT. PAMAX) THEN
        WRITE(IOCODE,1925)
		PRINT *,""
		PRINT *,"PAVG IS GREATER THAN PAMAX."
		PRINT *,"SIMULATION IS BEING TERMINATED."
		PRINT *, "Please check the results."
		PRINT *,""
        STOP
      ENDIF
C
      IOOO=0
	DO 11111 IB=1,II*JJ*KK
        IF(P(IB).GT.PMAXT.OR.P(IB).LT.0.0)THEN
          WRITE(6,22222)IB,P(IB)
22222     FORMAT(' P < 0  OR  P > PMAXT  ERROR : P(',I4,') = ',F12.4)
          IOOO=IOOO+1
        ENDIF
11111 CONTINUE
C
	IF(IOOO.GT.0) THEN
		PRINT *,""
		PRINT *,"WARNING: P < 0  OR  P > PMAXT."
		PRINT *,"SIMULATION IS BEING TERMINATED."
		PRINT *, "Please check the results."
		PRINT *,""
		STOP
	ENDIF 
C
C     SUMMARY REPORT.
C
      IF(ISUMRY .NE. 0) THEN
        CALL PRTPS2(P,SO,SW,SG,VS,PBOT,RSOR,XS,PN,SON,SWN,SGN,VSN
     &      ,OPR,COP,WPR,CWP,WIR,CWI,GPR,CGP,GIR,CGI,S1PR,CS1P
     &      ,S1IR,CS1I,S2PR,CS2P,S2IR,CS2I,S3PR,CS3P,S3IR,CS3I
     &      ,S4PR,CS4P,S4IR,CS4I,MBEO,MBEW,MBEG,MBES1,MBES2
     &      ,MBES3,MBES4,CMBEO,CMBEW,CMBEG,CMBE1,CMBE2,CMBE3
     &      ,CMBE4,FT,DELT,PAVG,PAVG0,SOMIN,PRECIP,II,JJ,KK
     &      ,IJKM,N,NSLUGS,IPMAP,ISOMAP,ISWMAP,ISGMAP,IPBMAP
     &      ,IRSMAP,IS1MAP,IS2MAP,IS3MAP,IS4MAP,MOBCTL,IOCODE
     &      ,CS,BNF,IFOAMB,BES,BEB)
        ISUMRY = 0
        IF(MOBCTL .GT. 0) 
     &    WRITE(IOCODE,1950) STBWSI,CWSI,CWSP,DENOMC,STBWS,CMBEWS
      ENDIF
      IF(N.EQ.1) WRITE(7,1960)
        TGPR=GPR+S1PR+S2PR+S3PR+S4PR
        TCGP=CGP+CS1P+CS2P+CS3P+CS4P
      WRITE(7,1970) N,FT,OPR,COP,WPR,CWP,WOR,TGPR,TCGP,TGOR
     &             ,S1PR,CS1P,S1OR
1960  FORMAT(3X,'TIME',2X,'TIME',4X,'OPR',5X,'CUMOIL',7X,'WPR',5X,
     &'CUMWAT',5X,'WOR',5X,'GPR',7X,'CUMGAS',4X,'GOR',7X,'S1PR',8X,
     &'CUMS1',3X,'S1OR',/,
     & 3X,'STEP',2X,'DAYS',3X,'STB/D',5X,'STB',8X,'STB/D',5X,'STB',
     & 5X,'STB/STB',
     & 2X,'MCF/D',7X,'MCF',4X,'SCF/STB',5X,'MCF/D',8X,'MCF',2X,
     & 'SCF/STB',/
     &            ,3X,'====',2X,'====','  ======','    ======',2X,
     &'    =====','    ======','   =======','  ===== ','     ====== ',
     &' ======= ','    ===== ','      =====',' ======= ')
1970  FORMAT(I5,F7.1,F9.1,F11.0,F9.1,F11.0,F9.1,F9.1,F12.0,F8.0
     &      ,F9.1,F12.0,F8.0)
C
900   CONTINUE
C-------------------------------------------------------------------
C >>>>>>>>>>>>>>  E N D  O F  T I M E - S T E P  L O O P  <<<<<<<<<<<<
C                 ======================================
  995 CONTINUE
      WRITE(6,1995) N,ITTOT
 1995 FORMAT(//,5X,'TOTAL TIME STEPS = ',I5,/
     &         ,5X,'TOTAL ITERATIONS = ',I5)
      IF(KSW1 .GT. 0) WRITE(8,1995) N,ITTOT
      RETURN
 1525   FORMAT(/1X,'OIL PERMEABILITY IN BLOCK ',3(1X,I3)
     &        ,' IS BEING SET TO ZERO TO SIMULATE SOLID PRECIPITATION')
 1620  FORMAT(///T7,9('*'),' WELL REPORT FOR ALL ACTIVE WELLS '
     & ,4X,'ELAPSED TIME =',F11.3,'  DAYS FROM BEGINNING OF SIMULATION '
     & ,10('*'))
 1625  FORMAT(/T48,'--------- RATE --------',24X,' ------- CUMULATIVE ',
     & '--------',/,6X,'WELL   LOCATION',3X,'BHFP    BHFP     PI ',3X,
     & '  OIL      NGAS    WATER    NGOR     WOR',5X,
     & '    OIL        NGAS       WATER',/,
     & 7X,'ID',5X,'I  J  K   PSIA    PSIA  BBLS/PSI',
     & 2X,'STB/D    MCF/D    STB/D  SCF/STB  STB/STB',6X,' MSTB       ',
     & 'MMCF       MSTB'/,24X,'CALC    SPEC',/)
 1630 FORMAT(6X,A5,1X,3I3,F8.0,F7.0,1X,F7.2,1X,F9.1,2F9.1,1X,
     &       F8.0,1X,F8.1,1X,3F11.1)
 1650 FORMAT(6X,118('-'),/,12X,'TOTALS',27X,F9.1,F9.1,F9.1,19X
     &      ,3F11.1,/)
 1651 FORMAT(13X,A5,27X,F9.1,F9.1
     &        ,F9.1,1X,F8.0,1X,F8.1,1X,3F11.1,/)
 1652  FORMAT(6X,118('-'),/,6X,'SUMMARY'/)
 1700 FORMAT(///T7,13('*'),' SOLVENT REPORT FOR ALL ACTIVE ',
     &'WELLS',3X,'ELAPSED TIME =',F11.3,' DAYS FROM BEGINNING OF', 
     &' SIMULATION ',10('*'))
 1710 FORMAT(/T47,'   --------------- RATE ',12('-'), 6X, 14('-'), 
     &' CUMULATIVE',13('-'),
     & /,6X,'WELL   LOCATION',3X,'BHFP    BHFP     PI ',3X,
     & 'SOLVENT1 SOLVENT2 SOLVENT3 SOLVENT4',4X,
     & 'SOLVENT1   SOLVENT2   SOLVENT3   SOLVENT4',/,
     & 7X,'ID',5X,'I  J  K   PSIA    PSIA  BBLS/PSI',3X,
     & 'MCF/D    MCF/D    MCF/D    MCF/D',5X,
     & '  MMCF       MMCF       MMCF       MMCF'/,24X,'CALC    SPEC'/)
 1720 FORMAT(6X, A5, 1X, 3I3, 2F8.0, F8.3, 4F9.1, 1X,4F11.1)
 1825 FORMAT(6X,122('='),/,7X,'TOTALS',31X,F10.1,3F9.1, 1X,4F11.1)
 1900 FORMAT(/T15,'MAXIMUM WOR HAS BEEN EXCEEDED --- SIMULATION',
     &' IS BEING TERMINATED'//)
 1910 FORMAT(/T15,'MAXIMUM GOR HAS BEEN EXCEEDED --- SIMULATION',
     &' IS BEING TERMINATED'//)
 1920 FORMAT(/T15,'MINIMUM AVERAGE RESERVOIR PRESSURE WAS NOT',
     &' ACHIEVED --- SIMULATION IS BEING TERMINATED'//)
 1925 FORMAT(/T15,'MAXIMUM AVERAGE RESERVOIR PRESSURE',
     &' HAS BEEN EXCEEDED --- SIMULATION IS BEING TERMINATED'//)
 1950 FORMAT(//1X,'*** CUMULATIVE MBE ON MOBILITY CONTROL AGENT ***',
     &/,1X,'INITIAL BBLS IN PLACE ---------------- = ',F12.3,
     &/,1X,'CUMULATIVE BBLS INJECTED ------------- = ',F12.3,
     &/,1X,'CUMULATIVE BBLS PRODUCED ------------- = ',F12.3,
     &/,1X,'ACTUAL BBLS REMAINING ---------------- = ',F12.3,
     &/,1X,'CALCULATED BBLS REMAINING ------------ = ',F12.3,
     &/,1X,'CUMULATIVE MATERIAL BALANCE ERROR ---- = ',G12.4)
      END SUBROUTINE AMSUB
      SUBROUTINE CMAT(AW,AE,AS,AN,AT,AB,E,B,TOL,II,JJ,KK,IJKM,ITMAX
     &               ,IOCODE,KSW1,KSW3,QI,AQI,AL3,AL2,AL1,AD,AU1,AU2
     &               ,AU3,QN,AQN,RN,DXN,ADX,P)
C
C     INPUT ARRAYS: AW,AE,AS,AN,AT,AB,E,B
C     OUTPUT ARRAYS: AL3,AL2,AL1,AD,AU1,AU2,AU3
C     OUTPUT ARRAYS: QI,AQI,QN,AQN,RN,DXN,ADX,P
C
      DIMENSION AW(IJKM),AE(IJKM),AS(IJKM),AN(IJKM),AT(IJKM)
     &         ,AB(IJKM),E(IJKM),B(IJKM),P(IJKM)
      DIMENSION AL3(IJKM),AL2(IJKM),AL1(IJKM),AD(IJKM)
     &         ,AU1(IJKM),AU2(IJKM),AU3(IJKM)
      DIMENSION QI(15,IJKM),AQI(15,IJKM),QN(IJKM),AQN(IJKM)
      DIMENSION RN(IJKM),DXN(IJKM),ADX(IJKM)
C
C     ORTHOMIN SPARSE MATRIX SOLVER BASED ON PAPER BY P. K. W. VINSOME
C     FOUTH SYMPOSIUM ON RESERVOIR SIMULATION
C     LOS ANGELES, CALIFORNIA     FEBRUARY 19-20,1976
C
      INX = II
      INXY = II*JJ
      IB = 0
      DO 500 K = 1,KK
        DO 450 J = 1,JJ
          DO 400 I = 1,II
            IB = IB + 1
            FAC = 1.0/E(IB)
            IF(I .NE. 1) AL1(IB) = FAC*AW(IB)
            IF(I .NE. II) AU1(IB) = FAC*AE(IB)
            IF(J .NE. 1) AL2(IB) = FAC*AS(IB)
            IF(J .NE. JJ) AU2(IB) = FAC*AN(IB)
            IF(K .NE. 1) AL3(IB) = FAC*AT(IB)
            IF(K .NE. KK) AU3(IB) = FAC*AB(IB)
            RN(IB) = FAC*B(IB)
  400     CONTINUE
  450   CONTINUE
  500 CONTINUE
C
C     APPROXIMATE LDU FACTORIZATION
C

      AD(1) = 1.0
      DO 550 I = 2,INX
        TERM = 1.0 - AL1(I)*AD(I-1)*AU1(I-1)
        AD(I) = 1.0/TERM
  550 CONTINUE
      DO 600 I = INX+1,INXY
        TERM = 1.0 - AL1(I)*AD(I-1)*AU1(I-1)
     &             - AL2(I)*AD(I-INX)*AU2(I-INX)
        AD(I) = 1.0/TERM
  600 CONTINUE
      DO 650 I = INXY+1,IJKM
        TERM = 1.0 - AL1(I)*AD(I-1)*AU1(I-1)
     &             - AL2(I)*AD(I-INX)*AU2(I-INX)
     &             - AL3(I)*AD(I-INXY)*AU3(I-INXY)
        AD(I) = 1.0/TERM
  650 CONTINUE
      CALL ORTH(AL3,AL2,AL1,AD,AU1,AU2,AU3,TOL
     &         ,INX,INXY,IJKM,ITMAX,IOCODE,KSW1,KSW3
     &         ,RN,DXN,ADX,QI,AQI,QN,AQN,P)
      RETURN
      END SUBROUTINE CMAT
      SUBROUTINE CODES(IOCODE,FACT1,FACT2,TMAX,WORMAX,GORMAX,PAMIN,PAMAX
     &                ,OMEGA,TOL,DSMAX,DPMAX,RTOL,RSWGHT,KSW1,KSW2,KSW3
     &                ,NN,KSOL,MITER,NCYCLE,ITMAX,NERR)
      REAL OMEGA
      CHARACTER C80
      READ(5,8080) C80
 8080 FORMAT(A80)
      READ(5,*) KSW1,KSW2,KSW3
      READ(5,8080) C80
      READ(5,*) NN,FACT1,FACT2,TMAX,WORMAX,GORMAX,PAMIN,PAMAX
      WRITE(IOCODE,2100) NN,FACT1,FACT2,TMAX,WORMAX,GORMAX,PAMIN,PAMAX
C
C     NN--MAXIMUM NUMBER OF TIME-STEPS
C     FACT1--FACTOR FOR INCREASING TIME-STEP SIZE
C     FACT2--FACTOR FOR DECREASING TIME-STEP SIZE
C     TMAX--MAXIMUM SIMULATION TIME
C
      READ(5,8080) C80
      READ(5,*) KSOL,MITER,OMEGA,TOL,NCYCLE,DSMAX,DPMAX,ITMAX,RTOL,NERR
      IF(KSOL.EQ.1) WRITE(IOCODE,2150) MITER,OMEGA,TOL,NCYCLE
      IF(KSOL.EQ.2) WRITE(IOCODE,2160) MITER,OMEGA,TOL,NCYCLE
      IF(KSOL.EQ.3) WRITE(IOCODE,2170)
      IF(KSOL.EQ.4) WRITE(IOCODE,2180) MITER
      WRITE(IOCODE,2200) DSMAX,DPMAX
      WRITE(6,2250) ITMAX,RTOL
      IF(NERR .GT. 0) WRITE(6,2260)
C
C     READ FLUID PROPERTY WEIGHTING FACTOR
C
      READ(5,8080) C80
      READ(5,*) RSWGHT
      WRITE(6,2400) RSWGHT
      RETURN
 2100 FORMAT(//T15,'MAXIMUM NUMBER OF TIME-STEPS =',I5/
     &       T15,'FACTOR FOR INCREASING DELT =',F10.6,3X,
     &       'WHEN DSMAX AND DPMAX NOT EXCEEDED.',/,
     &       T15,'FACTOR FOR DECREASING DELT =',F10.6,3X,
     &       'WHEN DSMAX OR DPMAX IS EXCEEDED.',/,
     &       T15,'MAXIMUM SIMULATION TIME =',F11.6/,
     &       T15,'MAXIMUM RESERVOIR WOR/TIME-STEP =',F8.0,' STB/STB'/
     &       T15,'MAXIMUM RESERVOIR GOR/TIME-STEP =',F8.0,' SCF/STB'/
     &       T15,'MINIMUM AVERAGE RESERVOIR PRESSURE/TIME-STEP =',F8.0/
     &     T15,'MAXIMUM AVERAGE RESERVOIR PRESSURE/TIME-STEP =',F8.0//)
 2150 FORMAT(//T15,'SOLUTION METHOD IS PLANAR SOR',
     &/T20,'MAXIMUM NUMBER OF ITERATIONS       (MITR) = ',5X,I5,
     &/T20,'INITIAL ACCELERATION PARAMETER    (OMEGA) = ',F10.4,
     &/T20,'MAXIMUM PRESSURE CHANGE             (TOL) = ',F10.4,
     &/T20,'PARAMETER FOR CHANGING OMEGA     (NCYCLE) = ',5X,I5)
 2160 FORMAT(//T15,'SOLUTION METHOD IS LINE SOR',
     &/T20,'MAXIMUM NUMBER OF ITERATIONS       (MITR) = ',5X,I5,
     &/T20,'INITIAL ACCELERATION PARAMETER    (OMEGA) = ',F10.4,
     &/T20,'MAXIMUM PRESSURE CHANGE             (TOL) = ',F10.4,
     &/T20,'PARAMETER FOR CHANGING OMEGA     (NCYCLE) = ',5X,I5)
 2170 FORMAT(//T15,'SOLUTION METHOD IS D4')
 2180 FORMAT(//T15,'SOLUTION METHOD IS ORTHOMIN',
     &/T20,'MAXIMUM NUMBER OF ITERATIONS       (MITR) = ',5X,I5)
 2200 FORMAT(/T15,'AUTOMATIC TIME STEP CRITERIA:',
     &/T20,'MAXIMUM ALLOWED SATURATION CHANGE (DSMAX) = ',F10.4,
     &/T20,'MAXIMUM ALLOWED PRESSURE CHANGE   (DPMAX) = ',F10.4/)
 2250 FORMAT(/,15X,'MAXIMUM NUMBER OF ITERATIONS = ',I2
     &      ,/,15X,'MAXIMUM RELATIVE ERROR FOR CONVERGENCE = ',F8.6)
 2260 FORMAT(/,15X,'MATERIAL BALANCE ERROR CONTROL OPTION INVOKED')
 2400 FORMAT(/,15X,'SOLUBILITY WEIGHTING = ',F6.4,' (1.0 = UPSTREAM)')
      END SUBROUTINE CODES
      SUBROUTINE COEF(P,VP,VG,VS,XS,BO,BW,BG,BS,RSOR,RSWR,RSO
     &               ,RSWS1,OK,WK,GK,UO,UW,UG,US,RHOO,RHOW,RHOG,RHOS
     &               ,PCW,PCG,QO,QW,QG,QS,AWG,AWS,EL,TX,TY,TZ,DIV1
     &               ,RSWGHT,II,JJ,KK,NSLUGS,IJKM,MOBCTL
     &               ,GOWT,GWWT,GGWT,GSWT,GWSWT,AW,AE,AS,AN,AT,AB,E,B
     &               ,OX,OY,OZ,WX,WY,WZ,GX,GY,GZ,SX,SY,SZ,WSX,WSY,WSZ
     &               ,FWX,FWY,FWZ,FGX,FGY,FGZ)
C
C     THIS ROUTINE COMPUTES THE FLOW COEFFICIENTS (TRANSMISSIBILITIES)
C     AND FORMS THE PRESSURE EQUATION FOR THE FIRST ITERATION. IT ALSO
C     FORMS THE INITIAL RESIDUALS FOR THE TIME STEP.
C
      PARAMETER (D288 = 1./288.)
      DIMENSION P(IJKM),VP(IJKM),VG(IJKM),VS(4*IJKM),XS(IJKM)
     &         ,BO(IJKM),BW(IJKM),BG(IJKM),BS(4*IJKM),RSOR(IJKM)
     &         ,RSWR(IJKM),RSO(4*IJKM),RSWS1(IJKM),OK(IJKM),WK(IJKM)
     &         ,GK(IJKM),UO(IJKM),UW(IJKM),UG(IJKM),US(4*IJKM)
     &         ,RHOO(IJKM),RHOW(IJKM),RHOG(IJKM),RHOS(4*IJKM)
     &         ,PCW(IJKM),PCG(IJKM),QO(IJKM),QW(IJKM),QG(IJKM)
     &         ,QS(4*IJKM),AWG(IJKM),AWS(4*IJKM),EL(IJKM)
      DIMENSION TX(II+1,JJ,KK),TY(II,JJ+1,KK),TZ(II,JJ,KK+1)
      DIMENSION AW(IJKM),AE(IJKM),AS(IJKM),AN(IJKM),AT(IJKM)
     &         ,AB(IJKM),E(IJKM),B(IJKM),GOWT(IJKM),GWWT(IJKM)
     &         ,GGWT(IJKM),GSWT(4*IJKM),GWSWT(IJKM),OX(IJKM),OY(IJKM)
     &         ,OZ(IJKM),WX(IJKM),WY(IJKM),WZ(IJKM),GX(IJKM),GY(IJKM)
     &         ,GZ(IJKM),SX(4*IJKM),SY(4*IJKM),SZ(4*IJKM),WSX(IJKM)
     &         ,WSY(IJKM),WSZ(IJKM)
C
      DIMENSION FWX(IJKM),FWY(IJKM),FWZ(IJKM)
      DIMENSION FGX(IJKM),FGY(IJKM),FGZ(IJKM)
C
      IJM = II*JJ
      IIS = NSLUGS*II
      IJMS = NSLUGS*IJM
      IJKMS = NSLUGS*IJKM
      RSWTM1 = 1. - RSWGHT
C
C     ADD PRODUCTION/INJECTION TERMS TO RESIDUALS
C
      DO 100 IB = 1,IJKM
        GOWT(IB) = GOWT(IB) + QO(IB)
        GWWT(IB) = GWWT(IB) + QW(IB)
        GGWT(IB) = GGWT(IB) + QG(IB)
  100 CONTINUE
      DO 150 IBS = 1,IJKMS
        GSWT(IBS) = GSWT(IBS) + QS(IBS)
  150 CONTINUE
      IB = 0
      IBASE = 0
      DO 800 K = 1,KK
      DO 800 J = 1,JJ
      DO 800 I = 1,II
      IB = IB + 1
      KSW = 1
      IF(I.EQ.II ) GOTO 600
C
C     Calculate "east" flow coefficients
C
      IBX = IB + 1
      TXX  = TX(I+1,J,K)
      GO TO 700
  175 CONTINUE
      WSX(IB) = TWS
  200 CONTINUE
      OX(IB) = TO
      WX(IB) = TW
C 
      FWX(IB) = FW
      FGX(IB) = FGP
      GX(IB) = TG
      KSW = 2
      IF(J .EQ. JJ) GOTO 600
C
C     Calculate "north" flow coefficients
C
      IBX = IB + II
      TXX  = TY(I,J+1,K)
      GO TO 700
  225 CONTINUE
      WSY(IB) = TWS
  250 CONTINUE
      OY(IB) = TO
      WY(IB) = TW

C 
      FWY(IB) = FW
      FGY(IB) = FGP
C
      GY(IB) = TG
      KSW = 3
      IF(K .EQ. KK) GOTO 600
C
C     Calculate "bottom" flow coefficients
C
      IBX = IB + IJM
      TXX  = TZ(I,J,K+1)
      GO TO 700
  275 CONTINUE
      WSZ(IB) = TWS
  300 CONTINUE
      OZ(IB) = TO
      WZ(IB) = TW
C
      FWZ(IB) = FW
      FGZ(IB) = FGP
C
      GZ(IB) = TG
C
C     FORM PRESSURE EQUATION
C
      R3 = AWG(IB)
      IF(NSLUGS .GT. 0) THEN
        IBS = IBASE + 1
        R1 = BO(IB) - R3*VG(IB)*RSOR(IB) - VS(IBS)*AWS(IBS)*RSO(IBS)
        R2 = BW(IB) - R3*VG(IB)*RSWR(IB) - VS(IBS)*AWS(IBS)*RSWS1(IB)
        DO 350 ISOL = 2,NSLUGS
          IBS = IBASE + ISOL
          R1 = R1 - VS(IBS)*AWS(IBS)*RSO(IBS)
  350   CONTINUE
        IF(I .EQ. 1) THEN
          AW(IB) = 0.0
        ELSE
          IBM = IB - 1
          AWSUM = R1*OX(IBM) + R2*WX(IBM) + R3*GX(IBM)
          DO 400 ISOL = 1,NSLUGS
            IBS = IBASE + ISOL
            AWSUM = AWSUM + AWS(IBS)*SX(IBS-NSLUGS)
  400     CONTINUE
          AW(IB) = AWSUM
        ENDIF
        IF(J .EQ. 1) THEN
          AS(IB) = 0.0
        ELSE
          IBM = IB - II
          ASSUM = R1*OY(IBM) + R2*WY(IBM) + R3*GY(IBM)
          DO 450 ISOL = 1,NSLUGS
            IBS = IBASE + ISOL
            ASSUM = ASSUM + AWS(IBS)*SY(IBS-IIS)
  450     CONTINUE
          AS(IB) = ASSUM
        ENDIF
        IF(K .EQ. 1) THEN
          AT(IB) = 0.0
        ELSE
          IBM = IB - IJM
          ATSUM = R1*OZ(IBM) + R2*WZ(IBM) + R3*GZ(IBM)
          DO 500 ISOL = 1,NSLUGS
            IBS = IBASE + ISOL
            ATSUM = ATSUM + AWS(IBS)*SZ(IBS-IJMS)
  500     CONTINUE
          AT(IB) = ATSUM
        ENDIF
        AESUM = R1*OX(IB) + R2*WX(IB) + R3*GX(IB)
        ANSUM = R1*OY(IB) + R2*WY(IB) + R3*GY(IB)
        ABSUM = R1*OZ(IB) + R2*WZ(IB) + R3*GZ(IB)
        BSUM = R1*GOWT(IB) + R2*GWWT(IB) + R3*GGWT(IB)
        DO 550 ISOL = 1,NSLUGS
          IBS = IBASE + ISOL
          AESUM = AESUM + AWS(IBS)*SX(IBS)
          ANSUM = ANSUM + AWS(IBS)*SY(IBS)
          ABSUM = ABSUM + AWS(IBS)*SZ(IBS)
          BSUM = BSUM + AWS(IBS)*GSWT(IBS)
  550   CONTINUE
        AE(IB) = AESUM
        AN(IB) = ANSUM
        AB(IB) = ABSUM
        B(IB) = BSUM
      ELSE
        R1 = BO(IB) - R3*RSOR(IB)
        R2 = BW(IB) - R3*RSWR(IB)
        IF(I .EQ. 1) THEN
          AW(IB) = 0.
        ELSE
          AW(IB) = R1*OX(IB-1) + R2*WX(IB-1) + R3*GX(IB-1) 
        ENDIF
        IF(J .EQ. 1 ) THEN
          AS(IB) = 0.
        ELSE
          AS(IB) = R1*OY(IB-II) + R2*WY(IB-II) + R3*GY(IB-II) 
        ENDIF
        IF(K .EQ. 1) THEN
          AT(IB) = 0.
        ELSE
          AT(IB) = R1*OZ(IB-IJM) + R2*WZ(IB-IJM) + R3*GZ(IB-IJM) 
        ENDIF
        AE(IB) = R1*OX(IB) + R2*WX(IB) + R3*GX(IB) 
        AN(IB) = R1*OY(IB) + R2*WY(IB) + R3*GY(IB) 
        AB(IB) = R1*OZ(IB) + R2*WZ(IB) + R3*GZ(IB) 
        B(IB) = R1*GOWT(IB) + R2*GWWT(IB) + R3*GGWT(IB)
      ENDIF
      E(IB) = - AW(IB) - AE(IB) - AS(IB) - AN(IB) - AT(IB) - AB(IB) 
     &        - VP(IB)*E(IB)*DIV1
      IBASE = IBASE + NSLUGS
      GOTO 800
C
  600 CONTINUE
      TO = 0.
      TW = 0.
C 
      FW = 0.
      FGP = 0.

      TG = 0.
      GOTO (200,250,300) KSW
C
C     COMPUTE FLOW COEFFICIENTS AND FLUXES, ADD FLUXES TO RESIDUALS
C
  700 CONTINUE
      DPD = P(IBX) - P(IB)
      FACT = D288*(EL(IBX)-EL(IB))
      HOD = DPD - (RHOO(IB)+RHOO(IBX))*FACT
      IBO = IB
      IF(HOD .GT. 0.) IBO = IBX
      IBOD = IB + IBX - IBO
      HWD = DPD - (RHOW(IB)+RHOW(IBX))*FACT - PCW(IBX) + PCW(IB)
      IBW = IB
      IF(HWD .GT. 0.) IBW = IBX
      IBWD = IB + IBX - IBW
      HGD = DPD - (RHOG(IB)+RHOG(IBX))*FACT + PCG(IBX) - PCG(IB)
      IBG = IB
      IF(HGD .GT. 0.) IBG = IBX
      IBGD = IB + IBX - IBG
      BOA = RSWGHT*BO(IBO) + RSWTM1*BO(IBOD)
      UOA = RSWGHT*UO(IBO) + RSWTM1*UO(IBOD)
      TO = TXX*OK(IBO)/(BOA*UOA)
      FO = TO*HOD
      GOWT(IB) = GOWT(IB) - FO
      GOWT(IBX) = GOWT(IBX) + FO
      BWA = RSWGHT*BW(IBW) + RSWTM1*BW(IBWD)
      UWA = RSWGHT*UW(IBW) + RSWTM1*UW(IBWD)
      TW = TXX*WK(IBW)/(BWA*UWA)
      FW = TW*HWD
      GWWT(IB) = GWWT(IB) - FW
      GWWT(IBX) = GWWT(IBX) + FW
      BGA = RSWGHT*BG(IBG) + RSWTM1*BG(IBGD)
      UGA = RSWGHT*UG(IBG) + RSWTM1*UG(IBGD)
      IF(NSLUGS .GT. 0) THEN
        IBSDX = NSLUGS*(IBX-IB)
        DO 750 ISOL = 1,NSLUGS
          IBS = IBASE + ISOL
          IBSX = IBS + IBSDX
          HSD = DPD - (RHOS(IBS)+RHOS(IBSX))*FACT + PCG(IBX) - PCG(IB)
          IBSU = IBS
          IF(HSD .GT. 0.0) IBSU = IBSX
          IBSD = IBS + IBSX - IBSU
          BSA = RSWGHT*BS(IBSU) + RSWTM1*BS(IBSD)
          USA = RSWGHT*US(IBSU) + RSWTM1*US(IBSD)
          IF(IBO .EQ. IB) THEN
            RSOA = RSWGHT*VS(IBS )*RSO(IBS )
     &           + RSWTM1*VS(IBSX)*RSO(IBSX)
          ELSE
            RSOA = RSWGHT*VS(IBSX)*RSO(IBSX)
     &           + RSWTM1*VS(IBS )*RSO(IBS )
          ENDIF
          IF(RSOA .LT. 0.0) RSOA = 0.0
          IF(IBSU .EQ. IBS) THEN
            TS = TXX*VS(IBS )*GK(IB )/(BSA*USA)
          ELSE
            TS = TXX*VS(IBSX)*GK(IBX)/(BSA*USA)
          ENDIF
          IF(TS .LT. 0.0) TS = 0.0
          FS = TS*HSD + RSOA*FO
          TS = TS + RSOA*TO
          IF(ISOL .EQ. 1) THEN
            IF(IBW .EQ. IB) THEN
              RSWA = RSWGHT*VS(IBS )*RSWS1(IB ) 
     &             + RSWTM1*VS(IBSX)*RSWS1(IBX)
            ELSE
              RSWA = RSWGHT*VS(IBSX)*RSWS1(IBX)
     &             + RSWTM1*VS(IBS )*RSWS1(IB )
            ENDIF
            IF(RSWA .LT. 0.0) RSWA = 0.0
            FS = FS + RSWA*FW
            TS = TS + RSWA*TW
          ENDIF
          GSWT(IBS) = GSWT(IBS) - FS
          GSWT(IBSX) = GSWT(IBSX) + FS
          IF(KSW .EQ. 1) THEN
            SX(IBS) = TS
          ELSEIF(KSW .EQ. 2) THEN
            SY(IBS) = TS
          ELSE
            SZ(IBS) = TS
          ENDIF
  750   CONTINUE
        RSOA = RSWGHT*VG(IBO)*RSOR(IBO) + RSWTM1*VG(IBOD)*RSOR(IBOD)
        RSWA = RSWGHT*VG(IBW)*RSWR(IBW) + RSWTM1*VG(IBWD)*RSWR(IBWD)
        TG = TXX*VG(IBG)*GK(IBG)/(BGA*UGA)
C 
        TGP = TXX*GK(IBG)/UGA
      ELSE
        RSOA = RSWGHT*RSOR(IBO) + RSWTM1*RSOR(IBOD)
        RSWA = RSWGHT*RSWR(IBW) + RSWTM1*RSWR(IBWD)
        TG = TXX*GK(IBG)/(BGA*UGA)
C 
        TGP = TXX*GK(IBG)/UGA
      ENDIF
C
      FGP = TGP*HGD
      FG = TG*HGD + RSOA*FO + RSWA*FW
      TG = TG + RSOA*TO + RSWA*TW
      GGWT(IB) = GGWT(IB) - FG 
      GGWT(IBX) = GGWT(IBX) + FG
      IF(MOBCTL .GT. 0) THEN
        TWS = XS(IBW)*TW
        FWS = TWS*HWD
        GWSWT(IB) = GWSWT(IB) - FWS
        GWSWT(IBX) = GWSWT(IBX) + FWS
        GOTO (175,225,275) KSW
      ENDIF
      GOTO (200,250,300) KSW
  800 CONTINUE
      RETURN
      END SUBROUTINE COEF
      SUBROUTINE CUV (II,JJ,KK,IJKM,DX,DY,DZ,
     &           FWX,FWY,FWZ,UW)
      DIMENSION DX(IJKM),DY(IJKM),DZ(IJKM),
     &          FWX(IJKM),FWY(IJKM),FWZ(IJKM),
     &          UW(IJKM)
C
         DO 22 ijk = 1,IJKM
           FWX(ijk) = -FWX(ijk)/DY(ijk)/DZ(ijk)
           FWY(ijk) = -FWY(ijk)/DX(ijk)/DZ(ijk)
           FWZ(ijk) = -FWZ(ijk)/DX(ijk)/DY(ijk)
22      CONTINUE

        IB=0
        IJM = II*JJ
        DO 55 K=1,KK
        DO 55 J=1,JJ
        DO 55 I=1,II
          IB   = IB + 1
          FFWX1= FWX(IB)
          FFWY1= FWY(IB)
          FFWZ1= FWZ(IB)
          FFWX2= FFWX1
          FFWY2= FFWY1
          FFWZ2= FFWZ1
          IF(I.EQ.II) FFWX1=FWX(IB-1)
          IF(JJ.EQ.1) GO TO 82
          IF(J.EQ.JJ) FFWY1=FWY(IB-II)
82        IF(KK.EQ.1) GO TO 84
          IF(K.EQ.KK) FFWZ1=FWZ(IB-IJM)
84        IF(I.NE.1) FFWX2=FWX(IB-1)
          IF(J.NE.1) FFWY2=FWY(IB-II)
          IF(K.NE.1) FFWZ2=FWZ(IB-IJM)
          FFWX = ( FFWX1 + FFWX2 ) / 2.0
          FFWY = ( FFWY1 + FFWY2 ) / 2.0
          FFWZ = ( FFWZ1 + FFWZ2 ) / 2.0
          UW(IB) = SQRT ( FFWX**2 + FFWY**2 + FFWZ**2 )
55      CONTINUE
C
         FWX(IJKM)=FWX(IJKM-1)
         FWY(IJKM)=FWY(IJKM-1)
         FWZ(IJKM)=FWZ(IJKM-1)

      RETURN
      END SUBROUTINE CUV
      SUBROUTINE D4GAUS(TT,CC,RR,LINK,NLBW,NRBW,IXA,INAT,IJKM,MAXB,MAXA
     &                 ,MAXROW,A,ROW,X)
      DIMENSION TT(MAXB,6),CC(IJKM),RR(IJKM),A(MAXA),X(IJKM)
      DIMENSION ROW((-MAXROW):MAXROW)
      DIMENSION LINK(IJKM,6),NLBW(IJKM),NRBW(IJKM),IXA(IJKM)
     &         ,INAT(IJKM)
      COMMON/D4CNT/NTOP,NTOT,NBOT 
C
C     THIS ROUTINE SOLVES THE PRESSURE EQUATION USING GAUSS ELIMINATION
C     WITH AN ALTERNATE DIAGONAL (D4) ORDERING
C
C     NORMALIZE UPPER HALF, SHIFT REORDERED RESIDUALS TO X ARRAY
C
      DO 200 IBR = 1,NTOP
        IB = INAT(IBR)
        FAC = 1.0/CC(IB)
        DO 100 ID = 1,6
          TT(IB,ID) = FAC*TT(IB,ID)
  100   CONTINUE
        X(IBR) = FAC*RR(IB)
  200 CONTINUE
      IBR = NTOP
      DO 600 L = 1,NBOT
        IBR = IBR + 1
C
C     ELIMINATE LOWER LEFT QUADRANT AND FILL IN LOWER RIGHT QUADRANT
C
        NL = NLBW(L)
        NR = NRBW(L)
        DO 300 I = -NL,NR
          ROW(I) = 0.0
  300   CONTINUE
        IB = INAT(IBR)
        ROW(0) = CC(IB)
        TEMP = RR(IB)
        DO 400 ID = 1,6
          IBUR = LINK(IBR,ID)
          IF(IBUR .GT. 0) THEN
            FAC = TT(IB,ID)
            IBU = INAT(IBUR)
            DO 350 JD = 1,6
              IBLR = LINK(IBUR,JD)
              IF(IBLR .GT. 0)
     &          ROW(IBLR-IBR) = ROW(IBLR-IBR) - FAC*TT(IBU,JD)
  350       CONTINUE
            TEMP = TEMP - FAC*X(IBUR)
          ENDIF
  400   CONTINUE
C
C     ELIMINATE ELEMENTS LEFT OF DIAGONAL, NORMALIZE, AND STORE
C
        DO 500 IE = -NL,-1
          FAC = ROW(IE)
          IBER = IBR + IE
          ISTORE = IBER - NTOP
          NR = NRBW(ISTORE)
          IBASE = IXA(ISTORE)
          IROW = IE
          DO 450 IA = 1,NR
            IROW = IROW + 1
            ROW(IROW) = ROW(IROW) - FAC*A(IBASE+IA)
  450     CONTINUE
          TEMP = TEMP - FAC*X(IBER)
  500   CONTINUE
        NR = NRBW(L)
        IBASE = IXA(L)
        FAC = 1.0/ROW(0)
        DO 550 IROW = 1,NR
          A(IBASE+IROW) = FAC*ROW(IROW)
  550   CONTINUE
        X(IBR) = FAC*TEMP
  600 CONTINUE
C
C     SHIFT RESIDUALS BACK TO RR ARRAY
C
      DO 650 IBR = 1,NTOT
        RR(IBR) = X(IBR)
  650 CONTINUE
C
C     BACK SUBSTITUTION ON LOWER HALF
C
      X(INAT(NTOT)) = RR(NTOT)
      IBR = NTOT
      DO 750 L = NBOT-1,1,-1
        IBR = IBR - 1
        NR = NRBW(L)
        IA = IXA(L)
        TEMP = RR(IBR)
        DO 700 I = 1,NR
          TEMP = TEMP - A(I+IA)*RR(I+IBR)
  700   CONTINUE
        RR(IBR) = TEMP
        X(INAT(IBR)) = TEMP
  750 CONTINUE
C
C     BACK SUBSTITUTION ON UPPER HALF
C
      DO 850 IBR = 1,NTOP
        IB = INAT(IBR)
        TEMP = RR(IBR)
        DO 800 ID = 1,6
          IBLR = LINK(IBR,ID)
          IF(IBLR .GT. 0) TEMP = TEMP - TT(IB,ID)*RR(IBLR)
  800   CONTINUE
        X(IB) = TEMP
  850 CONTINUE
      RETURN
      END SUBROUTINE D4GAUS
      SUBROUTINE D4ORD(II,JJ,KK,MAXA,MAXROW,IJKM
     &                ,LINK,NLBW,NRBW,IXA,INAT)
      DIMENSION LINK(IJKM,6),NLBW(IJKM),NRBW(IJKM),IXA(IJKM)
     &         ,INAT(IJKM)
      COMMON/D4CNT/NTOP,NTOT,NBOT 
      DIMENSION NSIZE(2)
C
C     THIS ROUTINE COMPUTES THE BOOKKEEPING ARRAYS USED BY D4GAUS
C
      IJM = II*JJ
      DO 100 IB = 1,IJKM
        IXA(IB) = 0
  100 CONTINUE
      IBR = 0
      NRMAX = II + JJ + KK
      DO 500 IP = 1,2
        NRMIN = IP + 2
        DO 450 NR = NRMIN,NRMAX,2
          IF(II .GE. JJ .AND. II .GE. KK) THEN
            DO 200 I = 1,II
              DO 150 J = 1,JJ
                K = NR - I - J
                IF(K .GE. 1 .AND. K .LE. KK) THEN
                  IB = I + II*(J-1) + IJM*(K-1)
                  IBR = IBR + 1
                  IXA(IB) = IBR
               ENDIF
  150         CONTINUE
  200       CONTINUE
          ELSEIF(JJ .GE. KK) THEN
            DO 300 J = 1,JJ
              DO 250 K = 1,KK
                I = NR - J - K
                IF(I .GE. 1 .AND. I .LE. II) THEN
                  IB = I + II*(J-1) + IJM*(K-1)
                  IBR = IBR + 1
                  IXA(IB) = IBR
                ENDIF
  250         CONTINUE
  300       CONTINUE
          ELSE
            DO 400 K = 1,KK
              DO 350 I = 1,II
                J = NR - K - I
                IF(J .GE. 1 .AND. J .LE. JJ) THEN
                  IB = I + II*(J-1) + IJM*(K-1)
                  IBR = IBR + 1
                  IXA(IB) = IBR
                ENDIF
  350         CONTINUE
  400       CONTINUE
          ENDIF
  450   CONTINUE
        NSIZE(IP) = IBR
  500 CONTINUE
      NTOP = NSIZE(1)
      NTOT = NSIZE(2)
      NBOT = NTOT - NTOP
      IF(NBOT .GT. NTOP) THEN
        DO 550 IB = 1,NTOT
          IF(IXA(IB) .GT. 0) THEN
            IF(IXA(IB) .GT. NTOP) THEN
              IXA(IB) = IXA(IB) - NTOP
            ELSE
              IXA(IB) = IXA(IB) + NBOT
            ENDIF
          ENDIF
  550   CONTINUE
        NTOP = NBOT
        NBOT = NTOT - NTOP
      ENDIF
C
C     SET POINTERS TO AJACENT CELLS
C
      IB = 0
      DO 800 K = 1,KK
        DO 750 J = 1,JJ
          DO 700 I = 1,II
            IB = IB + 1
            IBR = IXA(IB)
            IF(IBR .GT. 0) THEN
              INAT(IBR) = IB
              DO 650 ID = 1,6
                LINK(IBR,ID) = 0
  650         CONTINUE
              IF(I .NE.  1) LINK(IBR,1) =  IXA(IB-1)
              IF(I .NE. II) LINK(IBR,2) =  IXA(IB+1)
              IF(J .NE.  1) LINK(IBR,3) =  IXA(IB-II)
              IF(J .NE. JJ) LINK(IBR,4) =  IXA(IB+II)
              IF(K .NE.  1) LINK(IBR,5) =  IXA(IB-IJM)
              IF(K .NE. KK) LINK(IBR,6) =  IXA(IB+IJM)
            ENDIF
  700     CONTINUE
  750   CONTINUE
  800 CONTINUE
C
C     DETERMINE STORAGE REQUIREMENTS AND SET STORAGE POINTERS
C
      IR = 0
      NBAND = 0
      IXA(1) = 0
      IBR = NTOP
      DO 950 L = 1,NBOT
        IBR = IBR + 1
        IL = IBR
        DO 900 ID = 1,6
          IBUR = LINK(IBR,ID)
          IF(IBUR .GT. 0) THEN
            DO 850 JD = 1,6
              IBLR = LINK(IBUR,JD)
              IF(IBLR .GT. 0) THEN
                IF(IBLR .LT. IL) IL = IBLR
                IF(IBLR .GT. IR) IR = IBLR
              ENDIF
  850       CONTINUE
          ENDIF
  900   CONTINUE
        NBW = IBR - IL
        NLBW(L) = NBW
        IF(NBW .GT. NBAND) NBAND = NBW
        NBW = IR - IBR
        NRBW(L) = NBW
        IF(NBW .GT. NBAND) NBAND = NBW
        IF(L .NE. NBOT) IXA(L+1) = IXA(L) + NBW
  950 CONTINUE
      WRITE(6,1900) NTOT,NBAND,IXA(NBOT)
      IF(IXA(NBOT) .GT. MAXA .OR. NBAND .GT. MAXROW) THEN
        IF(IXA(NBOT) .GT. MAXA) WRITE(6,1910) MAXA
        IF(NBAND .GT. MAXROW) WRITE(6,1920) MAXROW
        WRITE(6,1930)
		PRINT *,""
		PRINT *,"WARNING: P < 0  OR  P > PMAXT."
		PRINT *,"SIMULATION IS BEING TERMINATED."
		PRINT *, "Please check the results."
		PRINT *,""
	  STOP
      ENDIF
      RETURN
 1900 FORMAT(//,5X,'NUMBER OF BLOCKS IN RESERVOIR = ',I6
     &      ,//,5X,'MAXIMUM BANDWIDTH             = ',I6
     &      ,//,5X,'MINIMUM WORKSPACE REQUIRED    = ',I6)
 1910 FORMAT(/,5X,'WORK SPACE OF ',I6,' IS NOT SUFFICIENT FOR '
     &           ,'THIS PROBLEM')
 1920 FORMAT(/,5X,'BANDWIDTH LIMIT OF ',I3,' IS NOT SUFFICIENT FOR '
     &           ,'THIS PROBLEM')
 1930 FORMAT(/,5X,'JOB TERMINATED')
      END SUBROUTINE D4ORD
C
      SUBROUTINE FFIND(X,N,XO,IL,IU,IFLAG)
      DIMENSION X(N)
      IF(XO.LT.X(1))THEN
        IL=1
        IU=2
        IFLAG=-1
        RETURN
      ENDIF
      DO 10 I=2,N
        IF(XO.LT.X(I))THEN
          IL=I-1
          IU=I
          IFLAG=0
          RETURN
        ENDIF
  10  CONTINUE
      IL=N-1
      IU=N
      IFLAG=1
      RETURN
      END SUBROUTINE FFIND
C
      SUBROUTINE FINTE1(X,Y,N,XO,YO)
      DIMENSION X(N),Y(N)
      IF(XO.LT.X(1)) THEN
        YO=Y(2)+(Y(1)-Y(2))*(XO-X(2))/(X(1)-X(2))
        RETURN
      ENDIF
      DO 10 I=2,N
        IF(XO.LT.X(I)) THEN
          YO=Y(I-1)+(XO-X(I-1))*(Y(I)-Y(I-1))/(X(I)-X(I-1))
          RETURN
        ENDIF
  10  CONTINUE
      YO=Y(N-1)+(Y(N)-Y(N-1))*(XO-X(N-1))/(X(N)-X(N-1))
      RETURN
      END SUBROUTINE FINTE1
      SUBROUTINE FOAM(
     &     DX,DY,DZ,DV,DT,NI,NJ,NK,JFLOW,JSTAT,T,
     &     CSI,CS,CSPRE,
     &     ROW,ROWPRE,UW,FWX,FWY,FWZ,
     &     QW,SWPRE,SW,FI,
     &     BNFI,BNFPRE,BNF,BLNPRE,BLN,GF,GFPRE,
     &     QGP,SO,SG,SGPRE,UG,FGX,FGY,FGZ,
     &     VMUG,PKRG,VC,PKO,
     &     IQN1,IQN2,IQN3,LAYER,KIP,NVQN,NW,
     &     ITSTEP,BES,BEB,TOBI,TOBO,TOSMI,TOSMO,RES,
     &     idir,jchfm,VMUGF,TV,PKRGF,PKRGS,ILOOK,ILOOKO,
     &     PKRW,VMUW,CRUX,CRUY,CRUZ,XX1,XX2,XX3,XX4,RR)

      COMMON/FOAMP/VCD,VCE,B,AK3,VREF3,C3
      COMMON/MAXLIM/SOLIM,CSLIM,XF,SGLIM,SWLIM
      
      DIMENSION ILOOK(NI,NJ,NK),ILOOKO(NI,NJ,NK)
      DIMENSION FWX(NI,NJ,NK),FWY(NI,NJ,NK),FWZ(NI,NJ,NK)
      DIMENSION FGX(NI,NJ,NK),FGY(NI,NJ,NK),FGZ(NI,NJ,NK)
      DIMENSION SO(NI,NJ,NK),SW(NI,NJ,NK),SG(NI,NJ,NK)
      DIMENSION SWPRE(NI,NJ,NK),SGPRE(NI,NJ,NK)
      DIMENSION BNF(NI,NJ,NK)
      DIMENSION BNFPRE(NI,NJ,NK)
      DIMENSION BLN(NI,NJ,NK),BLNPRE(NI,NJ,NK)
      DIMENSION GF(NI,NJ,NK),GFPRE(NI,NJ,NK)
      DIMENSION CS(NI,NJ,NK),RES(NI,NJ,NK)
      DIMENSION CSPRE(NI,NJ,NK),PKO(NI,NJ,NK)
      DIMENSION PKRG(NI,NJ,NK),PKRW(NI,NJ,NK)
      DIMENSION VMUG(NI,NJ,NK),VMUW(NI,NJ,NK)
      DIMENSION ROW(NI,NJ,NK),ROWPRE(NI,NJ,NK)
      DIMENSION QW(NI,NJ,NK),QGP(NI,NJ,NK)
      DIMENSION VC(NI,NJ,NK),UG(NI,NJ,NK),UW(NI,NJ,NK)
      DIMENSION DX(NI,NJ,NK),DY(NI,NJ,NK),DZ(NI,NJ,NK),DV(NI,NJ,NK)
      DIMENSION CSI(NW),BNFI(NW),FI(NI,NJ,NK)
      DIMENSION IQN1(NW),IQN2(NW),IQN3(NW),LAYER(NW),KIP(NW)
      DIMENSION CRUX(0:NI,NJ,NK),CRUY(NI,0:NJ,NK),
     &            CRUZ(NI,NJ,0:NK)    
      DIMENSION RR(NI,NJ,NK)
      DIMENSION XX1(NI,NJ,NK),XX2(NI,NJ,NK)
      DIMENSION XX3(NI,NJ,NK),XX4(NI,NJ,NK)

      DIMENSION VMUGF(NI,NJ,NK),TV(NI,NJ,NK)      
      DIMENSION PKRGF(NI,NJ,NK),PKRGS(NI,NJ,NK)
      DIMENSION IDIR(NW)
C  *** Unit conversions, by Min 
           DT = 86400.0*DT
        DO 1150 I = 1,NI 
         DO 1150 J = 1,NJ 
            DO 1150 K = 1,NK 
C  FT --> CM
               DX(I,J,K) = 30.48*DX(I,J,K)
               DY(I,J,K) = 30.48*DY(I,J,K)
               DZ(I,J,K) = 30.48*DZ(I,J,K)
C  FT^3 --> CM^3
               DV(I,J,K) = 28316.85*DV(I,J,K)
C  LBM/FT^3 --> G/CM^3
               ROW(I,J,K) = 0.01601846*ROW(I,J,K)
               ROWPRE(I,J,K) = 0.01601846*ROWPRE(I,J,K)
C  FT/DAY --> CM/SEC
               FWX(I,J,K) = 0.0003527778*FWX(I,J,K)
               FWY(I,J,K) = 0.0003527778*FWY(I,J,K)
               FWZ(I,J,K) = 0.0003527778*FWZ(I,J,K)
               FGX(I,J,K) = 0.0003527778*FGX(I,J,K)
               FGY(I,J,K) = 0.0003527778*FGY(I,J,K)
               FGZ(I,J,K) = 0.0003527778*FGZ(I,J,K)
C  LBM/DAY --> G/SEC
               QW(I,J,K) = 0.005249912*QW(I,J,K)
C  FT^3/DAY --> CM^3/DAY
               QGP(I,J,K) = 0.3277413*QGP(I,J,K)

               UW(I,J,K) = 0.0003527778*UW(I,J,K)
               UG(I,J,K) = 0.0003527778*UG(I,J,K)
C  MD --> DARCY
               PKO(I,J,K) = PKO(I,J,K)/1000.

1150   CONTINUE
         
C----------------------------
C     UPDATE CS(I,J)
C----------------------------
            CALL SUR(
     &      DX,DY,DZ,DV,DT,NI,NJ,NK,
     &      CS,CSPRE,
     &      ROW,ROWPRE,FWX,FWY,FWZ,
     &      QW,SWPRE,SW,FI,
     &      CSI,IQN1,IQN2,IQN3,LAYER,KIP,NVQN,NW,IDIR,
     &      CRUX,CRUY,CRUZ,XX1,XX2,XX3,XX4,RR)
      IF (jchfm .eq. 1) THEN 
      CALL FTABLE(NI,NJ,NK,ILOOK,ILOOKO,SG,SGPRE,SO,SW,CS,FI,PKO,
     &                  ICHECK,T,UG,UW,RES,PKRW,VMUW,PKRG,VMUG) 
       GOTO 1968
      ENDIF

C*****
C     SET FLAGS
C       IFLAG1 = 1 : FOAM CAN NOT OCCUR
C       IFLAG2 = 1 : NO FLOWING FOAM
C       IFLAG3 = 1 : NO STATIC FOAM
C*****

       IFLAG1 = 1
       IFLAG2 = 1
       IFLAG3 = 1
 
C*****
C     IF FOAM FLOWED AT PREVIOUS TIME STEP,
C     SET IFLAG2 = 2 (CALL POP)
C*****
        
       DO 80 K = 1,NK
          DO 80 I = 1,NI
             DO 80 J = 1,NJ
                IF(BNF(I,J,K).GT.0.0)THEN
                   IFLAG2 = 2
                   GOTO 410
                ENDIF
 80   CONTINUE
 
C*****
C     DECIDE WHETHER FOAM CAN OCCUR OR NOT
C     IF FOAM CAN OCCUR, SET IFLAG1 = 2 (SNAP-OFF, LEAVE-BEHIND)
C     AND USE GAS VELOCITY AT PREVIOUS TIME STEP 
C     TO CHECK WHETHER SNAP-OFF OCCURS OR NOT
C     IF SNAP-OFF OCCURS, SET IFLAG2 = 2 (CALL POP)
C     THE CRITICAL VELOCITY IS CALCULATED BY USING 
C     GAS VELOCITY AT PREVIOUS TIME STEP AND 
C     WATER VELOCITY AT CURRENT TIME STEP
C*****
 
 410  CONTINUE
       DO 100 K = 1,NK
          DO 100 J = 1,NJ
             DO 100 I = 1,NI
          
                IF((SG(I,J,K).GT.SGLIM).AND.(SO(I,J,K).LT.SOLIM)
     &               .AND.(SW(I,J,K).GT.SWLIM)
     &               .AND.(CS(I,J,K).GT.CSLIM))THEN
                   IFLAG1 = 2
                   IF(VCD.GT.0.)THEN
                   IF(UW(I,J,K).GT.0.0.AND.UG(I,J,K).GT.0.0) THEN
                      FLIG = UW(I,J,K)/(UW(I,J,K) + UG(I,J,K))
                      VC(I,J,K) = VCD/FLIG**VCE
                      IF(UG(I,J,K).GT.VC(I,J,K))IFLAG2 = 2
                   ELSE
                      VC(I,J,K) = 999999.99
                   ENDIF
                   ELSE
                      IFLAG2 = 2
                      VC(I,J,K) = 0.0
                   ENDIF
                ENDIF
  100  CONTINUE
 
C*****
C     IF FOAM IS BEING INJECTED,
C     SET IFLAG2 = 2 (CALL POP)
C**** 
       DO 8998 IW = 1,NW
          IF(BNFI(IW).GT.0.0)IFLAG2 = 2
 8998  CONTINUE
 
C*****
C     MODIFY PKRG(I,J) AND VMUG(I,J) IF NECESSARY
C*****

       DO 150 K = 1,NK
          DO 150 J = 1,NJ
             DO 150 I = 1,NI
                VMUGF(I,J,K) = VMUG(I,J,K)
                PKRGF(I,J,K) = PKRG(I,J,K)
 150            PKRGS(I,J,K) = PKRG(I,J,K)

 
C*****
C     IF FOAM CAN OCCUR (IFLAG1 = 2)
C     CHECK WHETHER LEAVE-BEHIND LAMELLA OCCURS OR NOT
C     IF LEAVE-BEHIND LAMELLA OCCURS,
C     SET IFLAG3 = 2 AND MODIFY PKRG(I,J) 
C*****
      IF(IFLAG1.EQ.2)THEN
         DO 220 K = 1,NK
            DO 220 J = 1,NJ
               DO 220 I = 1,NI
                  IF((SG(I,J,K).GT.SGLIM).AND.(SO(I,J,K).LT.SOLIM)
     &                 .AND.(SW(I,J,K).GT.SWLIM)
     &                 .AND.(CS(I,J,K).GT.CSLIM)
     &                 .AND.(SGPRE(I,J,K).LT.SGLIM)
     &                 .AND.(SWPRE(I,J,K).GT.SWLIM)
     &                 .AND.(CSPRE(I,J,K).GT.CSLIM))THEN
                     PKRGS(I,J,K) = PKRG(I,J,K)/(1.0 + B*SG(I,J,K))
                     IFLAG3 = 2
                  ENDIF
220      CONTINUE
 
         IF(IFLAG3.EQ.2.AND.JSTAT.EQ.1)THEN
            WRITE(21,*)
            WRITE(21,*)' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ '
            WRITE(21,*)' STATIC FOAM FIRST OCCURRED AT ',
     1           ' TIME = ',T,' [DAY] '
            WRITE(21,*)' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ '
            JSTAT = 2 
         ENDIF
      ENDIF
 
C*****          
C     IF FLOWING FOAM EXIST (IFLAG2 = 2)
C     USE GAS VELOCITY AT PREVIOUS TIME STEP TO SOLVE 
C     THE POPULATION BALANCE EQUATION
C*****
       IF(IFLAG2.EQ.2)THEN
         CALL POP(
     &        DX,DY,DZ,DV,DT,NI,NJ,NK,
     &        BNFPRE,BNF,BLNPRE,BLN,GF,GFPRE,
     &        QGP,SO,SG,SGPRE,FGX,FGY,FGZ,
     &        CS,VC,UG,FI,
     &        BNFI,IQN1,IQN2,IQN3,LAYER,KIP,NVQN,NW,idir,
     &        SW,CRUX,CRUY,CRUZ,XX1,XX2,XX3,XX4,RR)
 
C*****
C     MODIFY PKRG(I,J) AND VMUG(I,J) 
C     (1 DARCY = 9.869E-9 CM^2)
C*****
 
         XXXX1 = (9.8041D-13) * AK3*VREF3**C3
         DO 530 K = 1,NK
            DO 530 J = 1,NJ
               DO 530 I = 1,NI
                  IF((SG(I,J,K).GT.SGLIM).AND.(SO(I,J,K).LT.SOLIM)
     &                 .AND.(SW(I,J,K).GT.SWLIM)
     &                 .AND.(CS(I,J,K).GT.CSLIM)
     &                 .AND.(BNF(I,J,K).GT.0.0))THEN
                     PKRGF(I,J,K) = XF*PKRG(I,J,K)
                     TV(I,J,K) = XXXX1*PKO(I,J,K)**(1.5)
     &                    *VMUG(I,J,K)*BNF(I,J,K)
                  ELSE
                  TV(I,J,K) = 0.0
                  ENDIF
 530     CONTINUE
 
         DO 560 K = 1,NK
            DO 560 J = 1,NJ
               DO 560 I = 1,NI
                  IF(UG(I,J,K).GT.0.0)THEN
                     VMUGF(I,J,K) = TV(I,J,K)/UG(I,J,K)**C3
                     IF(VMUGF(I,J,K).LT.VMUG(I,J,K)) THEN
                        VMUGF(I,J,K) = VMUG(I,J,K)
                     ENDIF
                  ENDIF
 560     CONTINUE
         
         IF(JFLOW.EQ.1)THEN
            WRITE(21,*)
            WRITE(21,*)' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ '
            WRITE(21,*)' FLOWING FOAM FIRST OCCURRED AT ',
     &           ' TIME = ',T, ' [DAY] '
            WRITE(21,*)' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ '
            JFLOW = 2 
         ENDIF
      ENDIF

C****
C    RETURN THE MODIFIED VALUES
C****
    
      IF(IFLAG2.EQ.2.AND.IFLAG3.EQ.2)THEN
         DO 130 K = 1,NK
            DO 130 J = 1,NJ
               DO 130 I = 1,NI
                  IF((PKRGF(I,J,K)/VMUGF(I,J,K)).LT.
     &                 (PKRGS(I,J,K)/VMUG(I,J,K)))THEN
                     PKRG(I,J,K) = PKRGF(I,J,K)
                     VMUG(I,J,K) = VMUGF(I,J,K)
                  ELSE
                     PKRG(I,J,K) = PKRGS(I,J,K)
                  ENDIF
 130     CONTINUE
      ELSE IF(IFLAG2.EQ.2)THEN
         DO 160 K = 1,NK
            DO 160 J = 1,NJ
               DO 160 I = 1,NI
                  PKRG(I,J,K) = PKRGF(I,J,K)
 160              VMUG(I,J,K) = VMUGF(I,J,K)
      ELSE IF(IFLAG3.EQ.2)THEN
         DO 260 K = 1,NK
            DO 260 J = 1,NJ
               DO 260 I = 1,NI
 260              PKRG(I,J,K) = PKRGS(I,J,K)
      ENDIF
C  *** calculate matrial balance error of surfactant and bubble,
1968       continue

      IJKM=NI*NJ*NK       
      CALL MBESF(ITSTEP,NI,NJ,NK,IJKM,DT,DV, 
     &     BES,BEB,TOBI,TOBO,TOSMI,TOSMO, 
     &     QW,QGP,CS,BNF,CSI,BNFI,
     &     SW,FI,ROW,SG,BLN,GF,
     &     IQN1,IQN2,IQN3,LAYER,KIP,NVQN,NW,idir)
C   ***  convert back to original units 

      DT = DT/86400.0
      DO 1160 I = 1,NI 
         DO 1160 J = 1,NJ 
            DO 1160 K = 1,NK 
               DX(I,J,K) = DX(I,J,K)/30.48
               DY(I,J,K) = DY(I,J,K)/30.48
               DZ(I,J,K) = DZ(I,J,K)/30.48
               DV(I,J,K) = DV(I,J,K)/28316.85
               ROW(I,J,K) = ROW(I,J,K)/0.01601846
               ROWPRE(I,J,K) = ROWPRE(I,J,K)/0.01601846

               FWX(I,J,K) = FWX(I,J,K)/0.0003527778
               FWY(I,J,K) = FWY(I,J,K)/0.0003527778
               FWZ(I,J,K) = FWZ(I,J,K)/0.0003527778

               FGX(I,J,K) = FGX(I,J,K)/0.0003527778
               FGY(I,J,K) = FGY(I,J,K)/0.0003527778
               FGZ(I,J,K) = FGZ(I,J,K)/0.0003527778

               QW(I,J,K) = QW(I,J,K)/0.005249912
               
               QGP(I,J,K) = QGP(I,J,K)/0.3277413

               UW(I,J,K) = UW(I,J,K)/0.0003527778
               UG(I,J,K) = UG(I,J,K)/0.0003527778

               PKO(I,J,K) = PKO(I,J,K)*1000.

1160  CONTINUE
      RETURN
      END SUBROUTINE FOAM

      SUBROUTINE FRESIN(XPER,XQUA,XCON,XVEL,YRES)
C.... this routine returns resistance factor YRES based on 
C.... permeability (md) XPER, quality (%) XQUA, 
C.... concentration (lbm/lbm) XCON, 
C.... and water+gas interstitial velocity (ft/day) XVEL
C
C	VAX  IMPLICIT REAL*8 ( A-H, O-Z )
C
      PARAMETER (INPER=4, INQUA=5, INCON=4, INVEL=5)
C
C.... local arrays
C
      DIMENSION Y(INCON),YQ(INQUA),TEMC(INCON),TEMV(INVEL),TEMR(INVEL)
     &         ,TEMQ(INQUA),YP(INPER)
C
C.... use common block to pass tables
C
      COMMON /FOAM40/ TQUA(INPER,INQUA),TCON(INPER,INCON,INQUA)
     &               ,TVEL(INPER,INVEL,INQUA),TPER(INPER)
     &               ,TRES(INPER,INVEL,INCON,INQUA),NPER,NQUA,NCON,NVEL

      IF(XPER.LT.TPER(1) .OR. XPER.GT.TPER(NPER))THEN
        PRINT *,' ***** WARNING ***** XPER (MD) =',XPER
      ENDIF
      CALL FFIND(TPER,NPER,XPER,ILP,IUP,IFP)

      DO 100 M=ILP,IUP
      PRINT *,'TPER(M) =',TPER(M)

      DO 15 I=1,NQUA
        TEMQ(I)=TQUA(M,I)
15    CONTINUE
      IF(XQUA.LT.TEMQ(1) .OR. XQUA.GT.TEMQ(NQUA))THEN
        PRINT *,' ***** WARNING ***** XQUA (%) =',XQUA
      ENDIF
      CALL FFIND(TEMQ,NQUA,XQUA,ILQ,IUQ,IFQ)

      DO 10 JQ=ILQ,IUQ
      PRINT *,'TQUA(M,JQ) =',TQUA(M,JQ)

        DO 30 I=1,NCON
          TEMC(I)=TCON(M,I,JQ)
30      CONTINUE
        IF(XCON.LT.TEMC(1) .OR. XCON.GT.TEMC(NCON))THEN
        PRINT *,' ***** WARNING ***** XCON (PPM) =',XCON*1000000.
        ENDIF
        CALL FFIND(TEMC,NCON,XCON,ILC,IUC,IFC)

        DO 20 KC=ILC,IUC
        PRINT *,'TCON(M,KC,JQ) =',TCON(M,KC,JQ)
C
C.... obtain resistance factor based on velocity from table lookup 
C.... (log linear interpolation)
C
          DO 40 I=1,NVEL
            TEMV(I)=LOG10(TVEL(M,I,JQ))
            TEMR(I)=LOG10(TRES(M,I,KC,JQ))
40        CONTINUE
          IF(XVEL.LE.0.0)THEN
			PRINT *,""
			PRINT *,'ERROR: XVEL IS LESS THAN 0.0.' 
			PRINT *,"SIMULATION IS BEING TERMINATED."
			PRINT *, "Please check the results."
			PRINT *,""
	        STOP
          ENDIF
          XLOG=LOG10(XVEL)
          IF(XLOG.LT.TEMV(1) .OR. XLOG.GT.TEMV(NVEL))THEN
          PRINT *,' ***** WARNING ***** XVEL (FT/DAY) = ',XVEL
          ENDIF
          CALL FINTE1(TEMV,TEMR,NVEL,XLOG,YLOG)
          YLOG=10.0**YLOG
          Y(KC)=YLOG
          PRINT *,'Y(KC) =',Y(KC)
20      CONTINUE
C
C.... interpolate resistance factor based on concentration
C.... (linear interpolation)
C
        IF(IFC.EQ.-1)THEN
          YLOG=Y(IUC)+(XCON-TCON(M,IUC,JQ))*(Y(IUC)-Y(ILC))
     &          /(TCON(M,IUC,JQ)-TCON(M,ILC,JQ))
        ELSE
          YLOG=Y(ILC)+(XCON-TCON(M,ILC,JQ))*(Y(IUC)-Y(ILC))
     &          /(TCON(M,IUC,JQ)-TCON(M,ILC,JQ))
        ENDIF
          YQ(JQ)=YLOG
10    CONTINUE
C
C.... interpolate resistance factor based on quality
C.... (linear interpolation)
C
      IF(IFQ.EQ.-1)THEN
        YLOG=YQ(IUQ)+(XQUA-TQUA(M,IUQ))*(YQ(IUQ)-YQ(ILQ))
     &       /(TQUA(M,IUQ)-TQUA(M,ILQ))
      ELSE
        YLOG=YQ(ILQ)+(XQUA-TQUA(M,ILQ))*(YQ(IUQ)-YQ(ILQ))
     &       /(TQUA(M,IUQ)-TQUA(M,ILQ))
      ENDIF
          YP(M)=YLOG
          PRINT *,'YP(M) =',YP(M)
          IF(YP(M).LE.0.0)THEN
			PRINT *,""
			PRINT *,'ERROR: YP(M) IS LESS THAN 0.0'
			PRINT *,"Simulation is over, please check the results."
			PRINT *,""
			STOP
          ENDIF
100   CONTINUE
C
C.... interpolate resistance factor based on permeability
C.... (log. linear interpolation)
C
      XLOG=LOG10(XPER)
      PULOG=LOG10(TPER(IUP))
      PLLOG=LOG10(TPER(ILP))
      YULOG=LOG10(YP(IUP))
      YLLOG=LOG10(YP(ILP))
      IF(IFP.EQ.-1)THEN
        YLOG=YULOG+(XLOG-PULOG)*(YULOG-YLLOG)
     &            /(PULOG-PLLOG)
      ELSE
        YLOG=YLLOG+(XLOG-PLLOG)*(YULOG-YLLOG)
     &            /(PULOG-PLLOG)
      ENDIF
      YLOG=10.0**YLOG
          YRES=YLOG
      RETURN
      END SUBROUTINE FRESIN
C
      SUBROUTINE FTABLE(NI,NJ,NK,ILOOK,ILOOKO,SG,SGPRE,SO,SW,CS,FI,PKO,
     &                  ICHECK,T,UG,UW,RMOBF,PKRW,VMUW,PKRG,VMUG) 
C
C.... this routine modifies gas-phase relative mobility when foam exists
C.... and then back calculates relative permeability of the gas-foam phase
C.... by assuming viscosity is not affected by foam
C
C.... INPUT: SOLIM,SWLIM,SGLIM,CSLIM,VGLIM,RMOBMI,T,UG,UW,PKRW,VMUW,
C....        NI,NJ,NK,SG,SGPRE,SO,SW,CS,FI,PKO,VMUG
C.... OUTPUT: ILOOKO,ICHECK
C.... INPUT & OUTPUT: ILOOK,RMOBF,PKRG
C
      COMMON /FOAM20/ SOLIM,SWLIM,SGLIM,CSLIM,VGLIM,RMOBMI,QUALIM
      DIMENSION ILOOKO(NI,NJ,NK),ILOOK(NI,NJ,NK)
     &      ,CS(NI,NJ,NK),SG(NI,NJ,NK)
     &      ,SO(NI,NJ,NK),SW(NI,NJ,NK),SGPRE(NI,NJ,NK),UG(NI,NJ,NK)
     &      ,FI(NI,NJ,NK),PKO(NI,NJ,NK),RMOBF(NI,NJ,NK),VMUG(NI,NJ,NK)
     &      ,PKRW(NI,NJ,NK),PKRG(NI,NJ,NK),VMUW(NI,NJ,NK),UW(NI,NJ,NK)
C
C.... store ILOOK(I,J,K) at previous time step into array ILOOKO(I,J,K)
C
      DO 100 K=1,NK
      DO 100 J=1,NJ
      DO 100 I=1,NI
        ILOOKO(I,J,K)=ILOOK(I,J,K)
100   CONTINUE
C
C.... update ILOOK(I,J,K) for the current time step by checking the
C.... foam existence criteria in each block
C....   ILOOK(I,J,K) = 0  -->  no foam
C....   ILOOK(I,J,J) = 1  -->  foam 
C....
C.... criteria:
C....   surfactant concentration CS(I,J,K) (lbm/lbm) > CSLIM 
C....   gas saturation SG(I,J,K) > SGLIM
C....   oil saturation SO(I,J,K) < SOLIM
C....   water saturation SW(I,J,K) > SWLIM
C....   gas interstitial velocity FGVEL (ft/day) > VGLIM
C....     (if VGLIM > 0)
C....   gas saturation increment DSG > 0
C....     (if no foam in grid block at previous time step)
C....   gas quality QUA > QUALIM
C....     (if no foam in grid block at previous time step)
C....
C....   VGLIM is the critical gas interstitial velocity (ft/day)
C....   SOLIM is the limiting oil saturation
C....   SWLIM is the limiting water saturation
C....   SGLIM is the limiting gas saturation
C....   CSLIM is the limiting surfactant concentration (lbm/lbm)
C
      DO 10 K=1,NK
      DO 10 J=1,NJ
      DO 10 I=1,NI
        IF(ILOOKO(I,J,K).EQ.1)THEN
C
C.... check if foam coalesced at current time step
C
          IF(CS(I,J,K).LT.CSLIM 
     &       .OR.SO(I,J,K).GT.SOLIM
     &       .OR.SG(I,J,K).LT.SGLIM
     &       .OR.SW(I,J,K).LT.SWLIM)THEN
            ILOOK(I,J,K)=0
            WRITE(2,999)I,J,K,CS(I,J,K),SW(I,J,K),SO(I,J,K),SG(I,J,K)
999   FORMAT(2X, 'FOAM COALESCED AT BLOCK #', 3I4,
     &       3X, 'DUE TO: CS = ', F10.7, ' SW, SO, SG = ', 3F7.4)
          ENDIF

        ELSE
C
C.... check if foam generated at current time step
C
         DSG=SG(I,J,K)-SGPRE(I,J,K)
         IF(DSG.GT.0.0)THEN
C
C.... calculate quality (%) QUA
C
          IF(UG(I,J,K).GT.0.0 .AND. UW(I,J,K).GT.0.0)THEN
              QUA=UG(I,J,K)/(UW(I,J,K)+UG(I,J,K))*100.0
          ELSE
              QUA=0.0
          ENDIF
          IF(QUA.GT.QUALIM)THEN
          IF(VGLIM.GT.0.0)THEN
C
C.... critical velocity exists
C
            FGVEL=UG(I,J,K)/FI(I,J,K)/0.00035278
            IF(CS(I,J,K).GT.CSLIM 
     &         .AND.SO(I,J,K).LT.SOLIM
     &         .AND.SG(I,J,K).GT.SGLIM
     &         .AND.SW(I,J,K).GT.SWLIM
     &         .AND.FGVEL.GT.VGLIM)THEN
                   ILOOK(I,J,K)=1
            ENDIF
          ELSE
C
C.... no critical velocity 
C
            IF(CS(I,J,K).GT.CSLIM 
     &         .AND.SO(I,J,K).LT.SOLIM
     &         .AND.SG(I,J,K).GT.SGLIM
     &         .AND.SW(I,J,K).GT.SWLIM)THEN
                   ILOOK(I,J,K)=1
            ENDIF
          ENDIF
          ENDIF
         ENDIF
        ENDIF
10    CONTINUE
C
C.... update ICHECK for the current time step according to ILOOK(I,J,K)
C....   ICHECK = 0  -->  no foam
C....   ICHECK = 1  -->  foam exists
C
      ICHECK=0
      DO 200 K=1,NK
      DO 200 J=1,NJ
      DO 200 I=1,NI
        IF(ILOOK(I,J,K).EQ.1)THEN
          ICHECK=1
          GOTO 201
        ENDIF
200   CONTINUE
C
C.... modify gas-phase relative mobility if foam exists at current time step
C
201   CONTINUE
      IF(ICHECK.EQ.1)THEN
        WRITE(2,998)T
998   FORMAT(2X, 'FOAM EXISTS AT TIME =', F10.5)
        DO 1001 K=1,NK
        DO 1001 J=1,NJ
        DO 1001 I=1,NI
          IF(ILOOK(I,J,K).EQ.0)THEN
C
C.... set resistance factor qual to 1.0 if no foam at current time step
C
            RES=1.0
          ELSE
C
C.... foam at current time step
C
C.... calculate quality (%) QUA
C
            IF(UG(I,J,K).GT.0.0 .AND. UW(I,J,K).GT.0.0)THEN
              QUA=UG(I,J,K)/(UW(I,J,K)+UG(I,J,K))*100.0
            ELSE
              QUA=0.0
            ENDIF
C
C.... convert permeability from darcy PKO to md PKO1
C
            PKO1=PKO(I,J,K)*1000.0
C
C.... calculate water+gas interstitial velocity (ft/day) FVEL
C
            FVEL=(UW(I,J,K)+UG(I,J,K))/FI(I,J,K)/0.00035278
C
C.... obtain resistance factor
C
            IF(ILOOKO(I,J,K).EQ.0)THEN
C
C.... obtain resistance factor from table lookup 
C.... modify gas-phase relative mobility 
C.... and then back calculate gas-phase relative permeability
C
            CALL FRESIN(PKO1,QUA,CS(I,J,K),FVEL,RES)
            IF(RES.LT.1.0)RES=1.0
              WRITE(2,1000)I,J,K,RES,CS(I,J,K),
     &                   SW(I,J,K),SO(I,J,K),SG(I,J,K),
     &                   FVEL,QUA,PKO1
1000  FORMAT(2X, 'FOAM GENERATES AT BLOCK #', 3I4, 
     &       2X, 'WITH RESISTANCE FACTOR OF', F5.1, /
     &       3X, 'DUE TO: CS = ', F10.7, ' SW, SO, SG = ', 3F7.4, 
     &       ' FVEL = ', F10.7, 
     &       ' QUA = ', F8.3, ' PERM = ', F10.2)
                RMOB1=PKRW(I,J,K)/VMUW(I,J,K)
                RMOB3=PKRG(I,J,K)/VMUG(I,J,K)
                WRITE(2,788)PKRG(I,J,K),RMOB1,RMOB3,VMUG(I,J,K)
788             FORMAT(2X,' PKRG, RMOB1, RMOB3, VMUG = ',4F9.4)
                WKSP=(RMOB3+RMOB1)/RES-RMOB1
                ICON=1
                IF(WKSP.LT.RMOBMI)THEN
                  RMOB3=RMOBMI
                  ICON=2
                ELSEIF(WKSP.LT.RMOB3)THEN
                  RMOB3=WKSP
                  ICON=3
                ENDIF
                RMOBF(I,J,K)=RMOB3
                PKRG(I,J,K)=VMUG(I,J,K)*RMOB3
                WRITE(2,789)I,J,K,PKRG(I,J,K),ICON
789             FORMAT(2X,'BLOCK',3I4,' PKRG = ',F9.4,' CONDITION',I2)
            ELSE
C
C.... foam at previous and current time step
C.... use previous time step foam relative mobility to calculate
C.... gas-phase relative permeability
C
                ICON=0
                WRITE(2,789)I,J,K,PKRG(I,J,K),ICON
                PKRG(I,J,K)=VMUG(I,J,K)*RMOBF(I,J,K)
                WRITE(2,789)I,J,K,PKRG(I,J,K),ICON
            ENDIF
          ENDIF
1001    CONTINUE
      ENDIF
      RETURN
      END SUBROUTINE FTABLE

      SUBROUTINE GRID1(IOCODE,II,JJ,KK,VAREL,DUMMY,DX,DY,DZ,EL)
C
C     WORK ARRAYS: VAREL, DUMMY
C
      DIMENSION VAREL(II,JJ),DUMMY(1),DX(II,JJ,KK),DY(II,JJ,KK)
     &         ,DZ(II,JJ,KK),EL(II,JJ,KK)
      CHARACTER C80*80
      READ(5,1000) C80
C
C     READ INPUT CODES FOR DX,DY,DZ
C
      READ(5,*) KDX,KDY,KDZ
C
C     ESTABLISH GRID BLOCK LENGTH (DX) DISTRIBUTION
C
      IF(KDX .LT. 0) THEN
        READ(5,*) DXC
        DO 300 K = 1,KK
        DO 300 J = 1,JJ
        DO 300 I = 1,II
          DX(I,J,K) = DXC
  300   CONTINUE
        WRITE(IOCODE,1300)
        WRITE(IOCODE,1305) DXC
      ELSEIF(KDX .EQ. 0) THEN
        READ(5,*) (DUMMY(I),I=1,II)
        DO 310 K = 1,KK
        DO 310 J = 1,JJ
        DO 310 I = 1,II
          DX(I,J,K) = DUMMY(I)
  310   CONTINUE
        DO 320 I = 1,II
          WRITE(IOCODE,1310) I,DUMMY(I)
  320   CONTINUE
      ELSE
        WRITE(IOCODE,1320)
        K = 1
        WRITE(IOCODE,1325) K
        DO 330 J = 1,JJ
          READ(5,*) (DX(I,J,K),I=1,II)
          WRITE(IOCODE,1330) (DX(I,J,K),I=1,II)
  330   CONTINUE
        DO 360 K = 2,KK
          WRITE(IOCODE,1325) K
          DO 350 J = 1,JJ
            DO 340 I = 1,II
              DX(I,J,K) = DX(I,J,1)
  340       CONTINUE
            WRITE(IOCODE,1330) (DX(I,J,K),I=1,II)
  350     CONTINUE
  360   CONTINUE
      ENDIF
      WRITE(IOCODE,1300)
C
C     ESTABLISH GRID BLOCK LENGTH (DY) DISTRIBUTION
C
      IF(KDY .LT. 0) THEN
        READ(5,*) DYC
        DO 400 K = 1,KK
        DO 400 J = 1,JJ
        DO 400 I = 1,II
          DY(I,J,K) = DYC
  400   CONTINUE
        WRITE(IOCODE,1300)
        WRITE(IOCODE,1400) DYC
      ELSEIF(KDY .EQ. 0) THEN
        READ(5,*) (DUMMY(J),J=1,JJ)
        DO 410 K = 1,KK
        DO 410 J = 1,JJ
        DO 410 I = 1,II
          DY(I,J,K) = DUMMY(J)
  410   CONTINUE
        DO 420 J = 1,JJ
          WRITE(IOCODE,1410) J,DUMMY(J)
  420   CONTINUE
      ELSE
        WRITE(IOCODE,1420)
        K = 1
        WRITE(IOCODE,1325) K
        DO 430 I = 1,II
          READ(5,*) (DY(I,J,K),J=1,JJ)
          WRITE(IOCODE,1330) (DY(I,J,K),J=1,JJ)
  430   CONTINUE
        DO 460 K = 2,KK
          WRITE(IOCODE,1325) K
          DO 450 J = 1,JJ
            DO 440 I = 1,II
              DY(I,J,K) = DY(I,J,1)
  440       CONTINUE
            WRITE(IOCODE,1330) (DY(I,J,K),I=1,II)
  450     CONTINUE
  460   CONTINUE
      ENDIF
      WRITE(IOCODE,1300)
C
C     ESTABLISH GRID BLOCK LENGTH (DZ) DISTRIBUTION
C
      IF(KDZ .LT. 0) THEN
        READ(5,*) DZC
        DO 500 K = 1,KK
        DO 500 J = 1,JJ
        DO 500 I = 1,II
          DZ(I,J,K) = DZC
  500   CONTINUE
        WRITE(IOCODE,1300)
        WRITE(IOCODE,1500) DZC
      ELSEIF(KDZ .EQ. 0) THEN
        READ(5,*) (DUMMY(K),K=1,KK)
        DO 510 K = 1,KK
        DO 510 J = 1,JJ
        DO 510 I = 1,II
          DZ(I,J,K) = DUMMY(K)
  510   CONTINUE
        DO 520 K = 1,KK
          WRITE(IOCODE,1510) K,DUMMY(K)
  520   CONTINUE
      ELSE
        WRITE(IOCODE,1520)
        DO 540 K = 1,KK
          WRITE(IOCODE,1325) K
          DO 530 J = 1,JJ
            READ(5,*) (DZ(I,J,K),I=1,II)
            WRITE(IOCODE,1330) (DZ(I,J,K),I=1,II)
  530     CONTINUE
  540   CONTINUE
      ENDIF
      WRITE(IOCODE,1300)
C
C     GRID BLOCK LENGTH MODIFICATIONS
C
      READ(5,1000) C80
      READ(5,*) NUMDX,NUMDY,NUMDZ,IDCODE
      IF(NUMDX .GT. 0) THEN
        WRITE(IOCODE,1550)
        DO 600 L = 1,NUMDX
          READ(5,*) I,J,K,DX(I,J,K)
          WRITE(IOCODE,1560) I,J,K,DX(I,J,K)
  600   CONTINUE
        IF(IDCODE .EQ. 1) THEN
          WRITE(IOCODE,1320)
          DO 620 K = 1,KK
            WRITE(IOCODE,1325) K
            DO 610 J = 1,JJ
              WRITE(IOCODE,1330) (DX(I,J,K),I=1,II)
  610       CONTINUE
  620     CONTINUE
        ENDIF
      ENDIF
      IF(NUMDY .GT. 0) THEN
        WRITE(IOCODE,1620)
        DO 630 L = 1,NUMDY
          READ(5,*) I,J,K,DY(I,J,K)
          WRITE(IOCODE,1560) I,J,K,DY(I,J,K)
  630   CONTINUE
        IF(IDCODE .EQ. 1) THEN
          WRITE(IOCODE,1420)
          DO 650 K = 1,KK
            WRITE(IOCODE,1325) K
            DO 640 J = 1,JJ
              WRITE(IOCODE,1330) (DY(I,J,K),I=1,II)
  640       CONTINUE
  650     CONTINUE
        ENDIF
      ENDIF
      IF(NUMDZ .GT. 0) THEN
        WRITE(IOCODE,1650)
        DO 660 L = 1,NUMDZ
          READ(5,*) I,J,K,DZ(I,J,K)
          WRITE(IOCODE,1560) I,J,K,DZ(I,J,K)
  660   CONTINUE
        IF(IDCODE .EQ. 1) THEN
          WRITE(IOCODE,1520)
          DO 680 K = 1,KK
            WRITE(IOCODE,1325) K
            DO 670 J = 1,JJ
              WRITE(IOCODE,1330) (DZ(I,J,K),I=1,II)
  670       CONTINUE
  680     CONTINUE
        ENDIF
      ENDIF
C
C     ESTABLISH NODE MID-POINT ELEVATION.
C
      READ(5,1000) C80
      READ(5,*) KEL
      IF(KEL .EQ. 0) THEN
        READ(5,*) ELEV
        DO 910 J = 1,JJ
        DO 910 I = 1,II
          VAREL(I,J) = ELEV
  910   CONTINUE
      ELSEIF(KEL .EQ. 1) THEN
        DO 930 J = 1,JJ
          READ(5,*) (VAREL(I,J),I=1,II)
  930   CONTINUE
      ENDIF
      DO 960 I = 1,II
        DO 950 J = 1,JJ
          TOP = VAREL(I,J)
          DO 940 K = 1,KK
            EL(I,J,K) = TOP + 0.5*DZ(I,J,K)
            TOP = TOP + DZ(I,J,K)
  940     CONTINUE
  950   CONTINUE
  960 CONTINUE
      WRITE(IOCODE,1960)
      DO 970 K = 1,KK
        WRITE(IOCODE,1325) K
        DO 970 J = 1,JJ
          WRITE(IOCODE,1330) (EL(I,J,K),I=1,II)
  970 CONTINUE
      RETURN
 1000 FORMAT(A80)
 1300 FORMAT(//)
 1305 FORMAT(T15,'GRID BLOCK LENGTH (DX) IS INITIALLY'
     &          ,' SET AT',F10.4,' FOR ALL NODES'//)
 1310 FORMAT(T15,'GRID SIZE (DX) IN COLUMN',I5,' IS INITIALLY SET AT'
     &          ,F8.2,' FOR ALL NODES',/)
 1320 FORMAT(//T15,'********GRID BLOCK LENGTH (DX) DISTRIBUTION********'
     &      ,/)
 1325 FORMAT(/,1X,'K =',I2,/)
 1330 FORMAT(1X,20F6.0)
 1400 FORMAT(T15,'GRID BLOCK WIDTH  (DY) IS INITIALLY'
     &          ,' SET AT',F10.4,' FOR ALL NODES'//)
 1410 FORMAT(T15,'GRID SIZE (DY) IN ROW   ',I5,' IS INITIALLY SET AT'
     &          ,F8.2,' FOR ALL NODES',/)
 1420 FORMAT(//T15,'********GRID BLOCK WIDTH  (DY) DISTRIBUTION********'
     &      ,/)
 1500 FORMAT(T15,'GRID BLOCK DEPTH  (DZ) IS INITIALLY'
     &          ,' SET AT',F10.4,' FOR ALL NODES'//)
 1510 FORMAT(T15,'GRID SIZE (DZ) IN LAYER ',I5,' IS INITIALLY SET AT'
     &          ,F8.2,' FOR ALL NODES',/)
 1520 FORMAT(//T15,'********GRID BLOCK DEPTH  (DZ) DISTRIBUTION********'
     &      ,/)
 1550 FORMAT(//,T15,'********GRID BLOCK LENGTH (DX) NODE MODIFICATIONS'
     &    ,'**********',//T15,'     I    J    K          NEW DX VALUE')
 1560 FORMAT(15X,3I5,5X,F14.4)
 1620 FORMAT(//,T15,'********GRID BLOCK WIDTH  (DY) NODE MODIFICATIONS'
     &    ,'**********',//T15,'     I    J    K          NEW DY VALUE')
 1650 FORMAT(//,T15,'********GRID BLOCK DEPTH  (DZ) NODE MODIFICATIONS'
     &    ,'**********',//T15,'     I    J    K          NEW DZ VALUE')
 1960 FORMAT(//T15,'********** NODE MIDPOINT ELEVATIONS **********'/)
      END SUBROUTINE GRID1
      SUBROUTINE INPUTF(IOCODE,II,JJ,KK,IFOAM,JCHFM,CS0,BNF0)  
      DIMENSION CS0(II,JJ,KK)
      DIMENSION BNF0(II,JJ,KK)

      COMMON/SURFP/ROR,DELTA,CKS,AS
      COMMON/POPP/CK2,CSREF,BKF,AF,BK1,BNC,VREF1,VREF2,C1,C2,E1,E2
      COMMON/FOAMP/VCD,VCE,B,AK3,VREF3,C3
      COMMON/MAXLIM/SOLIM,CSLIM,XF,SGLIM,SWLIM
      COMMON/LITER/MAXITR,EPSC,EPSN
        
        CHARACTER C80*80

        READ(5,91) C80
        WRITE(IOCODE,92) C80
        READ(5,*) IFOAM 
	  WRITE(IOCODE,1000) IFOAM
        
        IF(IFOAM .EQ. 1) THEN

       READ(5,91) C80
       WRITE(IOCODE,92) C80
       READ(5,*) JCHFM
       
        READ(5,91) C80
        WRITE(IOCODE,92) C80
        READ(5,*) MAXITR,EPSC,EPSN
        WRITE(IOCODE,*) MAXITR,EPSC,EPSN
  
C*****
C     INPUT INITIAL SURFACTANT CONCENTRATION, CS0 [G/G]
C*****
 
        READ(5,91) C80
        WRITE(IOCODE,92) C80
        READ(5,*) CS00
        WRITE(IOCODE,*) CS00

        DO 111 I = 1,II 
        DO 111 J = 1,JJ
        DO 111 K = 1,KK 
         CS0(I,J,K) = CS00
111     CONTINUE
C
C     INPUT CONSTANTS FOR SURFACTANT ADSORPTION
C       ROR [G/CM^3], DELTA [CM^2/G], CKS [G/G], AS [G/CM^2]
C 
        READ(5,91) C80
        WRITE(IOCODE,92) C80
        READ(5,*) ROR,DELTA,CKS,AS
        WRITE(IOCODE,*) ROR,DELTA,CKS,AS

       if (jchfm .eq. 1) then
        CALL READHC(IFOAM)
        return
       endif


C     INPUT FOAM OCCURRING CONDITIONS
C       SOLIM, CSLIM [G/G]
C 
        READ(5,91) C80
        WRITE(IOCODE,92) C80
        READ(5,*) SOLIM,CSLIM
        WRITE(IOCODE,*) SOLIM,CSLIM

C     INPUT CONSTANTS FOR CALCULATION OF CRITICAL VELOCITY
C       VCD, VCE
C 
        READ(5,91) C80
        WRITE(IOCODE,92) C80
        READ(5,*) VCD,VCE
        WRITE(IOCODE,*) VCD,VCE

C 
C     INPUT CONSTANTS FOR BUBBLE GENERATION
C       BK1 [#/CM^3/SEC], BNC [#/CM^3]
C       VREF1 [CM/SEC], E1, C1
C 
        READ(5,91) C80
        WRITE(IOCODE,92) C80
        READ(5,*) BK1,BNC,VREF1,E1,C1
        WRITE(IOCODE,*) BK1,BNC,VREF1,E1,C1
 
C 
C     INPUT CONSTANTS FOR BUBBLE COALESCENCE
C       CK2 [CM^3/SEC/CM^3], CSREF [G/G]
C       VREF2 [CM/SEC], E2, C2
C 
 
        READ(5,91) C80
        WRITE(IOCODE,92) C80
        READ(5,*) CK2,CSREF,VREF2,E2,C2
        WRITE(IOCODE,*) CK2,CSREF,VREF2,E2,C2
C 
C     INPUT CONSTANTS FOR BUBBLE TRAPPING
C       BKF [CM^3/#], AF [#/CM^3]
C 
 
        READ(5,91) C80
        WRITE(IOCODE,92) C80
        READ(5,*) BKF,AF
        WRITE(IOCODE,*) BKF,AF
C 
C     INPUT FRACTION OF GAS THAT IS FLOWING, XF
C 
 
        READ(5,91) C80
        WRITE(IOCODE,92) C80
        READ(5,*) XF
        WRITE(IOCODE,*) XF

C
C     INPUT CONSTANTS FOR MOBILITY MODIFICATION
C       B, AK3, VREF3 [CM/SEC], C3
C
 
        READ(5,91) C80
        WRITE(IOCODE,92) C80
        READ(5,*) B,AK3,VREF3,C3
        WRITE(IOCODE,*) B,AK3,VREF3,C3
        ENDIF
 
C
C     END OF INPUT DATA
C
	  WRITE(IOCODE,*) 
        WRITE(IOCODE,*)' **  END OF INPUT FOAM DATA  *********** '
        WRITE(IOCODE,*)' ###################################### '
  91    FORMAT(A80)
  92    FORMAT(1x,A80)
 1000   FORMAT(1x,'IFOAM = ', I3)

        RETURN
        END SUBROUTINE INPUTF
C
      SUBROUTINE INTERP(X,Y,N,XO,YO)
      DIMENSION X(1),Y(1)
C.... Interpolation routine for increasing independent variable (X)
      IF(XO.LE.X(1)) YO = Y(1)
      IF(XO.LE.X(1)) RETURN
      IF(XO.GE.X(N)) YO=Y(N)
      IF(XO.GE.X(N)) RETURN
      DO 10 I=2,N
      IF(XO.GE.X(I)) GO TO 10
      YO=Y(I-1) +(XO-X(I-1))*(Y(I)-Y(I-1))/(X(I)-X(I-1))
      RETURN
  10  CONTINUE
      END SUBROUTINE INTERP
      SUBROUTINE INTPVT(BPT,RM,X,Y,N,XO,YO)
      DIMENSION X(1),Y(1)
      IF(XO.GT.BPT)GO TO 100
      IF(XO.GE.X(N))YO=Y(N)
      IF(XO.GE.X(N))RETURN
      IF(XO.LE.X(1)) YO = Y(1)
      IF(XO.LE.X(1)) RETURN
      DO 10 I=2,N
      IF(XO.GE.X(I))GO TO 10
      YO=Y(I-1)+(XO-X(I-1))*(Y(I)-Y(I-1))/(X(I)-X(I-1))
      RETURN
   10 CONTINUE
  100 CONTINUE
      DO 200 I=2,N
      IF(BPT.GE.X(I))GO TO 200
      YOBP=Y(I-1)+(BPT-X(I-1))*(Y(I)-Y(I-1))/(X(I)-X(I-1))
      YO=YOBP+RM*(XO-BPT)
      RETURN
  200 CONTINUE
      END SUBROUTINE INTPVT
C
      SUBROUTINE LSOR(AW,AE,AS,AN,AT,AB,E,B,OMEGA,TOL
     &               ,NX,NY,NZ,NCYCLE,MITER,IOCODE,KSW1,KSW3
     &               ,UM,AZL,BZL,CZL,DZL,UZL,BETA,GAMMA,W,P)
C
C     THIS PROGRAM SOLVES A LINEAR SYSTEM OF THREE-DIMENSIONAL FINITE-
C     DIFFERENCE EQUATIONS BY LINE SUCCESSIVE OVERRELAXATION
C
      DIMENSION AW(NX*NY*NZ),AE(NX*NY*NZ),AN(NX*NY*NZ),AS(NX*NY*NZ)
     &         ,AB(NX*NY*NZ),AT(NX*NY*NZ),E(NX*NY*NZ),B(NX*NY*NZ)
     &         ,P(NX*NY*NZ)
      DIMENSION UM(1),AZL(1),BZL(1),CZL(1),DZL(1),UZL(1),BETA(1)
     &         ,GAMMA(1),W(1)
C
      DMAX=0.0
      NXY = NX*NY
      NXYZ = NXY*NZ
      IF(NCYCLE .GT. 0 .AND. OMEGA .LT. 0.0) OMEGA = 1.375
      DO 100 IB = 1,NXYZ
        P(IB) = 0.0
  100 CONTINUE
      IT = 0
  200 CONTINUE
      IF(IT .GE. MITER) THEN
        WRITE(IOCODE,1200) IT,TOL,DMAX
        RETURN
      ENDIF
      IT = IT + 1
      TW = 1.0 - OMEGA
      DMAXLT = DMAX
      DMAX = 0.0
      DO 600 J = 1,NY
        DO 550 I = 1,NX
          DO 400 K = 1,NZ
            IB = I + NX*(J-1) + NXY*(K-1)
            UM(K) = P(IB)
            AZL(K) = AT(IB)
            BZL(K) = E(IB)
            CZL(K) = AB(IB)
            BB = B(IB)
            IF(I .NE.  1) BB = BB - AW(IB)*P(IB-1)
            IF(I .NE. NX) BB = BB - AE(IB)*P(IB+1)
            IF(J .NE.  1) BB = BB - AS(IB)*P(IB-NX)
            IF(J .NE. NY) BB = BB - AN(IB)*P(IB+NX)
            DZL(K) = BB
  400     CONTINUE
          CALL LTRI(NZ,AZL,BZL,CZL,DZL,UZL,BETA,GAMMA,W)
          DO 500 K = 1,NZ
            IB = I + NX*(J-1) + NXY*(K-1)
            P(IB) = TW*UM(K) + OMEGA*UZL(K)
            DM = ABS(P(IB) - UM(K))
            IF(DM .GT. DMAX) DMAX = DM
  500     CONTINUE
  550   CONTINUE
  600 CONTINUE
      IF(NCYCLE .GT. 0) THEN
        IF(MOD(IT,NCYCLE) .EQ. 0) THEN
          THETA = DMAX/DMAXLT
          IF(THETA .LT. 1.0) THEN
            OM = OMEGA - 1.0
            RHOSQ = (THETA+OM)*(THETA+OM)/(THETA*OMEGA*OMEGA)
            IF(RHOSQ .LT. .9999) THEN
              OMEGOP = 2.0/(1.0+SQRT(1.0-RHOSQ))
            ELSE
              OMEGOP = OMEGA
            ENDIF
          ELSE
            OMEGOP = OMEGA
          ENDIF
          OMEGA = 1.25*OMEGOP - 0.5
          IF(OMEGA .LT. 1) OMEGA = 1.0
        ENDIF
      ENDIF
      IF(IT .EQ. 1) DMAX0 = DMAX
      IF(DMAX .GT. TOL .AND. (DMAX/DMAX0) .GT. 1.D-3) GOTO 200
      IF(KSW3 .GT. 0) WRITE(IOCODE,1600) IT,OMEGA
      IF(KSW1 .GT. 0 .AND. KSW3 .GT. 0) WRITE(8,1600) IT,OMEGA
      RETURN
 1200 FORMAT(T15,'LINE SOR DID NOT CONVERGE IN ',I5
     &      ,' ITERATIONS'/T15,'TOL = ',F10.7,10X,'DMAX = ',F15.7)
 1600 FORMAT(T5,'LINE SOR CONVERGED AFTER ',I3
     &      ,' ITERATIONS WITH OMEGA = ',F6.3)
      END SUBROUTINE LSOR
      SUBROUTINE LTRI(N,A,BI,C,D,X,BETA,GAMMA,W)
C
C     THIS PR0GRAM SOLVES THE TRIDIAGONAL SYSTEM
C     GENERATED BY THE SYSTEM OF N EQUATIONS
C
      DIMENSION A(1),BI(1),C(1),D(1),X(1),BETA(1),GAMMA(1),W(1)
      BETA(1) = BI(1)
      GAMMA(1) = D(1)/BI(1)
      NM = N - 1
      DO 100 I = 1,NM
        W(I) = C(I)/BETA(I)
        IP = I + 1
        BETA(IP) = BI(IP) - A(IP)*W(I)
  100 CONTINUE
      DO 200 I = 2,N
        IM = I - 1
        GAMMA(I) = (D(I)-A(I)*GAMMA(IM))/BETA(I)
  200 CONTINUE
      X(N) = GAMMA(N)
      DO 300 J = 1,NM
        I = N - J
        IP = I + 1
        X(I) = GAMMA(I) - W(I)*X(IP)
  300 CONTINUE
      RETURN
      END SUBROUTINE LTRI
C
      SUBROUTINE MATBL2(PN,P,VP,QO,QW,QG,QS,STBO,STBW,MCFGT,MCFS1T
     &                 ,MCFS2T,MCFS3T,MCFS4T,STBON,STBWN,MCFGN,MCFS1N
     &                 ,MCFS2N,MCFS3N,MCFS4N,DELT,RESVOL,NSLUGS
     &                 ,IJKM,COP,CWP,CGP,CS1P,CS2P,CS3P,CS4P
     &                 ,CWI,CGI,CS1I,CS2I,CS3I,CS4I,OPR,WPR,GPR,S1PR
     &                 ,S2PR,S3PR,S4PR,WIR,GIR,S1IR,S2IR,S3IR,S4IR,MBEO
     &                 ,MBEW,MBEG,MBES1,MBES2,MBES3,MBES4,PAVG0,PAVG)
      PARAMETER (D5615 = 1.0/5.615)
      DIMENSION PN(IJKM),P(IJKM),VP(IJKM),QO(IJKM),QW(IJKM),QG(IJKM)
     &         ,QS(4*IJKM)
      DIMENSION SP(4),SI(4)
      EQUIVALENCE (SP(1),S1P) , (SP(2),S2P) , (SP(3),S3P) , (SP(4),S4P)
     &          , (SI(1),S1I) , (SI(2),S2I) , (SI(3),S3I) , (SI(4),S4I)
      REAL MCFGT,MCFS1T,MCFS2T,MCFS3T,MCFS4T,MCFGN,MCFS1N,MCFS2N,MCFS3N
     &    ,MCFS4N,MBEO,MBEW,MBEG,MBES1,MBES2,MBES3,MBES4
C
C.... **************** REMARKS ON UNITS ********************************
C (1) Input values of QO, QW & QG are in STBO/D, STBW/D & MCFG/D
C (2) Internally,     QO, QW & QG are in SCFO/D, SCFW/D & SCFG/D
C (3) MBE'S are done in done (below) in  STBO/D, STBW/D & MCFG/D
C (4) Solvents will be handled exactly as  hydrocarbon gas
C....*******************************************************************
      MBEO  = 0.0
      MBEW  = 0.0
      MBEG  = 0.0
      MBES1 = 0.0
      MBES2 = 0.0
      MBES3 = 0.0
      MBES4 = 0.0
      FACT1 = DELT * D5615
      FACT2 = DELT * 0.001
      DIV1  = 1.0/DELT
      DIV2  = 1./RESVOL
C
      PAVG0 = 0.0
      PAVG  = 0.0
      OP = 0.0
      WP = 0.0
      GP = 0.0
      WI = 0.0
      GI = 0.0
      IF(NSLUGS .GT. 0) THEN
        S1P = 0.0
        S2P = 0.0
        S3P = 0.0
        S4P = 0.0
        S1I = 0.0
        S2I = 0.0
        S3I = 0.0
        S4I = 0.0
      ENDIF
      IBS = 0
      DO 200 IB = 1,IJKM
        PAVG0 = PAVG0 + PN(IB)*VP(IB)
        PAVG = PAVG + P(IB)*VP(IB)
        OP = OP + QO(IB)*FACT1
        IF(QW(IB) .GT. 0.0) WP = WP + QW(IB)*FACT1
        IF(QW(IB) .LT. 0.0) WI = WI - QW(IB)*FACT1
        IF(QG(IB) .GT. 0.0) GP = GP + QG(IB)*FACT2
        IF(QG(IB) .LT. 0.0) GI = GI - QG(IB)*FACT2
        DO 100 ISOL = 1,NSLUGS
          IBS = IBS + 1
          IF(QS(IBS) .GT. 0.0) SP(ISOL) = SP(ISOL) + QS(IBS)*FACT2
          IF(QS(IBS) .LT. 0.0) SI(ISOL) = SI(ISOL) - QS(IBS)*FACT2
  100   CONTINUE
  200 CONTINUE
      PAVG = PAVG  * DIV2
      PAVG0= PAVG0 * DIV2
      OPR  = OP * DIV1
      WPR  = WP * DIV1
      GPR  = GP * DIV1
      WIR  = WI * DIV1
      GIR  = GI * DIV1
      COP = COP + OP
      CWP = CWP + WP
      CGP = CGP + GP
      CWI = CWI + WI
      CGI = CGI + GI
C
      DENOM = STBON - OP
      IF(ABS(DENOM) .GE. 1.E-07) MBEO = 100.*(STBO/DENOM - 1.0)
C
      DENOM = STBWN - WP + WI
      IF(ABS(DENOM) .GE. 1.E-07) MBEW = 100.*(STBW/DENOM - 1.0)
C
      DENOM = MCFGN - GP + GI
      IF(ABS(DENOM) .GE. 1.E-07 .AND. MCFGT .GT. 100.) 
     &                           MBEG = 100.*(MCFGT/DENOM - 1.0) 
C
      IF(NSLUGS .GT. 0) THEN
        S1PR  = S1P * DIV1
        S1IR  = S1I * DIV1
        S2PR  = S2P * DIV1
        S2IR  = S2I * DIV1
        S3PR  = S3P * DIV1
        S3IR  = S3I * DIV1
        S4PR  = S4P * DIV1
        S4IR  = S4I * DIV1
        CS1P = CS1P + S1P
        CS1I = CS1I + S1I
        CS2P = CS2P + S2P
        CS2I = CS2I + S2I
        CS3P = CS3P + S3P
        CS3I = CS3I + S3I
        CS4P = CS4P + S4P
        CS4I = CS4I + S4I
C
        DENOM = MCFS1N - S1P + S1I
        IF(ABS(DENOM) .GE. 1.E-07 .AND. MCFS1T .GT. 100.) 
     &     MBES1 = 100.*(MCFS1T/DENOM - 1.0)
C
        DENOM = MCFS2N - S2P + S2I
        IF(ABS(DENOM) .GE. 1.E-07 .AND. MCFS2T .GT. 100.) 
     &     MBES2 = 100.*(MCFS2T/DENOM - 1.0)
C
        DENOM = MCFS3N - S3P + S3I
        IF(ABS(DENOM) .GE. 1.E-07 .AND. MCFS3T .GT. 100.) 
     &     MBES3 = 100.*(MCFS3T/DENOM - 1.0)
C
        DENOM = MCFS4N - S4P + S4I
        IF(ABS(DENOM) .GE. 1.E-07 .AND. MCFS4T .GT. 100.)
     &     MBES4 = 100.*(MCFS4T/DENOM - 1.0)
      ENDIF
      RETURN
      END SUBROUTINE MATBL2
C
      SUBROUTINE MBESF(NN,NI,NJ,NK,IJKM,DT,DV, 
     &                   BES,BEB,TOBI,TOBO,TOSMI,TOSMO, 
     &                   QW,QGP,CS,BNF,CSI,BNFI,
     &                   SW,FI,ROW,SG,BLN,GF,
     &                   IQN1,IQN2,IQN3,LAYER,KIP,NVQN,NW,idir)

        DIMENSION DV(NI,NJ,NK),QW(NI,NJ,NK),QGP(NI,NJ,NK),CSI(NW)

        DIMENSION BNF(NI,NJ,NK),SW(NI,NJ,NK),
     &            FI(NI,NJ,NK),ROW(NI,NJ,NK),SG(NI,NJ,NK),
     &            CS(NI,NJ,NK),BLN(NI,NJ,NK),GF(NI,NJ,NK)
        DIMENSION BNFI(NW),IQN1(NW),IQN2(NW),IQN3(NW),LAYER(NW),KIP(NW)
       dimension idir(nw)

      COMMON/SURFP/ROR,DELTA,CKS,AS
      COMMON/POPP/CK2,CSREF,BKF,AF,BK1,BNC,VREF1,VREF2,C1,C2,E1,E2
      COMMON/MAXLIM/SOLIM,CSLIM,XF,SGLIM,SWLIM
      COMMON/ZERO/SMAS0,BUBB0

      IF(NN.EQ.0)GOTO 777
C*****
C     CALCULATE CUMULATIVE SURFACTANT-IN AND SURFACTANT-OUT [#]
C     CALCULATE CUMULATIVE BUBBLE-IN AND BUBBLE-OUT [#]
C*****
          BI = 0.0
          BO = 0.0
          SMO = 0.0
          SMI = 0.0
      
      DO 200 K=1,NK
      DO 200 J=1,NJ
      DO 200 I=1,NI

      IF(QW(I,J,K).GT.0.0) SMO = SMO + QW(I,J,K)*CS(I,J,K)
      IF(QGP(I,J,K).GT.0.0) BO =  BO + QGP(I,J,K)*BNF(I,J,K)
200      CONTINUE

          DO 202 IW=1,NVQN
               IF(IDIR(IW).EQ.3) THEN
                  IQ1=IQN1(IW)
                  IQ2=IQN2(IW)
                  IQ3 = IQN3(IW)
               ELSEIF(IDIR(IW).EQ.2) THEN 
                  IQ1=IQN3(IW)
                  IQ2=IQN1(IW)
                  IQ3=IQN2(IW)
               ELSE
                  IQ1=IQN2(IW)
                  IQ2=IQN3(IW)
                  IQ3=IQN1(IW)
               ENDIF
                 LAY   =  IQ3 + LAYER(IW) - 1
              DO 201 KK1=IQ3,LAY
                 IF (IDIR(IW).EQ.3) THEN
                     QWEN=QW(IQ1,IQ2,KK1)
                     QGPEN=QGP(IQ1,IQ2,KK1)  
                 ELSEIF(IDIR(IW).EQ.2) THEN
                     QWEN=QW(IQ1,KK1,IQ2)
                     QGPEN=QGP(IQ1,KK1,IQ2)                  
                 ELSE
                     QWEN=QW(KK1,IQ1,IQ2)
                     QGPEN=QGP(KK1,IQ1,IQ2)      
                 ENDIF
              IF(KIP(IW).EQ.2.OR.KIP(IW).EQ.-2.OR.KIP(IW).EQ.-12) THEN
           IF(QWEN.LT.0.0) THEN
                 SMI = SMI - QWEN*CSI(IW)
              ENDIF
              ENDIF

              IF(KIP(IW).EQ.100.OR.KIP(IW).EQ.-4.OR.KIP(IW).EQ.-14) THEN
           IF(QGPEN.LT.0.0) THEN
                BI = BI - QGPEN*BNFI(IW)
              END IF

          ENDIF
201         CONTINUE
202       CONTINUE
      DO 300 K=1,NK
      DO 300 J=1,NJ
      DO 300 I=1,NI
         BI = BI + GF(I,J,K) 
         BO = BO + BLN(I,J,K)
300   CONTINUE 

          BO = BO*DT
          BI = BI*DT
          SMO = SMO*DT
          SMI = SMI*DT

          TOBI = TOBI + BI 
          TOBO = TOBO + BO
          TOSMI = TOSMI + SMI 
          TOSMO = TOSMO + SMO


C*****
C     CALCULATE MASS ACCUMULATED IN SYSTEM 
C     AND SURFACTANT (INCLUDING ADSORPTION) [G]
C     AND CALCULATE BUBBLE ACCUMULATED IN SYSTEM [#]
C*****

777     CONTINUE
        SMAS = 0.0
        BBUB = 0.0

        XXXX1 = ROR*DELTA*CKS*AS
        XXXX2 = (1.0 - XF)*BKF*AF

        DO 803 K = 1,NK
        DO 801 J = 1,NJ
        DO 802 I = 1,NI

          SMAS = SMAS + (SW(I,J,K)*FI(I,J,K)*ROW(I,J,K)*CS(I,J,K)
     1         + (1.0 - FI(I,J,K))*CS(I,J,K)*XXXX1
     2         /(1.0 + CKS*CS(I,J,K)))*DV(I,J,K)
          BBUB = BBUB + (SG(I,J,K)*FI(I,J,K)*BNF(I,J,K)
     1         *(XF + XXXX2/(1.0 + BKF*BNF(I,J,K))))*DV(I,J,K)
802     CONTINUE
801     CONTINUE
803     CONTINUE

        IF(NN.EQ.0)THEN
          SMAS0 = SMAS
          BUBB0 = BBUB
          RETURN
        ENDIF

C*****
C     CALCULATE MATERIAL BALANCE ERRORS [%] FOR SURFACTANT 
C     (NO OIL INJECTION)
C     AND BUBBLE POPULATION BALANCE ERROR [%]
C*****

          BES = 0.0
          BEB = 0.0

          IF(SMAS.GT.0.0)THEN
             BES = (1.0 - (SMAS0 - TOSMO + TOSMI)/SMAS)*100.0
             PRINT *,'SMAS0=',SMAS0,' TOSMO=',TOSMO,' TOSMI=',TOSMI
             PRINT *,'SMAS=',SMAS
            IF(ABS(BES).GE.0.1)THEN
              WRITE(6,*)' SURFACTANT BALANCE [%] = ',BES
            ENDIF
          ENDIF
          IF(BBUB.GT.0.0)THEN
            BEB = (1.0 - (TOBI - TOBO + BUBB0)/BBUB)*100.0
            IF(ABS(BEB).GE.0.1)THEN
              WRITE(6,*)' BUBBLE BALANCE [%] = ',BEB
            ENDIF
          ENDIF


        RETURN
      END SUBROUTINE MBESF
      SUBROUTINE MSOLVE(AL3,AL2,AL1,AD,AU1,AU2,AU3,R
     &                 ,INX,INXY,IJKM,XX)
C
C     INPUT ARRAYS: AL3,AL2,AL1,AD,AU1,AU2,AU3,R
C     OUTPUT ARRAY: XX
C
      DIMENSION AL3(IJKM),AL2(IJKM),AL1(IJKM),AD(IJKM)
     &         ,AU1(IJKM),AU2(IJKM),AU3(IJKM)
      DIMENSION XX(IJKM),R(IJKM)
C
C     FORWARD ELIMINATION
C
      XX(1) = AD(1)*R(1)
      DO 100 I = 2,INX
        XX(I) = AD(I)*(R(I)-AL1(I)*XX(I-1))
  100 CONTINUE
      DO 200 I = INX+1,INXY
        XX(I) = AD(I)*(R(I)-AL1(I)*XX(I-1)-AL2(I)*XX(I-INX))
  200 CONTINUE
      DO 300 I = INXY+1,IJKM
        XX(I) = AD(I)*(R(I)-AL1(I)*XX(I-1)-AL2(I)*XX(I-INX)
     &         -AL3(I)*XX(I-INXY))
  300 CONTINUE
      DO 400 I = 1,IJKM
        XX(I) = XX(I)/AD(I)
  400 CONTINUE
C
C     BACK SUBSTITUTION
C
      DO 500 I = IJKM-1,IJKM-INX+1,-1
        XX(I) = AD(I)*(XX(I)-AU1(I)*XX(I+1))
  500 CONTINUE
      DO 600 I = IJKM-INX,IJKM-INXY+1,-1
        XX(I) = AD(I)*(XX(I)-AU1(I)*XX(I+1)-AU2(I)*XX(I+INX))
  600 CONTINUE
      DO 700 I = IJKM-INXY,1,-1
        XX(I) = AD(I)*(XX(I)-AU1(I)*XX(I+1)-AU2(I)*XX(I+INX)
     &         -AU3(I)*XX(I+INXY))
  700 CONTINUE
      RETURN
      END SUBROUTINE MSOLVE
      SUBROUTINE MVEC(AL3,AL2,AL1,AU1,AU2,AU3,R
     &               ,INX,INXY,IJKM,C)
C
C     INPUT ARRAYS: AL3,AL2,AL1,AU1,AU2,AU3,R
C     OUTPUT ARRAY: C
C
      DIMENSION AL3(IJKM),AL2(IJKM),AL1(IJKM)
     &         ,AU1(IJKM),AU2(IJKM),AU3(IJKM)
      DIMENSION R(IJKM), C(IJKM)
      DO 100 I = 1,IJKM
        C(I) = R(I)
  100 CONTINUE
      DO 200 I = 1,IJKM-1
        C(I) = C(I) + AU1(I)*R(I+1)
  200 CONTINUE
      DO 300 I = 1,IJKM-INX
        C(I) = C(I) + AU2(I)*R(I+INX)
  300 CONTINUE
      DO 400 I = 1,IJKM-INXY
        C(I) = C(I) + AU3(I)*R(I+INXY)
  400 CONTINUE
      DO 500 I = 2,IJKM
        C(I) = C(I) + AL1(I)*R(I-1)
  500 CONTINUE
      DO 600 I = INX+1,IJKM
        C(I) = C(I) + AL2(I)*R(I-INX)
  600 CONTINUE
      DO 700 I = INXY+1,IJKM
        C(I) = C(I) + AL3(I)*R(I-INXY)
  700 CONTINUE
      RETURN
      END SUBROUTINE MVEC
C
      SUBROUTINE NODES2(IFOAM,IOCODE,QVS,IQN1,IQN2,IQN3,NVQN,KSIS
     &               ,PID,PWF,KIP,WELLID,IDIR
     &               ,LAYER,QVO,QVW,QVG,QVT,NW,NWL
     &         ,II,JJ,KK,DX,DY,DZ,KX,KY,KZ,IWM,RW,XSI,BNFI,iswith)

      DIMENSION QVS(NW),IQN1(NW),IQN2(NW),IQN3(NW),IDIR(NW)
      DIMENSION PID(NW,NWL),PWF(NW,NWL),KIP(NW),
     & LAYER(NW),QVO(NW),
     & RW(NW,NWL),
     & QVW(NW),QVG(NW),QVT(NW)
      DIMENSION DX(II,JJ,KK),DY(II,JJ,KK),DZ(II,JJ,KK),KX(II,JJ,KK)
     & ,KY(II,JJ,KK),KZ(II,JJ,KK),IWM(NW),XSI(NW),BNFI(NW),iswith(nw)
      REAL KX,KY,KZ,KKX,KKY,KKZ
      CHARACTER C80*80
      CHARACTER*5 WELLID(NW)
C
C     ESTABLISH RATE-SPECIFIED & PRESSURE-SPECIFIED WELLS
C
C     INPUT RATE SIGNS BY CONVENTION:
C     INJECTORS ARE NEGATIVE; PRODUCERS ARE POSITIVE.
C
C     NOTE: If KIP(J) = 100, QVS(J) is injection of Base Solvent
C           If KIP(J) = 200, QVS(J) is injection of Solvent 2
C           If KIP(J) = 300, QVS(J) is injection of Solvent 3
C           If KIP(J) = 400, QVS(J) is injection of Solvent 4
C
      READ(5,8080) C80
8080  FORMAT (A80)
      write(*,1111) NWL
 1111 format(1x,'NWL=',I5)
      READ(5,*) NVQN,KSIS
      IF(NVQN .EQ. 0) GOTO 900
      IF(NVQN.GT.NW)THEN
        WRITE(IOCODE,999)
999     FORMAT(//,T5,75('*'),/,T15,
     &   'NUMBERS OF WELL ENTERED EXCEED MAXIMUM DECLARED IN MASTER',
     &   /,T5,75('*'),/)
		PRINT *,""
		PRINT *,"NUMBERS OF WELL EXCEED MAXIMUM DECLARED IN MASTER"
		PRINT *,"Simulation is being terminated."
		PRINT *,""
        STOP
      ENDIF
      WRITE(IOCODE,1000) NVQN,KSIS
      WRITE(IOCODE,1010)
      DO 200 J = 1,NVQN
        READ(5,'(A5)') WELLID(J)
        READ(5,*) IQN1(J),IQN2(J),IQN3(J),LAYER(J),KIP(J)
     & ,QVO(J),QVW(J),QVG(J),QVT(J),QVS(J),IDIR(J),IWM(J),iswith(j)
        write(*,*) IQN1(J),IQN2(J),IQN3(J),LAYER(J),KIP(J)
     & ,QVO(J),QVW(J),QVG(J),QVT(J),QVS(J),IDIR(J),IWM(J),iswith(j)

        IF(IDIR(J).EQ.3) THEN
	     IQ1=IQN1(J)
		 IQ2=IQN2(J)
		 IQ3=IQN3(J)
        ELSEIF(IDIR(J).EQ.2) THEN
           IQ1=IQN3(J)	
           IQ2=IQN1(J)
           IQ3=IQN2(J)
        ELSE
           IQ1=IQN2(J)
           IQ2=IQN3(J)
           IQ3=IQN1(J)
        ENDIF
        LAY = IQ3 + (LAYER(J)-1)
        DO 150 K = IQ3,LAY
           READ(5,*) RW(J,K), PWF(J,K)
           IF(IDIR(J).EQ.1) THEN
              BWIDTH=0.
              YWC=0.
              DO 110 J1=1,JJ
                 BWIDTH=BWIDTH+DY(K,J1,IQ2)
                 IF (J1.LT.IQ1) THEN
                    YWC=YWC+DY(K,J1,IQ2)
                 ENDIF
                 IF (J1.EQ.IQ1) THEN
                    YWC=YWC+DY(K,J1,IQ2)/2.
                 ENDIF
 110          CONTINUE
              HTHICK=0.
              ZWC=0.
              DO 115 K1=1,KK
                 HTHICK=HTHICK+DZ(K,IQ1,K1)
                 IF (K1.LT.IQ2) THEN
                    ZWC=ZWC+DZ(K,IQ1,K1)
                 ENDIF
                 IF(K1.EQ.IQ2) THEN
                    ZWC=ZWC+DZ(K,IQ1,K1)/2.
                 ENDIF
 115          CONTINUE
              DDY=DY(K,IQ1,IQ2)
              DDZ=DZ(K,IQ1,IQ2)
              KKY=KY(K,IQ1,IQ2)
              KKZ=KZ(K,IQ1,IQ2)
              CALL RADIUS(BWIDTH,HTHICK,DDY,DDZ,YWC,ZWC,KKY,KKZ
     &                        ,RO,IWM(J),KK)
C
C   TO SHUT IN A LAYER SET RW = 0 SO THAT PID = 0
C
              IF(ABS(RW(J,K)).GT.0.000001)THEN 
              PID(J,K)=0.00708*(KKY*KKZ)**0.5*DX(K,IQ1,IQ2)
     &                 /(LOG(RO/RW(J,K)))
              ELSE
              PID(J,K)=0.0
              ENDIF
          WRITE(IOCODE,1110) k,IQN2(J),IQN3(J),QVO(J),QVW(J),QVG(J)
     &                    ,QVT(J),QVS(J),PWF(J,K),PID(J,K)
           ELSEIF(IDIR(J).EQ.2) THEN
              ALENGT=0.
              XWC=0.
              DO 120 I=1,II 
                 ALENGT=ALENGT+DX(I,K,IQ1) 
                 IF(I.LT.IQ2) THEN
                    XWC=XWC+DX(I,K,IQ1) 
                 ENDIF
                 IF(I.EQ.IQ2) THEN
                    XWC=XWC+DX(I,K,IQ1)/2.
                 ENDIF
 120          CONTINUE
              HTHICK=0.
              ZWC=0.
              DO 125 K1=1,KK
                 HTHICK=HTHICK+DZ(IQ2,K,K1)
                 IF (K1.LT.IQ1) THEN
                    ZWC=ZWC+DZ(IQ2,K,K1)
                 ENDIF
                 IF(K1.EQ.IQ1) THEN
                    ZWC=ZWC+DZ(IQ2,K,K1)/2.
                 ENDIF
 125          CONTINUE
              DDX=DX(IQ2,K,IQ1)
              DDZ=DZ(IQ2,K,IQ1)
              KKX=KX(IQ2,K,IQ1)
              KKZ=KZ(IQ2,K,IQ1)
              CALL RADIUS(ALENGT,HTHICK,DDX,DDZ,XWC,ZWC,KKX,KKZ
     &               ,RO,IWM(J),KK)
              IF(ABS(RW(J,K)).GT.0.000001)THEN 
              PID(J,K)=0.00708*(KKX*KKZ)**0.5*DY(IQ1,K,IQ2)
     &             /(LOG(RO/RW(J,K)))
              ELSE
              PID(J,K)=0.0
              ENDIF
          WRITE(IOCODE,1110) IQN1(J),k,IQN3(J),QVO(J),QVW(J),QVG(J)
     &                    ,QVT(J),QVS(J),PWF(J,K),PID(J,K)
          ELSE
             ALENGT=0.
             XWC=0.
             DO 130 I=1,II
                ALENGT=ALENGT+DX(I,IQ2,K)
                IF (I.LT.IQ1) THEN
                   XWC=XWC+DX(I,IQ2,K)
                ENDIF
                IF(I.EQ.IQ1) THEN
                   XWC=XWC+DX(I,IQ2,K)/2.
                ENDIF
 130         CONTINUE
             BWIDTH=0.
             YWC=0.
             DO 135 J1=1,JJ
                BWIDTH=BWIDTH+DY(IQ1,J1,K)
                IF(J1.LT.IQ2) THEN
                   YWC=YWC+DY(IQ1,J1,K)
                ENDIF
                IF(J1.EQ.IQ2) THEN
                   YWC=YWC+DY(IQ1,J1,K)/2.
                ENDIF
 135         CONTINUE
             DDX=DX(IQ1,IQ2,K)
             DDY=DY(IQ1,IQ2,K)
             KKX=KX(IQ1,IQ2,K)
             KKY=KY(IQ1,IQ2,K)
             write(*,66) ALENGT,BWIDTH
 66          format(1x, f13.6,f13.6)
             write(*,66) DDX,DDY
             write(*,66) XWC,YWC
             CALL RADIUS(ALENGT,BWIDTH,DDX,DDY,XWC,YWC,KKX
     &            ,KKY,RO,IWM(J),JJ)
              IF(ABS(RW(J,K)).GT.0.000001)THEN 
             PID(J,K)=0.00708*(KKX*KKY)**0.5*DZ(IQ1,IQ2,K)
     &            /(LOG(RO/RW(J,K)))
              ELSE
              PID(J,K)=0.0
              ENDIF
          WRITE(IOCODE,1110) IQN1(J),IQN2(J),K,QVO(J),QVW(J),QVG(J)
     &                    ,QVT(J),QVS(J),PWF(J,K),PID(J,K)
          ENDIF
          write(*,51) J,K,PID(J,K)
 51       format(1x,'PID(',I3,',',I3,')=',F15.10)
  150   CONTINUE
  200 CONTINUE
C
C ***  Read CS rate specified at water injection well only
C ***  or,read BNF rate specified at solvent or gas injection wells only.

      IF(IFOAM.EQ.1) THEN
      DO 7050 J=1,NVQN
         XSI(J) = 0.0
         BNFI(J)= 0.0
         IF(KIP(J).EQ.2.OR.KIP(J).EQ.-2.OR.KIP(J).EQ.-12) THEN
            READ(5,*) XSI(J)
         ELSEIF(KIP(J).EQ.1.OR.KIP(J).EQ.-1.OR.KIP(J).EQ.-11)then
               GO TO 401
           else
            READ(5,*) BNFI(J)
         END IF
401         CONTINUE
7050  CONTINUE
      END IF
C
      WRITE(IOCODE,1150)
      DO 500 J = 1,NVQN
         IF(IDIR(J).EQ.3) THEN
        IQ3 = IQN3(J)
        LAY = IQ3 + (LAYER(J)-1)
        WRITE(IOCODE, 1330) J, IDIR(J)
        DO 400 K = IQ3,LAY
          IF(KIP(J) .GE. 100) THEN
            JTMP = KIP(J)/100
            IF(JTMP .EQ. 1) THEN
              WRITE(IOCODE,1200) IQN1(J),IQN2(J),K
            ELSE
              WRITE(IOCODE,1210) IQN1(J),IQN2(J),K,JTMP
            ENDIF
          ELSEIF(KIP(J) .EQ. 0) THEN
            WRITE(IOCODE,1215) IQN1(J),IQN2(J),K
          ELSEIF(KIP(J) .EQ. 1) THEN
            WRITE(IOCODE,1220) IQN1(J),IQN2(J),K
          ELSEIF(KIP(J) .EQ. 2) THEN
            IF(KSIS .EQ. 0) THEN
              WRITE(IOCODE,1230) IQN1(J),IQN2(J),K
            ELSE
              WRITE(IOCODE,1240) IQN1(J),IQN2(J),K
            ENDIF
          ELSEIF(KIP(J) .EQ. 3) THEN
            WRITE(IOCODE,1250) IQN1(J),IQN2(J),K
          ELSEIF(KIP(J) .EQ. -1) THEN
            WRITE(IOCODE,1260) IQN1(J),IQN2(J),K
          ELSEIF(KIP(J) .EQ. -2) THEN 
            WRITE(IOCODE,1270) IQN1(J),IQN2(J),K
            IF(KSIS .EQ. 1) WRITE(IOCODE,1280)
          ELSEIF(KIP(J) .EQ. -3) THEN
            WRITE(IOCODE,1290) IQN1(J),IQN2(J),K
          ELSEIF(KIP(J) .EQ. -11) THEN
            WRITE(IOCODE,1300) IQN1(J),IQN2(J),K
          ELSEIF(KIP(J) .EQ. -12) THEN
            WRITE(IOCODE,1310) IQN1(J),IQN2(J),K
            IF(KSIS .EQ. 1) WRITE(IOCODE,1280)
          ELSEIF(KIP(J) .EQ. -13) THEN
            WRITE(IOCODE,1320) IQN1(J),IQN2(J),K
          ENDIF
  400   CONTINUE
        ELSEIF(IDIR(J).EQ.2) THEN
           IQ3=IQN2(J)
           LAY=IQ3+(LAYER(J)-1)
           WRITE(IOCODE,1330) J,IDIR(J)
           DO 425 K=IQ3,LAY
              IF(KIP(J).GE.100) THEN
                 JTMP=KIP(J)/100
                 IF(JTMP.EQ.1) THEN
                    WRITE(IOCODE,1200) IQN1(J),K,IQN3(J)
                 ELSE
                    WRITE(IOCODE,1210) IQN1(J),K,IQN3(J),JTMP
                 ENDIF
              ELSEIF(KIP(J).EQ.0) THEN
                 WRITE(IOCODE,1215) IQN1(J),K,IQN3(J)
              ELSEIF(KIP(J).EQ.1) THEN
                 WRITE(IOCODE,1220) IQN1(J),K,IQN3(J)
              ELSEIF(KIP(J).EQ.2) THEN
                 if(ksis.eq.0) then
                    write(iocode,1230) iqn1(j),k,iqn3(j)
                 else
                    write(iocode,1240) iqn1(j),k,iqn3(j)
                 endif
              elseif(kip(j).eq.3) then
                 write(iocode,1250) iqn1(j),k,iqn3(j)
              elseif(kip(j).eq.-1) then
                 write(iocode,1260) iqn1(j),k,iqn3(j)
              elseif(kip(j).eq.-2) then
                 write(iocode,1270) iqn1(j),k,iqn3(j)
                 IF(KSIS.EQ.1) WRITE(IOCODE,1280)
              ELSEIF(KIP(J).EQ.-3) THEN
                 WRITE(IOCODE,1290) IQN1(J),K,IQN3(J)
              ELSEIF(KIP(J).EQ.-11) THEN
                 WRITE(IOCODE,1300) IQN1(J),K,IQN3(J)
              ELSEIF(KIP(J).EQ.-12) THEN
                 WRITE(IOCODE,1310) IQN1(J),K,IQN3(J)
                 IF(KSIS.EQ.1) WRITE(IOCODE,1280)
              ELSEIF(KIP(J).EQ.-13) THEN
                 WRITE(IOCODE,1320) IQN1(J),K,IQN3(J)
              ENDIF
 425          CONTINUE
              ELSE
                 IQ3=IQN1(J)
                 LAY=IQ3+(LAYER(J)-1)
                 WRITE(IOCODE,1330) J,IDIR(J)
                 DO 450 K=IQ3,LAY
                    IF(KIP(J).GE.100) THEN
                       JTMP=KIP(J)/100
                    IF(JTMP.EQ.1) THEN
                       WRITE(IOCODE,1200) K,IQN2(J),IQN3(J)
                    ELSE
                       WRITE(IOCODE,1210) K,IQN2(J),IQN3(J)
                    ENDIF
                    ELSEIF(KIP(J).EQ.0) THEN
                       WRITE(IOCODE,1215) K,IQN2(J),IQN3(J)
                    ELSEIF(KIP(J).EQ.1) THEN
                       WRITE(IOCODE,1220) K,IQN2(J),IQN3(J)
                    ELSEIF(KIP(J).EQ.2) THEN
                       IF(KSIS.EQ.0) THEN
                          WRITE(IOCODE,1230) K,IQN2(J),IQN3(J)
                       ELSE
                          WRITE(IOCODE,1240) K,IQN2(J),IQN3(J)
                       ENDIF
                    ELSEIF(KIP(J).EQ.3) THEN
                       WRITE(IOCODE,1250) K,IQN2(J),IQN3(J)
                    ELSEIF(KIP(J).EQ.-1) THEN
                       WRITE(IOCODE,1260) K,IQN2(J),IQN3(J)
                    ELSEIF(KIP(J).EQ.-2) THEN
                       WRITE(IOCODE,1270) K,IQN2(J),IQN3(J)
                       IF(KSIS.EQ.1) WRITE(IOCODE,1280)
                    ELSEIF(KIP(J).EQ.-3) THEN
                       WRITE(IOCODE,1290) K,IQN2(J),IQN3(J)
                    ELSEIF(KIP(J).EQ.-11) THEN
                       WRITE(IOCODE,1300) K,IQN2(J),IQN3(J)
                    ELSEIF(KIP(J).EQ.-12) THEN
                       WRITE(IOCODE,1310) K,IQN2(J),IQN3(J)
                    ELSEIF(KIP(J).EQ.-13) THEN
                       WRITE(IOCODE,1320) K,IQN2(J),IQN3(J)
                    ENDIF
 450                CONTINUE
                    ENDIF
 500                CONTINUE
  900 CONTINUE
      RETURN
 1000 FORMAT(//,T15,'NVQN, KSIS = ',2I5)
 1010 FORMAT(//T15,'RESERVOIR CONTAINS THE FOLLOWING RATE NODES',/
     &      ,1X,'   NODE   ',3X,'  OIL(STBD)',3X,'WATER(STBD)'
     &      ,3X,'GAS(MCFD)',3X,'TOTAL(STBD)',3X,'SOLVENT(MCFD)'
     &      ,3X,'BHFP(PSIA)',6X,'PID')
 1100 FORMAT(A5,5I5,5F10.0)
 1110 FORMAT(1X,3I3,3X,F11.2,5F13.2,F14.6)
 1150 FORMAT(/)
 1200 FORMAT(T15,'BLOCK ',3I3,
     & ' CONTAINS A RATE SPECIFIED  "BASE SOLVENT"  INJECTION WELL')
 1210 FORMAT(T15,'BLOCK ',3I3,
     & ' CONTAINS A RATE SPECIFIED  "SOLVENT',I3,'"  INJECTION WELL')
 1215 FORMAT(T15,'BLOCK ',3I3,
     & ' CONTAINS A SPECIAL HISTORY MATCHING PRODUCING WELL')
 1220 FORMAT(T15,'BLOCK ',3I3,
     & ' CONTAINS A RATE SPECIFIED PRODUCING WELL')
 1230 FORMAT(T15,'BLOCK ',3I3,
     & ' CONTAINS A RATE SPECIFIED WATER INJECTION WELL')
 1240 FORMAT(T15,'BLOCK ',3I3,
     & ' CONTAINS A RATE SPECIFIED WATER INJECTION WELL',
     & ' WITH MOBILITY CONTROL AGENT')
 1250 FORMAT(T15,'BLOCK ',3I3,
     & ' CONTAINS A RATE SPECIFIED GAS INJECTION WELL')
 1260 FORMAT(T15,'BLOCK ',3I3,' CONTAINS AN ',
     & 'EXPLICIT PRESSURE SPECIFIED PRODUCING WELL')
 1270 FORMAT(T15,'BLOCK ',3I3, ' CONTAINS AN ',
     & 'EXPLICIT PRESSURE SPECIFIED WATER INJECTION WELL')
 1280 FORMAT(/,T30,'WITH MOBILITY CONTROL AGENT')
 1290 FORMAT(T15,'BLOCK ',3I3,' CONTAINS AN ',
     & 'EXPLICIT PRESSURE SPECIFIED GAS INJECTION WELL')
 1300 FORMAT(T15,'BLOCK ',3I3,' CONTAINS AN ',
     & 'IMPLICIT PRESSURE SPECIFIED PRODUCING WELL')
 1310 FORMAT(T15,'BLOCK ',3I3,' CONTAINS AN ',
     & 'IMPLICIT PRESSURE SPECIFIED WATER INJECTION WELL')
 1320 FORMAT(T15,'BLOCK ',3I3,' CONTAINS AN ',
     & 'IMPLICIT PRESSURE SPECIFIED GAS INJECTION WELL')
 1330 FORMAT(T15, 'IDIR(',I2,')=',I1)
      END SUBROUTINE NODES2
      SUBROUTINE ORTH(AL3,AL2,AL1,AD,AU1,AU2,AU3,TOL
     &               ,INX,INXY,IJKM,ITMAX,IOCODE,KSW1,KSW3
     &               ,RN,DXN,ADX,QI,AQI,QN,AQN,DP)
C
C     INPUT ARRAYS: AL3,AL2,AL1,AD,AU1,AU2,AU3,RN 
C     OUTPUT ARRAYS: DXN,ADX,QI,AQI,QN,AQN,DP,RN
C     WORK ARRAY: AQIAQI
C
      DIMENSION AL3(IJKM),AL2(IJKM),AL1(IJKM),AD(IJKM)
     &         ,AU1(IJKM),AU2(IJKM),AU3(IJKM)
      DIMENSION DP(IJKM),RN(IJKM),DXN(IJKM),ADX(IJKM)
      DIMENSION AQIAQI(15),QI(15,IJKM),AQI(15,IJKM)
      DIMENSION QN(IJKM),AQN(IJKM)
      DATA NMAX/15/
      CONV1 = TOL*TOL
      IF(CONV1 .GT. 1.E-4) CONV1 = 1.E-4
      RSQ = 0.0
      DO 100 IB = 1,IJKM
        DP(IB) = 0.0
        RSQ = RSQ + RN(IB)*RN(IB)
  100 CONTINUE
      CONV = CONV1*RSQ
      N = 0
      DO 800 ITER = 1,ITMAX
        IT = ITER
        IF(N .EQ. NMAX) N = 0
        N = N + 1
        NM1 = N - 1
        CALL MSOLVE(AL3,AL2,AL1,AD,AU1,AU2,AU3,RN
     &             ,INX,INXY,IJKM,DXN)
        CALL MVEC(AL3,AL2,AL1,AU1,AU2,AU3,DXN
     &           ,INX,INXY,IJKM,ADX)
        IF(N .EQ. 1) THEN
          DO 200 IB = 1,IJKM
            QN(IB) = DXN(IB)
            AQN(IB) = ADX(IB)
            QI(1,IB) = QN(IB)
            AQI(1,IB) = AQN(IB)
  200     CONTINUE
        ELSE
          DO 300 IB = 1,IJKM
            QN(IB) = DXN(IB)
  300     CONTINUE
          DO 500 I = 1,NM1
            AQIADX = 0.0
            DO 350 IB = 1,IJKM
              AQIADX = AQIADX + AQI(I,IB)*ADX(IB)
  350       CONTINUE
            AI = AQIADX/AQIAQI(I)
            DO 400 IB = 1,IJKM
              QN(IB) = QN(IB) - AI*QI(I,IB)
  400       CONTINUE
  500     CONTINUE
          CALL MVEC(AL3,AL2,AL1,AU1,AU2,AU3,QN
     &             ,INX,INXY,IJKM,AQN)
          DO 650 IB = 1,IJKM
            QI(N,IB) = QN(IB)
            AQI(N,IB) = AQN(IB)
  650     CONTINUE
        ENDIF
        AQNAQN = 0.0
        AQNRN = 0.0
        DO 700 IB = 1,IJKM
          AQNAQN = AQNAQN + AQN(IB)*AQN(IB)
          AQNRN = AQNRN + AQN(IB)*RN(IB)
  700   CONTINUE      
        AQIAQI(N) = AQNAQN
        OMEGA = AQNRN/AQNAQN
        RSQ = 0.0
        DO 750 IB = 1,IJKM
          DP(IB) = DP(IB) + OMEGA*QN(IB)
          RN(IB) = RN(IB) - OMEGA*AQN(IB)
          RSQ = RSQ + RN(IB)*RN(IB)
  750   CONTINUE
        IF(RSQ .LT. CONV) GOTO 900
  800 CONTINUE
  900 CONTINUE
      IF(KSW3 .GT. 0) WRITE(IOCODE,1900) IT
      IF(KSW1 .GT. 0 .AND. KSW3 .GT. 0) WRITE(8,1900) IT
      RETURN
 1900 FORMAT(5X,'ORTHOMIN CONVERGED AFTER ',I3,' ITERATIONS')
      END SUBROUTINE ORTH
      SUBROUTINE PARM1(IOCODE,II,JJ,KK,DUMMY,VP,KX,KY,KZ)
C
C     WORK ARRAY: DUMMY
C
      DIMENSION DUMMY(1),VP(II,JJ,KK),KX(II,JJ,KK),KY(II,JJ,KK)
     &         ,KZ(II,JJ,KK)
      REAL KX,KY,KZ,KXC,KYC,KZC
      CHARACTER C80*80
      READ(5,1000) C80
C
C     READ INPUT CODES FOR PHI,KX,KY,KZ
C
      READ(5,*)KPH,KKX,KKY,KKZ
C
C     ESTABLISH POROSITY (PHI) DISTRIBUTION
C
      IF(KPH .LT. 0) THEN
        READ(5,*)PHIC
        DO 140 K = 1,KK
        DO 140 J = 1,JJ
        DO 140 I = 1,II
          VP(I,J,K) = PHIC
  140   CONTINUE
        WRITE(IOCODE,1100)
        WRITE(IOCODE,26)PHIC
      ELSEIF(KPH .EQ. 0) THEN
        READ(5,*)(DUMMY(K),K=1,KK)
        DO 150 K = 1,KK
        DO 150 J = 1,JJ
        DO 150 I = 1,II
          VP(I,J,K) = DUMMY(K)
  150   CONTINUE
        DO 160 K=1,KK
          WRITE(IOCODE,510) K,DUMMY(K)
  160   CONTINUE
      ELSE
        WRITE(IOCODE,39)
        DO 180 K = 1,KK
          WRITE(IOCODE,38)K
          DO 170 J = 1,JJ
            READ(5,*)(VP(I,J,K),I=1,II)
            WRITE(IOCODE,73)(VP(I,J,K),I=1,II)
  170     CONTINUE
  180   CONTINUE
      ENDIF
      WRITE(IOCODE,1100)
C
C     ESTABLISH PERMEABILITY (KX) DISTRIBUTION
C
      IF(KKX .LT. 0) THEN
        READ(5,*)KXC
        DO 200 K = 1,KK
        DO 200 J = 1,JJ
        DO 200 I= 1,II
          KX(I,J,K)=KXC
  200   CONTINUE
        WRITE(IOCODE,1100)
        WRITE(IOCODE,29)KXC
      ELSEIF(KKX .EQ. 0) THEN
        READ(5,*)(DUMMY(K),K=1,KK)
        DO 187 K=1,KK
        DO 187 J=1,JJ
        DO 187 I=1,II
  187     KX(I,J,K)=DUMMY(K)
          DO 182 K=1,KK
  182       WRITE(IOCODE,511)K,DUMMY(K)
      ELSE
        WRITE(IOCODE,43)
        DO 192 K=1,KK
          WRITE(IOCODE,38)K
          DO 190 J=1,JJ
            READ(5,*)(KX(I,J,K),I=1,II)
  190       WRITE(IOCODE,72)(KX(I,J,K),I=1,II)
  192  CONTINUE
      ENDIF
      WRITE(IOCODE,1100)
C
C     ESTABLISH PERMEABILITY (KY) DISTRIBUTION
C
      IF(KKY .LT. 0) THEN
        READ(5,*)KYC
        DO 202 K=1,KK
        DO 202 J=1,JJ
        DO 202 I=1,II
202       KY(I,J,K)=KYC
        WRITE(IOCODE,1100)
        WRITE(IOCODE,33)KYC
      ELSEIF(KKY .EQ. 0) THEN
        READ(5,*)(DUMMY(K),K=1,KK)
        DO 205 K=1,KK
        DO 205 J=1,JJ
        DO 205 I=1,II
  205     KY(I,J,K)=DUMMY(K)
        DO 210 K=1,KK
  210     WRITE(IOCODE,512)K,DUMMY(K)
      ELSE
        WRITE(IOCODE,47)
        DO 212 K=1,KK
          WRITE(IOCODE,38)K
          DO 215 J=1,JJ
            READ(5,*)(KY(I,J,K),I=1,II)
  215       WRITE(IOCODE,72)(KY(I,J,K),I=1,II)
  212   CONTINUE
      ENDIF
      WRITE(IOCODE,1100)
C
C     ESTABLISH PERMEABILITY (KZ) DISTRIBUTION
C
      IF(KKZ .LT. 0) THEN
        READ(5,*)KZC
        DO 230 K=1,KK
        DO 230 J=1,JJ
        DO 230 I=1,II
230       KZ(I,J,K)=KZC
        WRITE(IOCODE,1100)
        WRITE(IOCODE,36)KZC
      ELSEIF(KKZ .EQ. 0) THEN
        READ(5,*)(DUMMY(K),K=1,KK)
        DO 235 K=1,KK
        DO 235 J=1,JJ
        DO 235 I=1,II
  235     KZ(I,J,K)=DUMMY(K)
        DO 237 K=1,KK
  237   WRITE(IOCODE,513)K,DUMMY(K)
      ELSE
        WRITE(IOCODE,48)
        DO 240 K=1,KK
        WRITE(IOCODE,38)K
        DO 242 J=1,JJ
          READ(5,*)(KZ(I,J,K),I=1,II)
  242     WRITE(IOCODE,72)(KZ(I,J,K),I=1,II)
240     CONTINUE
      ENDIF
      WRITE(IOCODE,1100)
C
C     POROSITY AND PERMEABILITY MODIFICATIONS
C
      READ(5,1000) C80
      READ(5,*) NUMP,NUMKX,NUMKY,NUMKZ,IPCODE
      IF(NUMP .GT. 0) THEN
        WRITE(IOCODE,27)
        DO 500 L = 1,NUMP
          READ(5,*) I,J,K,VP(I,J,K)
          WRITE(IOCODE,32) I,J,K,VP(I,J,K)
  500   CONTINUE
        IF(IPCODE .EQ. 1) THEN
          WRITE(IOCODE,39)
          DO 550 K = 1,KK
            WRITE(IOCODE,38) K
            DO 525 J = 1,JJ
              WRITE(IOCODE,73) (VP(I,J,K),I=1,II)
  525       CONTINUE
  550     CONTINUE
        ENDIF
      ENDIF
      IF(NUMKX .GT. 0) THEN
        WRITE(IOCODE,31)
        DO 600 L = 1,NUMKX
          READ(5,*) I,J,K,KX(I,J,K)
          WRITE(IOCODE,32) I,J,K,KX(I,J,K)
  600   CONTINUE
        IF(IPCODE .EQ. 1) THEN
          WRITE(IOCODE,43)
          DO 650 K = 1,KK
            WRITE(IOCODE,38) K
            DO 625 J = 1,JJ
              WRITE(IOCODE,72) (KX(I,J,K),I=1,II)
  625       CONTINUE
  650     CONTINUE
        ENDIF
      ENDIF
      IF(NUMKY .GT. 0) THEN
        WRITE(IOCODE,34)
        DO 700 L=1,NUMKY
          READ(5,*) I,J,K,KY(I,J,K)
          WRITE(IOCODE,32) I,J,K,KY(I,J,K)
  700   CONTINUE
        IF(IPCODE .EQ. 1) THEN
          WRITE(IOCODE,47)
          DO 750 K = 1,KK
            WRITE(IOCODE,38) K
            DO 725 J = 1,JJ
              WRITE(IOCODE,72) (KY(I,J,K),I=1,II)
  725       CONTINUE
  750     CONTINUE
        ENDIF
      ENDIF
      IF(NUMKZ .GT. 0) THEN
        WRITE(IOCODE,37)
        DO 800 L = 1,NUMKZ
          READ(5,*) I,J,K,KZ(I,J,K)
          WRITE(IOCODE,32) I,J,K,KZ(I,J,K)
  800   CONTINUE
        IF(IPCODE .EQ. 1) THEN
          WRITE(IOCODE,48)
          DO 850 K = 1,KK
            WRITE(IOCODE,38) K
            DO 825 J = 1,JJ
              WRITE(IOCODE,72) (KZ(I,J,K),I=1,II)
  825       CONTINUE
  850     CONTINUE
        ENDIF
      ENDIF
      RETURN
 1000 FORMAT(A80)
 1100 FORMAT(//)
26    FORMAT(T15,'POROSITY (PHI) IS INITIALLY SET AT',F8.4,' FOR ALL',
     &' NODES'//)
   72 FORMAT(1X,20F6.2)
   73 FORMAT(1X,20F6.3)
   27 FORMAT(//T15,'**********POROSITY NODE MODIFICATIONS**********',
     &//T15,'     I    J    K          NEW PHI VALUE')
29    FORMAT(T15,'PERMEABILITY (KX) IS INITIALLY',
     &' SET AT',F10.4,' FOR ALL NODES'//)
   31 FORMAT(//T15,'**********PERMEABILITY (KX) NODE MODIFICATIONS',
     &'**********',//T15,'     I    J    K          NEW KX VALUE')
32    FORMAT(15X,3I5,5X,F14.4)
33    FORMAT(T15,'PERMEABILITY (KY) IS INITIALLY',
     &' SET AT',F10.4,' FOR ALL NODES'//)
   34 FORMAT(//T15,'**********PERMEABILITY (KY) NODE MODIFICATIONS',
     &'**********',//T15,'     I    J    K          NEW KY VALUE')
36    FORMAT(T15,'PERMEABILITY (KZ) IS INITIALLY',
     &' SET AT',F10.4,' FOR ALL NODES'//)
   37 FORMAT(//T15,'**********PERMEABILITY (KZ) NODE MODIFICATIONS',
     &'**********',//T15,'     I    J    K          NEW KZ VALUE')
38    FORMAT(/1X,'K =',I2/)
39    FORMAT(//T15,'**********POROSITY DISTRIBUTION FOLLOWS**********'/)
43    FORMAT(//T15,'**********PERMEABILITY (KX) DISTRIBUTION**********'
     &/)
47    FORMAT(//T15,'**********PERMEABILITY (KY) DISTRIBUTION**********'
     &/)
48    FORMAT(//T15,'**********PERMEABILITY (KZ) DISTRIBUTION**********'
     &/)
  510 FORMAT(//T15,'POROSITY IN LAYER',I5,' IS INITIALLY SET AT',F8.5,
     &' FOR ALL NODES',/)
  511 FORMAT(T15,'PERMEABILITY (KX) IN LAYER',I5,' IS INITIALLY SET AT'
     &,F8.2,' FOR ALL NODES',/)
  512 FORMAT(T15,'PERMEABILITY (KY) IN LAYER',I5,' IS INITIALLY SET AT'
     &,F8.2,' FOR ALL NODES',/)
  513 FORMAT(T15,'PERMEABILITY (KZ) IN LAYER',I5,' IS INITIALLY SET AT'
     &,F8.2,' FOR ALL NODES',/)
      END SUBROUTINE PARM1
      SUBROUTINE PFUN(P,PBOT,SO,SW,SG,VG,VS,DPO,NSLUGS,IJKM,MPOT,MPWT
     &                ,MPGT,VP,BO,BW,BG,BS,RSOR,RSWR,RSO,RSWS1,E,AWG
     &                ,AWS,C21,C23,C31,C33,CSP,CSS,BVBP)
C
C     THIS ROUTINE COMPUTES FUNCTIONS OF PRESSURE AND SATURATION PRESSURE
C     WHICH ARE UPDATED EVERY ITERATION
C
      DIMENSION P(IJKM),PBOT(IJKM),SO(IJKM),SW(IJKM),SG(IJKM),VG(IJKM)
     &         ,VS(4*IJKM),DPO(IJKM),VP(IJKM),BO(IJKM),BW(IJKM)
     &         ,BG(IJKM),BS(4*IJKM),RSOR(IJKM),RSWR(IJKM),RSO(4*IJKM)
     &         ,RSWS1(IJKM),E(IJKM),AWG(IJKM),AWS(4*IJKM),C21(IJKM)
     &         ,C23(IJKM),C31(IJKM),C33(IJKM),CSP(4*IJKM),CSS(4*IJKM)
      DIMENSION DRSO(4),CS(4),RLAMDA(4)
C
      REAL KRWT,KRGT,MUOT,MUWT,MUGT,KROWT,KROGT
      COMMON /SPVT/ SWT(10,25),KRWT(10,25),KRGT(10,25),PCOWT(10,25),
     & PCGOT(10,25),POT(25),MUOT(25),BOT(25),BOPT(25),RSOT(25),
     & RSOPT(25),
     & PWT(25),MUWT(25),BWT(25),BWPT(25),RSWT(25),RSWPT(25),
     & PGT(25),MUGT(25),BGT(25),BGPT(25),CRT(25),SWC(10),SORW(10),
     & SGT(10,25),KROWT(10,25),KROGT(10,25),RKOSWC(10),DKOSWC(10),
     & KR3P
C
      PARAMETER (NTE = 25 , NBOT = 51 , NBOTM = NBOT-1) 
      COMMON/PVTRST/PST(NTE,4),VST(NTE,4),BST(NTE,4),RST(NTE,4)
     &             ,RWT(NTE,4),DBSDPT(NTE,4),DRSDPT(NTE,4)
     &             ,DRWDPT(NTE,4),BO1T(NTE),VO1T(NTE)
     &             ,BW1T(NTE),VW1T(NTE),CSC(NTE),FRCO2(NTE)
     &             ,VORST(NBOT),VWRST(NBOT),DVO1T(NBOT),DVW1T(NBOT)
     &             ,UORST(NBOT),UWRST(NBOT),DUO1T(NBOT),DUW1T(NBOT)
     &             ,VORSPT(NBOT),VWRSPT(NBOT),DVO1PT(NBOT)
     &             ,DVW1PT(NBOT),RUSQT(NBOT,4),RUGQT(NBOT)
     &             ,RUOQT(NBOT),USW1T(NBOT,4),UGW1T(NBOT),UOW1T(NBOT)
     &             ,USW2T(NBOT,4),UGW2T(NBOT),UOW2T(NBOT),VOPT(NTE)
     &             ,VWPT(NTE),PSMIN(4),PSMAX(4)
     &             ,BOSLP,BWSLP,BO1SLP,BW1SLP,VOSLP
     &             ,VO1SLP,VW1SLP,COH,CWH,CVOH,PMISC,PMCM,VSMISC
     &             ,OM1,OM2,RDRSO,RDRSW,RDRSO1,RDRSW1,RDMU,RDPRMP
     &             ,NPTS(4),IPSOL(4)
C
C
C  *** This common block contains four varibles separated from
C  *** common block PVTRST 

      COMMON/RHOSTO/RHOSCO,RHOSCG,RHOSCW,RHOSC(4)

      LOGICAL BVBP(IJKM)
      PGMAX = PGT(MPGT)
      PGMIN = PGT(2)
      POMAX = POT(MPOT)
      POMIN = POT(2)
      PWMAX = PWT(MPWT)
      PWMIN = PWT(2)
      IPG = 2
      IPO = 2
      IPW = 2
      DO 800 IB = 1,IJKM
        IF(VP(IB) .LT. 1.0E-6) GOTO 800
        VGG = VG(IB)
        PP = P(IB)
        PPN = PP - DPO(IB)
        CALL INTERP(PGT,CRT,MPGT,PPN,CR)
        VP(IB) = VP(IB)*(1.0+CR*DPO(IB))
        BPT = PBOT(IB)
        X = PP
        IF(X .GE. PGMAX) THEN
          IPG = MPGT
          GOTO 150
        ELSEIF(X .LE. PGMIN) THEN
          IPG = 2
          GOTO 150
        ENDIF
  100   IF(X .GT. PGT(IPG)) THEN
          IPG = IPG + 1
          GOTO 100
        ENDIF
  125   IF(X .LT. PGT(IPG-1)) THEN
          IPG = IPG - 1
          GOTO 125
        ENDIF
  150   IMG = IPG - 1
        GFRAC = (X-PGT(IMG))/(PGT(IPG)-PGT(IMG))
        GFRACM = 1.0 - GFRAC
        VOP = GFRAC*VOPT(IPG) + GFRACM*VOPT(IMG)
        VWP = GFRAC*VWPT(IPG) + GFRACM*VWPT(IMG)
        BBG = GFRAC*BGT(IPG) + GFRACM*BGT(IMG)
        CR = GFRAC*CRT(IPG) + GFRACM*CRT(IMG)
        BG(IB) = BBG
        CG = - BGPT(IPG)/BBG
        IF(PP .GT. BPT) X = BPT
C
C     SOLUBILITY OF SEPARATOR GAS IN OIL
C
        IF(X .GE. POMAX) THEN
          IPO = MPOT
          GOTO 250
        ELSEIF(X .LE. POMIN) THEN
          IPO = 2
          GOTO 250
        ENDIF
  200   IF(X .GT. POT(IPO)) THEN
          IPO = IPO + 1
          GOTO 200
        ENDIF
  225   IF(X .LT. POT(IPO-1)) THEN
          IPO = IPO - 1
          GOTO 225
        ENDIF
  250   IM = IPO - 1
        FRAC = (X-POT(IM))/(POT(IPO)-POT(IM))
        RSOR(IB) = FRAC*RSOT(IPO) + (1.0-FRAC)*RSOT(IM)
        FRAC = 1.0 + RDRSO*VGG*RSOR(IB)
        IRO = FRAC
        IF(IRO .LT. 1) IRO = 1
        IF(IRO .GE. NBOT) IRO = NBOTM
        FX = IRO
        FRAC = FRAC - FX
        VO = FRAC*VORST(IRO+1) + (1.-FRAC)*VORST(IRO)
C
C     SOLUBILITY OF SEPARATOR GAS IN WATER
C
        IF(X .GE. PWMAX) THEN
          IPW = MPWT
          GOTO 350
        ELSEIF(X .LE. PWMIN) THEN
          IPW = 2
          GOTO 350
        ENDIF
  300   IF(X .GT. PWT(IPW)) THEN
          IPW = IPW + 1
          GOTO 300
        ENDIF
  325   IF(X .LT. PWT(IPW-1)) THEN
          IPW = IPW - 1
          GOTO 325
        ENDIF
  350   IM = IPW - 1
        FRAC = (X-PWT(IM))/(PWT(IPW)-PWT(IM))
        RSWR(IB) = FRAC*RSWT(IPW) + (1.0-FRAC)*RSWT(IM)
        FRAC = 1.0 + RDRSW*VGG*RSWR(IB)
        IRW = FRAC
        IF(IRW .LT. 1) IRW = 1
        IF(IRW .GE. NBOT) IRW = NBOTM
        FX = IRW
        FRAC = FRAC - FX
        VW = FRAC*VWRST(IRW+1) + (1.-FRAC)*VWRST(IRW)
        TESTO = VGG*RSOPT(IPO)
        TESTW = VGG*RSWPT(IPW)
C
C     SOLUBILITY OF SOLVENT IN OIL AND WATER
C
        IF(NSLUGS .GT. 0) THEN
          IBASE = NSLUGS*(IB-1)
          ROSUM = 0.0
          ROPSUM = 0.0
          DO 475 ISOL = 1,NSLUGS
            IBS = IBASE + ISOL
            VSS = VS(IBS)
            IPS = IPSOL(ISOL)
            IF(X .GE. PSMAX(ISOL)) THEN
              IPS = NPTS(ISOL)
              GOTO 450
            ELSEIF(X .LE. PSMIN(ISOL)) THEN
              IPS = 2
              GOTO 450
            ENDIF
  400       IF(X .GT. PST(IPS,ISOL)) THEN
              IPS = IPS + 1
              GOTO 400
            ENDIF
  425       IF(X .LT. PST(IPS-1,ISOL)) THEN
              IPS = IPS - 1
              GOTO 425
            ENDIF
  450       IPSOL(ISOL) = IPS
            IMS = IPS - 1
            FRAC = (X-PST(IMS,ISOL))/(PST(IPS,ISOL)-PST(IMS,ISOL))
            FRACM = 1.0 - FRAC
            RSO(IBS) = FRAC*RST(IPS,ISOL) + FRACM*RST(IMS,ISOL)
            BS(IBS) = FRAC*BST(IPS,ISOL) + FRACM*BST(IMS,ISOL)
            DRSO(ISOL) = DRSDPT(IPS,ISOL)
            CS(ISOL) = -DBSDPT(IPS,ISOL)/BS(IBS)
            ROSUM = ROSUM + VSS*RSO(IBS)
            ROPSUM = ROPSUM + VSS*DRSO(ISOL)
            IF(ISOL .EQ. 1) THEN
              RSWS1(IB) = FRAC*RWT(IPS,ISOL) + FRACM*RWT(IMS,ISOL)
              DRSW = DRWDPT(IPS,ISOL)
              RWSUM = VSS*RSWS1(IB)
              RWPSUM = VSS*DRSW
            ENDIF
  475     CONTINUE
          FRAC = 1.0 + RDRSO1*ROSUM
          ISO = FRAC
          IF(ISO .LT. 1) ISO = 1
          IF(ISO .GE. NBOT) ISO = NBOTM
          FX = ISO
          FRAC = FRAC - FX
          VO = VO + FRAC*DVO1T(ISO+1) + (1.0-FRAC)*DVO1T(ISO)
          FRAC = 1.0 + RDRSW1*RWSUM
          ISW = FRAC
          IF(ISW .LT. 1) ISW = 1
          IF(ISW .GE. NBOT) ISW = NBOTM
          FX = ISW
          FRAC = FRAC - FX
          VW = VW + FRAC*DVW1T(ISW+1) + (1.0-FRAC)*DVW1T(ISW)
          BO(IB) = VO*VOP
          BW(IB) = VW*VWP
          DLBOPS = (VGG*VORSPT(IRO)*RSOPT(IPO)+DVO1PT(ISO)*ROPSUM)/VO
          DLBWPS = (VGG*VWRSPT(IRW)*RSWPT(IPW)+DVW1PT(ISW)*RWPSUM)/VW
          SOBO = SO(IB)/BO(IB)
          SWBW = SW(IB)/BW(IB)
C
C     COEFFICIENT CALCULATION
C
          CSG = SG(IB)/BBG + RSOR(IB)*SOBO + RSWR(IB)*SWBW
          DELP = PP - BPT
          IF(DELP .LT. 100.0) DELP = 100.0
          STEST = DELP*(SOBO*(TESTO+ROPSUM)+SWBW*(TESTW+RWPSUM))
          IF(PP .GT. BPT .AND. STEST .GT. (.0001/BBG)) THEN
C
C     VARIABLE BUBBLE POINT LOGIC
C
            BVBP(IB) = .TRUE.
            CSGP = SOBO*RSOPT(IPO) + SWBW*RSWPT(IPW)
            C13  = -SO(IB)*DLBOPS
            C23S = -SW(IB)*DLBWPS
            C33S = VGG*CSGP
            DO 500 ISOL = 1,NSLUGS
              IBS = IBASE + ISOL
              DBODVI = RSO(IBS)*DVO1PT(ISO) - RSOR(IB)*VORSPT(IRO)
              DBWDVI =                      - RSWR(IB)*VWRSPT(IRW)
              RHOSS = SOBO*RSO(IBS)
              DBOP = DRSO(ISOL)*DVO1PT(ISO) - RSOPT(IPO)*VORSPT(IRO)
              DBWP =                        - RSWPT(IPW)*VWRSPT(IRW)
              RHOSSP = SOBO*DRSO(ISOL)
              IF(ISOL .EQ. 1) THEN
                DBWDVI = DBWDVI + RSWS1(IB)*DVW1PT(ISW)
                RHOSS = RHOSS + SWBW*RSWS1(IB)
                DBWP = DBWP + DRSW*DVW1PT(ISW)
                RHOSSP = RHOSSP + SWBW*DRSW
              ENDIF
              CS3 = VS(IBS)*RHOSSP
              IF(RHOSS*BS(IBS) .GT. .0001) THEN
                ZETA = SOBO*DBODVI*VOP/RHOSS
                ETA  = SWBW*DBWDVI*VWP/RHOSS
                RLAMDA(ISOL) = CSG/RHOSS
              ELSE
                ZETA = SOBO*DBOP*VOP/RHOSSP
                ETA  = SWBW*DBWP*VWP/RHOSSP
                RLAMDA(ISOL) = CSGP/RHOSSP
              ENDIF
              C13 = C13 + ZETA*CS3
              C23S = C23S + ETA*CS3
              C33S = C33S + RLAMDA(ISOL)*CS3
              CSP(IBS) = CS3
              CSS(IBS) = RHOSS
              AWS(IBS) = ZETA + ETA
  500       CONTINUE
            C11     = SO(IB)*(CR+COH)
            C21(IB) = SW(IB)*(CR+CWH)
            C23(IB) = C23S
            C33(IB) = C33S
            AG = -(C13+C23S)/C33S
            AWG(IB) = AG 
            E(IB) = C11 + C21(IB)
          ELSE
            BVBP(IB) = .FALSE.
            SSG = SG(IB)
            C11  = SO(IB)*(CR-DLBOPS+COH)
            C21S = SW(IB)*(CR-DLBWPS+CWH)
            C31S = VGG*(SSG*(CR+CG)/BBG+SOBO*RSOPT(IPO)
     &                                 +SWBW*RSWPT(IPW))
            C13 = -1.0
            C23S = 0.0
            C33S = VGG/BBG
            DO 600 ISOL = 1,NSLUGS
              IBS = IBASE + ISOL
              DBODVI = RSO(IBS)*DVO1PT(ISO) - RSOR(IB)*VORSPT(IRO)
              DBWDVI = - RSWR(IB)*VWRSPT(IRW)
              CS1 = SSG/BS(IBS)*(CR+CS(ISOL)) + SOBO*DRSO(ISOL)
              RHOSS = SSG/BS(IBS) + RSO(IBS)*SOBO
              IF(ISOL .EQ. 1) THEN
                DBWDVI = DBWDVI + RSWS1(IB)*DVW1PT(ISW)
                CS1 = CS1 + SWBW*DRSW
                RHOSS = RHOSS + RSWS1(IB)*SWBW
              ENDIF
              IF(RHOSS*BS(IBS) .GT. .0001) THEN
                ZETA = SOBO*DBODVI*VOP/RHOSS
                ETA = SWBW*DBWDVI*VWP/RHOSS
                RLAMDA(ISOL) = CSG/RHOSS
              ELSE
                ZETA = 0.0
                ETA = 0.0
                RLAMDA(ISOL) = BS(IBS)/BBG
              ENDIF
              CS1 = VS(IBS)*CS1
              CS3 = VS(IBS)/BS(IBS)
              C11 = C11 + ZETA*CS1
              C13 = C13 + ZETA*CS3
              C21S = C21S + ETA*CS1
              C23S = C23S + ETA*CS3
              C31S = C31S + RLAMDA(ISOL)*CS1
              C33S = C33S + RLAMDA(ISOL)*CS3
              CSP(IBS) = CS1
              CSS(IBS) = RHOSS
              AWS(IBS) = ZETA + ETA
  600       CONTINUE
            C21(IB) = C21S
            C23(IB) = C23S
            C31(IB) = C31S
            C33(IB) = C33S
            AG = -(C13+C23S)/C33S
            AWG(IB) = AG 
            E(IB) = C11 + C21S + AG*C31S
          ENDIF
          DO 700 ISOL = 1,NSLUGS
            IBS = IBASE + ISOL
            AWS(IBS) = AWS(IBS) + AG*RLAMDA(ISOL)
  700     CONTINUE
        ELSE
          BO(IB) = VO*VOP
          BW(IB) = VW*VWP
          DLBOPS = VORSPT(IRO)*RSOPT(IPO)/VO
          DLBWPS = VWRSPT(IRW)*RSWPT(IPW)/VW
          DELP = PP - BPT
          IF(DELP .LT. 100.0) DELP = 100.0
          STEST = DELP*(SO(IB)/BO(IB)*TESTO+SW(IB)/BW(IB)*TESTW)
          IF(PP .GT. BPT .AND. STEST .GT. (.0001/BBG)) THEN
C
C     VARIABLE BUBBLE POINT LOGIC
C
            BVBP(IB) = .TRUE.
            C11     = SO(IB)*(CR+COH)
            C21(IB) = SW(IB)*(CR+CWH)
            C13     = -SO(IB)*DLBOPS
            C23(IB) = -SW(IB)*DLBWPS
            C33(IB) = SO(IB)*RSOPT(IPO)/BO(IB)
     &              + SW(IB)*RSWPT(IPW)/BW(IB)
            AWG(IB) = -(C13+C23(IB))/C33(IB)
            E(IB) = C11 + C21(IB)
          ELSE
            BVBP(IB) = .FALSE.
            C11     = SO(IB)*(CR-DLBOPS+COH)
            C21(IB) = SW(IB)*(CR-DLBWPS+CWH)
            C31(IB) = SG(IB)*(CR+CG)/BBG + SO(IB)*RSOPT(IPO)/BO(IB)
     &              + SW(IB)*RSWPT(IPW)/BW(IB)
            C33(IB) = 1.0/BBG
            AWG(IB) = BBG
            E(IB) = C11 + C21(IB) + BBG*C31(IB)
          ENDIF
        ENDIF
  800 CONTINUE
      RETURN
      END SUBROUTINE PFUN
C
      SUBROUTINE POP(
     &  DX,DY,DZ,DV,DT,NI,NJ,NK,
     &  BNFPRE,BNF,BLNPRE,BLN,GF,GFPRE,
     &  QGP,SO,SG,SGPRE,FGX,FGY,FGZ,
     &  CS,VC,UG,FI,
     &  BNFI,IQN1,IQN2,IQN3,LAYER,KIP,NVQN,NW,IDIR,
     &  SW,BUX,BUY,BUZ,XX1,XX2,XX3,BLNTMP,RR)


      COMMON/LITER/MAXITR,EPSC,EPSN
      COMMON/POPP/CK2,CSREF,BKF,AF,BK1,BNC,VREF1,VREF2,C1,C2,E1,E2
      COMMON/MAXLIM/SOLIM,CSLIM,XF,SGLIM,SWLIM

      DIMENSION FGX(NI,NJ,NK),FGY(NI,NJ,NK),FGZ(NI,NJ,NK)
      DIMENSION SO(NI,NJ,NK),SG(NI,NJ,NK),SGPRE(NI,NJ,NK)
      DIMENSION BNF(NI,NJ,NK),BNFPRE(NI,NJ,NK)
      DIMENSION BLN(NI,NJ,NK),BLNPRE(NI,NJ,NK)
      DIMENSION GF(NI,NJ,NK),GFPRE(NI,NJ,NK)
      DIMENSION CS(NI,NJ,NK),FI(NI,NJ,NK)
      DIMENSION QGP(NI,NJ,NK),SW(NI,NJ,NK)
      DIMENSION VC(NI,NJ,NK),UG(NI,NJ,NK)
      DIMENSION DX(NI,NJ,NK),DY(NI,NJ,NK),DZ(NI,NJ,NK),DV(NI,NJ,NK)
        DIMENSION RR(NI,NJ,NK)
        DIMENSION XX1(NI,NJ,NK),XX2(NI,NJ,NK)
        DIMENSION XX3(NI,NJ,NK),BLNTMP(NI,NJ,NK)
        DIMENSION BUX(0:NI,NJ,NK),BUY(NI,0:NJ,NK),
     &            BUZ(NI,NJ,0:NK)
        DIMENSION BNFI(NW),IQN1(NW),IQN2(NW),IQN3(NW),LAYER(NW),KIP(NW)
       DIMENSION IDIR(NW)
C*****
C     SAVE THE CURRENT VALUES OF BLN(I,J) [#/SEC], 
C     GF(I,J) [#/SEC], AND BNF(I,J) [#/CM^3]
C*****
        DO 900 K = 1,NK
        DO 911 J = 1,NJ
            DO 912 I = 1,NI
                BLNPRE(I,J,K) = BLN(I,J,K)
                GFPRE(I,J,K) = GF(I,J,K)
                BNFPRE(I,J,K) = BNF(I,J,K)
912         CONTINUE
911     CONTINUE
900     CONTINUE
 
C*****
C     CALCULATE BLN(I,J) AND GF(I,J) 
C*****
         
        DO 850 K = 1,NK 
           DO 850 J = 1,NJ
              DO 850 I = 1,NI 
                 IF(SG(I,J,K).GT.SGLIM .AND. SO(I,J,K).LT.SOLIM
     1                .AND. SW(I,J,K).GT.SWLIM
     1                .AND. CS(I,J,K).GT.CSLIM
     2                .AND. UG(I,J,K).GT.VC(I,J,K))THEN
                    XXXX2 = BK1*DV(I,J,K)/VREF1**C1
                    FK = 1.0 + (BNF(I,J,K)/BNC)**E1 
                    GF(I,J,K) = XXXX2/FK*UG(I,J,K)**C1
         ELSE
                    GF(I,J,K) = 0.0
                 ENDIF
850     CONTINUE
 
        BREAK = CK2 * 1.0E30

        DO 409 K = 1,NK
           DO 409 J = 1,NJ
              DO 409 I = 1,NI
                 IF(SG(I,J,K).GT.SGLIM .AND. SO(I,J,K).LT.SOLIM
     1                .AND. SW(I,J,K).GT.SWLIM
     1                .AND. CS(I,J,K).GT.CSLIM)THEN
                    XXXX1 = CK2*DV(I,J,K)*CSREF**E2/VREF2**C2
                    BLN(I,J,K) = XXXX1/CS(I,J,K)**E2
     1                   *BNF(I,J,K)*UG(I,J,K)**C2
                 ELSE
                    BLN(I,J,K) = BREAK
                 ENDIF
409       CONTINUE

C*****
C     CALCULATE TERM AND COEFFICIENT RELATED TO TRAPPED BUBBLES
C       XX3 [#/SEC]
C*****

        XXXX1 = (1.0 - XF)*BKF*AF
        DO 300 K = 1,NK
           DO 300 J = 1,NJ
              DO 300 I = 1,NI
                 XXXX2 = DV(I,J,K)/DT 
                 FK = XXXX1/(1.0 + BKF*BNFPRE(I,J,K))
                 XX3(I,J,K) = XXXX2*FI(I,J,K)*(XF + FK)
     1                *SGPRE(I,J,K)*BNFPRE(I,J,K)
300     CONTINUE
 
C*****
C     SOLVING FOR BNF(I,J) BY ITERATIVE METHOD
C     (LAGGING GF(I,J) AND BLN(I,J))
C*****
 
        DO 1000 ITER = 1,MAXITR
 
C...... using varying weighing factor to solve scillation problem
C
C          wi= (MAXITR*2 - ITER)/(MAXITR*2.0) * w
C
C     CALCULATE BUX(I,J) [#/CM^2/SEC] AND BUY(I,J) [#/CM^2/SEC]
C     USING GAS VELOCITY [CM/SEC] AT PREVIOUS TIME STEP
C       FGX(0,J) = FGX(NI,J) = 0
C       FGY(I,0) = FGY(I,NJ) = 0
C 
           DO 10 K = 1,NK
              DO 10 J = 1,NJ

                 BUX(0,J,K) = 0.0
                 BUX(NI,J,K) = 0.0

                 IF(NI.GT.1)THEN
        
                    DO 410 I = 1,NI-1
                       IF(FGX(I,J,K).GT.0.0)THEN
                          BUX(I,J,K) = BNF(I,J,K)
                       ELSE
                          BUX(I,J,K) = BNF(I+1,J,K)
                       ENDIF
 410                CONTINUE


                    DO 21 I = 1,NI-1
 21                    BUX(I,J,K) = BUX(I,J,K)*FGX(I,J,K)
                 ENDIF
10      CONTINUE
C
        DO 11 I =1,NI
           DO 11 K = 1,NK
              BUY(I,0,K) = 0.0
              BUY(I,NJ,K) = 0.0
              IF(NJ.GT.1)THEN
                 DO 387 J = 1,NJ-1
                    IF(FGY(I,J,K).GT.0.0)THEN
                       BUY(I,J,K) = BNF(I,J,K)
                    ELSE
                       BUY(I,J,K) = BNF(I,J+1,K)
                    ENDIF
 387             CONTINUE 
                 DO 82 J = 1,NJ-1
 82                 BUY(I,J,K) = BUY(I,J,K)*FGY(I,J,K)
              ENDIF
11      CONTINUE
C 
        DO 12 I =1,NI
           DO 12 J = 1,NJ

              BUZ(I,J,0) = 0.0
              BUZ(I,J,NK) = 0.0

              IF(NK.GT.1)THEN

                 DO 3871 K = 1,NK-1
                    IF(FGZ(I,J,K).GT.0.0)THEN
                       BUZ(I,J,K) = BNF(I,J,K)
                    ELSE
                       BUZ(I,J,K) = BNF(I,J,K+1)
                    ENDIF
 3871            CONTINUE 
 
                 DO 821 K = 1,NK-1
                    BUZ(I,J,K) = BUZ(I,J,K)*FGZ(I,J,K)
 821             CONTINUE 

              ENDIF

 12     CONTINUE
C*****
C     CALCULATE COEFFICIENT AND TERM RELATED TO TRAPPED BUBBLES
C       XX1 [#/SEC], XX2 [CM^3/SEC]
C*****

        XXXX1 = (1.0 - XF)*BKF*AF
        DO 310 K = 1,NK
           DO 310 J = 1,NJ
              DO 310 I = 1,NI
                 RX = DV(I,J,K)/DT*FI(I,J,K)*SG(I,J,K)
                 FK = XXXX1/(1.0 + BKF*BNF(I,J,K))
                 XX1(I,J,K) = RX*BNF(I,J,K)*(XF + FK)
                 XX2(I,J,K) = RX*(XF 
     &                + FK/(1.0 + BKF*BNF(I,J,K)))
310     CONTINUE
C*****
C     UPDATE BNF(I,J) FOR THIS ITERATION
C*****                
        DO 770 K = 1,NK 
           DO 770 J = 1,NJ
              DO 770 I = 1,NI
                 RR(I,J,K) = BNF(I,J,K)
770     CONTINUE
C  ***  calculate the RJWS (injection contribution to Bubble density)
        DO 630 K = 1,NK
           DO 630 J = 1,NJ
              DO 630 I = 1,NI
                    XXXX1 = DV(I,J,K)/DX(I,J,K)
                    XXXX2 = DV(I,J,K)/DY(I,J,K)
                    XXXX22 = DV(I,J,K)/DZ(I,J,K)
                    BNF(I,J,K) = RR(I,J,K) 
     &                      + ( - (BUX(I,J,K) - BUX(I-1,J,K))*XXXX1
     &                      - (BUY(I,J,K) - BUY(I,J-1,K))*XXXX2
     &                      - (BUZ(I,J,K) - BUZ(I,J,K-1))*XXXX22
     &                      + GF(I,J,K) - BLN(I,J,K) 
     &                      + XX3(I,J,K) - XX1(I,J,K))/XX2(I,J,K)
630               CONTINUE

               DO 700 IW=1,NVQN
               IF(IDIR(IW).EQ.3) THEN
                  IQ1=IQN1(IW)
                  IQ2=IQN2(IW)
                  IQ3=IQN3(IW)
               ELSEIF(IDIR(IW).EQ.2) THEN
                  IQ1=IQN3(IW)
                  IQ2=IQN1(IW)
                  IQ3=IQN2(IW)
               ELSE
                  IQ1=IQN2(IW)
                  IQ2=IQN3(IW)
                  IQ3=IQN1(IW)
               ENDIF
                 LAY   =  IQ3 + LAYER(IW) - 1
              DO 710 KK1=IQ3,LAY
                 IF (IDIR(IW).EQ.3) THEN
				QGPEN=QGP(IQ1,IQ2,KK1)
                  RREN=RR(IQ1,IQ2,KK1)
                 ELSEIF(IDIR(IW).EQ.2) THEN
				QGPEN=QGP(IQ2,KK1,IQ1)
                  RREN=RR(IQ2,KK1,IQ1)
                 ELSE
                QGPEN=QGP(KK1,IQ1,IQ2)
                    RREN=RR(KK1,IQ1,IQ2)
                 ENDIF
          IF(KIP(IW).EQ.1.OR.KIP(IW).EQ.-1.OR.KIP(IW).EQ.
     &  -11) THEN
             RJWS=RREN*QGPEN
         ELSE
         IF(KIP(IW).EQ.2.OR.KIP(IW).EQ.-2.OR.KIP(IW).EQ.
     &  -12) THEN
                   GO TO  700
                 ELSE 
                    RJWS=BNFI(IW)*QGPEN
          END IF
          END IF
       if(IDIR(IW).EQ.3) THEN
          BNF(IQ1,IQ2,KK1)=BNF(IQ1,IQ2,KK1)-RJWS/XX2(IQ1,IQ2,KK1)
          elseif(IDIR(IW).EQ.2) THEN
          BNF(IQ2,KK1,IQ1)=BNF(IQ2,KK1,IQ1)-RJWS/XX2(IQ2,KK1,IQ1)
               else
          BNF(KK1,IQ1,IQ2)=BNF(KK1,IQ1,IQ2)-RJWS/XX2(KK1,IQ1,IQ2)
        endif
710                   CONTINUE
700                CONTINUE

              
         DO 645 K = 1,NK
                  DO 645 J = 1,NJ
                     DO 645 I = 1,NI
                  IF(BNF(I,J,K).LT.0.0)THEN
               BLNTMP(I,J,K) = BNF(I,J,K)*XX2(I,J,K)+BLN(I,J,K)
                  IF(BLNTMP(I,J,K).LT.0.0)BLNTMP(I,J,K) = 0.0
                  BNF(I,J,K) = 0.0
                  ENDIF
 645          CONTINUE
C*****
C     IF SUM OF DIFFERENCES OVER I AND J < EPSN, STOP ITERATION
C*****
        

              IF(ITER.GT.1)THEN
         
                 SUM = 0.0
                 DO 950 K = 1,NK
                    DO 950 J = 1,NJ 
                       DO 950 I = 1,NI
                          SUM = SUM + ABS(RR(I,J,K) - BNF(I,J,K))

 950                   CONTINUE
                IF(SUM.LE.EPSN)GOTO 2000
              ENDIF

1000      CONTINUE    
 
C*****
C     END ITREATION
C*****
 
 2000      CONTINUE
    
        IF(ITER.GT.MAXITR)THEN
          WRITE(6,*) ' IN POP RES = ',SUM,' ITER = ',ITER,' RJWS=',
     &     RJWS   
        ENDIF
   
C*****
C     ADJUST BLN(I,J) FOR POPULATION BALANCE
C*****

        DO 840 K=1,NK
        DO 840 J=1,NJ
        DO 840 I=1,NI
        BLN(I,J,K)=BLNTMP(I,J,K)
840     CONTINUE
        RETURN
        END SUBROUTINE POP
C
      SUBROUTINE PRATEI(VG,VS,BO,BW,RSOR,RSWR,RSO,RSWS1,AWG,AWS,GM1
     &                 ,GM2,GM3,GM4,IQN1,IQN2,IQN3,NVQN,NSLUGS,NW
     &                 ,II,JJ,IJKM,E,IDIR
     &                 ,KIP,GMO,GMW,GMG,LAYER,NWL)
C
C     THIS ROUTINE MODIFIES THE PRESSURE EQUATION FOR THOSE BLOCKS
C     CONTAINING AN IMPLICIT PRESSURE WELL.
C
      DIMENSION VG(IJKM),VS(4*IJKM),BO(IJKM),BW(IJKM),RSOR(IJKM)
     &          ,RSWR(IJKM),RSO(4*IJKM),RSWS1(IJKM),AWG(IJKM)
     &          ,AWS(4*IJKM),E(IJKM)
      DIMENSION GM1(NW,1),GM2(NW,1),GM3(NW,1),GM4(NW,1),IDIR(NW)
      DIMENSION IQN1(NW),IQN2(NW),IQN3(NW)
      DIMENSION KIP(NW),GMO(NW,NWL),GMW(NW,NWL),GMG(NW,NWL),LAYER(NW)
      DO 800 IW = 1,NVQN
        ITYPE = -KIP(IW)
        IF(ITYPE .GT. 10) THEN
           IF(IDIR(IW).EQ.3) THEN
          I = IQN1(IW)
          J = IQN2(IW)
          IQ3 = IQN3(IW)
          ELSEIF(IDIR(IW).EQ.2) THEN
             I=IQN3(IW)
             J=IQN1(IW)
             IQ3=IQN2(IW)
          ELSE
             I=IQN2(IW)
             J=IQN3(IW)
             IQ3=IQN1(IW)
          ENDIF
          LAY = IQ3 + LAYER(IW) - 1
          DO 600 K = IQ3,LAY
C 
            IF(IDIR(IW).EQ.3) THEN
            IB = I + II*((J-1)+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=J+II*(K-1+JJ*(I-1))
            ELSE
               IB=K+II*(I-1+JJ*(J-1))
            ENDIF
C 
            AAG = AWG(IB)
            AAO = BO(IB) - AAG*VG(IB)*RSOR(IB)
            AAW = BW(IB) - AAG*VG(IB)*RSWR(IB)
            IF(NSLUGS .GT. 0) THEN
              IBS = 1 + NSLUGS*(IB-1)
              AAO = AAO - AWS(IBS)*VS(IBS)*RSO(IBS)
              AAW = AAW - AWS(IBS)*VS(IBS)*RSWS1(IB)
              DO 100 ISOL = 2,NSLUGS
                IBS = IBS + 1
                AAO = AAO - AWS(IBS)*VS(IBS)*RSO(IBS)
  100         CONTINUE
            ENDIF
            IF(ITYPE .EQ. 11) THEN
              SUMJ = AAO*GMO(IW,K) + AAW*GMW(IW,K) + AAG*GMG(IW,K)
              IF(NSLUGS .GT. 0) THEN
                IBASE = NSLUGS*(IB-1)
                DO 200 ISOL = 1,NSLUGS
                  IBS = IBASE + ISOL
                  IF(ISOL .EQ. 1) SUMJ = SUMJ + AWS(IBS)*GM1(IW,K)
                  IF(ISOL .EQ. 2) SUMJ = SUMJ + AWS(IBS)*GM2(IW,K)
                  IF(ISOL .EQ. 3) SUMJ = SUMJ + AWS(IBS)*GM3(IW,K)
                  IF(ISOL .EQ. 4) SUMJ = SUMJ + AWS(IBS)*GM4(IW,K)
  200           CONTINUE
              ENDIF
              E(IB) = E(IB) - SUMJ
            ELSEIF(ITYPE .EQ. 12) THEN
              E(IB) = E(IB) - AAW*GMW(IW,K)
            ELSEIF(ITYPE .EQ. 13) THEN
              E(IB) = E(IB) - AAG*GMG(IW,K)
            ELSE
              IBASE = NSLUGS*(IB-1)
              IF(ITYPE .EQ. 14) E(IB) = E(IB) - AWS(IBASE+1)*GM1(IW,K)
              IF(ITYPE .EQ. 15) E(IB) = E(IB) - AWS(IBASE+2)*GM2(IW,K)
              IF(ITYPE .EQ. 16) E(IB) = E(IB) - AWS(IBASE+3)*GM3(IW,K)
              IF(ITYPE .EQ. 17) E(IB) = E(IB) - AWS(IBASE+4)*GM4(IW,K)
            ENDIF
  600     CONTINUE
        ENDIF
  800 CONTINUE
      RETURN
      END SUBROUTINE PRATEI
C
      SUBROUTINE PRATEO(DP,GM1,GM2,GM3,GM4,IQN1,IQN2,IQN3,NVQN,NSLUGS
     &                 ,NW,II,JJ,IJKM,QO,QW,QG,QS,GOWT,GWWT,GGWT
     &                 ,GSWT,IDIR,KIP,GMO,GMW,GMG,LAYER,NWL)
      DIMENSION DP(IJKM),GM1(NW,1),GM2(NW,1),GM3(NW,1),GM4(NW,1)
     &         ,QO(IJKM),QW(IJKM),QG(IJKM),QS(4*IJKM),GOWT(IJKM)
     &         ,GWWT(IJKM),GGWT(IJKM),GSWT(4*IJKM),IDIR(NW)
      DIMENSION  IQN1(NW),IQN2(NW),IQN3(NW)
      DIMENSION KIP(NW),GMO(NW,NWL),GMW(NW,NWL),GMG(NW,NWL),LAYER(NW)
C
C     UPDATE RATES AND RESIDUALS FOR WELLS UNDER IMPLICIT BHP CONTROL
C
      DO 800 IW = 1,NVQN
        ITYPE = - KIP(IW)
        IF(ITYPE .GE. 10) THEN
           IF(IDIR(IW).EQ.3) THEN
          I = IQN1(IW)
          J = IQN2(IW)
          IQ3 = IQN3(IW)
          ELSEIF(IDIR(IW).EQ.2) THEN
             I=IQN3(IW)
             J=IQN1(IW)
             IQ3=IQN2(IW)
          ELSE
             I=IQN2(IW)
             J=IQN3(IW)
             IQ3=IQN1(IW)
          ENDIF
          LAY = IQ3 + LAYER(IW) - 1
          DO 600 K = IQ3,LAY
C 
             IF (IDIR(IW).EQ.3) THEN
            IB = I + II*((J-1)+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=J+II*(K-1+JJ*(I-1))
            ELSE
               IB=K+II*(I-1+JJ*(J-1))
            ENDIF
C 
            IF(ITYPE .EQ. 11) THEN
              DDP = DP(IB)
              DQO = GMO(IW,K)*DDP
              DQW = GMW(IW,K)*DDP
              DQG = GMG(IW,K)*DDP
              TQO = QO(IB) + DQO
              IF(TQO.GT.0.)THEN
              QO(IB) = TQO
              ELSE
              DQO=DQO-TQO
              QO(IB) = 0.0
              ENDIF
              TQW = QW(IB) + DQW
              IF(TQW.GT.0.)THEN
              QW(IB) = TQW
              ELSE
              DQW=DQW-TQW
              QW(IB) = 0.0
              ENDIF
              TQG = QG(IB) + DQG
              IF(TQG.GT.0.)THEN
              QG(IB) = TQG
              ELSE
              DQG=DQG-TQG
              QG(IB) = 0.0
              ENDIF
              GOWT(IB) = GOWT(IB) + DQO
              GWWT(IB) = GWWT(IB) + DQW
              GGWT(IB) = GGWT(IB) + DQG
              IF(NSLUGS .GT. 0) THEN
                IBASE = NSLUGS*(IB-1)
                DO 100 ISOL = 1,NSLUGS
                  IBS = IBASE + ISOL
                  IF(ISOL .EQ. 1) THEN
                    DQS = GM1(IW,K)*DDP
                  ELSEIF(ISOL .EQ. 2) THEN
                    DQS = GM2(IW,K)*DDP
                  ELSEIF(ISOL .EQ. 3) THEN
                    DQS = GM3(IW,K)*DDP
                  ELSE
                    DQS = GM4(IW,K)*DDP
                  ENDIF
                  TQS = QS(IBS) + DQS
                  IF(TQS.GT.0.)THEN
                  QS(IBS) = TQS
                  ELSE
                  DQS=DQS-TQS
                  QS(IBS) = 0.0
                  ENDIF
                  GSWT(IBS) = GSWT(IBS) + DQS
  100           CONTINUE
              ENDIF
            ELSEIF(ITYPE .EQ. 12) THEN
              DQW = GMW(IW,K)*DP(IB)
              TQW = QW(IB) + DQW
              IF(TQW.LT.0.)THEN
              QW(IB) = TQW
              ELSE
              DQW=DQW-TQW
              QW(IB) = 0.0
              ENDIF
              GWWT(IB) = GWWT(IB) + DQW
            ELSEIF(ITYPE .EQ. 13) THEN
              DQG = GMG(IW,K)*DP(IB)
              TQG = QG(IB) + DQG
              IF(TQG.LT.0.)THEN
              QG(IB) = TQG
              ELSE
              DQG=DQG-TQG
              QG(IB) = 0.0
              ENDIF
              GGWT(IB) = GGWT(IB) + DQG
            ELSE
              IF(ITYPE .EQ. 14) THEN
                IBS = 1 + NSLUGS*(IB-1)
                DQS = GM1(IW,K)*DP(IB)
              ELSEIF(ITYPE .EQ. 15) THEN
                IBS = 2 + NSLUGS*(IB-1)
                DQS = GM2(IW,K)*DP(IB)
              ELSEIF(ITYPE .EQ. 16) THEN
                IBS = 3 + NSLUGS*(IB-1)
                DQS = GM3(IW,K)*DP(IB)
              ELSEIF(ITYPE .EQ. 17) THEN
                IBS = 4 + NSLUGS*(IB-1)
                DQS = GM4(IW,K)*DP(IB)
              ENDIF
              TQS = QS(IBS) + DQS
              IF(TQS.LT.0.)THEN
              QS(IBS) = TQS
              ELSE
              DQS=DQS-TQS
              QS(IBS) = 0.0
              ENDIF
              GSWT(IBS) = GSWT(IBS) + DQS
            ENDIF
  600     CONTINUE
        ENDIF
  800 CONTINUE
      RETURN
      END SUBROUTINE PRATEO
C
      SUBROUTINE PRTPS2(P,SO,SW,SG,VS,PBOT,RSOR,XS,PN,SON,SWN
     &                 ,SGN,VSN,OPR,COP,WPR,CWP,WIR,CWI,GPR,CGP
     &                 ,GIR,CGI,S1PR,CS1P,S1IR,CS1I,S2PR,CS2P,S2IR
     &                 ,CS2I,S3PR,CS3P,S3IR,CS3I,S4PR,CS4P,S4IR,CS4I
     &                 ,MBEO,MBEW,MBEG,MBES1,MBES2,MBES3,MBES4
     &                 ,CMBEO,CMBEW,CMBEG,CMBE1,CMBE2,CMBE3,CMBE4
     &                 ,ETI,DELT,PAVG,PAVG0,SOMIN,PRECIP,II,JJ,KK
     &                 ,IJKM,NSTEP,NSLUGS,IPMAP,ISOMAP,ISWMAP
     &                 ,ISGMAP,IPBMAP,IRSMAP,IS1MAP,IS2MAP,IS3MAP
     &                 ,IS4MAP,MOBCTL,IOCODE,CS,BNF,IFOAM,BES,BEB)
      REAL MBEO,MBEW,MBEG,MBES1,MBES2,MBES3,MBES4
      DIMENSION P(II,JJ,KK),SO(II,JJ,KK),SW(II,JJ,KK),SG(II,JJ,KK)
     &         ,VS(4*IJKM),PBOT(II,JJ,KK),RSOR(II,JJ,KK),XS(II,JJ,KK)
      DIMENSION PN(II,JJ,KK),SON(II,JJ,KK),SWN(II,JJ,KK),SGN(II,JJ,KK)
     &         ,VSN(4*IJKM),CS(II,JJ,KK),BNF(II,JJ,KK)
      DIMENSION DS(4),SM(4),ISM(4),JSM(4),KSM(4)
      DATA SCFBBL/5.615/
      IF(NSTEP .EQ. 0) THEN
        WRITE(IOCODE,1000)
        GOTO 300
      ENDIF
      PPM = 0.
      SOM = 0.
      SWM = 0.
      SGM = 0.
      IPM = 0
      IOM = 0
      IWM = 0
      IGM = 0
      JPM = 0
      JOM = 0
      JWM = 0
      JGM = 0
      KPM = 0
      KOM = 0
      KWM = 0
      KGM = 0
      DO 100 ISOL = 1,NSLUGS
        SM(ISOL) = 0.0
        ISM(ISOL) = 0
        JSM(ISOL) = 0
        KSM(ISOL) = 0
  100 CONTINUE
      IBS = 0
      DO 160 K = 1,KK
      DO 160 J = 1,JJ
      DO 160 I = 1,II
      DPO = P(I,J,K) - PN(I,J,K)
      DSO = SO(I,J,K) - SON(I,J,K)
      DSW = SW(I,J,K) - SWN(I,J,K)
      DSG = SG(I,J,K) - SGN(I,J,K)
      DO 110 ISOL = 1,NSLUGS
        IBS = IBS + 1
        DS(ISOL) = VS(IBS) - VSN(IBS)
  110 CONTINUE
      IF(ABS(DPO) .GT. ABS(PPM)) THEN
        PPM = DPO
        IPM = I
        JPM = J
        KPM = K
      ENDIF
      IF(ABS(DSO) .GT. ABS(SOM)) THEN
        SOM = DSO
        IOM = I
        JOM = J
        KOM = K
      ENDIF
      IF(ABS(DSW) .GT. ABS(SWM)) THEN
        SWM = DSW
        IWM = I
        JWM = J
        KWM = K
      ENDIF
      IF(ABS(DSG) .GT. ABS(SGM)) THEN
        SGM = DSG
        IGM = I
        JGM = J
        KGM = K
      ENDIF
      DO 120 ISOL = 1,NSLUGS
        IF(ABS(DS(ISOL)) .GT. ABS(SM(ISOL))) THEN
          SM(ISOL) = DS(ISOL)
          ISM(ISOL) = I
          JSM(ISOL) = J
          KSM(ISOL) = K
        ENDIF
  120 CONTINUE
  160 CONTINUE
C------------------------------------------------------------------
      WRITE(IOCODE,1160)
      WRITE(IOCODE,1170)
      WRITE(IOCODE,1180)
      TGPR=GPR+S1PR+S2PR+S3PR+S4PR
      TGIR=GIR+S1IR+S2IR+S3IR+S4IR
      TCGI=CGI+CS1I+CS2I+CS3I+CS4I
      TCGP=CGP+CS1P+CS2P+CS3P+CS4P
      IF(OPR .GT. 1.E-6) THEN
        WOR = WPR/OPR
        GOR = 1000.*TGPR/OPR
        S1OR = 1000.*S1PR/OPR
      ELSE
        WOR = 0.
        GOR = 0.
        S1OR = 0.
      ENDIF
      IF(COP .GT. 1.E-6) THEN
        CWOR = CWP/COP
        CGOR = 1000.*TCGP/COP
      ELSE
        CWOR = 0.
        CGOR = 0.
      ENDIF
      WRITE(IOCODE,1190) ETI,NSTEP,DELT,PAVG,PAVG0,IPM,JPM,KPM,PPM,
     & IOM,JOM,KOM,SOM,IGM,JGM,KGM,SGM,IWM,JWM,KWM,SWM,
     & MBEO,MBEG,MBEW
      WRITE(IOCODE,1191)OPR,COP,TGPR,TCGP,WPR,CWP,
     & TGIR,TCGI,WIR,CWI,WOR,CWOR,GOR,CGOR
C
C     WRITE CUMULATIVE MATERIAL BALANCES
C
      WRITE(IOCODE,1200) CMBEO,CMBEG,CMBEW
      WRITE(IOCODE,1900) BES, BEB 
      IF(NSLUGS.EQ.0) GO TO 300
      IF(SOMIN .GT. 0.0) WRITE(IOCODE,1205) PRECIP
      WRITE(IOCODE,1210)
      DO 250 L = 1,NSLUGS
        WRITE(IOCODE,1240) L,ISM(L),JSM(L),KSM(L),SM(L)
  250 CONTINUE
      WRITE(IOCODE,1250)
      DO 260 L = 1,NSLUGS
        IF(L.EQ.1) WRITE(IOCODE,1255) L, MBES1,CMBE1
        IF(L.EQ.2) WRITE(IOCODE,1255) L, MBES2,CMBE2
        IF(L.EQ.3) WRITE(IOCODE,1255) L, MBES3,CMBE3
        IF(L.EQ.4) WRITE(IOCODE,1255) L, MBES4,CMBE4
  260 CONTINUE
      WRITE(IOCODE,1260)
      DO 270 L = 1,NSLUGS
        IF(L.EQ.1) WRITE(IOCODE,1265) L, S1IR, CS1I, S1PR, CS1P
        IF(L.EQ.1) WRITE(IOCODE,1270) S1OR
        IF(L.EQ.2) WRITE(IOCODE,1265) L, S2IR, CS2I, S2PR, CS2P
        IF(L.EQ.3) WRITE(IOCODE,1265) L, S3IR, CS3I, S3PR, CS3P
        IF(L.EQ.4) WRITE(IOCODE,1265) L, S4IR, CS4I, S4PR, CS4P
  270 CONTINUE

  300 IF(IPMAP .GT. 0 .OR. NSTEP .EQ. 0) THEN
       WRITE(IOCODE,1300)
        DO 310 K = 1,KK
          WRITE(IOCODE,1305) K
          DO 310 J = 1,JJ
            WRITE(IOCODE,1310) (P(I,J,K),I=1,II)
  310   CONTINUE
      ENDIF
C
      IF(ISOMAP .GT. 0 .OR. NSTEP .EQ. 0) THEN
        WRITE(IOCODE,1315)
        DO 320 K = 1,KK
          WRITE(IOCODE,1305) K
          DO 320 J = 1,JJ
            WRITE(IOCODE,1322) (SO(I,J,K),I=1,II)
  320   CONTINUE
      ENDIF
C
      IF(ISWMAP .GT. 0 .OR. NSTEP .EQ. 0) THEN
        WRITE(IOCODE,1325)
        DO 330 K = 1,KK
          WRITE(IOCODE,1305) K
          DO 330 J = 1,JJ
            WRITE(IOCODE,1322) (SW(I,J,K),I=1,II)
  330   CONTINUE
        ENDIF

        IF(ISWMAP .GT. 0 .OR. NSTEP .EQ. 0) THEN
        WRITE(IOCODE,1326)
        DO 3300 K = 1,KK
          WRITE(IOCODE,1305) K
          DO 3300 J = 1,JJ
            WRITE(IOCODE,1323) (CS(I,J,K),I=1,II)
3300     CONTINUE
         ENDIF

        IF(ISGMAP .GT. 0 .OR. NSTEP .EQ. 0) THEN

        WRITE(IOCODE,1327)
        DO 3301 K = 1,KK
          WRITE(IOCODE,1305) K
          DO 3301 J = 1,JJ
            WRITE(IOCODE,1323) (BNF(I,J,K),I=1,II)
3301    CONTINUE

         ENDIF
C
        IF(MOBCTL .GT. 0) THEN
          WRITE(IOCODE,1330)
          DO 340 K = 1,KK
            WRITE(IOCODE,1305) K
            DO 340 J = 1,JJ
              WRITE(IOCODE,1320) (XS(I,J,K),I=1,II)
  340     CONTINUE
      ENDIF
C
      IF(ISGMAP .GT. 0 .OR. NSTEP .EQ. 0) THEN
        WRITE(IOCODE,1350)
        DO 440 K = 1,KK
          WRITE(IOCODE,1305) K
            DO 440 J = 1,JJ
              WRITE(IOCODE,1322) (SG(I,J,K),I=1,II)
  440   CONTINUE
      ENDIF
      IF(NSLUGS .EQ. 0) GOTO 700
      IF(IS1MAP .GT. 0 .OR. NSTEP .EQ. 0) THEN
        WRITE(IOCODE,1440)
        IBL = 1
        DO 500 K = 1,KK
          WRITE(IOCODE,1305) K
          DO 500 J = 1,JJ
            WRITE(IOCODE,1320) (VS(1+NSLUGS*(IB-1)),IB=IBL,IBL+II-1)
            IBL = IBL + II
  500   CONTINUE
      ENDIF
      IF(NSLUGS .EQ. 1) GOTO 700
      IF(IS2MAP .GT. 0 .OR. NSTEP .EQ. 0) THEN
        WRITE(IOCODE,1500)
        IBL = 1
        DO 550 K = 1,KK
          WRITE(IOCODE,1305) K
          DO 550 J = 1,JJ
            WRITE(IOCODE,1320) (VS(2+NSLUGS*(IB-1)),IB=IBL,IBL+II-1)
            IBL = IBL + II
  550   CONTINUE
      ENDIF
      IF(NSLUGS .EQ. 2) GOTO 700
      IF(IS3MAP .GT. 0 .OR. NSTEP .EQ. 0) THEN
        WRITE(IOCODE,1550)
        IBL = 1
        DO 600 K = 1,KK
          WRITE(IOCODE,1305) K
          DO 600 J = 1,JJ
            WRITE(IOCODE,1320) (VS(3+NSLUGS*(IB-1)),IB=IBL,IBL+II-1)
            IBL = IBL + II
  600   CONTINUE
      ENDIF
      IF(NSLUGS .EQ. 3) GOTO 700
      IF(IS4MAP .GT. 0 .OR. NSTEP .EQ. 0) THEN
        WRITE(IOCODE,1600)
        IBL = 1
        DO 650 K = 1,KK
          WRITE(IOCODE,1305) K
          DO 650 J = 1,JJ
            WRITE(IOCODE,1320) (VS(4+NSLUGS*(IB-1)),IB=IBL,IBL+II-1)
            IBL = IBL + II
  650   CONTINUE
      ENDIF
  700 CONTINUE
      IF(IRSMAP .GT. 0 .OR. NSTEP .EQ. 0) THEN
        WRITE(IOCODE,1700)
        DO 750 K = 1,KK
          WRITE(IOCODE,1305) K
          DO 750 J = 1,JJ
            WRITE(IOCODE,1310) (SCFBBL*RSOR(I,J,K),I=1,II)
  750   CONTINUE
      ENDIF
C
      IF(IPBMAP .GT.0 .OR. NSTEP .EQ. 0) THEN
        WRITE(IOCODE,1750)
        DO 800 K = 1,KK
          WRITE(IOCODE,1305) K
            DO 800 J = 1,JJ
              WRITE(IOCODE,1310) (PBOT(I,J,K),I=1,II)
  800   CONTINUE
      ENDIF
      IF(NSTEP .GT. 0) WRITE(IOCODE,1800)
      RETURN
C
 1000 FORMAT(////T15,10('*'),' INITIAL ARRAYS ',10('*')/)
 1160 FORMAT(//T30,69('*'),/T30,'*',T98,'*'/T30,'*',T98,'*')
 1170 FORMAT(T30,'*',T45,'SUMMARY REPORT:                         '
     &       ,T98,'*')
 1180 FORMAT(T30,'*',T98,'*'/T30,'*',T98,'*'/T30,69('*'),///)
 1190 FORMAT(/,1X,'ELAPSED TIME (DAYS)    =',G14.6,3X,
     & 'TIME STEP NUMBER             =',I5,7X,
     & 'TIME STEP SIZE (DAYS)   =',G14.6,//,1X,
     & 'CURRENT AVG PRESSURE (PSIA) =',F9.1,3X,
     & 'PREVIOUS AVG PRESSURE (PSIA) =',F9.1,3X,
     & 'PRESSURE DPMAX(',I3,',',I3,',',I3,')  =',F9.1,/,1X,
     & 'OIL DSMAX(',I3,',',I3,',',I3,')      =',F9.5,3X,
     & 'GAS DSMAX(',I3,',',I3,',',I3,')       =',F9.5,3X,
     & 'WATER DSMAX(',I3,',',I3,',',I3,')     =',F9.5,/,1X,
     & 'OIL MATERIAL BALANCE (%)    =',F9.6,3X,
     & 'GAS MATERIAL BALANCE (%)    =',F9.6,3X,
     & 'WATER MATERIAL BALANCE (%)   =',F9.6)
 1191 FORMAT(/,1X,
     & 'OIL PRODUCTION RATE (STB/D) =',F9.1,3X,
     & 'CUM. OIL PRODUCTION (STB)    =',F12.0,/,1X,
     & 'GAS PRODUCTION RATE (MSCF/D)=',F9.1,3X,
     & 'CUM. GAS PRODUCTION (MSCF)   =',F12.0,/,1X,
     & 'WATER PRODUCTION RATE(STB/D)=',F9.1,3X,
     & 'CUM. WATER PRODUCTION (STB)  =',F12.0,//,1X,
     & 'GAS INJECTION RATE (MSCF/D) =',F9.1,3X,
     & 'CUM. GAS INJECTION (MSCF)    =',F12.0,/,1X,
     & 'WATER INJECTION RATE (STB/D)=',F9.1,3X,
     & 'CUM. WATER INJECTION (STB)   =',F12.0,//,1X,
     & 'PRODUCING WOR (STB/STB)     =',F9.3,3X,
     & 'CUM. WOR (STB/STB)           =',F9.3,/,1X,
     & 'PRODUCING GOR (SCF/STB)     =',F9.0,3X,
     & 'CUM. GOR (SCF/STB)           =',F9.0,//)
 1200 FORMAT(//10X,'CUMULATIVE MATERIAL BALANCES (OIL, GAS, WATER) ='
     &      ,F16.8,'%',3X,F16.8,'%',3X,F16.8,'%'/)
 1900 FORMAT(//10X,'CUMULATIVE MATERIAL BALANCES (SURFACT, BUBBLE) ='
     &      ,F16.8,'%',3X,E16.8,'%'/)
 1205 FORMAT(//1X,'SOLID PRECIP. OPTION IS "ON" - CUMULATIVE VOLUME',
     &' OF OIL "PRECIPITATED" = ',F10.0,' STB')
 1210 FORMAT(/,1X,'***** MAXIMUM SOLVENT SATURATION CHANGES *****'/)
 1240 FORMAT(15X,'SOLVENT',I2,2X,'DVSMAX(',I3,',',I3,',',I3,')   ='
     &,F9.5)
 1250 FORMAT(//,1X,'***** SOLVENT MATERIAL BALANCES --- TIME-STEP &',
     &' CUMULATIVE *****'/)
 1255 FORMAT(15X,'SOLVENT',I2,' MAT. BAL. (%) =',G15.6,4X,G15.6)
 1260 FORMAT(//,1X,
     &'******* SOLVENT INJECTION/PRODUCTION RATES ********'/)
 1265 FORMAT(/,15X,'SOLVENT',I3,
     & 5X,'INJECTION RATE (MCF/D)  = ',  F10.1,
     & 3X,'CUMULATIVE INJECTION (MCF) = ',    F12.0,/,
     & 27X,'PRODUCTION RATE (MCF/D) =',F11.1,
     & 3X,'CUMULATIVE PRODUCTION (MCF) =',   F12.0)
 1270 FORMAT(15X,'SOL 1/OIL PRODUCING RATIO (SCF/STB) =',F10.0)
 1300 FORMAT(//T15,'***** RESERVOIR PRESSURE DISTRIBUTION - PSIA *****')
 1305 FORMAT(1X,'K =',I2)
 1310 FORMAT(5X,20F6.0)
 1315 FORMAT(//T15,'*********  OIL SATURATION - FRACTION  *********')
 1320 FORMAT(5X,20F6.3)
 1322 FORMAT(5X,20F6.3)
 1323 FORMAT(1X,10E11.4)
 1325 FORMAT(//T15,'******** WATER SATURATION - FRACTION  *********')
 1326 FORMAT(//T15,'*** SURFACT CONCENTRATION - FRACTION  *****')
 1327 FORMAT(//T15,'******** BUBBLE DENSITY - #/CM^3  *********')
 1330 FORMAT(//T10,'**** FRACTION OF WATER CONTAINING MOBILITY',
     &' CONTROL AGENT ****')
 1350 FORMAT(//T15,'********* GAS SATURATION - FRACTION  *********')
 1440 FORMAT(//T15,'********* BASE SOLVENT - FRACTION  *********')
 1500 FORMAT(//T15,'********* SOLVENT NO. 2 - FRACTION  *********')
 1550 FORMAT(//T15,'********* SOLVENT NO. 3 - FRACTION  *********')
 1600 FORMAT(//T15,'********* SOLVENT NO. 4 - FRACTION  *********')
 1700 FORMAT(//T15,'*****  HC-GAS SOLUBILITIES - SCF/STB *****')
 1750 FORMAT(//T15,'******* BUBBLE POINT PRESSURES - PSIA *******')
 1800 FORMAT(///T5,54('*'),'  END OF REPORT  ',54('*'),6(/))
      END SUBROUTINE PRTPS2
      SUBROUTINE PSFUN(P,PBOT,SO,SW,SG,VG,VS,XS,BO,BW,BG,BS,RSOR,RSWR
     &                ,RSO,RSWS1,BETA,SORM,SCI,REDK,ISOLID,NSLUGS
     &                ,IJKM,MSATW,MSATG,MPGT,NOMOB,MOBCTL,STWB,OK,WK,GK
     &                ,UO,UW,UG,US,RHOO,RHOW,RHOG,RHOS,PCW,PCG
     &                ,NTABS,NTAB)
C
C     THIS ROUTINE CALCULATES FUNCTIONS OF SATURATION AND THOSE FUNCTIONS
C     OF PRESSURE AND SATURATION PRESSURE WHICH ARE ONLY UPDATED AT THE
C     BEGINNING OF A TIME STEP.
C
      DIMENSION P(IJKM),PBOT(IJKM),SO(IJKM),SW(IJKM),SG(IJKM),VG(IJKM)
     &         ,VS(4*IJKM),XS(IJKM),BO(IJKM),BW(IJKM),BG(IJKM)
     &         ,BS(4*IJKM),RSOR(IJKM),RSWR(IJKM),RSO(4*IJKM)
     &         ,RSWS1(IJKM),STWB(IJKM),OK(IJKM),WK(IJKM),GK(IJKM)
     &         ,UO(IJKM),UW(IJKM),UG(IJKM),US(4*IJKM),RHOO(IJKM)
     &         ,RHOW(IJKM),RHOG(IJKM),RHOS(4*IJKM),PCW(IJKM),PCG(IJKM)
     &         ,ISOLID(IJKM)
     &         ,NTAB(IJKM)
C
      PARAMETER (NTE = 25 , NBOT = 51 , NBOTM = NBOT-1) 
      COMMON/PVTRST/PST(NTE,4),VST(NTE,4),BST(NTE,4),RST(NTE,4)
     &             ,RWT(NTE,4),DBSDPT(NTE,4),DRSDPT(NTE,4)
     &             ,DRWDPT(NTE,4),BO1T(NTE),VO1T(NTE)
     &             ,BW1T(NTE),VW1T(NTE),CSC(NTE),FRCO2(NTE)
     &             ,VORST(NBOT),VWRST(NBOT),DVO1T(NBOT),DVW1T(NBOT)
     &             ,UORST(NBOT),UWRST(NBOT),DUO1T(NBOT),DUW1T(NBOT)
     &             ,VORSPT(NBOT),VWRSPT(NBOT),DVO1PT(NBOT)
     &             ,DVW1PT(NBOT),RUSQT(NBOT,4),RUGQT(NBOT)
     &             ,RUOQT(NBOT),USW1T(NBOT,4),UGW1T(NBOT),UOW1T(NBOT)
     &             ,USW2T(NBOT,4),UGW2T(NBOT),UOW2T(NBOT),VOPT(NTE)
     &             ,VWPT(NTE),PSMIN(4),PSMAX(4)
     &             ,BOSLP,BWSLP,BO1SLP,BW1SLP,VOSLP
     &             ,VO1SLP,VW1SLP,COH,CWH,CVOH,PMISC,PMCM,VSMISC
     &             ,OM1,OM2,RDRSO,RDRSW,RDRSO1,RDRSW1,RDMU,RDPRMP
     &             ,NPTS(4),IPSOL(4)

C  *** This common block contains four varibles separated from
C  *** common block PVTRST 

      COMMON/RHOSTO/RHOSCO,RHOSCG,RHOSCW,RHOSC(4)
C
      DIMENSION SWMAX(10),SWMIN(10),SGMAX(10),SGMIN(10)
      DIMENSION SWTNT(NTE),KROWTN(NTE),SGTNT(NTE),KROGTN(NTE)
      REAL KRWT,KRGT,MUOT,MUWT,MUGT,KROWT,KROGT
      REAL KROWTN,KROGTN
      COMMON /SPVT/SWT(10,25),KRWT(10,25),KRGT(10,25),PCOWT(10,25)
     &      ,PCGOT(10,25)
     &      ,POT(25),MUOT(25),BOT(25),BOPT(25),RSOT(25),RSOPT(25)
     &      ,PWT(25),MUWT(25),BWT(25),BWPT(25),RSWT(25),RSWPT(25)
     &      ,PGT(25),MUGT(25),BGT(25),BGPT(25),CRT(25),SWC(10)
     &      ,SORW(10)
     &      ,SGT(10,25),KROWT(10,25),KROGT(10,25),RKOSWC(10)
     &      ,DKOSWC(10),KR3P
C
      PARAMETER (PSC=14.7)
      DIMENSION RHOS1(4)
      OM1M = 1.0 - OM1
      OM2M = 1.0 - OM2
      E1 = 4.0*OM1
      E2 = 4.0*OM2
      DO 50 I=1,NTABS
      SWMAX(I) = SWT(I,MSATW)
      SWMIN(I) = SWT(I,2)
      SGMAX(I) = SGT(I,MSATG)
      SGMIN(I) = SGT(I,2)
   50 CONTINUE
      IPW = 2
      IPG = 2
      DO 400 IB = 1,IJKM
        SSW = SW(IB)
        SSG = SG(IB)
        NT=NTAB(IB)
        IF(SSW .GE. SWMAX(NT)) THEN
          IPW = MSATW
          GOTO 150
        ELSEIF(SSW .LE. SWMIN(NT)) THEN
          IPW = 2
          GOTO 150
        ENDIF
  100   IF(SSW .GT. SWT(NT,IPW)) THEN
          IPW = IPW + 1
          GOTO 100
        ENDIF
  125   IF(SSW .LT. SWT(NT,IPW-1)) THEN
          IPW = IPW - 1
          GOTO 125
        ENDIF
  150   IMW = IPW - 1
        WFRAC = (SSW-SWT(NT,IMW))/(SWT(NT,IPW)-SWT(NT,IMW))
        IF(SSG .GE. SGMAX(NT)) THEN
          IPG = MSATG
          GOTO 250
        ELSEIF(SSG .LE. SGMIN(NT)) THEN
          IPG = 2
          GOTO 250
        ENDIF
  200   IF(SSG .GT. SGT(NT,IPG)) THEN
          IPG = IPG + 1
          GOTO 200
        ENDIF
  225   IF(SSG .LT. SGT(NT,IPG-1)) THEN
          IPG = IPG - 1
          GOTO 225
        ENDIF
  250   IMG = IPG - 1
        GFRAC = (SSG-SGT(NT,IMG))/(SGT(NT,IPG)-SGT(NT,IMG))
        WK(IB) = WFRAC*KRWT(NT,IPW) + (1.0-WFRAC)*KRWT(NT,IMW)
        GK(IB) = GFRAC*KRGT(NT,IPG) + (1.0-GFRAC)*KRGT(NT,IMG)
        PCW(IB) = WFRAC*PCOWT(NT,IPW) + (1.0-WFRAC)*PCOWT(NT,IMW)
        PCG(IB) = GFRAC*PCGOT(NT,IPG) + (1.0-GFRAC)*PCGOT(NT,IMG)
        SSO1 = 1.0 - SO(IB)
        IF(KR3P .EQ. 0) THEN
         DO 375 I=1,MSATW
          SWTNT(I)=SWT(NT,I)
          KROWTN(I)=KROWT(NT,I)
  375    CONTINUE
          CALL INTERP(SWTNT,KROWTN,MSATW,SSO1,OK(IB))
        ELSEIF(KR3P .EQ. 1) THEN
         DO 385 I=1,MSATG
          SGTNT(I)=SGT(NT,I)
          KROGTN(I)=KROGT(NT,I)
  385    CONTINUE
          CALL INTERP(SGTNT,KROGTN,MSATG,SSO1,OK(IB))
        ELSEIF(KR3P .EQ. 2) THEN
          OWK = WFRAC*KROWT(NT,IPW) + (1.0-WFRAC)*KROWT(NT,IMW)
          OGK = GFRAC*KROGT(NT,IPG) + (1.0-GFRAC)*KROGT(NT,IMG)
          OK(IB) = RKOSWC(NT)*((OWK*DKOSWC(NT)+WK(IB))
     &             *(OGK*DKOSWC(NT)+GK(IB))
     &             -WK(IB)-GK(IB))
          IF(OK(IB) .LT. 0.0) OK(IB) = 0.0
        ENDIF
        IF(BETA .GT. 0.0) THEN
          STWB(IB) = SORW(IB)*WK(IB)/(WK(IB)+BETA*OWK)
          IF(STWB(IB) .GT. SO(IB)) STWB(IB) = SO(IB)
        ENDIF
        VGG = VG(IB)
        PP = P(IB)
        FRAC = 1.0 + RDRSO*VGG*RSOR(IB)
        IMU = FRAC
        IF(IMU .LT. 1) IMU = 1
        IF(IMU .GE. NBOT) IMU = NBOTM
        FX = IMU
        FRAC = FRAC - FX
        UOO = (1.0-FRAC)*UORST(IMU) + FRAC*UORST(IMU+1)
        UO(IB) = UOO*(1.0+CVOH*(PBOT(IB)-PSC)) + VOSLP*(PP-PBOT(IB))
        FRAC = 1.0 + RDRSW*VGG*RSWR(IB)
        IMU = FRAC
        IF(IMU .LT. 1) IMU = 1
        IF(IMU .GE. NBOT) IMU = NBOTM
        FX = IMU
        FRAC = FRAC - FX
        UW(IB) = (1.0-FRAC)*UWRST(IMU) + FRAC*UWRST(IMU+1)
        CALL INTERP(PGT,MUGT,MPGT,PP,UG(IB))
        RHOO(IB) = (RHOSCO + RSOR(IB)*RHOSCG)/BO(IB)
        RHOW(IB) = (RHOSCW + RSWR(IB)*RHOSCG)/BW(IB)
        RHOG(IB) = RHOSCG/BG(IB)
  400 CONTINUE
      IF(NSLUGS .GT. 0) THEN
        IBASE = 0
        DO 700 IB = 1,IJKM
          VGG = VG(IB)
          PP = P(IB)
          IF(VSMISC .LT. 1.E-6) THEN
            VSRAMP = 1.0
          ELSE
            VSRAMP = (1.0-VGG)/VSMISC
            IF(VSRAMP .GT. 1.0) VSRAMP = 1.0
          ENDIF
          FRAC = 1.0 + RDMU*P(IB)
          IMU = FRAC
C
          IF(IMU .LT. 1) IMU = 1
          IF(IMU .GE. NBOT) IMU = NBOTM
          FX = IMU
          FRAC = FRAC - FX
          FRACM = 1.0 - FRAC
          IMUP = IMU + 1
          ROSUM = 0.0
          DDOSUM = 0.0
          USUM = 0.0
          RHSUM = 0.0
          DO 450 ISOL = 1,NSLUGS
            IBS = IBASE + ISOL
            RHOS1(ISOL) = RHOSC(ISOL)/BS(IBS)
            RSOO = VS(IBS)*RSO(IBS)
            ROSUM = ROSUM + RSOO
            DDOSUM = DDOSUM + RSOO*RHOSC(ISOL)
            USUM = USUM + VS(IBS)*(FRACM*RUSQT(IMU,ISOL)
     &                           +FRAC*RUSQT(IMUP,ISOL))
            RHSUM = RHSUM + VS(IBS)*RHOS1(ISOL)
  450     CONTINUE
          RUMGSQ = USUM + VGG*(FRACM*RUGQT(IMU)+FRAC*RUGQT(IMUP))
          RHOMGS = RHSUM + VGG*RHOG(IB)
          RHOO1 = RHOO(IB) + DDOSUM/BO(IB)
          RHOW(IB) = RHOW(IB) + VS(IBASE+1)*RSWS1(IB)*RHOSC(1)/BW(IB)
          RHOG1 = RHOG(IB)
          SFRAC = 1.0 + RDRSO1*ROSUM
          ISO = SFRAC
          IF(ISO .LT. 1) ISO = 1
          IF(ISO .GE. NBOT) ISO = NBOTM
          FX = ISO
          SFRAC = SFRAC - FX
          DUO = SFRAC*DUO1T(ISO+1) + (1.0-SFRAC)*DUO1T(ISO)
          UO1 = DUO*UO(IB)
          IF(PP .LT. PMISC) THEN
            IF(PP .GT. PMCM) THEN
              ALPHA = RDPRMP*(PP-PMCM)
            ELSE
              ALPHA = 0.0
            ENDIF
            ALPHAM = 1.0 - ALPHA
            TERM = OM1*RHOMGS
            FACTOR = ALPHAM/(RUMGSQ**E1)
            UO(IB) = ALPHAM*UO1
            UG(IB) = FACTOR*(FRACM*UGW1T(IMU)+FRAC*UGW1T(IMUP))
            RHOO(IB) = ALPHAM*RHOO1
            RHOG(IB) = ALPHAM*(OM1M*RHOG1+TERM)
            DO 500 ISOL = 1,NSLUGS
              IBS = IBASE + ISOL
              US(IBS) = FACTOR*(FRACM*USW1T(IMU,ISOL)
     &                         +FRAC*USW1T(IMUP,ISOL))
              RHOS(IBS) = ALPHAM*(OM1M*RHOS1(ISOL)+TERM)
  500       CONTINUE
          ELSE
            ALPHA = 1.0
            ALPHAM = 0.0
            UO(IB) = 0.0
            UG(IB) = 0.0
            RHOO(IB) = 0.0
            RHOG(IB) = 0.0
            DO 550 ISOL = 1,NSLUGS
              IBS = IBASE + ISOL
              US(IBS) = 0.0
              RHOS(IBS) = 0.0
  550       CONTINUE
          ENDIF
          IF(PP .GT. PMCM) THEN
            SOS = SO(IB) + (1.0-VGG)*SG(IB)
            SN = 1.0 - SW(IB)
            RUOQ = 1.0/(UO1**.25)
            IF(BETA .GT. 0.0) THEN
              DENOM = SOS - STWB(IB)
              IF(DENOM .GT. 1.E-6) THEN
                RUMOSQ = ((SO(IB)-STWB(IB))*RUOQ+SG(IB)*USUM)/DENOM
                RHOMOS = ((SO(IB)-STWB(IB))*RHOO1+SG(IB)*RHSUM)/DENOM
              ELSE
                RUMOSQ = RUOQ
                RHOMOS = RHOO1
              ENDIF
              DENOM = SN - STWB(IB)
              IF(DENOM .GT. 1.E-6) THEN
                RUMQ = ((SO(IB)-STWB(IB))*RUOQ+SG(IB)*RUMGSQ)/DENOM
                RHOM = ((SO(IB)-STWB(IB))*RHOO1+SG(IB)*RHOMGS)/DENOM
              ELSE
                RUMQ = RUOQ
                RHOM = RHOO1
              ENDIF
            ELSE
              IF(SOS .GT. 0.0) THEN
                RUMOSQ = (SO(IB)*RUOQ+SG(IB)*USUM)/SOS
                RHOMOS = (SO(IB)*RHOO1+SG(IB)*RHSUM)/SOS
              ELSE
                RUMOSQ = RUOQ
                RHOMOS = RHOO1
              ENDIF
              IF(SN .GT. 0.0) THEN
                RUMQ = (SO(IB)*RUOQ+SG(IB)*RUMGSQ)/SN
                RHOM = (SO(IB)*RHOO1+SG(IB)*RHOMGS)/SN
              ELSE
                RUMQ = RUOQ
                RHOM = RHOO1
              ENDIF
            ENDIF
            UO(IB) = UO(IB) + ALPHA/(RUMOSQ**E2)*(UO1**OM2M)
            UG(IB) = UG(IB) + ALPHA/(RUMGSQ**E2)*(FRACM*UGW2T(IMU)
     &                                           +FRAC*UGW2T(IMUP))
            RHOO(IB) = RHOO(IB) + ALPHA*(OM2M*RHOO1+OM2*RHOMOS)
            RHOG(IB) = RHOG(IB) + ALPHA*(OM2M*RHOG1+OM2*RHOMGS)
            FACTOR = ALPHA/(RUMQ**E2)
            TERM = OM2*RHOM
            DO 600 ISOL = 1,NSLUGS
              IBS = IBASE + ISOL
              US(IBS) = US(IBS) + FACTOR*(FRACM*USW2T(IMU,ISOL)
     &                                   +FRAC*USW2T(IMUP,ISOL))
              RHOS(IBS) = RHOS(IBS) + ALPHA*(OM2M*RHOS1(ISOL)+TERM)
  600       CONTINUE
            DO 675 I=1,MSATW
             SWTNT(I)=SWT(NT,I)
             KROWTN(I)=KROWT(NT,I)
  675       CONTINUE
            CALL INTERP(SWTNT,KROWTN,MSATW,SW(IB),HK)
            IF(BETA .GT. 0.0) THEN
              DENOM = SN - STWB(IB)
              IF(DENOM .GT. 1.E-6) THEN
                FXO = (SO(IB)-STWB(IB)-SORM)/DENOM
                IF(FXO .LT. 0.0) FXO = 0.0
                FXG = SG(IB)/DENOM
                IF(FXG .GT. 1.0) FXG = 1.0
              ELSE
                FXO = 1.0
                FXG = 0.0
              ENDIF
            ELSE
              IF(SN .GT. 1.E-6) THEN
                 FXO = SO(IB)/SN  
                 IF(FXO .LT. 0.0) FXO = 0.0
                 IF(FXO .GT. 1.0) FXO = 1.0
                 FXG = 1.0 - FXO
              ELSE
                FXO = 1.0
                FXG = 0.0
              ENDIF
            ENDIF
            FM = VSRAMP*ALPHA
            FI = 1.0 - FM
            OK(IB) = FI*OK(IB) + FM*FXO*HK
            GK(IB) = FI*GK(IB) + FM*FXG*HK
            IF(ISOLID(IB) .GT. 0) THEN
              OK(IB) = 0.0
              WK(IB) = REDK*WK(IB)
              GK(IB) = REDK*GK(IB)
            ENDIF
            PCG(IB) = FI*PCG(IB)
          ENDIF
        IBASE = IBASE + NSLUGS
  700   CONTINUE
      ENDIF
      IF(MOBCTL .GT. 0) THEN
        DO 800 IB = 1,IJKM
          SC = XS(IB)*SW(IB)
          CALL INTERP(CSC,FRCO2,NOMOB,SC,REDUCE)
          FACTOR = 1.0 - SCI*REDUCE
          IF(FACTOR .LE. 0.0) THEN
            GK(IB) = 0.0
          ELSE
            GK(IB) = FACTOR*GK(IB)
          ENDIF
  800   CONTINUE
      ENDIF
      RETURN
      END SUBROUTINE PSFUN
C
      SUBROUTINE QRATE2(P,VG,VS,BO,BW,BG,BS,RSOR,RSWR,RSO,RSWS1,UO,UW
     &                 ,UG,US,OK,WK,GK,GM1,GM2,GM3,GM4,QVS,IQN1,IQN2
     &                 ,IQN3,NVQN,NSLUGS,NW,II,JJ,IJKM,QO,QW,QG,QS
     &                 ,PID,PWF,PWFC,KIP,GMO,GMW,GMG,IDIR,PMAXT
     &              ,LAYER,QVO,QVW,QVG,QVT,NWL,iswith)
C
C     THIS ROUTINE CALCULATES RATES FOR ALL WELL TYPES AND IT CALCULATES
C     THE COEFFICIENTS FOR INPLICIT PRESSURE WELLS.
C
      DIMENSION P(IJKM),VG(IJKM),VS(4*IJKM),BO(IJKM),BW(IJKM),BG(IJKM)
     &         ,BS(4*IJKM),RSOR(IJKM),RSWR(IJKM),RSO(4*IJKM)
     &         ,RSWS1(IJKM),UO(IJKM),UW(IJKM),UG(IJKM),US(4*IJKM)
     &         ,OK(IJKM),WK(IJKM),GK(IJKM),QO(IJKM),QW(IJKM),QG(IJKM)
     &         ,QS(4*IJKM)
      DIMENSION IQN1(NW),IQN2(NW),IQN3(NW)
      DIMENSION GM1(NW,1),GM2(NW,1),GM3(NW,1),GM4(NW,1),QVS(1),IDIR(NW)
      DIMENSION PID(NW,NWL),PWF(NW,NWL),PWFC(NW,NWL),KIP(NW),
     & GMO(NW,NWL),GMW(NW,NWL),GMG(NW,NWL),LAYER(NW),QVO(NW),
     & QVW(NW),QVG(NW),QVT(NW)
       dimension iswith(nw)
      DO 100 IW = 1,NW
        DO 75 K = 1,NWL
          GM1(IW,K) = 0.0
          GM2(IW,K) = 0.0
          GM3(IW,K) = 0.0
          GM4(IW,K) = 0.0
   75   CONTINUE
  100 CONTINUE
      DO 800 IW = 1,NVQN
         IF(IDIR(IW).EQ.3) THEN
        IQ1 = IQN1(IW)
        IQ2 = IQN2(IW)
        IQ3 = IQN3(IW)
        ELSEIF(IDIR(IW).EQ.2) THEN
           IQ1=IQN3(IW)
           IQ3=IQN2(IW)
           IQ2=IQN1(IW)
        ELSE
           IQ2=IQN3(IW)
           IQ1=IQN2(IW)
           IQ3=IQN1(IW)
        ENDIF
        LAY = IQ3 + (LAYER(IW)-1)
        DO 150 K = IQ3,LAY
          PWFC(IW,K) = -1.0
C 
          IF (IDIR(IW).EQ.3) THEN
          IB = IQ1 + II*(IQ2-1+JJ*(K-1))
          ELSEIF(IDIR(IW).EQ.2) THEN
          IB=IQ2+II*(K-1+JJ*(IQ1-1))
          ELSE
             IB=K+II*(IQ1-1+JJ*(IQ2-1))
          ENDIF
C 
          GMO(IW,K) = OK(IB)/UO(IB)
          GMW(IW,K) = WK(IB)/UW(IB)
          IF(NSLUGS .GT. 0) THEN
            GKK = GK(IB)
            IBS = NSLUGS*(IB-1)
            DO 125 ISOL = 1,NSLUGS
              IBS = IBS + 1
              SMOB = VS(IBS)*GKK/US(IBS)
              IF(ISOL .EQ. 1) THEN
                GM1(IW,K) = SMOB
              ELSEIF(ISOL .EQ. 2) THEN
                GM2(IW,K) = SMOB
              ELSEIF(ISOL .EQ. 3) THEN
                GM3(IW,K) = SMOB
              ELSEIF(ISOL .EQ. 4) THEN
                GM4(IW,K) = SMOB
              ENDIF
  125       CONTINUE
            GMG(IW,K) = VG(IB)*GKK/UG(IB)
          ELSE
            GMG(IW,K) = GK(IB)/UG(IB)
          ENDIF
  150   CONTINUE
        IF(KIP(IW) .EQ. 0) THEN
C
C     HISTORY MATCHING OPTION : INDIVIDUAL FLUID RATES AT SURFACE CONDITIONS
C     ARE USED TO CALCULATE A RESERVOIR VOIDAGE.  THIS VOIDAGE IS USED AS 
C     THE WELL CONSTRAINT.  FLUID MOBILITIES ARE USED TO CALCULATE INDIVIDUAL
C     FLOW RATES.
C

           IF(IDIR(IW).EQ.3) THEN
           IB = IQ1 + II*(IQ2-1+JJ*(IQ3-1))
           ELSEIF(IDIR(IW).EQ.2) THEN
              IB=IQ2+II*(IQ3-1+JJ*(IQ1-1))
           ELSE
              IB=IQ3+II*(IQ1-1+JJ*(IQ2-1))
           ENDIF
C
           FGAS = 1000.0*QVG(IW)-(QVO(IW)*RSOR(IB)
     &            +QVW(IW)*RSWR(IB))*5.615
           IF(FGAS .LT. 0.0) FGAS = 0.0
           QVT(IW) = QVO(IW)*BO(IB)+QVW(IW)*BW(IB)+FGAS*BG(IB)/5.615
           ENDIF
           IF(KIP(IW) .EQ. 0 .OR. KIP(IW) .EQ. 1) THEN
C
C     RATE SPECIFIED PRODUCER
C
          SUM = 0.0
          SUMV = 0.0
          DO 175 K = IQ3,LAY
C
             IF (IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
C
            QO(IB) = PID(IW,K)*GMO(IW,K)/BO(IB)
            SUM = SUM + QO(IB)
            SUMV = SUMV + PID(IW,K)*(GMO(IW,K)+GMW(IW,K)+GMG(IW,K)
     &            +GM1(IW,K)+GM2(IW,K)+GM3(IW,K)+GM4(IW,K))
  175     CONTINUE
          IF(ABS(QVT(IW)) .GT. 0.0) THEN
            DP = QVT(IW)/SUMV
          ELSE
            DP = QVO(IW)/SUM
          ENDIF
          FACTOR = 5.615*DP
          DO 225 K = IQ3,LAY
C
             IF(IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
C
            QO(IB) = FACTOR*QO(IB)
            PWFC(IW,K) = P(IB) - DP

       IF(PWF(IW,K) .GT. PWFC(IW,K) .and. iswith(iw) .eq. 1)THEN
            KIP(IW)=-11
           WRITE(66,888)IW,KIP(IW)
888        FORMAT(' ***** WARNING: KIP(',I4,') CHANGED TO ',I4)
            ENDIF             

            CON = FACTOR*PID(IW,K)
            QW(IB) = CON*GMW(IW,K)/BW(IB)
            QG(IB) = CON*GMG(IW,K)/BG(IB) + VG(IB)*(RSOR(IB)*QO(IB)
     &              +RSWR(IB)*QW(IB))
            IBS = NSLUGS*(IB-1)
            DO 200 L = 1,NSLUGS
              IBS = IBS + 1
              IF(L.EQ.1) QS(IBS) = CON*GM1(IW,K)/BS(IBS)
     &                   + VS(IBS)*(RSO(IBS)*QO(IB)+RSWS1(IB)*QW(IB))
              IF(L.EQ.2) QS(IBS) = CON*GM2(IW,K)/BS(IBS)
     &                   + VS(IBS)*RSO(IBS)*QO(IB)
              IF(L.EQ.3) QS(IBS) = CON*GM3(IW,K)/BS(IBS)
     &                   + VS(IBS)*RSO(IBS)*QO(IB)
              IF(L.EQ.4) QS(IBS) = CON*GM4(IW,K)/BS(IBS)
     &                   + VS(IBS)*RSO(IBS)*QO(IB)
  200       CONTINUE
  225     CONTINUE
        ELSEIF(KIP(IW) .EQ. 2) THEN
C
          SUM = 0.
          DO 250 K = IQ3,LAY
C 
             IF(IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
C 
           QW(IB) = PID(IW,K)*(GMO(IW,K)+GMW(IW,K)+GMG(IW,K)+GM1(IW,K)
     &                        +GM2(IW,K)+GM3(IW,K)+GM4(IW,K))/BW(IB)
            SUM = SUM + QW(IB)
  250     CONTINUE
          DP = QVW(IW)/SUM
          FACTOR = 5.615*DP
          DO 275 K = IQ3,LAY
C
             IF(IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
C 
            QW(IB) = FACTOR*QW(IB)
            PWFC(IW,K) = P(IB) - DP

         IF (PWF(IW,K) .LT. PWFC(IW,K) .and. iswith(iw) .eq. 1) THEN
           KIP(IW)=-12
           WRITE(66,888)IW,KIP(IW)
           ENDIF
  275     CONTINUE
        ELSEIF(KIP(IW) .EQ. 3) THEN
C
C     RATE SPECIFIED GAS INJECTOR
C
          SUM = 0.
          DO 300 K = IQ3,LAY
             IF(IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
            QG(IB) = PID(IW,K)*(GMO(IW,K)+GMW(IW,K)+GMG(IW,K)+GM1(IW,K)
     &                        +GM2(IW,K)+GM3(IW,K)+GM4(IW,K))/BG(IB)
            SUM = SUM + QG(IB)
  300     CONTINUE
          FACTOR = 1000.*QVG(IW)/SUM
          DP = FACTOR/5.615
          DO 325 K = IQ3,LAY
             IF(IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
            QG(IB) = FACTOR*QG(IB)
            PWFC(IW,K) = P(IB) - DP

        IF (PWF(IW,K) .LT. PWFC(IW,K) .and. iswith(iw) .eq. 1) THEN
           KIP(IW)=-13
           WRITE(66,888)IW,KIP(IW)
            ENDIF
  325     CONTINUE
        ELSEIF(KIP(IW) .GE. 100) THEN
C
C     RATE SPECIFIED SOLVENT INJECTORS  
C
          INDEX = KIP(IW)/100
          SUM = 0.
          DO 350 K = IQ3,LAY
             IF(IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
            IBS = INDEX + NSLUGS*(IB-1)
            QS(IBS) = PID(IW,K)*(GMO(IW,K)+GMW(IW,K)+GMG(IW,K)+GM1(IW,K)
     &                         +GM2(IW,K)+GM3(IW,K)+GM4(IW,K))/BS(IBS)
            SUM = SUM + QS(IBS)
  350     CONTINUE
          FACTOR = 1000.*QVS(IW)/SUM
          DP = FACTOR/5.615
          DO 375 K = IQ3,LAY
             IF(IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
            IBS = INDEX + NSLUGS*(IB-1)
            QS(IBS) = FACTOR*QS(IBS)
            PWFC(IW,K) = P(IB) - DP 

        IF (PWF(IW,K) .LT. PWFC(IW,K) .and. iswith(iw).eq. 1) THEN
           KIP(IW)=-13-INDEX
           WRITE(66,888)IW,KIP(IW)
           ENDIF
 375      CONTINUE
          ELSEIF(KIP(IW) .EQ. -1 .OR. KIP(IW) .EQ. -11) THEN
C
C     PRESSURE SPECIFIED PRODUCER
C
          DO 475 K = IQ3,LAY
             IF(IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
            PIDCF = 5.616*PID(IW,K)
            GMO(IW,K) = PIDCF*GMO(IW,K)/BO(IB)
            GMW(IW,K) = PIDCF*GMW(IW,K)/BW(IB)
            GMG(IW,K) = PIDCF*GMG(IW,K)/BG(IB)
     &                + VG(IB)*(RSOR(IB)*GMO(IW,K)+RSWR(IB)*GMW(IW,K))
            IBS = NSLUGS*(IB-1)
            DO 400 ISOL = 1,NSLUGS
              IBS = IBS + 1
              IF(ISOL .EQ. 1) GM1(IW,K) = PIDCF*GM1(IW,K)/BS(IBS)
     &              + VS(IBS)*(RSO(IBS)*GMO(IW,K)+RSWS1(IB)*GMW(IW,K))
              IF(ISOL .EQ. 2) GM2(IW,K) = PIDCF*GM2(IW,K)/BS(IBS)
     &                       + VS(IBS)*RSO(IBS)*GMO(IW,K)
              IF(ISOL .EQ. 3) GM3(IW,K) = PIDCF*GM3(IW,K)/BS(IBS)
     &                       + VS(IBS)*RSO(IBS)*GMO(IW,K)
              IF(ISOL .EQ. 4) GM4(IW,K) = PIDCF*GM4(IW,K)/BS(IBS)
     &                       + VS(IBS)*RSO(IBS)*GMO(IW,K)
  400       CONTINUE
            DP = P(IB) - PWF(IW,K)
            IF(DP .GT. 0.0) THEN
              QO(IB) = GMO(IW,K)*DP
              QW(IB) = GMW(IW,K)*DP
              QG(IB) = GMG(IW,K)*DP
              IBS = NSLUGS*(IB-1)
              DO 425 ISOL = 1,NSLUGS
                IBS = IBS + 1
                IF(ISOL .EQ. 1) QS(IBS) = GM1(IW,K)*DP
                IF(ISOL .EQ. 2) QS(IBS) = GM2(IW,K)*DP
                IF(ISOL .EQ. 3) QS(IBS) = GM3(IW,K)*DP
                IF(ISOL .EQ. 4) QS(IBS) = GM4(IW,K)*DP
  425         CONTINUE
            ELSE
              QO(IB) = 0.0
              QW(IB) = 0.0
              QG(IB) = 0.0
              IBS = NSLUGS*(IB-1)
              DO 450 ISOL = 1,NSLUGS
                QS(IBS+ISOL) = 0.0
  450         CONTINUE
            ENDIF
  475     CONTINUE
        ELSEIF(KIP(IW) .EQ. -2 .OR. KIP(IW) .EQ. -12) THEN
C
C     PRESSURE SPECIFIED WATER INJECTOR
C
          DO 500 K = IQ3,LAY
             IF(IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
            GMW(IW,K) = 5.615*PID(IW,K)*(GMO(IW,K)+GMW(IW,K)+GMG(IW,K)
     &               +GM1(IW,K)+GM2(IW,K)+GM3(IW,K)+GM4(IW,K))/BW(IB)
            DP = P(IB) - PWF(IW,K)
            IF(DP .LT. 0.0) THEN
              QW(IB) = GMW(IW,K)*DP
            ELSE
              QW(IB) = 0.0
            ENDIF
  500     CONTINUE
        ELSEIF(KIP(IW) .EQ. -3 .OR. KIP(IW) .EQ. -13) THEN
C
C     PRESSURE SPECIFIED GAS INJECTOR
C
          DO 525 K = IQ3,LAY
             IF(IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
            GMG(IW,K) = 5.615*PID(IW,K)*(GMO(IW,K)+GMW(IW,K)+GMG(IW,K)
     &               +GM1(IW,K)+GM2(IW,K)+GM3(IW,K)+GM4(IW,K))/BG(IB)
            DP = P(IB) - PWF(IW,K)
            IF(DP .LT. 0.0) THEN
              QG(IB) = GMG(IW,K)*DP
            ELSE
              QG(IB) = 0.0
            ENDIF
  525     CONTINUE
        ELSE
C
C     PRESSURE SPECIFIED SOLVENT INJECTORS
C
          INDEX = -KIP(IW) - 3
          IF(INDEX .GT. 10) INDEX = INDEX - 10
          IF(INDEX .GT. 4) GOTO 800
          DO 550 K = IQ3,LAY
             IF(IDIR(IW).EQ.3) THEN
            IB = IQ1 + II*(IQ2-1+JJ*(K-1))
            ELSEIF(IDIR(IW).EQ.2) THEN
               IB=IQ2+II*(K-1+JJ*(IQ1-1))
            ELSE
               IB=K+II*(IQ1-1+JJ*(IQ2-1))
            ENDIF
            IBS = INDEX + NSLUGS*(IB-1)
            GMS = 5.615*PID(IW,K)*(GMO(IW,K)+GMW(IW,K)+GMG(IW,K)
     &           +GM1(IW,K)+GM2(IW,K)+GM3(IW,K)+GM4(IW,K))/BS(IBS)
            IF(INDEX .EQ. 1) THEN
              GM1(IW,K) = GMS
            ELSEIF(INDEX .EQ. 2) THEN
              GM2(IW,K) = GMS
            ELSEIF(INDEX .EQ. 3) THEN
              GM3(IW,K) = GMS
            ELSEIF(INDEX .EQ. 4) THEN
              GM4(IW,K) = GMS
            ENDIF
            DP = P(IB) - PWF(IW,K)
            IF(DP .LT. 0.0) THEN
              QS(IBS) = GMS*DP
            ELSE
              QS(IBS) = 0.0
            ENDIF
  550     CONTINUE
        ENDIF
  800 CONTINUE
      RETURN
      END SUBROUTINE QRATE2
C
      SUBROUTINE RADIUS(A,H,DX,DZ,XWC,ZWC,KX,KZ,RO,I,IJ)
      REAL KX,KZ
      write(*,67) A,H
 67   format(1x,f13.6,f13.6)
      write(*,68) DX,DZ,XWC,ZWC
 68   format(1x, f13.6,f13.6,f13.6,f13.6)
      IF(I.EQ.1) THEN
         ONE=1.
         PIE=4.*ATAN(ONE)
         XW=XWC
         ZW=ZWC
         IF(XW.GT.A/2) XW=A-XW
         IF(ZW.GT.H/2) ZW=H-ZW
         EE1=EXP(-2.*PIE*(XW/SQRT(KX))/(H/SQRT(KZ)))
         BBEE=LOG(1.-EE1)+0.5*LOG(1.-2.*COS(2.*PIE*ZW/H)
     &        *EE1+EE1**2)
         ALFA=(DX/SQRT(KX))/(DZ/SQRT(KZ))
         write(*,5)
 5       format(1x,'SUMXZ')
         SUMXZ=0.
         DO 100 N=1,IJ-1
            RN=FLOAT(N)
            ALFAN=ALFA*SIN(PIE*RN/(2.*H/DZ))
            XN=(ALFAN+SQRT(1.+ALFAN**2))**2
            C1=(COS(PIE*RN*ZW/H))**2
            C2=1.+XN**(-2.*XW/DX)
            C3=1.+XN**(-2.*(A-XW)/DX)
            C4=SIN(PIE*RN/(2.*H/DZ))
            C5=SQRT(1.+ALFAN**2)
            C6=1.-XN**(-2.*A/DX)
            SUMXZ=SUMXZ+(C1*C2*C3)/(C4*C5*C6)
 100     CONTINUE
         SUMXZ=(PIE/(H/DZ))*SUMXZ
         C7=PIE/(6.*(A/DX)**2)*(A/SQRT(KX))/(H/SQRT(KZ))
         C8=C7+0.25*LOG(KX/KZ)-LOG(SIN(PIE*ZW/H))-1.84
     &        -BBEE-SUMXZ
         write(*,6) C8
 6       format(1x,'c8=',f15.5)
         RO=H*EXP(C8)
         write(*,66) RO
 66      format(1x,'RO=',f13.6)
      ELSE
         RO=0.28*((KZ/KX)**0.5*DX**2+(KX/KZ)**0.5*DZ**2)**0.5
     &        /((KZ/KX)**0.25+(KX/KZ)**0.25)
         write(*,77) RO
 77      format(1x,'RO2=',f13.6)
      ENDIF
      RETURN
      END SUBROUTINE RADIUS
      SUBROUTINE READHC(IFOAM)
C
      PARAMETER (INPER=4, INQUA=5, INCON=4, INVEL=5)
      CHARACTER HEAD*80
      COMMON /FOAM20/ SOLIM,SWLIM,SGLIM,CSLIM,VGLIM,RMOBMI,QUALIM
      COMMON /FOAM40/ TQUA(INPER,INQUA),TCON(INPER,INCON,INQUA)
     &               ,TVEL(INPER,INVEL,INQUA),TPER(INPER)
     &               ,TRES(INPER,INVEL,INCON,INQUA),NPER,NQUA,NCON,NVEL
C
C.... read foam-related data if IFOAM is equal to 1
C
      IF(IFOAM.EQ.1)THEN
C
C....   read limiting surfactant concentration in the water phase CSLIM (ppm)
C....        limiting oil saturation SOLIM
C....        limiting water saturation SWLIM
C....        limiting gas saturation SGLIM
C....        limiting quality QUALIM (%)
C....        critical gas interstitial velocity VGLIM (ft/day)
C....        minimum nonzero acceptable foam relative mobility RMOBMI (1/cp)
C
        READ(5,6000)HEAD
        READ(5,6000)HEAD
6000    FORMAT (A80)
        READ(5,*) CSLIM,SOLIM,SWLIM,SGLIM,VGLIM,RMOBMI,QUALIM,FSCAL
        WRITE(66,6040) CSLIM,SOLIM,SWLIM,SGLIM,VGLIM,RMOBMI,QUALIM,FSCAL
6040  FORMAT( / 5X, 'CSLIM (PPM)', 5X, 'SOLIM', 5X, 'SWLIM', 5X, 'SGLIM',
     &        / 6X, F6.1, 4X, 3 ( 5X, F5.3 ), // 5X,'VGLIM (FT/DAY)',
     &   4X, 'RMOBMI (1/CP)', 4X, 'QUALIM (%)',4X,'FSCAL',
     &   / 6X, F10.6, 10X, F8.6, 7X, F6.2, 7X, F5.3)
C
C.... convert CSLIM unit from ppm to lbm/lbm
C
        ONEMIL=1.0D6
        CSLIM=CSLIM/ONEMIL
C
C.... read  no. of quality entries NQUA
C....       no. of concentration entries NCON
C....       no. of permeability entries NPER
C....       no. of velocity entries NVEL
C
        READ(5,6000)HEAD
        READ(5,6000)HEAD
        READ(5,*) NPER,NQUA,NCON,NVEL
        WRITE(66,6050) NPER,NQUA,NCON,NVEL
6050  FORMAT( / 5X, 'NPER', 5X, 'NQUA', 5X, 'NCON', 5X, 'NVEL',
     &        / 4 ( 5X, I4 ))
        IF(NPER.LT.2 .OR. NQUA.LT.2
     &               .OR. NCON.LT.2 .OR. NVEL.LT.2)THEN
          WRITE(66,61)
61    FORMAT( 1X, '***** ERROR *****'
     &      / 1X, 'PROGRAM STOPPED IN SUBROUTINE READHC DUE TO'
     &      / 1X, 'NUMBER OF ENTRIES IS LESS THAN 2')

		PRINT *,""
		PRINT *,"ERROR:PROGRAM STOPPED IN SUBROUTINE READHC DUE TO"
		PRINT *,"NUMBER OF ENTRIES IS LESS THAN 2."
		PRINT *,""
          STOP
        ENDIF
C
C.... check array size for foam tables
C
        IF((NQUA.GT.INQUA).OR.(NPER.GT.INPER))THEN
          WRITE(66,6021) INPER,INQUA
6021  FORMAT( 1X, '***** ERROR *****'
     &      / 1X, 'PROGRAM STOPPED IN SUBROUTINE READHC DUE TO'
     &      / 1X, 'INSUFFICIENT TABLE DIMENSIONS'
     &      / 8X, 'INPER', 5X, 'INQUA' / 11X, I2, 8X, I2 )

		PRINT *,""
		PRINT *,"ERROR:PROGRAM STOPPED IN SUBROUTINE READHC DUE TO"
		PRINT *,"INSUFFICIENT TABLE DIMENSIONS."
		PRINT *,""
          STOP
        ELSEIF((NCON.GT.INCON).OR.(NVEL.GT.INVEL))THEN
          WRITE(66,6031) INCON, INVEL
6031  FORMAT( 1X, '***** ERROR *****'
     &      / 1X, 'PROGRAM STOPPED IN SUBROUTINE READHC DUE TO'
     &      / 1X, 'INSUFFICIENT TABLE SIZE FOR RESISTANCE FACTOR'
     &      / 8X, 'INCON', 5X, 'INVEL' / 11X, I2, 8X, I2 )
		PRINT *,""
		PRINT *,"ERROR:PROGRAM STOPPED IN SUBROUTINE READHC DUE TO"
		PRINT *,"INSUFFICIENT TABLE SIZE FOR RESISTANCE FACTOR."
		PRINT *,""
          STOP
        ENDIF
C
C.... for each table
C
        DO 7050 M=1,NPER
C
C.... read permeability (md) data
C
        READ(5,6000)HEAD
        READ(5,6000)HEAD
            READ(5,*) TPER(M)
C
C....
C
        DO 7030 JQ=1,NQUA
C
C.... read quality (%) data
C
        READ(5,6000)HEAD
        READ(5,6000)HEAD
            READ(5,*) TQUA(M,JQ)
            NT=JQ+(M-1)*NQUA
            WRITE(66,6070) NT, TPER(M),TQUA(M,JQ)
6070  FORMAT(/ 5X, 'FOAM RESISTANCE FACTOR TABLE #', I2,
     &       / 5X, '----- TPER (MD)     TQUA (%) -----',
     &       / 10X, F7.1, 8X, F5.1)
C
C.... read concentration (ppm) data
C
        READ(5,6000)HEAD
        READ(5,6000)HEAD
            READ(5,*) (TCON(M,KC,JQ),KC=1,NCON)
            WRITE(66,6080)
            WRITE(66,6090) (TCON(M,KC,JQ),KC=1,NCON)
6080  FORMAT( / 22X, 'TCON (PPM)')
6090  FORMAT( 10X, 6( 5X, F6.1 ) )
        DO 55 KC=1,NCON-1
        IF(TCON(M,KC,JQ).GE.TCON(M,KC+1,JQ))THEN
          WRITE(66,621)
621   FORMAT( 1X, '***** ERROR *****'
     &      / 1X, 'PROGRAM STOPPED IN SUBROUTINE READHC DUE TO'
     &      / 1X, 'CONCENTARTION ARRAY IS NOT IN THE INCREASING ORDER')
		PRINT *,""
		PRINT *,"ERROR:PROGRAM STOPPED IN SUBROUTINE READHC DUE TO"
		PRINT *,"CONCENTARTION ARRAY IS NOT IN THE INCREASING ORDER."
		PRINT *,""
          STOP
        ENDIF
55      CONTINUE
C
C.... convert TCON unit from ppm to lbm/lbm
C
            DO 7035 KC=1,NCON
               TCON(M,KC,JQ)=TCON(M,KC,JQ)/ONEMIL
7035        CONTINUE
C
C.... read velocity (ft/day) and resistance factor data
C
        READ(5,6000)HEAD
        READ(5,6000)HEAD
            WRITE(66,7000)
7000  FORMAT( / 1X, 'TVEL (FT/D)', 10X, 'TRES')
            DO 7020 I=1,NVEL
              READ(5,*) TVEL(M,I,JQ),(TRES(M,I,KC,JQ),KC=1,NCON)
             DO 1155 KC=1,NCON
             TRES(M,I,KC,JQ)=TRES(M,I,KC,JQ)*FSCAL
1155         CONTINUE
              WRITE(66,7010) TVEL(M,I,JQ),(TRES(M,I,KC,JQ),KC=1,NCON)
7010  FORMAT( 5X, F5.2, 6( 5X, F6.1 ) )
7020        CONTINUE
        DO 56 I=1,NVEL-1
        IF(TVEL(M,I,JQ).GE.TVEL(M,I+1,JQ))THEN
          WRITE(66,622)
622   FORMAT( 1X, '***** ERROR *****'
     &      / 1X, 'PROGRAM STOPPED IN SUBROUTINE READHC DUE TO'
     &      / 1X, 'VELOCITY ARRAY IS NOT IN THE INCREASING ORDER')
		PRINT *,""
		PRINT *,"ERROR:PROGRAM STOPPED IN SUBROUTINE READHC DUE TO"
		PRINT *,"VELOCITY ARRAY IS NOT IN THE INCREASING ORDER."
		PRINT *,""
		STOP
        ENDIF
56      CONTINUE
7030    CONTINUE
        DO 57 JQ=1,NQUA-1 
        IF(TQUA(M,JQ).GE.TQUA(M,JQ+1))THEN
          WRITE(66,623)
623   FORMAT( 1X, '***** ERROR *****'
     &      / 1X, 'PROGRAM STOPPED IN SUBROUTINE READHC DUE TO'
     &      / 1X, 'QUALITY ARRAY IS NOT IN THE INCREASING ORDER')
		PRINT *,""
		PRINT *,"ERROR:PROGRAM STOPPED IN SUBROUTINE READHC DUE TO"
		PRINT *,"QUALITY ARRAY IS NOT IN THE INCREASING ORDER."
		PRINT *,""
          STOP
        ENDIF
57      CONTINUE
7050    CONTINUE
        DO 58 M=1,NPER-1 
        IF(TPER(M).GE.TPER(M+1))THEN
          WRITE(66,624)
624   FORMAT( 1X, '***** ERROR *****'
     &      / 1X, 'PROGRAM STOPPED IN SUBROUTINE READHC DUE TO'
     &      / 1X, 'PERMEABILITY ARRAY IS NOT IN THE INCREASING ORDER')
		PRINT *,""
		PRINT *,"ERROR:PROGRAM STOPPED IN SUBROUTINE READHC DUE TO"
		PRINT *,"PERMEABILITY ARRAY IS NOT IN THE INCREASING ORDER."
		PRINT *,""
          STOP
        ENDIF
58      CONTINUE

      ELSE

        WRITE(66,6060)
6060  FORMAT(2X, 'FOAM OPTION IS NOT SELECTED')

      ENDIF
      RETURN
      END SUBROUTINE READHC
C
      SUBROUTINE RESID(VP,SO,SW,SG,BO,BW,BG,BS,RSOR,RSWR,RSO,RSWS1
     &                ,GOWT,GWWT,GGWT,GSWT,OX,OY,OZ,WX,WY,WZ,GX,GY,GZ
     &                ,SX,SY,SZ,AWG,AWS,DELT,DIV1,TOL,NSLUGS,II,JJ,KK
     &                ,IJKM,KSW1,KSW2,OL,WL,GL,SL,VG,VS,AW,AE,AS,AN,AT
     &                ,AB,B,E,TSLUG,SCFO,SCFW,SCFG,SCFGD,RESVOL,RMAX)
C
C     THIS ROUTINE COMPLETES THE UPDATE OF THE RESIDUALS AND TESTS FOR
C     CONVERGENCE. IF NOT CONVERGED IT FORMS THE PRESSURE EQUATION FOR
C     THE NEXT ITERATION.
C
      DIMENSION VP(IJKM),SO(IJKM),SW(IJKM),SG(IJKM),BO(IJKM),BW(IJKM)
     &         ,BG(IJKM),BS(4*IJKM),RSOR(IJKM),RSWR(IJKM),RSO(4*IJKM)
     &         ,RSWS1(IJKM),GOWT(IJKM),GWWT(IJKM),GGWT(IJKM)
     &         ,GSWT(4*IJKM),OX(IJKM),OY(IJKM),OZ(IJKM),WX(IJKM)
     &         ,WY(IJKM),WZ(IJKM),GX(IJKM),GY(IJKM),GZ(IJKM)
     &         ,SX(4*IJKM),SY(4*IJKM),SZ(4*IJKM),AWG(IJKM),AWS(4*IJKM)
     &         ,OL(IJKM),WL(IJKM),GL(IJKM),SL(4*IJKM),VG(IJKM)
     &         ,VS(4*IJKM),AW(IJKM),AE(IJKM),AS(IJKM),AN(IJKM),AT(IJKM)
     &         ,AB(IJKM),B(IJKM),E(IJKM)
      DIMENSION SRMAX(4),ISMAX(4),TSLUG(4)
      IJM = II*JJ
      IIS = NSLUGS*II
      IJMS = NSLUGS*IJM
      ORMAX = 0.0
      WRMAX = 0.0
      GRMAX = 0.0
      IOMAX = 1
      IWMAX = 1
      IGMAX = 1
      SCFO = 0.0
      SCFW = 0.0
      SCFG = 0.0
      SCFGD = 0.0
      RESVOL = 0.0
      DO 100 ISOL = 1,NSLUGS
        SRMAX(ISOL) = 0.0
        ISMAX(ISOL) = 1
        TSLUG(ISOL) = 0.0
  100 CONTINUE
      IBS = 0
      DO 500 IB = 1,IJKM
        VPP = VP(IB)
        OLP1 = VPP*SO(IB)/BO(IB)
        WLP1 = VPP*SW(IB)/BW(IB)
        VPPG = VPP*SG(IB)
        GFLP1 = VPPG/BG(IB)
        GDLP1 = RSOR(IB)*OLP1 + RSWR(IB)*WLP1
        IF(NSLUGS .GT. 0) THEN
          IBS = IBS + 1
          SLP1 = VS(IBS)*(VPPG/BS(IBS)+RSO(IBS)*OLP1+RSWS1(IB)*WLP1)
          GSWT(IBS) = DIV1*(SLP1-SL(IBS)) + GSWT(IBS)
          SL(IBS) = SLP1
          SMIN = .01*VPP/BS(IBS)
          IF(SLP1 .GT. SMIN) SMIN = SLP1
          ASR = ABS(GSWT(IBS))/SMIN
          IF(ASR .GT. SRMAX(1)) THEN
            SRMAX(1) = ASR
            ISMAX(1) = IB
          ENDIF
          TSLUG(1) = TSLUG(1) + SLP1
          DO 450 ISOL = 2,NSLUGS
            IBS = IBS + 1
            SLP1 = VS(IBS)*(VPPG/BS(IBS)+RSO(IBS)*OLP1)
            GSWT(IBS) = DIV1*(SLP1-SL(IBS)) + GSWT(IBS)
            SL(IBS) = SLP1
            SMIN = .01*VPP/BS(IBS)
            IF(SLP1 .GT. SMIN) SMIN = SLP1
            ASR = ABS(GSWT(IBS))/SMIN
            IF(ASR .GT. SRMAX(ISOL)) THEN
              SRMAX(ISOL) = ASR
              ISMAX(ISOL) = IB
            ENDIF
            TSLUG(ISOL) = TSLUG(ISOL) + SLP1
  450     CONTINUE
          GFLP1 = VG(IB)*GFLP1
          GDLP1 = VG(IB)*GDLP1
        ENDIF
        GLP1 = GFLP1 + GDLP1
        GOWT(IB) = DIV1*(OLP1-OL(IB)) + GOWT(IB)
        GWWT(IB) = DIV1*(WLP1-WL(IB)) + GWWT(IB)
        GGWT(IB) = DIV1*(GLP1-GL(IB)) + GGWT(IB)
        OL(IB) = OLP1
        WL(IB) = WLP1
        GL(IB) = GLP1
        OMIN = .1*VPP/BO(IB)
        IF(OLP1 .GT. OMIN) OMIN = OLP1
        AOR = ABS(GOWT(IB))/OMIN
        IF(AOR .GT. ORMAX) THEN
          ORMAX = AOR
          IOMAX = IB
        ENDIF
        WMIN = .1*VPP/BW(IB)
        IF(WLP1 .GT. WMIN) WMIN = WLP1
        AWR = ABS(GWWT(IB))/WMIN
        IF(AWR .GT. WRMAX) THEN
          WRMAX = AWR
          IWMAX = IB
        ENDIF
        GMIN = .01*VPP/BG(IB)
        IF(GLP1 .GT. GMIN) GMIN = GLP1
        AGR = ABS(GGWT(IB))/GMIN
        IF(AGR .GT. GRMAX) THEN
          GRMAX = AGR
          IGMAX = IB
        ENDIF
        SCFO  = SCFO + OLP1
        SCFW  = SCFW + WLP1
        SCFG  = SCFG + GFLP1
        SCFGD = SCFGD + GDLP1
        RESVOL = RESVOL + VPP
  500 CONTINUE
      ORMAX = DELT*ORMAX
      WRMAX = DELT*WRMAX
      GRMAX = DELT*GRMAX
      SSMAX = 0.0
      DO 525 ISOL = 1,NSLUGS
        SRMAX(ISOL) = DELT*SRMAX(ISOL)
        IF(SRMAX(ISOL) .GT. SSMAX) SSMAX = SRMAX(ISOL)
  525 CONTINUE
      RMAX = MAX(ORMAX,WRMAX,GRMAX,SSMAX)
      IF(KSW2 .GT. 0) WRITE(6,1400) IOMAX,ORMAX,IWMAX,WRMAX,IGMAX,GRMAX
      IF(KSW1 .GT. 0) WRITE(8,1400) IOMAX,ORMAX,IWMAX,WRMAX,IGMAX,GRMAX
      IF(NSLUGS .GT. 0) THEN
        IF(KSW2 .GT. 0)
     &    WRITE(6,1400) (ISMAX(ISOL),SRMAX(ISOL),ISOL=1,NSLUGS)
        IF(KSW1 .GT. 0)
     &    WRITE(8,1400) (ISMAX(ISOL),SRMAX(ISOL),ISOL=1,NSLUGS)
      ENDIF
C
C     FORM NEW PRESSURE EQUATION
C
      IF(RMAX .GT. TOL) THEN
        IB = 0
        IBASE = 0
        DO 900 K = 1,KK
          DO 850 J = 1,JJ
            DO 800 I = 1,II
              IB = IB + 1
              AAG = AWG(IB)
              IF(NSLUGS .GT. 0) THEN
                IBS = IBASE + 1
                AAO = BO(IB) - AAG*VG(IB)*RSOR(IB) 
     &                      - VS(IBS)*AWS(IBS)*RSO(IBS)
                AAW = BW(IB) - AAG*VG(IB)*RSWR(IB)
     &                      - VS(IBS)*AWS(IBS)*RSWS1(IB)
                DO 550 ISOL = 2,NSLUGS
                  IBS = IBASE + ISOL
                  AAO = AAO - VS(IBS)*AWS(IBS)*RSO(IBS)
  550           CONTINUE
                IF(I .NE. 1) THEN
                  IBM = IB - 1
                  AWSUM = AAO*OX(IBM) + AAW*WX(IBM) + AAG*GX(IBM)
                  DO 600 ISOL = 1,NSLUGS
                    IBS = IBASE + ISOL
                    AWSUM = AWSUM + AWS(IBS)*SX(IBS-NSLUGS)
  600             CONTINUE
                  AW(IB) = AWSUM
                ENDIF
                IF(J .NE. 1) THEN
                  IBM = IB - II
                  ASSUM = AAO*OY(IBM) + AAW*WY(IBM) + AAG*GY(IBM)
                  DO 650 ISOL = 1,NSLUGS
                    IBS = IBASE + ISOL
                    ASSUM = ASSUM + AWS(IBS)*SY(IBS-IIS)
  650             CONTINUE
                  AS(IB) = ASSUM
                ENDIF
                IF(K .NE. 1) THEN
                  IBM = IB - IJM
                  ATSUM = AAO*OZ(IBM) + AAW*WZ(IBM) + AAG*GZ(IBM)
                  DO 700 ISOL = 1,NSLUGS
                    IBS = IBASE + ISOL
                    ATSUM = ATSUM + AWS(IBS)*SZ(IBS-IJMS)
  700             CONTINUE
                  AT(IB) = ATSUM
                ENDIF
                AESUM = AAO*OX(IB) + AAW*WX(IB) + AAG*GX(IB)
                ANSUM = AAO*OY(IB) + AAW*WY(IB) + AAG*GY(IB)
                ABSUM = AAO*OZ(IB) + AAW*WZ(IB) + AAG*GZ(IB)
                BSUM = AAO*GOWT(IB) + AAW*GWWT(IB) + AAG*GGWT(IB)
                DO 750 ISOL = 1,NSLUGS
                  IBS = IBASE + ISOL
                  AESUM = AESUM + AWS(IBS)*SX(IBS)
                  ANSUM = ANSUM + AWS(IBS)*SY(IBS)
                  ABSUM = ABSUM + AWS(IBS)*SZ(IBS)
                  BSUM = BSUM + AWS(IBS)*GSWT(IBS)
  750           CONTINUE
                AE(IB) = AESUM
                AN(IB) = ANSUM
                AB(IB) = ABSUM
                B(IB) = BSUM
                IBASE = IBASE + NSLUGS
              ELSE
                AAO = BO(IB) - AAG*RSOR(IB)
                AAW = BW(IB) - AAG*RSWR(IB)
                IF(I .NE. 1) THEN
                  IBM = IB - 1
                  AW(IB) = AAO*OX(IBM) + AAW*WX(IBM) + AAG*GX(IBM)
                ENDIF
                IF(J .NE. 1) THEN
                  IBM = IB - II
                  AS(IB) = AAO*OY(IBM) + AAW*WY(IBM) + AAG*GY(IBM)
                ENDIF
                IF(K .NE. 1) THEN
                  IBM = IB - IJM
                  AT(IB) = AAO*OZ(IBM) + AAW*WZ(IBM) + AAG*GZ(IBM)
                ENDIF
                AE(IB) = AAO*OX(IB) + AAW*WX(IB) + AAG*GX(IB)
                AN(IB) = AAO*OY(IB) + AAW*WY(IB) + AAG*GY(IB)
                AB(IB) = AAO*OZ(IB) + AAW*WZ(IB) + AAG*GZ(IB)
                B(IB) = AAO*GOWT(IB) + AAW*GWWT(IB) + AAG*GGWT(IB)
              ENDIF
              E(IB) = - AW(IB) - AE(IB) - AS(IB) - AN(IB) - AT(IB)
     &                - AB(IB) - VP(IB)*E(IB)*DIV1
  800       CONTINUE
  850     CONTINUE
  900   CONTINUE
      ENDIF
      RETURN
 1400 FORMAT(4(1X,I5,1X,E14.7))
      END SUBROUTINE RESID
C
      SUBROUTINE SLORD(NX,NZ,IJKM,MAXA,LINK,NLBW,NRBW,IXA,MAXBND)
      DIMENSION LINK(IJKM,6),NLBW(IJKM),NRBW(IJKM),IXA(IJKM)
      COMMON/D4CNT/NTOP,NTOT,NBOT 
      DIMENSION NSIZE(2)
C
C     THIS ROUTINE COMPUTES THE BOOKKEEPING ARRAYS USED BY SLSOR
C
      NRMAX = NX + NZ
      I1 = 1
      IF(NZ .GT. NX) I1 = NX
      I2 = NX + 1 - I1
      IDIR = (I2-I1)/(NX-1)
      IBR = 0
      DO 300 NRMIN = 2,3
        DO 250 NR = NRMIN,NRMAX,2
          DO 200 I = I1,I2,IDIR
            K = NR - I
            IF(K .GE. 1 .AND. K .LE. NZ) THEN
              IBR = IBR + 1
              IXA(I+NX*(K-1)) = IBR
            ENDIF
  200     CONTINUE
  250   CONTINUE
        NSIZE(NRMIN-1) = IBR
  300 CONTINUE
      NTOP = NSIZE(1)
      NTOT = NSIZE(2)
      NBOT = NTOT - NTOP
      IB = 0
      DO 500 K = 1,NZ
        DO 450 I = 1,NX
          IB = IB + 1
          IBR = IXA(IB)
          DO 400 ID = 1,4
            LINK(IBR,ID) = 0
  400     CONTINUE
          IF(I .NE.  1) LINK(IBR,1) = IXA(IB-1)
          IF(I .NE. NX) LINK(IBR,2) = IXA(IB+1)
          IF(K .NE.  1) LINK(IBR,3) = IXA(IB-NX)
          IF(K .NE. NZ) LINK(IBR,4) = IXA(IB+NX)
  450   CONTINUE
  500 CONTINUE
      MAXBND = 0
      IBR = NTOP
      IR = IBR + 1
      DO 950 L = 1,NBOT
        IBR = IBR + 1
        IL = IBR
        DO 900 ID = 1,4
          IBUR = LINK(IBR,ID)
          IF(IBUR .GT. 0) THEN
            DO 850 JD = 1,4
              IBLR = LINK(IBUR,JD)
              IF(IBLR .GT. 0) THEN
                IF(IBLR .LT. IL) IL = IBLR
                IF(IBLR .GT. IR) IR = IBLR
              ENDIF
  850       CONTINUE
          ENDIF
  900   CONTINUE
        NLBW(L) = IBR - IL
        NRBW(L) = IR - IBR
        IF(NRBW(L) .GT. MAXBND) MAXBND = NRBW(L)
  950 CONTINUE
      IF(NBOT*MAXBND .GT. MAXA) THEN
        WRITE(6,1950)
		PRINT *,""
		PRINT *,"ERROR:DIMENSION OF AMAT INSUFFICIENT TO RUN SLICE SOR"
		PRINT *,""
        STOP
      ENDIF
      RETURN
 1950 FORMAT(//,10X,'DIMENSION OF AMAT INSUFFICIENT TO RUN SLICE SOR')
      END SUBROUTINE SLORD
C
      SUBROUTINE SLSOR(AW,AE,AS,AN,AT,AB,E,B,OMEGA,TOL
     &                ,LINK,NLBW,NRBW,IXA,NX,NY,NZ,IJKM,NCYCLE,ITMAX
     &                ,IOCODE,KSW1,KSW3,MAXROW,MAXBND
     &                ,CC,TT,RR,AA,ROW,X)
C
C     THIS ROUTINE SOLVES THE PRESSURE EQUATION USING PLANAR SUCCESSIVE
C     OVERRELAXATION. THE SOLUTION OF THE EQUATIONS IN A PLANE IS BY
C     GAUSS ELIMINATION WITH D4 ORDERING.
C
      DIMENSION AW(IJKM),AE(IJKM),AS(IJKM),AN(IJKM),AT(IJKM)
     &         ,AB(IJKM),E(IJKM),B(IJKM),X(IJKM)
      DIMENSION CC(IJKM),TT(NX*NZ,4),RR(IJKM),AA(NBOT,MAXBND)
     &         ,ROW((-MAXROW):MAXROW)
      DIMENSION LINK(IJKM,6),NLBW(IJKM),NRBW(IJKM),IXA(IJKM)
      COMMON/D4CNT/NTOP,NTOT,NBOT 
      DO 50 IB = 1,IJKM
        X(IB) = 0.0
   50 CONTINUE
      IT = 1
  100 IF(IT .LE. ITMAX) THEN
        DXMAXL = DXMAX
        DXMAX = 0.0
        DO 900 J = 1,NY
C
C     REORDER AND NORMALIZE UPPER LEFT QUADRANT
C
          IBSL = 0
          DO 200 K = 1,NZ
            IB = NX*((J-1)+NY*(K-1))
            DO 150 I = 1,NX
              IBSL = IBSL + 1
              IB = IB + 1
              BB = B(IB)
              IF(J .NE.  1) BB = BB - AS(IB)*X(IB-NX)
              IF(J .NE. NY) BB = BB - AN(IB)*X(IB+NX)
              IBR = IXA(IBSL)
              IF(IBR .LE. NTOP) THEN
                FAC = 1.0/E(IB)
                TT(IBR,1) = FAC*AW(IB)
                TT(IBR,2) = FAC*AE(IB)
                TT(IBR,3) = FAC*AT(IB)
                TT(IBR,4) = FAC*AB(IB)
                RR(IBR) = FAC*BB
              ELSE
                CC(IBR) = E(IB)
                TT(IBR,1) = AW(IB)
                TT(IBR,2) = AE(IB)
                TT(IBR,3) = AT(IB)
                TT(IBR,4) = AB(IB)
                RR(IBR) = BB
              ENDIF
  150       CONTINUE
  200     CONTINUE
          DO 550 IBR = NTOP+1,NTOT
            IL = -NLBW(IBR-NTOP)
            IR =  NRBW(IBR-NTOP)
C
C     ELIMINATE LOWER LEFT QUADRANT
C
            DO 250 I = IL,IR
              ROW(I) = 0.0
  250       CONTINUE
            ROW(0) = CC(IBR)
            TEMP = RR(IBR)
            DO 350 ID = 1,4
              IBUR = LINK(IBR,ID)
              IF(IBUR .GT. 0) THEN
                FAC = TT(IBR,ID)
                DO 300 JD = 1,4
                  IBLR = LINK(IBUR,JD)
                  IF(IBLR .GT. 0) THEN
                    IROW = IBLR - IBR
                    ROW(IROW) = ROW(IROW) - FAC*TT(IBUR,JD)
                  ENDIF
  300           CONTINUE
              ENDIF
              TEMP = TEMP - FAC*RR(IBUR)
  350       CONTINUE
C
C       ELIMINATE BELOW DIAGONAL IN LOWER RIGHT QUADRANT
C
            DO 450 IE = IL,-1
              FAC = ROW(IE)
              IBER = IBR + IE
              IBOT = IBER - NTOP
              IROW = IE
              DO 400 IA = 1,NRBW(IBOT)
                IROW = IROW + 1
                ROW(IROW) = ROW(IROW) - FAC*AA(IBOT,IA)
  400         CONTINUE
              TEMP = TEMP - FAC*RR(IBER)
  450       CONTINUE
C
C     NORMALIZE AND STORE
C
            IBOT = IBR - NTOP
            FAC = 1.0/ROW(0)
            DO 500 IROW = 1,NRBW(IBOT)
              AA(IBOT,IROW) = FAC*ROW(IROW)
  500       CONTINUE
            RR(IBR) = FAC*TEMP
  550     CONTINUE
C
C     BACK SUBSTITUTION ON LOWER HALF
C
          IBR = NTOT
          DO 650 IBOT = NBOT-1,1,-1
            IBR = IBR - 1
            TEMP = RR(IBR)
            DO 600 IROW = 1,NRBW(IBOT)
              TEMP = TEMP - AA(IBOT,IROW)*RR(IBR+IROW)
  600       CONTINUE
            RR(IBR) = TEMP
  650     CONTINUE
C
C     BACK SUBSTITION ON UPPER HALF
C
          DO 750  IBR = 1,NTOP
            TEMP = RR(IBR)
            DO 700 ID = 1,4
              IBLR = LINK(IBR,ID)
              IF(IBLR .GT. 0) TEMP = TEMP - TT(IBR,ID)*RR(IBLR)
  700       CONTINUE
            RR(IBR) = TEMP
  750     CONTINUE
C
C     STORE IN NATURAL ORDER
C
          IBSL = 0
          DO 850 K = 1,NZ
            IB = NX*((J-1)+NY*(K-1))
            DO 800 I = 1,NX
              IBSL = IBSL + 1
              IB = IB + 1
              DX = OMEGA*(RR(IXA(IBSL))-X(IB))
              X(IB) = X(IB) + DX
              DX = ABS(DX)
              IF(DX .GT. DXMAX) DXMAX = DX
  800       CONTINUE
  850     CONTINUE
  900   CONTINUE
        IF(NCYCLE .GT. 0) THEN
          IF(MOD(IT,NCYCLE) .EQ. 0) THEN
            THETA = DXMAX/DXMAXL
            IF(THETA .LT. 1.0) THEN
              OM = OMEGA - 1.0
              RHOSQ = (THETA+OM)*(THETA+OM)/(THETA*OMEGA*OMEGA)
              IF(RHOSQ .LT. .9999) THEN
                OMEGOP = 2.0/(1.0+SQRT(1.0-RHOSQ))
              ELSE
                OMEGOP = OMEGA
              ENDIF
            ELSE
              OMEGOP = OMEGA
            ENDIF
            OMEGA = 1.25*OMEGOP - 0.5
          ENDIF
        ENDIF
        IF(OMEGA .LT. 1.0) OMEGA = 1.0
        IF(IT .EQ. 1) DXMAX1 = DXMAX
        IT = IT + 1
        IF(DXMAX .GT. TOL .AND. (DXMAX/DXMAX1) .GT. 1.D-3) GOTO 100
        IF(KSW3 .GT. 0) WRITE(IOCODE,1600) IT,OMEGA
        IF(KSW1 .GT. 0 .AND. KSW3 .GT. 0) WRITE(8,1600) IT,OMEGA
      ENDIF
      RETURN
 1600 FORMAT(5X,'PLANAR(X-Z) SOR CONVERGED AFTER ',I3
     &      ,' ITERATIONS WITH OMEGA = ',F6.3)
      END SUBROUTINE SLSOR
        SUBROUTINE SUR(
     &  DX,DY,DZ,DV,DT,NI,NJ,NK,
     &  CS,CSPRE,
     &  ROW,ROWPRE,FWX,FWY,FWZ,
     &  QW,SWPRE,SW,FI,
     &  XSI,IQN1,IQN2,IQN3,LAYER,KIP,NVQN,NW,IDIR,
     &  CRUX,CRUY,CRUZ,XX1,XX2,XX3,XX4,RR)
 

      COMMON/LITER/MAXITR,EPSC,EPSN
      COMMON/SURFP/ROR,DELTA,CKS,AS

      DIMENSION FWX(NI,NJ,NK),FWY(NI,NJ,NK),FWZ(NI,NJ,NK)
      DIMENSION SWPRE(NI,NJ,NK),SW(NI,NJ,NK)
      DIMENSION CS(NI,NJ,NK),CSPRE(NI,NJ,NK)
      DIMENSION ROW(NI,NJ,NK),ROWPRE(NI,NJ,NK)
      DIMENSION QW(NI,NJ,NK)
      DIMENSION DX(NI,NJ,NK),DY(NI,NJ,NK),DZ(NI,NJ,NK)
      DIMENSION DV(NI,NJ,NK),FI(NI,NJ,NK)
      DIMENSION XSI(NW),IQN1(NW),IQN2(NW),IQN3(NW),LAYER(NW),KIP(NW)
 
        DIMENSION CRUX(0:NI,NJ,NK),CRUY(NI,0:NJ,NK),
     &            CRUZ(NI,NJ,0:NK)    
        DIMENSION RR(NI,NJ,NK)
        DIMENSION XX1(NI,NJ,NK),XX2(NI,NJ,NK)
        DIMENSION XX3(NI,NJ,NK),XX4(NI,NJ,NK)

        DIMENSION IDIR(NW)
C*****
C     SAVE THE CURRENT VALUE OF CS(I,J) IN CSPREV(I,J) [G/G]
C*****
        DO 160 K = 1,NK
        DO 160 J = 1,NJ
        DO 160 I = 1,NI
               CSPRE(I,J,K) = CS(I,J,K)
160     CONTINUE

C*****
C     CALCULATE COEFFICIENT AND TERM RELATED TO ADSORPTION
C       XX3 [G/SEC], XX4 [G/SEC]
C*****

        XXXX2 = ROR*DELTA*CKS*AS
        DO 302 K = 1,NK
        DO 301 J = 1,NJ
        DO 311 I = 1,NI
          XXXX1 = DV(I,J,K)/DT
          XX = (1.0 - FI(I,J,K))*XXXX2
     1       /(1.0 + CKS*CSPRE(I,J,K))
     2       + FI(I,J,K)*ROWPRE(I,J,K)*SWPRE(I,J,K) 
          XX3(I,J,K) = XX*XXXX1*CSPRE(I,J,K)  
          XX4(I,J,K) = FI(I,J,K)*XXXX1*ROW(I,J,K)*SW(I,J,K) 
311     CONTINUE
301     CONTINUE
302     CONTINUE
 
C*****
C     SOLVING FOR CS(I,J) BY ITERATIVE METHOD
C*****
        DO 1000 ITER = 1,MAXITR

 
C*****
C     CALCULATE CRUX(I,J), CRUY(I,J) [G/SEC/CM^2]
C       FWX(0,J) = FWX(NI,J) = 0
C       FWY(I,0) = FWY(I,NJ) = 0
C*****

C********************************************************
        DO 9001 K = 1,NK  

        DO 10 J = 1,NJ
          CRUX(0,J,K) = 0.0
          CRUX(NI,J,K) = 0.0
10      CONTINUE

        
        IF(NI.GT.1)THEN
        DO 400 J = 1,NJ
        DO 410 I = 1,NI-1
          IF(FWX(I,J,K).GT.0.0)THEN
            CRUX(I,J,K) = CS(I,J,K)*ROW(I,J,K) 
          ELSE
            CRUX(I,J,K) = CS(I+1,J,K)*ROW(I+1,J,K) 
          ENDIF
410     CONTINUE
400     CONTINUE

        DO 72 J = 1,NJ
        DO 21 I = 1,NI-1
          CRUX(I,J,K) = CRUX(I,J,K)*FWX(I,J,K)
21      CONTINUE 
72      CONTINUE 
        
        ENDIF

9001    CONTINUE
C******************************************************** 
        DO 9002 K = 1,NK

        DO 30 I = 1,NI
          CRUY(I,0,K) = 0.0
          CRUY(I,NJ,K) = 0.0
30      CONTINUE

        IF(NJ.GT.1)THEN
        DO 387 J = 1,NJ-1
        DO 386 I = 1,NI
          IF(FWY(I,J,K).GT.0.0)THEN
            CRUY(I,J,K) = CS(I,J,K)*ROW(I,J,K) 
          ELSE
            CRUY(I,J,K) = CS(I,J+1,K)*ROW(I,J+1,K) 
          ENDIF
386     CONTINUE 
387     CONTINUE 
 
        DO 82 J = 1,NJ-1
        DO 41 I = 1,NI
          CRUY(I,J,K) = CRUY(I,J,K)*FWY(I,J,K)
41      CONTINUE 
82      CONTINUE 

        ENDIF
9002    CONTINUE
C********************************************************** 
C******************************************************** 
        DO 9003 J = 1,NJ

        DO 3031 I = 1,NI
          CRUZ(I,J,0) = 0.0
          CRUZ(I,J,NK) = 0.0
3031    CONTINUE

        IF(NK.GT.1)THEN

        DO 3871 K = 1,NK-1
        DO 3861 I = 1,NI
          IF(FWZ(I,J,K).GT.0.0)THEN
            CRUZ(I,J,K) = CS(I,J,K)*ROW(I,J,K) 
          ELSE
            CRUZ(I,J,K) = CS(I,J,K+1)*ROW(I,J,K+1) 
          ENDIF
3861     CONTINUE 
3871     CONTINUE 
 
        DO 821 K = 1,NK-1
        DO 411 I = 1,NI
          CRUZ(I,J,K) = CRUZ(I,J,K)*FWZ(I,J,K)
411      CONTINUE 
821      CONTINUE 

        ENDIF
9003    CONTINUE
C*****
C     CALCULATE COEFFICIENT AND TERM RELATED TO ADSORPTION
C       XX1 [G/SEC], XX2 [G/SEC]
C*****
 

        DO 309 K = 1,NK
        DO 300 J = 1,NJ
        DO 310 I = 1,NI
          XXXX1 = DV(I,J,K)/DT
          XXXX2 = ROR*DELTA*CKS*AS*XXXX1
          XX = (1.0 - FI(I,J,K))*XXXX2
     1       /(1.0 + CKS*CS(I,J,K))
          XX2(I,J,K) = XX/(1.0 + CKS*CS(I,J,K)) + XX4(I,J,K)
          XX1(I,J,K) = (XX + XX4(I,J,K))*CS(I,J,K)
310     CONTINUE
300     CONTINUE
309     CONTINUE
 
C*****
C     UPDATE CS(I,J) FOR THIS ITERATION
C*****
        DO 760 K = 1,NK 
        DO 760 J = 1,NJ
        DO 760 I = 1,NI
               RR(I,J,K) = CS(I,J,K)
760     CONTINUE


C  ***  calculate the RJWS (injection contribution to CS)
        DO 630 K = 1,NK
        DO 630 J = 1,NJ
        DO 630 I = 1,NI

         IF(SW(I,J,K).GT.0.0)THEN
         XXXX1 = DV(I,J,K)/DX(I,J,K)
         XXXX2 = DV(I,J,K)/DY(I,J,K)
         XXXX22 = DV(I,J,K)/DZ(I,J,K)

            CS(I,J,K) = RR(I,J,K) 
     1          + ( - (CRUX(I,J,K) - CRUX(I-1,J,K))*XXXX1
     1              - (CRUY(I,J,K) - CRUY(I,J-1,K))*XXXX2
     1              - (CRUZ(I,J,K) - CRUZ(I,J,K-1))*XXXX22
     1              + XX3(I,J,K) - XX1(I,J,K))/XX2(I,J,K)
            ENDIF
630       CONTINUE
C 
        DO 700 IW=1,NVQN
        IF(IDIR(IW).EQ.3) THEN
           IQ1=IQN1(IW)
           IQ2=IQN2(IW)
           IQ3 = IQN3(IW)
        ELSEIF(IDIR(IW).EQ.2) THEN
           IQ1=IQN3(IW)
           IQ2=IQN1(IW)
           IQ3=IQN2(IW)
        ELSE
           IQ1=IQN2(IW)
           IQ2=IQN3(IW)
           IQ3=IQN1(IW)
        ENDIF
C 
          LAY   =  IQ3 + LAYER(IW) - 1
       DO 710 KK1=IQ3,LAY

          IF (IDIR(IW).EQ.3) THEN
           QWEN=QW(IQ1,IQ2,KK1)
            RREN=RR(IQ1,IQ2,KK1)
          ELSEIF(IDIR(IW).EQ.2) THEN
           QWEN=QW(IQ2,KK1,IQ1)
            RREN=RR(IQ2,KK1,IQ1)
          ELSE
           QWEN=QW(KK1,IQ1,IQ2)
            RREN=RR(KK1,IQ1,IQ2)
          ENDIF
         IF(KIP(IW).EQ.2.OR.KIP(IW).EQ.-2.OR.KIP(IW).EQ.-12) THEN
                 RJWS = XSI(IW)*QWEN
          ELSE
         IF(KIP(IW).EQ.1.OR.KIP(IW).EQ.-1.OR.KIP(IW).EQ.-11) THEN
                       RJWS = RREN*QWEN
          ELSE
          GOTO 700
                ENDIF
                ENDIF
              if(IDIR(IW).EQ.3) THEN
         CS(IQ1,IQ2,KK1)=CS(IQ1,IQ2,KK1)-RJWS/XX2(IQ1,IQ2,KK1)
       elseif(IDIR(IW).EQ.2) THEN
          CS(IQ2,KK1,IQ1)=CS(IQ2,KK1,IQ1)-RJWS/XX2(IQ2,KK1,IQ1)
            else
          CS(KK1,IQ1,IQ2)=CS(KK1,IQ1,IQ2)-RJWS/XX2(KK1,IQ1,IQ2)
         ENDIF
710        CONTINUE
700        CONTINUE
C*****
C     IF SUM OF DIFFERENCES OVER I AND J < EPSC, STOP ITERATION
C*****
        
        IF(ITER.GT.1)THEN
         
        SUM = 0.0
        DO 951 K = 1,NK
        DO 950 J = 1,NJ 
          DO 550 I = 1,NI
              SUM = SUM + ABS(RR(I,J,K) - CS(I,J,K))
550       CONTINUE
950     CONTINUE
951     CONTINUE
        IF(SUM.LE.EPSC)GOTO 2000
 
        ENDIF

1000    CONTINUE
 
C*****
C     END ITERATION
C*****
 
2000    CONTINUE

        IF(ITER.GT.MAXITR)THEN
          WRITE(6,*)' IN SURFACT RES = ',SUM,' ITER = ',ITER, 'RJWS='
     &     ,RJWS
        ENDIF
 

        RETURN
        END SUBROUTINE SUR
      SUBROUTINE TABLE2(IOCODE,NSLUGS,SOMIN,REDK,BETA,SORM
     &                 ,NOMOB,MOBCTL,SCI,PBO,MSATW,MSATG,MPOT
     &                 ,MPWT,MPGT,PMAXT
     &                 ,II,JJ,KK,IJKM,NTABS,NTAB,IDUMMY,NTABIJ)
C
C     WORK ARRAY : IDUMMY
C
      DIMENSION NTABIJ(II,JJ,KK),IDUMMY(IJKM),NTAB(IJKM)
      PARAMETER (RSMIN = 1.E-4 , PSC = 14.7)
C
      COMMON /SPVT/ SWT(10,25),KRWT(10,25),KRGT(10,25),PCOWT(10,25),
     & PCGOT(10,25),POT(25),MUOT(25),BOT(25),BOPT(25),RSOT(25),
     & RSOPT(25),
     & PWT(25),MUWT(25),BWT(25),BWPT(25),RSWT(25),RSWPT(25),
     & PGT(25),MUGT(25),BGT(25),BGPT(25),CRT(25),SWC(10),SORW(10),
     & SGT(10,25),KROWT(10,25),KROGT(10,25),RKOSWC(10),DKOSWC(10),
     & KR3P
C
      PARAMETER (NTE = 25 , NBOT = 51)
      COMMON/PVTRST/PST(NTE,4),VST(NTE,4),BST(NTE,4),RST(NTE,4)
     &             ,RWT(NTE,4),DBSDPT(NTE,4),DRSDPT(NTE,4)
     &             ,DRWDPT(NTE,4),BO1T(NTE),VO1T(NTE)
     &             ,BW1T(NTE),VW1T(NTE),CSC(NTE),FRCO2(NTE)
     &             ,VORST(NBOT),VWRST(NBOT),DVO1T(NBOT),DVW1T(NBOT)
     &             ,UORST(NBOT),UWRST(NBOT),DUO1T(NBOT),DUW1T(NBOT)
     &             ,VORSPT(NBOT),VWRSPT(NBOT),DVO1PT(NBOT)
     &             ,DVW1PT(NBOT),RUSQT(NBOT,4),RUGQT(NBOT)
     &             ,RUOQT(NBOT),USW1T(NBOT,4),UGW1T(NBOT),UOW1T(NBOT)
     &             ,USW2T(NBOT,4),UGW2T(NBOT),UOW2T(NBOT),VOPT(NTE)
     &             ,VWPT(NTE),PSMIN(4),PSMAX(4)
     &             ,BOSLP,BWSLP,BO1SLP,BW1SLP,VOSLP
     &             ,VO1SLP,VW1SLP,COH,CWH,CVOH,PMISC,PMCM,VSMISC
     &             ,OM1,OM2,RDRSO,RDRSW,RDRSO1,RDRSW1,RDMU,RDPRMP
     &             ,NPTS(4),IPSOL(4)
C
C  *** This common block contains four varibles separated from
C  *** common block PVTRST 
 
 
      COMMON/RHOSTO/RHOSCO,RHOSCG,RHOSCW,RHOSC(4)
 
      DIMENSION PDUM(NTE),UST(NTE),P1DUM(NTE),RSODUM(NTE),RSWDUM(NTE)
      EQUIVALENCE (PST(1,1),P1DUM(1)),(RST(1,1),RSODUM(1))
     &           ,(RWT(1,1),RSWDUM(1))
      REAL KROWT,KROGT,KRWT,KRGT,MUOT,MUWT,MUGT
      CHARACTER C80*80
      RINTVL = NBOT - 1
C
      WRITE(IOCODE,1050)
C
C     RELATIVE PERMEABILITY & CAPILLARY PRESSURE TABLE
C
      READ(5,1060) C80
      WRITE(IOCODE,1070) C80
      READ(5,*) KR3P
      WRITE(IOCODE,1080) KR3P
C
C     ESTABLISH RELATIVE PERMEABILITY TABLE DISTRIBUTION
C
      READ(5,*)ITABS
      WRITE(IOCODE,1053)ITABS
      READ(5,*)NTABS
      WRITE(IOCODE,1055)NTABS
       IF(ITABS .EQ. 1)THEN
       DO 30 K=1,KK
       DO 30 J=1,JJ
       DO 30 I=1,II
        IB=I+II*((J-1)+JJ*(K-1))
   30  NTAB(IB)=NTABS
       ELSEIF (ITABS .EQ. 2)THEN
        READ(5,*)(IDUMMY(K),K=1,KK)
        WRITE(IOCODE,1057)(IDUMMY(K),K=1,KK)
        DO 50 K=1,KK
        DO 50 J=1,JJ
        DO 50 I=1,II
         IB=I+II*((J-1)+JJ*(K-1))
   50   NTAB(IB)=IDUMMY(K)
       ELSE
        DO 70 K=1,KK
        DO 70 J=1,JJ
         READ(5,*)(NTABIJ(I,J,K),I=1,II)
         WRITE(IOCODE,1058)(NTABIJ(I,J,K),I=1,II)
   70   CONTINUE
        DO 80 K=1,KK
        DO 80 J=1,JJ
        DO 80 I=1,II
         IB=I+II*((J-1)+JJ*(K-1))
   80   NTAB(IB)=NTABIJ(I,J,K)
       ENDIF
C
C     READ FUNCTIONS OF WATER SATURATION (KROW,KRW,PCOW)
C
      DO 95 I=1,NTABS
      READ(5,1060) C80
      WRITE(IOCODE,1070) C80
      DO 100 J = 1,NTE
       READ(5,*) SWT(I,J),KROWT(I,J),KRWT(I,J),PCOWT(I,J)
       WRITE(IOCODE,1090) SWT(I,J),KROWT(I,J),KRWT(I,J),PCOWT(I,J)
       IF(SWT(I,J) .GT. 1.09) GOTO 105
  100 CONTINUE
  105 MSATW = J - 1
   95 CONTINUE
C
C     READ FUNCTIONS OF GAS SATURATION (KROG,KRG,PCGO)
C
      DO 115 I=1,NTABS
      READ(5,1060) C80
      WRITE(IOCODE,1070) C80
       DO 125 J = 1,NTE
       READ(5,*) SGT(I,J),KROGT(I,J),KRGT(I,J),PCGOT(I,J)
       WRITE(IOCODE,1090) SGT(I,J),KROGT(I,J),KRGT(I,J),PCGOT(I,J)
       IF(SGT(I,J) .GT. 1.09) GOTO 130
  125 CONTINUE
  130 MSATG = J - 1
  115 CONTINUE
C
C     DETERMINE "KROM" - CALLED RKOSWC - WHICH IS KROWT @ SWC
C                        FOR USE IN MODIFIED STONE EQUATION
C
      DO 145 I=1,NTABS
      DO 150 J=2,MSATW
        IF(KRWT(I,J) .GT. 0.0) GOTO 155
  150 CONTINUE
  155 SWC(I) = SWT(I,J-1)
      RKOSWC(I) = KROWT(I,J-1)
      DKOSWC(I) = 1./RKOSWC(I)
      WRITE(IOCODE,1155) SWC(I),RKOSWC(I)
  145 CONTINUE
C
C     BUBBLE POINT & MAXIMUM PRESSURES
C
      READ(5,1060) C80
      WRITE(IOCODE,1070) C80
      READ(5,*) PBO,VOSLP,BOSLP,BWSLP,PMAXT
      WRITE(IOCODE,1160) PBO,VOSLP,BOSLP,BWSLP,PMAXT
      DMU = PMAXT/RINTVL
      RDMU = 1.0/DMU
C
C     OIL DATA TABLE
C
      READ(5,1060) C80       
      WRITE(IOCODE,1070) C80
      DO 175 I = 1,NTE
        READ(5,*) POT(I),MUOT(I),BOT(I),RSOT(I)
        WRITE(IOCODE,1170) POT(I),MUOT(I),BOT(I),RSOT(I)
        RSOT(I) = 0.17809*RSOT(I)
        IF(POT(I) .GE. PMAXT) GOTO 180
  175 CONTINUE
  180 MPOT = I
C
C     WATER DATA TABLE
C
      READ(5,1060) C80   
      WRITE(IOCODE,1070) C80
      DO 200 I = 1,NTE
        READ(5,*) PWT(I),MUWT(I),BWT(I),RSWT(I)
        WRITE(IOCODE,1170) PWT(I),MUWT(I),BWT(I),RSWT(I)
        RSWT(I) = 0.17809*RSWT(I)
        IF(PWT(I) .GE. PMAXT) GOTO 205
  200 CONTINUE
  205 MPWT = I
C
C     GAS & ROCK DATA TABLE
C
      READ(5,1060) C80
      WRITE(IOCODE,1070) C80
      DO 225 I = 1,NTE
        READ(5,*) PGT(I),MUGT(I),BGT(I),CRT(I)
        WRITE(IOCODE,1220) PGT(I),MUGT(I),BGT(I),CRT(I)
        IF(PGT(I) .GE. PMAXT) GOTO 230
  225 CONTINUE
  230 MPGT = I
C
C     OIL, WATER, & GAS DENSITIES AT STOCK TANK CONDITIONS
C
      READ(5,1060) C80
      WRITE(IOCODE,1070) C80
      READ(5,*) RHOSCO,RHOSCW,RHOSCG
      WRITE(IOCODE,8104) RHOSCO,RHOSCW,RHOSCG
8104  FORMAT (2X,8F10.4)
C
C     CALCULATE SLOPES DBO/DP, DRSO/DP, DBW/DP, DRSW/DP, DBG/DP
C     NOTE: SLOPE AT POINT "I" IS BASED ON POINTS "I" AND "I-1"
C
      WRITE(IOCODE,1235)
      DO 250 I = 2,MPOT
        DIV = 1.0/(POT(I)-POT(I-1))
        BOPT(I) = (BOT(I)-BOT(I-1))*DIV
        RSOPT(I) = (RSOT(I)-RSOT(I-1))*DIV
        WRITE(IOCODE,1245) POT(I),BOT(I),BOPT(I),RSOT(I),RSOPT(I)
  250 CONTINUE
      WRITE(IOCODE,1260)
      DO 275 I = 2,MPWT
        DIV = 1.0/(PWT(I)-PWT(I-1))
        BWPT(I) = (BWT(I)-BWT(I-1))*DIV
        RSWPT(I) = (RSWT(I)-RSWT(I-1))*DIV
        WRITE(IOCODE,1245) PWT(I),BWT(I),BWPT(I),RSWT(I),RSWPT(I)
  275 CONTINUE
C
C     BUILD TABLES FOR COMPUTING OIL AND WATER FORMATION VOLUME 
C     FACTORS AND VISCOSITIES AS FUNCTIONS OF BOTH PRESSURE AND 
C     DISSOLVED HYDROCARBON GAS
C
      CALL INTERP(POT,BOT,MPOT,PBO,BOB)
      COH = -BOSLP/BOB
      CALL INTERP(PWT,BWT,MPWT,PBO,BWB)
      CWH = -BWSLP/BWB
      CALL INTERP(POT,MUOT,MPOT,PBO,UOB)
      CVOH = VOSLP/UOB
      VOPT(1) = 1.0
      VWPT(1) = 1.0
      WRITE(IOCODE,1280)
      DO 300 I = 2,MPGT
        BGPT(I) = (BGT(I)-BGT(I-1))/(PGT(I)-PGT(I-1))
        VOPT(I) = EXP(-COH*(PGT(I)-PSC))
        VWPT(I) = EXP(-CWH*(PGT(I)-PSC))
        WRITE(IOCODE,1290) PGT(I),BGT(I),BGPT(I),VOPT(I),VWPT(I),CRT(I)
  300 CONTINUE
      RSOMAX = RSOT(MPOT)
      IF(RSOMAX .GE. RSMIN) THEN
        DRSO = RSOMAX/RINTVL
        RDRSO = 1./DRSO
      ELSE
        RDRSO = 0.
      ENDIF
      RSWMAX = RSWT(MPWT)
      IF(RSWMAX .GE. RSMIN) THEN
        DRSW = RSWMAX/RINTVL
        RDRSW = 1./DRSW
      ELSE
        RDRSW = 0.
      ENDIF
      VORST(1) = BOT(1)
      VWRST(1) = BWT(1)
      UORST(1) = MUOT(1)
      UWRST(1) = MUWT(1)
      DO 325 I = 2,NBOT
        IF(RSOMAX .GE. RSMIN) THEN
          RSO = (I-1)*DRSO
          CALL INTERP(RSOT,BOT,MPOT,RSO,BO)
          CALL INTERP(RSOT,POT,MPOT,RSO,PO)
          CALL INTERP(PGT,VOPT,MPGT,PO,VOP)
          VORST(I) = BO/VOP
          CALL INTERP(RSOT,MUOT,MPOT,RSO,UOO)
          UORST(I) = UOO/(1.0+CVOH*(PO-PSC))
        ELSE
          VORST(I) = BOT(1)
          UORST(I) = MUOT(1)
        ENDIF
        VORSPT(I-1) = RDRSO*(VORST(I)-VORST(I-1))
        IF(RSWMAX .GE. RSMIN) THEN
          RSW = (I-1)*DRSW
          CALL INTERP(RSWT,BWT,MPWT,RSW,BW)
          CALL INTERP(RSWT,PWT,MPWT,RSW,PW)
          CALL INTERP(PGT,VWPT,MPGT,PW,VWP)
          VWRST(I) = BW/VWP
          CALL INTERP(RSWT,MUWT,MPWT,RSW,UWW)
          UWRST(I) = UWW
        ELSE
          VWRST(I) = BWT(1)
          UWRST(I) = MUWT(1)
        ENDIF
        VWRSPT(I-1) = RDRSW*(VWRST(I)-VWRST(I-1))
  325 CONTINUE
C
C     READ SOLVENT PVT DATA
C
      READ(5,1060) C80
      WRITE(IOCODE,1070) C80
      READ(5,*) NSLUGS,NSREAD
      WRITE(IOCODE,1405) NSLUGS,NSREAD
      IF(NSREAD .EQ. 0) GOTO 950
C
      READ(5,1060) C80
      WRITE(IOCODE,1075) C80
      READ(5,1060) C80
      WRITE(IOCODE,1075) C80
      READ(5,*) PBO1,VO1SLP,BO1SLP
      WRITE(IOCODE,1410) PBO1,VO1SLP,BO1SLP
C
      READ(5,1060) C80
      WRITE(IOCODE,1070) C80
      READ(5,*) PBW1,VW1SLP,BW1SLP
      WRITE(IOCODE,1410) PBW1,VW1SLP,BW1SLP
C
      READ(5,1060) C80
      READ(5,*) OM1,OM2
      WRITE(IOCODE,1415) OM1,OM2
C
      READ(5,1060) C80
      WRITE(IOCODE,1070) C80
      READ(5,*) PMISC,FPMISC,SOMIN,REDK,BETA,SORM,VSMISC
      WRITE(IOCODE,1420) PMISC,FPMISC,SOMIN,REDK,BETA,SORM,VSMISC
      IF(FPMISC .GT. .9999) FPMISC = .9999
      PMCM = FPMISC*PMISC
      RDPRMP = 1.0/(PMISC-PMCM)
C
C     IF BETA > 0.0, CALCULATE SORW FOR WATER-BLOCKING FUNCTION
C
      IF(NSLUGS .GT. 0 .AND. BETA .GT. 0.0) THEN
       DO 421 I=1,NTABS
        SORW(I) = 0.0
        DO 425 J = 1,MSATW
          IF(ABS(KROWT(I,J)) .LT. 0.000000001) GOTO 430
  425   CONTINUE
  430   SORW(I) = 1. - SWT(I,J)
        WRITE(6,1430) SORW(I)
  421  CONTINUE
      ENDIF
C
      READ(5,1060) C80
      READ(5,*) (RHOSC(J),J=1,NSREAD)
      WRITE(IOCODE,1435) (RHOSC(J),J=1,NSREAD)
C
      DO 500 J = 1,NSREAD
        READ(5,1060) C80
        WRITE(IOCODE,1070) C80
        READ(5,1060) C80
        WRITE(IOCODE,1075) C80
        DO 450 I = 1,NTE
          IF(J .EQ. 1) THEN
            READ(5,*) PST(I,J),VST(I,J),BST(I,J),RST(I,J)
     &               ,RWT(I,J),BO1T(I),VO1T(I),BW1T(I),VW1T(I)
            WRITE(IOCODE,1450) PST(I,J),VST(I,J),BST(I,J),RST(I,J)
     &                    ,RWT(I,J),BO1T(I),VO1T(I),BW1T(I),VW1T(I)
            RWT(I,J) = 0.17809*RWT(I,J)
          ELSE
            READ(5,*) PST(I,J),VST(I,J),BST(I,J),RST(I,J)
            WRITE(IOCODE,1460)PST(I,J),VST(I,J),BST(I,J),RST(I,J)
          ENDIF
          RST(I,J) = 0.17809*RST(I,J)
          PDUM(I) = PST(I,J)
          UST(I) = VST(I,J)
          IF(PST(I,J) .GE. PMAXT) GOTO 475
  450   CONTINUE
  475   NPTS(J) = I
        DO 480 I = 1,NBOT
          PP = (I-1)*DMU
          CALL INTERP(PDUM,UST,NPTS(J),PP,USS)
          RUSQT(I,J) = 1.0/(USS**.25)
          USW1T(I,J) = USS**(1.0-OM1)
          USW2T(I,J) = USS**(1.0-OM2)
  480   CONTINUE
  500 CONTINUE
      DO 525 I = 1,NBOT
        PP = (I-1)*DMU
        CALL INTERP(PGT,MUGT,MPGT,PP,UGG)
        RUGQT(I) = 1.0/(UGG**.25)
        UGW1T(I) = UGG**(1.0-OM1)
        UGW2T(I) = UGG**(1.0-OM2)
        CALL INTERP(POT,MUOT,MPOT,PP,UOO)
        RUOQT(I) = 1.0/(UOO**.25)
        UOW1T(I) = UOO**(1.0-OM1)
        UOW2T(I) = UOO**(1.0-OM2)
  525 CONTINUE
C
C     BUILD TABLES FOR COMPUTING THE INCREMENT TO OIL AND WATER
C     FORMATION VOLUME FACTORS AND VISCOSITIES AS A FUNCTION OF
C     DISSOLVED SOLVENT
C
      CALL INTERP(P1DUM,BO1T,NPTS(1),PBO1,BOB)
      CO1 = -BO1SLP/BOB
      CALL INTERP(P1DUM,BW1T,NPTS(1),PBW1,BWB)
      CW1 = -BW1SLP/BWB
      CALL INTERP(P1DUM,VO1T,NPTS(1),PBO1,UOB)
      CVO1 = VO1SLP/UOB
      CALL INTERP(P1DUM,VW1T,NPTS(1),PBW1,UWB)
      CVW1 = VW1SLP/UWB
      RSOMAX = RSODUM(NPTS(1))
      IF(RSOMAX .GT. RSMIN) THEN
        DRSO = RSOMAX/RINTVL
        RDRSO1 = 1./DRSO
      ELSE
        RDRSO1 = 0.0
      ENDIF
      RSWMAX = RSWDUM(NPTS(1))
      IF(RSWMAX .GT. RSMIN) THEN
        DRSW = RSWMAX/RINTVL
        RDRSW1 = 1./DRSW
      ELSE
        RDRSW1 = 0.0
      ENDIF
      DVO1T(1) = 0.0
      DVW1T(1) = 0.0
      DUO1T(1) = 1.0
      DUW1T(1) = 1.0
      DO 550 I = 2,NBOT
        IF(RSOMAX .GE. RSMIN) THEN
          RSO = (I-1)*DRSO
          CALL INTERP(RSODUM,BO1T,NPTS(1),RSO,BO)
          CALL INTERP(RSODUM,P1DUM,NPTS(1),RSO,PO)
          DVO1T(I) = BO/EXP(-CO1*(PO-PSC)) - BOT(1)
          CALL INTERP(RSODUM,VO1T,NPTS(1),RSO,UOO)
          DUO1T(I) = UOO/(1.0+CVO1*(PO-PSC))/VO1T(1)
        ELSE
          DVO1T(I) = 0.0
          DUO1T(I) = 1.0
        ENDIF
        DVO1PT(I-1) = RDRSO1*(DVO1T(I)-DVO1T(I-1))
        IF(RSWMAX .GE. RSMIN) THEN
          RSW = (I-1)*DRSW
          CALL INTERP(RSWDUM,BW1T,NPTS(1),RSW,BW)
          CALL INTERP(RSWDUM,P1DUM,NPTS(1),RSW,PW)
          DVW1T(I) = BW/EXP(-CW1*(PW-PSC)) - BWT(1)
          CALL INTERP(RSWDUM,VW1T,NPTS(1),RSW,UWW)
          DUW1T(I) = UWW/(1.0+CVW1*(PW-PSC))/VW1T(1)
        ELSE
          DVW1T(I) = 0.0
          DUW1T(I) = 1.0
        ENDIF
        DVW1PT(I-1) = RDRSW1*(DVW1T(I)-DVW1T(I-1))
  550 CONTINUE
C
C     READ MOBILITY CONTROL TABLE
C
      READ(5,1060) C80
      WRITE(IOCODE,1070) C80
      READ(5,*) NOMOB,MOBCTL,SCI
      WRITE(IOCODE,1615) NOMOB,MOBCTL,SCI
      IF(NOMOB .GT. 0) THEN
        READ(5,1060) C80
        WRITE(IOCODE,1070) C80
        DO 625 I = 1,NOMOB
          READ(5,*) CSC(I),FRCO2(I)
          WRITE(IOCODE,1090) CSC(I),FRCO2(I)
  625   CONTINUE
      ENDIF
      IF(NSLUGS .EQ. 0) GOTO 950
C
C     Calculate & print slopes DB1/DP,  DP2/DP, .... ,DP7/DP
C                      DRS1/DP, DRS2/DP, ... ,DRS7/SP,  DRW1/DP
C
      DO 700 J = 1,NSREAD
        WRITE(IOCODE,1650) J
        NO = NPTS(J)
        DO 675 I = 2,NO
          DIV = 1.0/(PST(I,J) - PST(I-1,J))
          DBSDPT(I,J) = (BST(I,J) - BST(I-1,J))*DIV
          DRSDPT(I,J) = (RST(I,J) - RST(I-1,J))*DIV
          IF(J .EQ. 1) DRWDPT(I,J) = (RWT(I,J) - RWT(I-1,J))*DIV
          WRITE(IOCODE,1670) PST(I,J),BST(I,J),DBSDPT(I,J),RST(I,J)
     &                      ,DRSDPT(I,J),RWT(I,J),DRWDPT(I,J)
  675   CONTINUE
  700 CONTINUE
      DO 900 ISOL = 1,NSLUGS
        PSMIN(ISOL) = PST(2,ISOL)
        PSMAX(ISOL) = PST(NPTS(ISOL),ISOL)
        IPSOL(ISOL) = 2
  900 CONTINUE
  950 CONTINUE
      RETURN
 1050 FORMAT(//,14X,'***** EMPIRICAL DATA TABLE *****'//)
 1053 FORMAT(1X,'ITABS=',I5)
 1055 FORMAT(1X,'NTABS=',I5)
 1057 FORMAT(1X,'DUMMY(K)=',5I5)
 1058 FORMAT(1X,'NTABIJ(I,J,K)=',10I5)
 1060 FORMAT(A80)
 1070 FORMAT(//,1X,A80)
 1075 FORMAT(1X,A80)
 1080 FORMAT(1X,'KR3P =',I5)
 1090 FORMAT(1X,5F10.4,2F10.2)
 1155 FORMAT(//1X,'SWC, KROM:',2G15.7)
 1160 FORMAT(F10.2,E10.3,1X,E10.3,E10.3,F10.2)
 1170 FORMAT(1X,F10.1,F10.4,F10.4,F10.0)
 1220 FORMAT(1X,F10.1,F8.4,E11.4,E10.3)
 1235 FORMAT(//,14X,'***** SLOPES FOR COMPRESSIBILITY CALCULATIONS'
     &      ,' ****'
     &      ,//,15X,'P',8X,'BO',6X,'DBO/DP',8X,'RSO',5X,'DRSO/DP',/)
 1245 FORMAT(12X,F7.1,F8.4,3X,E11.4,F8.1,2X,E11.4)
 1260 FORMAT(//,15X,'P',8X,'BW',6X,'DBW/DP',8X,'RSW',5X,'DRSW/DP',/)
 1280 FORMAT(//,15X,'P',12X,'BG',12X,'DBGDP',3X,'VOP',3X,'VWP')
 1290 FORMAT(10X,F9.1,1X,5E10.3)
 1405 FORMAT(//,1X,'NSOLVENTS = ',I2,5X,'NSREAD = ',I2)
 1410 FORMAT(1X,F9.1,E10.3,1X,E10.3,F10.2,I5)
 1415 FORMAT(//,1X,'MEG1 = ',F8.4,5X,'MEG2 = ',F8.4)
 1420 FORMAT(1X,F10.2,5F10.4,4X,F6.4)
 1430 FORMAT(1X,/,'"SORW" FOR WATER-BLOCKING FUNCTION = ',F10.4)
 1435 FORMAT(/,1X,'RHOSC(J) Solvent = ',4F10.5)
 1450 FORMAT(1X,F6.0,2F8.5,3F8.1,3F8.5)
 1460 FORMAT(1X,F10.1,F9.4,E11.4,F10.1,F10.1)
 1615 FORMAT(1X,2I5,F10.4,5X,'[NOMOB, MOBCTL,SCI]')
 1650 FORMAT(//9X,'***** SLOPES FOR SOLVENT',I3,'  COMPRESSIBILITY'
     &      ,' CALCULATIONS ****'
     &      ,/15X,'P',10X,'BS',10X,'DBS/DP',7X,'RSS'
     &      ,5X,'DRSS/DP',7X,'RWT',6X,'DRWS/SP',/)
 1670 FORMAT(12X,F7.1,E13.4,3X,E11.4,F8.1,2X,E11.4,2X,F8.1,2X,E11.4)
      END SUBROUTINE TABLE2
      SUBROUTINE TRAN2(II,JJ,KK,IOCODE,KRED,KX,KY,KZ,DX,DY,DZ
     &                ,A1,A2,A3,TX,TY,TZ)
C
C     WORK ARRAYS: A1, A2, A3
C     KRED: SWITCH FOR MODIFICATIONS (1: NO; 0: YES)
C
      DIMENSION KX(II,JJ,KK),KY(II,JJ,KK),KZ(II,JJ,KK),DX(II,JJ,KK)
     &         ,DY(II,JJ,KK),DZ(II,JJ,KK),A1(II,JJ,KK),A2(II,JJ,KK)
     &         ,A3(II,JJ,KK)
      DIMENSION TX(II+1,JJ,KK),TY(II,JJ+1,KK),TZ(II,JJ,KK+1)
      CHARACTER C80*80
      REAL KX,KY,KZ
      DO 30 K = 1,KK
      DO 30 J = 1,JJ
      DO 30 I = 1,II
        A1(I,J,K) = KX(I,J,K)*DY(I,J,K)*DZ(I,J,K)
        A2(I,J,K) = KY(I,J,K)*DX(I,J,K)*DZ(I,J,K)
        A3(I,J,K) = KZ(I,J,K)*DX(I,J,K)*DY(I,J,K)
   30 CONTINUE
      IF(II .GT. 1) THEN
        DO 50 K = 1,KK
        DO 50 J = 1,JJ
        DO 50 I = 2,II
          TX(I,J,K) = .012656*A1(I-1,J,K)*A1(I,J,K)/
     &               (DX(I-1,J,K)*A1(I,J,K)+DX(I,J,K)*A1(I-1,J,K))
   50   CONTINUE
      ENDIF
      IF(JJ .GT. 1) THEN
        DO 55 K = 1,KK
        DO 55 J = 2,JJ
        DO 55 I = 1,II
          TY(I,J,K) = .012656*A2(I,J-1,K)*A2(I,J,K)/
     &               (DY(I,J-1,K)*A2(I,J,K)+DY(I,J,K)*A2(I,J-1,K))
   55   CONTINUE
      ENDIF
      IF(KK .GT. 1) THEN
        DO 60 K = 2,KK
        DO 60 J = 1,JJ
        DO 60 I = 1,II
          TZ(I,J,K) = .012656*A3(I,J,K-1)*A3(I,J,K)/
     &               (DZ(I,J,K-1)*A3(I,J,K)+DZ(I,J,K)*A3(I,J,K-1))
   60   CONTINUE
      ENDIF
      IF(KRED .EQ. 1) GOTO 900
C
C     TRANSMISSIBILITY MODIFICATIONS
C
      READ(5,8080) C80
8080  FORMAT (A80)
      READ(5,*) NUMTX,NUMTY,NUMTZ,ITCODE,IPRINT
      IF(NUMTX .GT. 0) THEN
        IF(ITCODE .EQ. 1) WRITE(IOCODE,1300)
        DO 350 L = 1,NUMTX
          READ(5,*) I,J,K,TX(I,J,K)
          IF(ITCODE .EQ. 1) WRITE(IOCODE,1325) I,J,K,TX(I,J,K)
  350   CONTINUE
      ENDIF
      IF(IPRINT .EQ. 1) THEN
        WRITE(IOCODE,1340)
        DO 400 K = 1,KK
          WRITE(IOCODE,1350) K
          DO 375 J = 1,JJ
            WRITE(IOCODE,1370) (TX(I,J,K),I=1,II)
  375     CONTINUE
  400   CONTINUE
      ENDIF
      IF(NUMTY .GT. 0) THEN
        IF(ITCODE .EQ. 1) WRITE(IOCODE,1400)
        DO 450 L = 1,NUMTY
          READ(5,*) I,J,K,TY(I,J,K)
          IF(ITCODE .EQ. 1) WRITE(IOCODE,1325) I,J,K,TY(I,J,K)
  450   CONTINUE
      ENDIF
      IF(IPRINT .EQ. 1) THEN
        WRITE(IOCODE,1440)
        DO 500 K = 1,KK
          WRITE(IOCODE,1350) K
          DO 475 J = 1,JJ
          WRITE(IOCODE,1370) (TY(I,J,K),I=1,II)
  475     CONTINUE
  500   CONTINUE
      ENDIF
      IF(NUMTZ .GT. 0) THEN
        IF(ITCODE .EQ. 1) WRITE(IOCODE,1500)
        DO 550 L = 1,NUMTZ
          READ(5,*) I,J,K,TZ(I,J,K)
          IF(ITCODE .EQ. 1) WRITE(IOCODE,1325) I,J,K,TZ(I,J,K)
  550   CONTINUE
      ENDIF
      IF(IPRINT .EQ. 1) THEN
        WRITE(IOCODE,1540)
        DO 600 K = 1,KK
          WRITE(IOCODE,1350) K
          DO 575 J =1,JJ
            WRITE(IOCODE,1375) (TZ(I,J,K),I=1,II)
  575     CONTINUE
  600   CONTINUE
      ENDIF
  900 RETURN
 1300 FORMAT(//T15,'**********TRANSMISSIBILITY (TX) NODE MODIFICATIONS',
     & '**********',//T15,'     I    J    K          NEW TX VALUE')
 1325 FORMAT(15X,3I5,5X,F14.4)
 1340 FORMAT(//T15,'**********TRANSMISSIBILITY (TX) DISTRIBUTION'
     & ,'**********'/)
 1350 FORMAT(/1X,'K =',I2/)
 1370 FORMAT(1X,20F6.2)
 1375 FORMAT(1X,20F6.1)
 1400 FORMAT(//T15,'**********TRANSMISSIBILITY (TY) NODE MODIFICATIONS',
     & '**********',//T15,'     I    J    K          NEW TY VALUE')
 1440 FORMAT(//T15,'**********TRANSMISSIBILITY (TY) DISTRIBUTION'
     & ,'**********'/)
 1500 FORMAT(//T15,'**********TRANSMISSIBILITY (TZ) NODE MODIFICATIONS',
     & '**********',//T15,'     I    J    K          NEW TZ VALUE')
 1540 FORMAT(//T15,'**********TRANSMISSIBILITY (TZ) DISTRIBUTION'
     & ,'**********'/)
      END SUBROUTINE TRAN2
      SUBROUTINE UINIT2(EL,PBO,SOMIN,ISOLID,NSLUGS,II,JJ,KK,IJKM,MSATW
     &                 ,MSATG,MPOT,MPWT,MPGT,P,PBOT,SO,SW,SG,VG,VS
     &                 ,NTABS,NTAB)
      DIMENSION EL(IJKM),P(IJKM),PBOT(IJKM),SO(IJKM),SW(IJKM),SG(IJKM)
     &         ,VG(IJKM),VS(4*IJKM),ISOLID(IJKM)
     &         ,NTAB(IJKM)
      DIMENSION PWOC(10),PGOC(10),WOC(10),GOC(10),RWWOC(10),ROWOC(10)
     &         ,ROGOC(10),RGGOC(10)
     &         ,PCWSWC(10),FCOW(10),FCGO(10),PCGO(10),PCOW(10)
     &         ,ISWC(10)
      DIMENSION VSI(4)
C
      PARAMETER (NTE = 25 , NBOT = 51 , NBOTM = NBOT-1) 
      COMMON/PVTRST/PST(NTE,4),VST(NTE,4),BST(NTE,4),RST(NTE,4)
     &             ,RWT(NTE,4),DBSDPT(NTE,4),DRSDPT(NTE,4)
     &             ,DRWDPT(NTE,4),BO1T(NTE),VO1T(NTE)
     &             ,BW1T(NTE),VW1T(NTE),CSC(NTE),FRCO2(NTE)
     &             ,VORST(NBOT),VWRST(NBOT),DVO1T(NBOT),DVW1T(NBOT)
     &             ,UORST(NBOT),UWRST(NBOT),DUO1T(NBOT),DUW1T(NBOT)
     &             ,VORSPT(NBOT),VWRSPT(NBOT),DVO1PT(NBOT)
     &             ,DVW1PT(NBOT),RUSQT(NBOT,4),RUGQT(NBOT)
     &             ,RUOQT(NBOT),USW1T(NBOT,4),UGW1T(NBOT),UOW1T(NBOT)
     &             ,USW2T(NBOT,4),UGW2T(NBOT),UOW2T(NBOT),VOPT(NTE)
     &             ,VWPT(NTE),PSMIN(4),PSMAX(4)
     &             ,BOSLP,BWSLP,BO1SLP,BW1SLP,VOSLP
     &             ,VO1SLP,VW1SLP,COH,CWH,CVOH,PMISC,PMCM,VSMISC
     &             ,OM1,OM2,RDRSO,RDRSW,RDRSO1,RDRSW1,RDMU,RDPRMP
     &             ,NPTS(4),IPSOL(4)

C  *** This common block contains four varibles separated from
C  *** common block PVTRST 

      COMMON/RHOSTO/RHOSCO,RHOSCG,RHOSCW,RHOSC(4)
C
      COMMON /SPVT/ SWT(10,25),KRWT(10,25),KRGT(10,25),PCOWT(10,25),
     & PCGOT(10,25),POT(25),MUOT(25),BOT(25),BOPT(25),RSOT(25),
     & RSOPT(25),
     & PWT(25),MUWT(25),BWT(25),BWPT(25),RSWT(25),RSWPT(25),
     & PGT(25),MUGT(25),BGT(25),BGPT(25),CRT(25),SWC(10),SORW(10),
     & SGT(10,25),KROWT(10,25),KROGT(10,25),RKOSWC(10),DKOSWC(10),
     & KR3P
      REAL KROWT,KROGT,KRWT,KRGT,MUOT,MUWT,MUGT
      CHARACTER C80*80
      RSLOPE = 0.
      D144 = 1./144.
      READ(5,8080) C80
8080  FORMAT (A80)
      READ(5,*) KPI,KSI
      DO 100 IB = 1,IJKM
        PBOT(IB) = PBO
  100 CONTINUE
      IF(KPI .EQ. 0) THEN
       DO 50 I=1,NTABS
        READ(5,*) PWOC(I),PGOC(I),WOC(I),GOC(I)
        WRITE(6,1050) WOC(I),PWOC(I),GOC(I),PGOC(I)
        PWOCI=PWOC(I)
        PGOCI=PGOC(I)
C
C     Water density @ WOC (RWWOC)
C
        CALL INTERP(PWT,BWT,MPWT,PWOCI,BWWOC)
        CALL INTERP(PWT,RSWT,MPWT,PWOCI,RSWWOC)
        RWWOC(I) = (RHOSCW + RSWWOC*RHOSCG)/BWWOC
C
C     Oil density @ WOC  (ROWOC)
C
        CALL INTPVT(PBO,BOSLP,POT,BOT,MPOT,PWOCI,BOWOC)
        CALL INTPVT(PBO,RSLOPE,POT,RSOT,MPOT,PWOCI,RSOWOC)
        ROWOC(I) = (RHOSCO + RSOWOC*RHOSCG)/BOWOC
C
C     Oil density @ GOC  (ROGOC)
C
        CALL INTPVT(PBO,BOSLP,POT,BOT,MPOT,PGOCI,BOGOC)
        CALL INTPVT(PBO,RSLOPE,POT,RSOT,MPOT,PGOCI,RSOGOC)
        ROGOC(I) = (RHOSCO + RSOGOC*RHOSCG)/BOGOC
C
C     Gas density @ GOC  (ROGOC)
C
        CALL INTERP(PGT,BGT,MPGT,PGOCI,BGGOC)
        RGGOC(I) = RHOSCG/BGGOC
C
        WRITE(6,1150) RWWOC(I),ROWOC(I),ROGOC(I),RGGOC(I)
        DO 260 J = 2,MSATW
          IF(KRWT(I,J) .GT. 0.0) GOTO 270
  260   CONTINUE
        J = MSATW
  270   ISWC(I) = J - 1
        SWC(I) = SWT(I,J-1)
        PCWSWC(I) = PCOWT(I,J-1)
C
C     CONVERT HEIGHT ABOVE CONTACTS TO CAPILLARY PRESSURE AND
C     BACK INTERPOLATE TO GET WATER & GAS SATURATIONS; NOTE
C     THAT PSDUDO CAPILLARY PRESSURES SHOULD BE USED IF GRID-
C     BLOCK THICKNESS EXCEEDS 10 TO 15 FEET!
C
        FCOW(I) = (RWWOC(I)-ROWOC(I))*D144
        FCGO(I) = (ROGOC(I)-RGGOC(I))*D144
   50   CONTINUE
        DO 400 IB = 1,IJKM
          NT=NTAB(IB)
          P(IB) = PWOC(NT) + ROWOC(NT)*(EL(IB)-WOC(NT))*D144
          PCOW(NT) = FCOW(NT)*(WOC(NT)-EL(IB))
          IF(PCOW(NT) .GE. PCWSWC(NT)) THEN
            SW(IB) = SWC(NT)
            GOTO 325
          ELSE
            DO 300 IS = ISWC(NT)+1,MSATW
              IF(PCOW(NT) .GT. PCOWT(NT,IS)) THEN
                SW(IB) = SWT(NT,IS-1) + (PCOW(NT)-PCOWT(NT,IS-1))
     &                  /(PCOWT(NT,IS)-PCOWT(NT,IS-1))
     &                  *(SWT(NT,IS)-SWT(NT,IS-1))
                GOTO 325
              ENDIF
  300       CONTINUE
            P(IB) = P(IB) - PCOW(NT) + PCOWT(NT,MSATW)
            SW(IB) = SWT(NT,MSATW)
          ENDIF
  325     CONTINUE
          PCGO(NT) = FCGO(NT)*(GOC(NT)-EL(IB))
          IF(PCGO(NT) .LE. PCGOT(NT,1)) THEN
            SG(IB) = 0.0
            GOTO 375
          ELSE
            DO 350 IS = 2,MSATG
              IF(PCGO(NT) .LT. PCGOT(NT,IS)) THEN
                SG(IB) = SGT(NT,IS-1) + (PCGO(NT)-PCGOT(NT,IS-1))
     &                  /(PCGOT(NT,IS)-PCGOT(NT,IS-1))
     &                  *(SGT(NT,IS)-SGT(NT,IS-1))
                GOTO 375
              ENDIF
  350       CONTINUE
            P(IB) = P(IB) + PCGO(NT) - PCGOT(NT,MSATG)
            SG(IB) = 1.0 - SW(IB)
          ENDIF
  375     SO(IB) = 1.0 - SW(IB) - SG(IB)
  400   CONTINUE
      ELSE
        IBL = 1
        DO 420 K = 1,KK
          DO 410 J = 1,JJ
            READ(5,*) (P(IB),IB=IBL,IBL+II-1)
            IBL = IBL + II
  410     CONTINUE
  420   CONTINUE
        IF(KSI .EQ. 0) THEN
          READ(5,*) SOI,SWI,SGI,(VSI(ISOL),ISOL=1,NSLUGS)
          IBS = 0
          DO 500 IB = 1,IJKM
            SO(IB) = SOI
            SW(IB) = SWI
            SG(IB) = SGI
            DO 450 ISOL = 1,NSLUGS
              IBS = IBS + 1
              VS(IBS) = VSI(ISOL)
  450       CONTINUE
  500    CONTINUE
        ELSE
          IBL = 1
          DO 520 K = 1,KK
            DO 510 J =1,JJ
              READ(5,*) (SO(IB),IB=IBL,IBL+II-1)
              IBL = IBL + II
  510       CONTINUE
  520     CONTINUE
          IBL = 1
          DO 540 K = 1,KK
            DO 530 J = 1,JJ
              READ(5,*) (SW(IB),IB=IBL,IBL+II-1)
              IBL = IBL + II
  530       CONTINUE
  540     CONTINUE
          DO 600 IB = 1,IJKM
            SG(IB) = 1.0 - SO(IB) - SW(IB)
            IF(SG(IB).LT.0.0)THEN
          PRINT *,'WARNING:NEGATIVE INITIAL GAS SATURATION !'
		PRINT *,IB, SG(IB)


              SG(IB) = 0.0
              SO(IB) = 1.0 - SW(IB)
            ENDIF
  600     CONTINUE
        DO 750 ISOL = 1,NSLUGS
          IBL = 1
          DO 700 K = 1,KK
            DO 650 J = 1,JJ
              READ(5,*) (VS(ISOL+NSLUGS*(IB-1)),IB=IBL,IBL+II-1)
              IBL = IBL + II
  650       CONTINUE
  700     CONTINUE
  750   CONTINUE
        ENDIF
      ENDIF
      IBS = 0
      DO 850 IB = 1,IJKM
        IF(PBOT(IB) .GT. P(IB)) PBOT(IB) = P(IB)
        VGG = 1.0
        DO 800 ISOL = 1,NSLUGS
          IBS = IBS + 1
          VGG = VGG - VS(IBS)
  800   CONTINUE
       IF(VGG.LT.0.0)THEN
       PRINT *,'WARNING: INITIAL NEGATIVE VGG'
       VS(IBS-NSLUGS+1)=VS(IBS-NSLUGS+1)+VGG
       VGG=0.0
       ENDIF
        VG(IB) = VGG
  850 CONTINUE
      DO 900 IB = 1,IJKM
        IF(SO(IB) .LT. SOMIN) ISOLID(IB) = 0
  900 CONTINUE
      RETURN
 1050 FORMAT(///,1X,'PRESSURE & SAT. INITIALIZATION PARAMETERS',
     &/2X,'WOC,PWOC, GOC,PGOC:',4F10.1)
 1150 FORMAT(///,1X,'UINIT2: DENSITIES FOR SATURATION INITIALIZATION -',
     &' RWWOC,ROWOC,ROGOC,RGGOC ARE:',//,10X,4F14.4)
      END SUBROUTINE UINIT2
      SUBROUTINE UPDATE(VP,BO,BW,BG,BS,RSOR,RSWR,RSO,RSWS1,OX,OY,OZ,WX
     &             ,WY,WZ,GX,GY,GZ,SX,SY,SZ,WSX,WSY,WSZ,DPO,C21,C23
     &             ,C31,C33,CSP,CSS,BVBP,DELT,NSLUGS,II,JJ,KK,IJKM
     &             ,MOBCTL,P,PBOT,SO,SW,SG,VG,VS,GOWT,GWWT,GGWT,GSWT
     &             ,GWSWT)
C
C     THIS SUBROUTINE UPDATES THE FLUX PORTION OF THE RESIDUALS AND THEN
C     UPDATES THE PRIMARY VARIABLES
C
      DIMENSION VP(IJKM),BO(IJKM),BW(IJKM),BG(IJKM),BS(IJKM),RSOR(IJKM)
     &         ,RSWR(IJKM),RSO(4*IJKM),RSWS1(IJKM),OX(IJKM),OY(IJKM)
     &         ,OZ(IJKM),WX(IJKM),WY(IJKM),WZ(IJKM),GX(IJKM),GY(IJKM)
     &         ,GZ(IJKM),SX(4*IJKM),SY(4*IJKM),SZ(4*IJKM),WSX(IJKM)
     &         ,WSY(IJKM),WSZ(IJKM),DPO(IJKM),C21(IJKM),C23(IJKM)
     &         ,C31(IJKM),C33(IJKM),CSP(4*IJKM),CSS(4*IJKM)
     &         ,P(IJKM),PBOT(IJKM),SO(IJKM),SW(IJKM),SG(IJKM),VG(IJKM)
     &         ,VS(4*IJKM),GOWT(IJKM),GWWT(IJKM),GGWT(IJKM)
     &         ,GSWT(4*IJKM),GWSWT(IJKM)
C
      REAL KRWT,KRGT,MUOT,MUWT,MUGT,KROWT,KROGT
      COMMON /SPVT/ SWT(10,25),KRWT(10,25),KRGT(10,25),PCOWT(10,25),
     & PCGOT(10,25),POT(25),MUOT(25),BOT(25),BOPT(25),RSOT(25),
     & RSOPT(25),
     & PWT(25),MUWT(25),BWT(25),BWPT(25),RSWT(25),RSWPT(25),
     & PGT(25),MUGT(25),BGT(25),BGPT(25),CRT(25),SWC(10),SORW(10),
     & SGT(10,25),KROWT(10,25),KROGT(10,25),RKOSWC(10),DKOSWC(10),
     & KR3P
C
      PARAMETER (NTE = 25 , NBOT = 51 , NBOTM = NBOT-1) 
      COMMON/PVTRST/PST(NTE,4),VST(NTE,4),BST(NTE,4),RST(NTE,4)
     &             ,RWT(NTE,4),DBSDPT(NTE,4),DRSDPT(NTE,4)
     &             ,DRWDPT(NTE,4),BO1T(NTE),VO1T(NTE)
     &             ,BW1T(NTE),VW1T(NTE),CSC(NTE),FRCO2(NTE)
     &             ,VORST(NBOT),VWRST(NBOT),DVO1T(NBOT),DVW1T(NBOT)
     &             ,UORST(NBOT),UWRST(NBOT),DUO1T(NBOT),DUW1T(NBOT)
     &             ,VORSPT(NBOT),VWRSPT(NBOT),DVO1PT(NBOT)
     &             ,DVW1PT(NBOT),RUSQT(NBOT,4),RUGQT(NBOT)
     &             ,RUOQT(NBOT),USW1T(NBOT,4),UGW1T(NBOT),UOW1T(NBOT)
     &             ,USW2T(NBOT,4),UGW2T(NBOT),UOW2T(NBOT),VOPT(NTE)
     &             ,VWPT(NTE),PSMIN(4),PSMAX(4)
     &             ,BOSLP,BWSLP,BO1SLP,BW1SLP,VOSLP
     &             ,VO1SLP,VW1SLP,COH,CWH,CVOH,PMISC,PMCM,VSMISC
     &             ,OM1,OM2,RDRSO,RDRSW,RDRSO1,RDRSW1,RDMU,RDPRMP
     &             ,NPTS(4),IPSOL(4)
C
C  *** This common block contains four varibles separated from
C  *** common block PVTRST
      COMMON/RHOSTO/RHOSCO,RHOSCG,RHOSCW,RHOSC(4)

      DIMENSION GSWTS(4),RHOSSP(4)
      LOGICAL BVBP(IJKM)
      IJM = II*JJ
C
C     UPDATE OIL, WATER AND NATURAL GAS RESIDUALS
C
      IB = 0
      DO 400 K = 1,KK
        DO 350 J = 1,JJ
          DO 300 I = 1,II
            IB = IB + 1
            DP = DPO(IB)
            DO 200 ID = 1,3
              IF(ID .EQ. 1) THEN
                IF(I .EQ. II) GOTO 200
                IBX = IB + 1
                DDP = DPO(IBX) - DP
                FO = OX(IB)*DDP
                FW = WX(IB)*DDP
                FG = GX(IB)*DDP
              ELSEIF(ID .EQ. 2) THEN
                IF(J .EQ. JJ) GOTO 200
                IBX = IB + II
                DDP = DPO(IBX) - DP
                FO = OY(IB)*DDP
                FW = WY(IB)*DDP
                FG = GY(IB)*DDP
              ELSE
                IF(K .EQ. KK) GOTO 200
                IBX = IB + IJM
                DDP = DPO(IBX) - DP
                FO = OZ(IB)*DDP
                FW = WZ(IB)*DDP
                FG = GZ(IB)*DDP
              ENDIF
              GOWT(IB) = GOWT(IB) - FO
              GWWT(IB) = GWWT(IB) - FW
              GGWT(IB) = GGWT(IB) - FG
              GOWT(IBX) = GOWT(IBX) + FO
              GWWT(IBX) = GWWT(IBX) + FW
              GGWT(IBX) = GGWT(IBX) + FG
  200       CONTINUE
  300     CONTINUE
  350   CONTINUE
  400 CONTINUE
C
C     UPDATE SOLVENT AND SURFACTANT RESIDUALS
C
      IF(NSLUGS .GT. 0 .OR. MOBCTL .GT. 0) THEN
        IIS = NSLUGS*II
        IJMS = NSLUGS*IJM
        IB = 0
        IBASE = 0
        DO 700 K = 1,KK
          DO 650 J = 1,JJ
            DO 600 I = 1,II
              IB = IB + 1
              DP = DPO(IB)
              IF(I .NE. II) THEN
                IBX = IB + 1
                DDP = DPO(IBX) - DP
                DO 450 ISOL = 1,NSLUGS
                  IBS = IBASE + ISOL
                  IBSX = IBS + NSLUGS
                  FS = SX(IBS)*DDP
                  GSWT(IBS) = GSWT(IBS) - FS
                  GSWT(IBSX) = GSWT(IBSX) + FS
  450           CONTINUE
                IF(MOBCTL .GT. 0) THEN
                  FWS = WSX(IB)*DDP
                  GWSWT(IB) = GWSWT(IB) - FWS
                  GWSWT(IBX) = GWSWT(IBX) + FWS
                ENDIF
              ENDIF
              IF(J .NE. JJ) THEN
                IBX = IB + II
                DDP = DPO(IBX) - DP
                DO 500 ISOL = 1,NSLUGS
                  IBS = IBASE + ISOL
                  IBSX = IBS + IIS
                  FS = SY(IBS)*DDP
                  GSWT(IBS) = GSWT(IBS) - FS
                  GSWT(IBSX) = GSWT(IBSX) + FS
  500           CONTINUE
                IF(MOBCTL .GT. 0) THEN
                  FWS = WSY(IB)*DDP
                  GWSWT(IB) = GWSWT(IB) - FWS
                  GWSWT(IBX) = GWSWT(IBX) + FWS
                ENDIF
              ENDIF
              IF(K .NE. KK) THEN
                IBX = IB + IJM
                DDP = DPO(IBX) - DP
                DO 550 ISOL = 1,NSLUGS
                  IBS = IBASE + ISOL
                  IBSX = IBS + IJMS
                  FS = SZ(IBS)*DDP
                  GSWT(IBS) = GSWT(IBS) - FS
                  GSWT(IBSX) = GSWT(IBSX) + FS
  550           CONTINUE
                IF(MOBCTL .GT. 0) THEN
                  FWS = WSZ(IB)*DDP
                  GWSWT(IB) = GWSWT(IB) - FWS
                  GWSWT(IBX) = GWSWT(IBX) + FWS
                ENDIF
              ENDIF
              IBASE = IBASE + NSLUGS
  600       CONTINUE
  650     CONTINUE
  700   CONTINUE
      ENDIF
      DO 900 IB = 1,IJKM
        IF(VP(IB) .LT. 1.0E-6) GOTO 900
        P(IB) = P(IB) + DPO(IB)
        PVDT = VP(IB)/DELT
        GGWTSS = GGWT(IB) - VG(IB)*(RSOR(IB)*GOWT(IB)
     &                             +RSWR(IB)*GWWT(IB))
        IF(NSLUGS .GT. 0) THEN
          IBASE = NSLUGS*(IB-1)
          SOBO = SO(IB)/BO(IB)
          SWBW = SW(IB)/BW(IB)
          CSG = SG(IB)/BG(IB) + SOBO*RSOR(IB) + SWBW*RSWR(IB)
          CSGP = SOBO*RSOPT(2) + SWBW*RSWPT(2)
          IBS = IBASE + 1
          GSWTS(1) = GSWT(IBS) - VS(IBS)*(RSO(IBS)*GOWT(IB)
     &                                  +RSWS1(IB)*GWWT(IB))
          IF(CSS(IBS)*BS(IBS) .GT. .0001) THEN
            RLAMDA = CSG/CSS(IBS)
          ELSE
            IF(BVBP(IB)) THEN
              RHOSSP(1) = SOBO*DRSDPT(2,1) + SWBW*DRWDPT(2,1)
              RLAMDA = CSGP/RHOSSP(1)
            ELSE
              RLAMDA = BS(IBS)/BG(IB)
            ENDIF
          ENDIF
          GGWTSS = GGWTSS + RLAMDA*GSWTS(1)
          DO 725 ISOL = 2,NSLUGS
            IBS = IBASE + ISOL
            GSWTS(ISOL) = GSWT(IBS) - VS(IBS)*RSO(IBS)*GOWT(IB)
            IF(CSS(IBS)*BS(IBS) .GT. (.0001)) THEN
              RLAMDA = CSG/CSS(IBS)
            ELSE
              IF(BVBP(IB)) THEN
                RHOSSP(ISOL) = SOBO*DRSDPT(2,ISOL)
                RLAMDA = CSGP/RHOSSP(ISOL)
              ELSE
                RLAMDA = BS(IBS)/BG(IB)
              ENDIF
            ENDIF
            GGWTSS = GGWTSS + RLAMDA*GSWTS(ISOL)
  725     CONTINUE
        ENDIF
        VGG = 1.0
        IF(BVBP(IB)) THEN
C
C     VARIABLE BUBBLE POINT LOGIC
C
          DPB = - GGWTSS/(PVDT*C33(IB))
          PBOT(IB) = PBOT(IB) + DPB
          SW(IB) = SW(IB) - C21(IB)*DPO(IB) - C23(IB)*DPB
     &           - GWWT(IB)*BW(IB)/PVDT
          DO 750 ISOL = 1,NSLUGS
            IBS = IBASE + ISOL
            IF(CSS(IBS)*BS(IBS) .GT. .0001) THEN
              DVS = - (CSP(IBS)*DPB+GSWTS(ISOL)/PVDT)/CSS(IBS)
              VS(IBS) = VS(IBS) + DVS
            ELSEIF(ABS(GGWTSS*BG(IB)/PVDT) .GT. 1.0E-7) THEN
              VS(IBS) = GSWTS(ISOL)*C33(IB)/(GGWTSS*RHOSSP(ISOL))
            ENDIF
            IF(VS(IBS).GT.1.0)VS(IBS)=1.0
            IF(VS(IBS).LT.0.0)VS(IBS)=0.0
            VGG = VGG - VS(IBS)
  750     CONTINUE
        ELSE
          DSG = - (C31(IB)*DPO(IB)+GGWTSS/PVDT)/C33(IB)
          SG(IB) = SG(IB) + DSG
          SW(IB) = SW(IB) - C21(IB)*DPO(IB) - GWWT(IB)*BW(IB)/PVDT
          IF(NSLUGS .GT. 0) THEN
            SW(IB) = SW(IB) - C23(IB)*DSG
            DO 825 ISOL = 1,NSLUGS
              IBS = IBASE + ISOL
              IF(CSS(IBS)*BS(IBS) .GT. .0001) THEN
                DVS =  - (CSP(IBS)*DPO(IB)+VS(IBS)/BS(IBS)*DSG
     &                    +GSWTS(ISOL)/PVDT)/CSS(IBS)
                VS(IBS) = VS(IBS) + DVS
              ELSEIF(SG(IB) .GT. 1.0E-7) THEN
                VS(IBS) =  - (CSP(IBS)*DPO(IB)+GSWTS(ISOL)/PVDT)
     &                        *BS(IBS)/SG(IB)
              ENDIF
              IF(VS(IBS).GT.1.0)VS(IBS)=1.0
              IF(VS(IBS).LT.0.0)VS(IBS)=0.0
              VGG = VGG - VS(IBS)
  825       CONTINUE
          ENDIF
          IF(SG(IB) .GE. 0.0) THEN
            PBOT(IB) = P(IB)
          ELSE
            SG(IB) = 0.0
            PBOT(IB) = P(IB) - .01
          ENDIF
        ENDIF
        IF(PBOT(IB) .GT. P(IB)) PBOT(IB) = P(IB)
        IF(SG(IB) .GT. 1.0) SG(IB) = 1.0
        IF(SW(IB) .LT. 0.0) THEN
          SW(IB) = 0.0
        ELSEIF(SW(IB) .GT. 1.0) THEN
          SW(IB) = 1.0
        ENDIF
        SO(IB) = 1.0 - SW(IB) - SG(IB)
        IF(SO(IB).LT.0.0)THEN
          SO(IB)=0.0
          SG(IB)=1.0-SW(IB)
        ENDIF
        IF(VGG.LT.0.0)THEN
        PRINT *,'WARNING:NEGATIVE VGG!!!'
        VGG=0.0
        ENDIF
        VG(IB) = VGG
  900 CONTINUE
      RETURN
      END SUBROUTINE UPDATE